<?php
/**
 * Exit if accessed directly
 */

//alm 20210419 14:56

// alm 20180117/20180218
// dropdown users show "company (legal representative) if company not empty
// find_user now find in company name and is casse and accents independant
// list incomplete subscriptions


if ( !defined( 'ABSPATH' ) ) {
    exit;
}
if ( !class_exists( 'WPCOOP_Admin' ) ) {
  class WPCOOP_Admin {

        public function __construct() {
            global $wpcoop;
            // copy some parameters from wpcoop
            $this->plugin_version = $wpcoop->plugin_version;
            $this->plugin_prefix = $wpcoop->plugin_prefix;
            $this->usersdata_prefix = $wpcoop->usersdata_prefix;
            $this->plugin_dir_path = $wpcoop->plugin_dir_path;
            $this->includes_path = $wpcoop->includes_path;

            $this->plugin_markers_file_path = $wpcoop->plugin_markers_file_path;
            $this->subs_geo_markers_filename = $wpcoop->subs_geo_markers_filename;

            $this->plugin_textdomain = $wpcoop->plugin_textdomain;

            $this->plugin_read_capability=$wpcoop->plugin_read_capability;
            $this->plugin_edit_capability=$wpcoop->plugin_edit_capability;
            $this->plugin_parameters_capability=$wpcoop->plugin_parameters_capability;
            $this->plugin_settings_capability=$wpcoop->plugin_settings_capability;

            $this->possible_statuses = $wpcoop->shares->get_possible_statuses();
            $this->workflow = $wpcoop->functions->get_workflow();

            $this->plugin_usersubs_meta=$wpcoop->plugin_usersubs_meta;

            // some parameters for this class
            // admin page slug name
            $this->class_slug = 'wpcoop';
            // paramaters & shareholding & events pages slugs names
            $this->class_events_slug= $this->class_slug.'events';
            $this->class_parameters_slug = $this->class_slug.'parameters';
            $this->class_shareholding_slug= $this->class_slug.'shareholding';

            // load config

            //if (!$this->load_config()) {
            //    add_action( 'admin_notices', array($this,'dashboard_error_notice'));
            //} else {
              // when in admin menu, add admin pages subpage and settings
              add_action( 'admin_menu', array( $this, 'setup_admin_pages' ));

              // add contact fields removed in 0.23
              add_filter('user_contactmethods', array($this, 'modify_contactmethods'));

              // add profile category remove in 0.23
              add_action( 'show_user_profile', array($this,'add_profile_category_fields' ));
              add_action( 'edit_user_profile', array($this,'add_profile_category_fields' ));
              add_action( 'personal_options_update', array($this,'save_profile_category_fields' ));
              add_action( 'edit_user_profile_update', array($this,'save_profile_category_fields' ));

              // integration wpcoounters
              // TODO hook name in parameters
              add_filter('wpcoounters_read_site_counters', array($this, 'wpcoounters_update'));
          //}

        }

        public function dashboard_error_notice(){
          ?>
            <div class="error notice is-dismissible">
            <p><?php _e( $this->plugin_prefix.'config.php not found for wpcoop plugin, contact site administrator', $this->plugin_textdomain ); ?></p>
            </div>
            <?php
        }


        // manage wpcoounters values
        public function wpcoounters_update($target_values) {
           if (!is_array($target_values)) $target_values=array();

            // get values given by this plugin
            $values= get_option($this->plugin_prefix.'coop_values');
            if (!is_array($values)) $values=array();

            // subscription amount in counter 0
            // number of subscribers in counter 1
            // number of shares in counter 2
            foreach($target_values as $i=>$val) {
                if (!is_array($val)) $target_values[$i]=array();
                if (isset($values['date'])) $target_values[$i]['date']=$values['date'];
                if ($i==0 && isset($values['subs_amount'])) $target_values[0]['value']=$values['subs_amount'];
                if ($i==1 && isset($values['subs_number'])) $target_values[1]['value']=$values['subs_number'];
                if ($i==2 && isset($values['shares_number'])) $target_values[2]['value']=$values['shares_number'];
            }

            return $target_values;
        }

        public function permits_shareholding_menu(){
          $display=true;
          $options = get_option($this->plugin_prefix.'options_coop');
          if (!isset($options['type']) || $options['type']=='null' ||
              !isset($options['form']) || $options['form']=='null' ||
              !isset($options['created']) || empty($options['created']) ||
              !isset($options['name']) || empty($options['name']) ||
              !isset($options['embeded_name']) || empty($options['embeded_name']) ||
              !isset($options['address']) || empty($options['address']) ||
              !isset($options['town']) || empty($options['town']) ||
              !isset($options['zip']) || empty($options['zip']) ||
              !isset($options['policies']) || empty($options['policies'])){
            $display=false;
          }
          $options = get_option($this->plugin_prefix.'options_shares');
          if (!isset($options['cats']) || $options['cats']=='null' ||
                !isset($options['cols']) || $options['cols']=='null' ||
                !isset($options['price']) || empty($options['price'])){
             $display=false;
          }

          $options = get_option($this->plugin_prefix.'options_shares');
          if (!isset($options['cats']) || $options['cats']=='null' ||
                !isset($options['cols']) || $options['cols']=='null' ||
                !isset($options['price']) || empty($options['price'])){
             $display=false;
          }
          return $display;
        }

        public function setup_admin_pages() {
          // Add settings page for users who can edit plugins
          // add_menu_page( string $page_title,
          //                   string $menu_title, string $capability, string $menu_slug, callable $function = '', string $icon_url = '', int $position = null )

          //https://developer.wordpress.org/resource/dashicons/
          if($this->permits_shareholding_menu()){
            // ok if mandatory options set
            // shareholding management
            $mp=add_menu_page( __('WpCoop Company Shareholding',$this->plugin_textdomain),
                           __('WpCoop Shareholding',$this->plugin_textdomain),
                           $this->plugin_read_capability,
                           $this->class_shareholding_slug,
                           array($this, 'admin_main_page'),
                           'dashicons-bank', // icone  url
                           '3' // position
                         );

            // add help to menu page
            add_action('load-'.$mp, array($this, 'page_help'));
            //subscribers
            $smp=add_submenu_page($this->class_shareholding_slug, __('WpCoop Subscribers',$this->plugin_textdomain),
                             __('Subscribers',$this->plugin_textdomain),
                             $this->plugin_read_capability,
                             'subscribers',
                             array($this, 'admin_subscribers')
                             );
            // add help to subscribers page
            add_action('load-'.$smp, array($this, 'subscribers_help'));

            //subscriptions
            $smp=add_submenu_page($this->class_shareholding_slug, __('WpCoop Subscriptions',$this->plugin_textdomain),
                             __('Subscriptions',$this->plugin_textdomain),
                             $this->plugin_read_capability,
                             'add2',
                             array($this, 'admin_add_subpage2')
                             );
            // add help to submenu page 2
            add_action('load-'.$smp, array($this, 'subpage2_help'));
          }
          //////
          // events management
          $options= get_option($this->plugin_prefix.'options_events', array());
          if (!empty($options) && isset($options['menu_enabled']) && $options['menu_enabled']=='y') {

            $mp=add_menu_page( __('WpCoop Events ',$this->plugin_textdomain),
               __('WpCoop Events',$this->plugin_textdomain),
               $this->plugin_parameters_capability,
               $this->class_events_slug,
               array($this, 'admin_events_page'),
               'dashicons-groups', // icone  url
               '3' // position
            );
            // add help to menu page
            add_action('load-'.$mp, array($this, 'events_page_help'));

            // sub-menu meetings
            $smp=add_submenu_page($this->class_events_slug, __('WpCoop Meetings',$this->plugin_textdomain),
                 __('Meetings',$this->plugin_textdomain),
                   $this->plugin_read_capability,
                   'meetings',
                   array($this, 'display_meetings_page')
                                 );
            // add help to submenu meetings
            add_action('load-'.$smp, array($this, 'meetings_help'));

           // sub-menu actions
            $smp=add_submenu_page($this->class_events_slug, __('WpCoop Actions',$this->plugin_textdomain),
                             __('Actions',$this->plugin_textdomain),
                             $this->plugin_read_capability,
                             'actions',
                             array($this, 'admin_add_actions')
                             );
            // add help to submenu meetings
            add_action('load-'.$smp, array($this, 'meetings_help'));
          }
            //////
            // wpcoop parameters
            //
            $mp=add_menu_page( __('WpCoop Company Parameters',$this->plugin_textdomain),
               __('WpCoop Parameters',$this->plugin_textdomain),
               $this->plugin_parameters_capability,
               $this->class_parameters_slug,
               array($this, 'admin_parameters_page'),
               '', // icone  url ?
               '4' // position
             );
            // add help to menu page
            add_action('load-'.$mp, array($this, 'parameters_page_help'));
        }

        public function admin_events_page(){
          if (file_exists($this->includes_path.'classes_includes/events_page.php')){
             include($this->includes_path.'classes_includes/events_page.php');
          } else {
            _e('File not found : classes_includes/events_page.php',$this->plugin_textdomain);
          }
        }

        public function display_meetings_page(){
          if (file_exists($this->includes_path.'classes_includes/display_meetings_page.php')){
             include($this->includes_path.'classes_includes/display_meetings_page.php');
          } else {
            _e('File not found : classes_includes/display_meetings_page.php',$this->plugin_textdomain);
          }
        }

        private function display_meetings_form($args){
          if (file_exists($this->includes_path.'classes_includes/display_meetings_form.php')){
             include($this->includes_path.'classes_includes/display_meetings_form.php');
          } else {
            _e('File not found : classes_includes/display_meetings_form.php',$this->plugin_textdomain);
          }
        }


        public function admin_add_meetings() {
          print_tab($_REQUEST);
          $tabs= array(
                  array( 'slug'=>'ca',  'caption'=>__('CA',$this->plugin_textdomain)),
                  array( 'slug'=>'ago',  'caption'=>__('AGO',$this->plugin_textdomain)),
                  array( 'slug'=>'agoe', 'caption'=>__('AGOE',$this->plugin_textdomain)),
                  array( 'slug'=>'age',  'caption'=>__('AGE',$this->plugin_textdomain))
                );
          /////// get active tab
          $active_tab='ca';
          if( isset( $_GET[ 'tab' ] ) ) {
            foreach($tabs as $tab) {
              if($_GET[ 'tab' ]==$tab['slug']) $active_tab=$tab['slug'];
            }
          }
          $args=array(
                    'tab'=>$active_tab,
                    'items'=>5,  // default number of items
                    'fields'=>array(
                      array('lib'=>__('Date JJ/MM/AAAA', $this->plugin_texdomain),
                            'name'=>'meetings_'.$active_tab.'[date]'),
                      array('lib'=>__('Lieu', $this->plugin_texdomain),
                            'name'=>'meetings_'.$active_tab.'[place]'),
                      array('lib'=>__('Heure', $this->plugin_texdomain),
                            'name'=>'meetings_'.$active_tab.'[time]'),
                      array('lib'=>__('Lien', $this->plugin_texdomain),
                            'name'=>'meetings_'.$active_tab.'[link]')
                                    )
                    );
        }

        public function admin_parameters_page(){
          global $wpcoop;
          if (!$wpcoop->admin_params->load_parameters_page()){
           _e('File not found : classes_includes/parameters_page.php',$this->plugin_textdomain);
          }
        }

/*

          /////// displays tabs
          ?>
            <div class="wrap">
                <div class="icon32" id="icon-options-general"><br /></div>
                <h2>
                    <?php //_e('WpCoop v'.$this->version(), $this->plugin_textdomain) ?>
                </h2>
                <h2 class="nav-tab-wrapper">
                <?php
                if (!empty($tabs)) {
                  foreach ($tabs as $tab) {
                    $addclass= ($tab['slug']==$active_tab)? 'nav-tab-active' : '';
                    ?>
                    <a href="?page=<?php echo 'meetings'; ?>&tab=<?php echo $tab['slug']; ?>" class="nav-tab <?php echo $addclass; ?>"><?php echo $tab['caption']; ?> </a>
                    <?php
                  }
                }
                ?>
                </h2>
            </div>
          <?php
          switch ($active_tab) {
                 case 'ca':
                  // Manage board of directors
                  echo '<h3>'.__('Board of directors', $this->plugin_textdomain).'</h3>';

                  // check wpnonce

                  if (isset($_REQUEST[$this->plugin_prefix.'end'])) unset($_REQUEST);
                  if (isset($_REQUEST[$this->plugin_prefix.'meetings_year']) && $_REQUEST[$this->plugin_prefix.'meetings_year']=='new') {
                    // new ca
                    $this->display_meeting_form($args);



                  } elseif (isset($_REQUEST[$this->plugin_prefix.'meetings_year'])) {
                    // list ca for given year
                    $year=sprintf('%04d', intval($_REQUEST[$this->plugin_prefix.'meetings_year']));
                    $meetings= get_option($this->plugin_prefix.'meetings_'.$active_tab.'_'.$year);
                    foreach($meetings as $date){
                       $meeting=get_option($this->plugin_prefix.'meetings_'.$active_tab.'_'.$date);
                       print_tab($meeting);

                    }


                  } elseif (isset($_REQUEST[$this->plugin_prefix.'meetings_'.$active_tab]['date'])) {

                    $args['items']=intval($_REQUEST[$this->plugin_prefix.'meetings_items']);

                    //format date to check it
                    $ar_date=explode('/',$_REQUEST[$this->plugin_prefix.'meetings_'.$active_tab]['date']);
                    if (count($ar_date)!=3 || !checkdate($ar_date[1], $ar_date[0], $ar_date[2])) {
                        // date Nok

	                   $this->print_notices('notice notice-error', __('Incorrect Date', $this->plugin_textdomain));

                    } else {
                        // date ok

                        $fdate=sprintf('%04d%02d%02d',$ar_date[2],$ar_date[1],$ar_date[0]);

                        if (empty(end($_REQUEST[$this->plugin_prefix.'meetings_'.$active_tab]))) {

                            while (empty(end($_REQUEST[$this->plugin_prefix.'meetings_'.$active_tab]))) {
                                array_pop($_REQUEST[$this->plugin_prefix.'meetings_'.$active_tab]);
                            }

                            update_option($this->plugin_prefix.'meetings_'.$active_tab.'_'.$fdate, $_REQUEST[$this->plugin_prefix.'meetings_'.$active_tab]);
                            //@TODO lock tables ?
                            $dates=get_option($this->plugin_prefix.'meetings_'.$active_tab.'_'.substr($fdate,0,4));
                            if (!in_array($dates,$fdate)) $meetings[]=$fdate;
                            update_option($this->plugin_prefix.'meetings_'.$active_tab.'_'.substr($fdate,0,4), $meetings);
 	                        $this->print_notices('notice notice-success', __('Meeting Created/Updated', $this->plugin_textdomain));

                        }  else {
                          //add lines
                          $args['items']=intval($_REQUEST[$this->plugin_prefix.'meetings_items'])+5;
                        }

                    }
                    //re-display form with values

                    $this->display_meeting_form($args);

                  } else {
                    // action is not set, display select only
                    $this->display_meeting_form(array('tab'=>'ca','items'=>0, 'fields'=>array()));

                  }


                  break;
                 case 'ago':
                  break;
                 case 'agoe':
                  break;
                 case 'age':
                  break;
          }
        }
*/
        public function display_meeting_form($args) {
           ?>
           <form method="post" action="<?php echo admin_url('admin.php?page=meetings&tab='.$args['tab']) ?>" >
            <?php settings_fields($this->plugin_prefix.'meetings_'.$args['tab']); ?>
            <h3><?php _e('Meetings', $this->plugin_textdomain) ?></h3>
            <div>
             <table class="form-table">
             <?php
             if (empty($args['fields'])) {
                  $firstyear='2017'; // @TODO find it in parameters
                  $thisyear=date('Y');
                  ?>
                  <select name="<?php echo $this->plugin_prefix.'meetings_year' ?>">
                  <?php
                  echo '<option value="new">'.__('Add a meeting', $this->plugin_textdomain).'</option>';
                  for ($year=$thisyear; $year<$thisyear+2; $year++ ) {
                    echo '<option value="'.$year.'">'.$year.'</option>';
                  }
                  ?>
                  </select>
                  <?php
             }

             $args['values']= array($_REQUEST[$this->plugin_prefix.'meetings_'.$args['tab']]['date'],
                                    $_REQUEST[$this->plugin_prefix.'meetings_'.$args['tab']]['place'],
                                    $_REQUEST[$this->plugin_prefix.'meetings_'.$args['tab']]['time'],
                                    $_REQUEST[$this->plugin_prefix.'meetings_'.$args['tab']]['link']
                                   );

             for($i=1;$i<$args['items']+1;$i++) {
                $args['fields'][]=array('lib'=>sprintf(__('Résolution %d', $this->plugin_textdomain), $i), 'name'=>'meetings_'.$args['tab'].'[item'.$i.']');
                $args['values'][]=$_REQUEST[$this->plugin_prefix.'meetings_'.$args['tab']]['item'.$i];
             }

            foreach($args['fields'] as $k=>$field) {
              echo'
              <tr>
               <td>'.$field['lib'].'</td>
               <td><input type="text" name="'.$this->plugin_prefix.$field['name'].'" value="'.esc_attr($args['values'][$k]).'" /></td>
              </tr>
              ';
             }

             echo'<input type="hidden" name="'.$this->plugin_prefix.'meetings_items" value="'.esc_attr($args['items']).'" /></td>';
             ?>
             </table>
             <p class="submit">
              <input type="submit" class="button-primary" value="<?php _e('VALIDATE', $this->plugin_textdomain) ?>" />
             </p>
             <?php if($args['items']!=0) : ?>
             <p class="submit">
              <input type="submit" name="<?php echo $this->plugin_prefix.'end' ?>" class="button-primary" value="<?php _e('RETURN', $this->plugin_textdomain) ?>" />
             </p>
             <?php endif ?>
            </div>
           </form>
           <?php
        }

        public function print_notices($classes, $message) {
           printf( '<div class="%1$s"><p>%2$s</p></div>', esc_attr( $classes ), esc_html( $message ) );
        }

        public function admin_main_page() {

            // user can ? wpnonce ?

            if (isset($_REQUEST['noheader']) && $_REQUEST['noheader']=='true') {
             // form activated, no header send, issue document
             $ID=0;  // ? all users
             $list=0;
             $att=0;
             $title="";
	     $ne=0;
             if (!isset($_POST[$this->plugin_prefix.'get_all_user_docs'])) {
              $len=strlen($this->plugin_prefix.'get_user_docs');
              $len2=strlen($this->plugin_prefix.'get_user_doccnil');
              foreach($_POST as $k=>$v) {
                  if (substr($k, 0, $len)==$this->plugin_prefix.'get_user_docs') {
                   $ID=intval(substr($k, $len));
                   break;
                  }
                  if (substr($k, 0, $len2)==$this->plugin_prefix.'get_user_doccnil') {
                   $ID=intval(substr($k, $len2));
                   $list=5;
                   break;
                  }
                  if ($k==$this->plugin_prefix.'get_subs_list') {
                    $list=1;
                    $title= (isset($_POST[$this->plugin_prefix.'list_sheet_title']))?
                             $_POST[$this->plugin_prefix.'list_sheet_title'] : __('Subscribers list', $this->plugin_textdomain);
                  }
                  if ($k==$this->plugin_prefix.'get_att_sheet') {
                    $att=1;
                    $title= (isset($_POST[$this->plugin_prefix.'att_sheet_title']))?
                             $_POST[$this->plugin_prefix.'att_sheet_title'] : __('Attendance sheet', $this->plugin_textdomain);
                  }
                  if ($k==$this->plugin_prefix.'get_att_raise') {
                    $att=2;
                    $title= (isset($_POST[$this->plugin_prefix.'att_raise_title']))?
                             $_POST[$this->plugin_prefix.'att_raise_title'] : __('Attendance raise', $this->plugin_textdomain);
                  }
                  if ($k==$this->plugin_prefix.'get_subs_oreg') {
                      $list=2;
                  }
                  if ($k==$this->plugin_prefix.'get_subs_oreg_date') {
                      $list=21;
                  }
                  if ($k==$this->plugin_prefix.'get_subs2val_list') {
                      $list=3;
                  }
                  if ($k==$this->plugin_prefix.'get_incsubs_list') {
                      $list=4;
                  }
                  if ($k==$this->plugin_prefix.'get_csv_list') {
                      $list=6;
                  }
                  if ($k==$this->plugin_prefix.'get_subs_proxy') {
                      $list=7;
                  }

                  if ($k==$this->plugin_prefix.'att_sheet_ne') {
                    $ne= (isset($_POST[$this->plugin_prefix.'att_sheet_ne']))?
                             intval($_POST[$this->plugin_prefix.'att_sheet_ne']) : 0;
                  }
               }
             }

             $this->issue_documents($ID, $list, $att, $title, $ne, 'both');

             // no footer etc...
             exit();

            } else {

             $this->display_page();

            }
          //} // user can ?
        }

        public function admin_subscribers() {
            global $wpcoop;
            // here only if capability ok
            //print_tab($_POST);
            echo '<h3>'.__("Manage Coop members", $this->plugin_textdomain ).'</h3>';
            echo '<h4>'.__("Use Help button on the right", $this->plugin_textdomain ).'</h4>';
            //<div class="error"><p>Cette fonction n\'est pas encore testée à fond!!, voir l\'administrateur</p></div>';

            $user_data_fields=$wpcoop->members->get_user_data_fields();
            //print_tab($user_data_fields);

            //$added_profile_fields=$this->get_added_profile_fields();
            //print_tab($added_profile_fields);

            //$added_profile_category_fields=$this->get_added_profile_category_fields();
            //print_tab($added_profile_category_fields);

            $wpcoop_fields=$wpcoop->members->get_users_added_fields();
            //print_tab($wpcoop_fields);

            // form was submitted, check for wpnonce
            if ( isset($_POST[$this->plugin_prefix.'wpnonce']) &&
                    wp_verify_nonce( $_POST[$this->plugin_prefix.'wpnonce'],'wpcoopsubscribers')) {

                // fill user_data in case user exists
                $user_data=array();
                // no userObj yet
                $userObj=false;
                // choose or record any case you may have userid
                if (isset($_POST[$this->plugin_prefix.'user_id']) && $_POST[$this->plugin_prefix.'user_id']!=-1) {
                 // if != -1 edit user with userid
                 $user_data['ID']= (int) $_POST[$this->plugin_prefix.'user_id'];

                 // if user is not in this blog/site, put it with subscriber role
                 $blogid=get_current_blog_id();
                 if (!is_user_member_of_blog( $user_data['ID'], $blogid)) add_user_to_blog( $blogid, $user_data['ID'], 'subscriber' );


                 // fill   user_data with old values if any
                 $userObj = get_userdata( $user_data['ID'] );

                 if ($userObj === false) {
                    $class = 'notice notice-error';
                    $message = __( 'User ID unknown: ', $this->plugin_textdomain).$user_data['ID'];
                    printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message );
                    unset($user_data['ID']);
                 } else {
                    //echo '----userObj----<br>';
                    //print_tab($userObj);
                    $user_data['roles']= $userObj->roles;
                    $meta=get_user_meta($user_data['ID']);

                    //echo '----meta----<br>';
                    //print_tab($meta);

                    foreach($user_data_fields as $k=>$field) {
                        //echo 'user_data_field: '.$k.'<br>';
                        //$user_data[$k]= (isset($meta[$this->plugin_prefix.$k]))? $meta[$this->plugin_prefix.$k][0] : '';
                        $user_data[$k]= (isset($userObj->{$k}))? $userObj->{$k} : '';
                    }
                    //echo '----userdata--current data before wpcoop fields----<br>';
                    //print_tab($user_data);
                    //foreach($added_profile_fields as $k=>$l) {
                    //    $user_data[$k]= (isset($meta[$k]))? $meta[$k][0] : '';
                    //}
                    //foreach($added_profile_category_fields as $k=>$f) {
                    //    $user_data[$f['name']]= (isset($meta[$f['name']]))? $meta[$f['name']][0] : '';
                    //}
                    $slug='';
                    foreach($wpcoop_fields['tabs'] as $tab) {
                        if($tab['slug']!=$slug) {
                            $slug=$tab['slug'];
                            if ($slug=='wp') {
                              // TODO description!!!
                              continue;
                            }
                            $prefix = ($slug=='wp')? '' : $this->plugin_prefix.$this->usersdata_prefix.$slug.'_';

                        }
                       foreach($tab['fields'] as $field) {
                        $user_data[$prefix.$field['name']]= (isset($meta[$prefix.$field['name']]))? $meta[$prefix.$field['name']][0] : '';
                        switch($field['tag']) {
                            case 'input':
                                switch($field['type']){
                                    case 'checkbox':
                                        //echo $prefix.$field['name'].': '.meta[$prefix.$field['name']].'<br>';
                                        $user_data[$prefix.$field['name']] = (isset($meta[$prefix.$field['name']]) && $meta[$prefix.$field['name']][0]=='y') ? 'y' : 'n';
                                        break;
                                    case 'text':
                                    default:
                                }
                                break;
                            case 'textarea':
                            case 'select':
                            default:
                        }
                       }
                    } //$wpcoop_fields
                    // copy wp fields
                    if ($user_data[$this->plugin_prefix.$this->usersdata_prefix.'membertype_type']=='c') {
                        $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberperson_';
                    } else {
                        $prefix=$this->plugin_prefix.$this->usersdata_prefix.'representative_';
                    }
                    $user_data[$prefix.'first_name']=$user_data['first_name'];
                    $user_data[$prefix.'last_name']=$user_data['last_name'];
                    $user_data[$prefix.'user_email']=$user_data['user_email'];
                    $user_data[$prefix.'user_url']=$user_data['user_url'];
                    //echo '----userdata--current data--<br>';
                    //$user_data['cap'] =($userObj->has_cap($this->plugin_capability))? 1 : 0;
                    //print_tab($user_data);
                 } // userObj found

                } // userid exists select or modifyuser
                //print_tab($user_data);


                // form submitted via record button
                if (isset($_POST[$this->plugin_prefix.'record'])) {
                   // set user_data field not in $user_data_fields
                   $user_id = (isset($user_data['ID']))? $user_data['ID'] : -1;                         // edit current user or create new one
                   $user_login=(isset($user_data['user_login']))? $user_data['user_login'] : '';
                   $role = (isset($user_data['roles']))? $user_data['roles'][0] : 'subscriber';         // keep existant role
                   $desc = $user_data['description'] ?? '';
                   //$cap  = $user_data['cap']; // keep capability or not
                   $user_registered = (isset($user_data['user_registered']))? $user_data['user_registered'] : date('Y-m-d H:i:s'); // keep old registered date

                   $user_data=array();
                   if ($user_id!=-1) $user_data['ID']=$user_id;  // if ID==-1 don't set $user_data['ID']

                   // set user_data from post data : need to validate for security reason
                   foreach($user_data_fields as $k=>$f) {
                       $user_data[$k]= (isset($_POST[$this->plugin_prefix.$f['name']]))? sanitize_text_field($_POST[$this->plugin_prefix.$f['name']]) : '';
                   }
                   $user_data['role']=$role;
                   //$user_data['cap']=$cap;
                   $user_data['description']=$desc;
                   $user_data['user_registered']=$user_registered;

                    // get last and first names according to member or representative
                    // if capable person or minor -> account is opened for member, else representative
                   $prefix= $this->plugin_prefix.$this->usersdata_prefix;
                   if (isset($_POST[$prefix.'membertype_type']) && ($_POST[$prefix.'membertype_type']=='c' || $_POST[$prefix.'membertype_type']=='m')) {
                     //echo '-------------memberperson----------------<br>';
                     $slug='memberperson';
                   } else {
                     //echo '-------------representative---------------<br>';
                     $slug='representative';
                   }
                   $prefix=$this->plugin_prefix.$this->usersdata_prefix.$slug.'_';
                   // get member first and last name

                   $first_name=(isset($_POST[$prefix.'first_name']))? sanitize_text_field($_POST[$prefix.'first_name']) : '';
                   $last_name=(isset($_POST[$prefix.'last_name']))? sanitize_text_field($_POST[$prefix.'last_name']) : '';
                   $user_data['user_url'] = (isset($_POST[$prefix.'user_url']))? sanitize_text_field($_POST[$prefix.'user_url']) : '';
                   $user_data['user_email'] = (isset($_POST[$prefix.'user_email']))? sanitize_text_field($_POST[$prefix.'user_email']) : '';
                   $user_data['description'] = (isset($_POST['description']))? sanitize_text_field($_POST['description']) : '';

                   // constructs login from last and first names
                   //$login=remove_accents(strtolower(substr($last_name,0,3).substr($first_name,0,3)));
                   // convert to ascii BEFORE substr!
                   $login=strtolower(substr(remove_accents($last_name),0,3).substr(remove_accents($first_name),0,3));
                   $index=1;
                   while (get_user_by('login', $login)) $login=$login.$index++;

                   $user_data['first_name']=$first_name;
                   $user_data['last_name']=$last_name;
                   $user_data['user_login']=($user_login!='')? $user_login : $login;
                   $user_data['display_name'] = $first_name;
                   $user_data['display_name'].= ($user_data['display_name']=='')? $last_name : ' '.$last_name;
                   $user_data['nickname']=$user_data['user_login'];
                   $user_data['user_nicename']=$user_data['user_login'];
                   //prevent warning on insert
                   $user_data['user_pass']='';


                   //echo '-------------user data avant insert---------------<br>';
                   //print_tab($user_data);
                   // insert or update user depending on ID set or not

                    $user_id = wp_insert_user( $user_data ) ;

                    if ( ! is_wp_error( $user_id ) ) {
                        // on success add meta data for user

                        $class = 'notice notice-success';
                        $message = __('Enregistrement OK', $this->plugin_textdomain);
                        printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message );

                        // success, we will have to update meta
                        $insert_success=true;

                        // set user_data['ID'] for form (edit instead of create)
                        $user_data['ID']=$user_id;

                    } else {
                        //$user_id is wp_error object
                        foreach ($user_id->errors as $t=>$e) {
                           $class = 'notice notice-error';
                           $message = __( $e[0], $this->plugin_textdomain);
                           printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message );
                        }

                        // error, we won't have to update meta
                        $insert_success=false;

                    } // user creation/edit failed

                    // fill added fields for form

                    //foreach($added_profile_fields as $k=>$label) {
                    //    if (isset($_POST[$k])) {
                    //        $user_data[$k] = $_POST[$k];         //sanitized in update_user_meta
                    //    } else {
                    //        $user_data[$k] = '';
                    //    }
                        // update metaif success
                    //    if ($insert_success) update_user_meta( $user_id, $k, $user_data[$k]);
                    //}
                    //print_tab($user_added_fields);

                    // fill added profile category fields for form

                    //foreach($added_profile_category_fields as $field) {
                      //  if (isset($_POST[$field['name']]))  {
                    //        $user_data[$field['name']]= $_POST[$field['name']];  //sanitized in update_user_meta
                    //    } else {
                    //        $user_data[$field['name']]='';
                    //    }
                    //    if ($insert_success) update_user_meta( $user_id, $field['name'], $user_data[$field['name']]);
                    //}

                    // fields as of 0.23
                    //echo '------------ update wpcoop fields user_meta--------------<br>';
                    foreach($wpcoop_fields['tabs'] as $tab) {
                        if($tab['slug']!=$slug) {
                            $slug=$tab['slug'];
                            $prefix = ($slug=='wp')? '' : $this->plugin_prefix.$this->usersdata_prefix.$slug.'_';
                            if ($slug=='wp') continue;
                        }
                        foreach($tab['fields'] as $field) {
                        if (isset($_POST[$prefix.$field['name']]))  {
                           $user_data[$prefix.$field['name']]= $_POST[$prefix.$field['name']];  //sanitized in update_user_meta
                           $user_data[$prefix.$field['name']]=($field['tag']=='input' && $field['type']=='checkbox')? 'y' : $user_data[$prefix.$field['name']];
                           // warning if validation unsuccessfull
                           switch ($field['validate']?? '') {
                              case 'date':
                               if(!$wpcoop->functions->validate_date($_POST[$prefix.$field['name']])){
                                  $class = 'notice notice-warning';
                                  $message = __('Format Date incorrect', $this->plugin_textdomain);
                                  printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message );
                               }
                               break;
                           }
                        } else {
                            $user_data[$prefix.$field['name']]=($field['tag']=='input' && $field['type']=='checkbox')? 'n' : '';
                        }
                        //echo $prefix.$field['name'].' : '.$user_data[$prefix.$field['name']].'<br>';
                        if ($insert_success) update_user_meta( $user_id, $prefix.$field['name'], $user_data[$prefix.$field['name']]);
                        }
                    }
/*
                    if ($insert_success) {
                    // grant or revoke plugin_capability to user

                        $user = new WP_User( $user_id );  // on success, insert gave user_id

                        if (isset($_POST[$this->plugin_prefix.$this->plugin_capability])) {
                        //  echo 'wpcoop_manage ok';

                          $user_data['cap']=1;
                          $user->add_cap( $this->plugin_capability );
                        } else {
                        //  echo 'wpcoop_manege Nok';

                          $user_data['cap']=0;
                          $user->remove_cap( $this->plugin_capability );
                        }

                    } // update capability
                    // remove slash before displaying data
*/
                    $user_data=wp_unslash($user_data);
                    //print_tab($user_data);

                } // record

                // search users
                if (isset($_POST[$this->plugin_prefix.'search'])) {

                 $found=false;
                 $blogid= get_current_blog_id();
                 //$sites=get_sites(array('site__in'=>$blogid));
                 $users=get_users(array('blog_id'=>$blogid));

                 //$siteuserids = $this->display_found_users($sites[0], $users, $_POST[$this->plugin_prefix.'search'], __('Edit', $this->plugin_textdomain) );

                 $siteuserids = $this->display_found_users($blogid, $users, $_POST[$this->plugin_prefix.'search'], __('Edit', $this->plugin_textdomain) );

                 if (is_multisite()) {
                     $sites=get_sites(array('site__not_in'=>$blogid));
                     foreach ($sites as $site) {
                        $users=get_users(array('blog_id'=>$site->blog_id, 'exclude'=>$siteuserids));

                        $this->display_found_users($site, $users, $_POST[$this->plugin_prefix.'search'], __('Add and Edit', $this->plugin_textdomain));
                     }
                 }

                } else {


                // user form
                ?>
                    <form action="<?php echo admin_url('admin.php?page=subscribers') ?>" method="post" >
                    <?php echo wp_nonce_field( 'wpcoopsubscribers', $this->plugin_prefix.'wpnonce', true, false );
                    //echo '<table>';
                    if (isset($user_data['ID']) && $user_data['ID']!=-1) {
                     echo '<input type="hidden" name="'.$this->plugin_prefix.'user_id'.'" value="'.$user_data['ID'].'"   />';
                    }
                    $slug='';
                    foreach($wpcoop_fields['tabs'] as $tab) {
                        //echo $tab['slug'].'<br>';
                        if($tab['slug']!=$slug) {
                            echo '<table class="'.$this->plugin_prefix.$tab['class'].'" >';
                            $slug=$tab['slug'];
                            $prefix = ($slug=='wp')? '' : $this->plugin_prefix.$this->usersdata_prefix.$slug.'_';
                            echo '<tr><th class="'.$this->plugin_prefix.$tab['class'].'" >'.$tab['caption'].'</th></tr>';
                        }
                        foreach($tab['fields'] as $field) {
                          //echo $prefix.$field['name'].': '.$user_data[$prefix.$field['name']].'<br>';
                          //echo $field['tag'].'<br>';
                          $dis= (isset($field['dis']) && $field['dis']=='y')? 'disabled="disabled"' : '';
                          switch ($field['tag']) {
                            case 'textarea':
                             echo '<tr>
                                    <td>'.esc_html($field['caption']).'</td>
                                    <td><textarea  '.$dis.' name="'.esc_attr($prefix.$field['name']).'">'.esc_html($user_data[$prefix.$field['name']]?? '').'</textarea></td>
                                    <td>'.esc_html($field['desc']).'</td>
                                   </tr>';
                             break;
                            case 'select':
                             $options= (isset($field['values']))? $this->get_select_options($field['values']) : array() ;
                             if (!empty($options)) {
                                     echo  '<tr>
                                             <td>'.esc_html($field['caption']).'</td>
                                             <td>
                                              <select '.$dis.' name="'.esc_attr($prefix.$field['name']).'" >';
                                              foreach($options as $k=>$option) {
                                                $sel= ($user_data[$prefix.$field['name']]==$k)? 'selected="selected"' : '';
                                                echo '<option value="'.esc_attr($k).'" '.$sel.' >'.esc_html($option).'</option>';
                                              }
                                      echo '
                                              </select>
                                             </td>
                                             <td>'.esc_html($field['desc']).'</td>
                                            </tr>';
                                 }
                                 break;
                                case 'input':
                                 $type="text";
                                 $checked='';
                                 $value='value="'.esc_attr($user_data[$prefix.$field['name']]?? '').'"';
                                 switch ($field['type']) {
                                  case 'checkbox':
                                   $type="checkbox";
                                   if($user_data[$prefix.$field['name']]=='y') $checked='checked="checked"';
                                   $value='';
                                   break;
                                 }
                                 echo  '<tr>
                                         <td>'.esc_html($field['caption']).'</td>
                                         <td><input '.$dis.'type="'.$type.'" name="'.esc_attr($prefix.$field['name']).'" '.$value.' '.$checked.' /></td>
                                         <td>'.esc_html($field['desc']).'</td>
                                        </tr>';
                               break;
                          } // switch tag
                        } // field
                        echo '</table>';
                    }
/*
                    //display coop admin checkbox for non admin non super admin users
                    if ($userObj!==false && !$userObj->has_cap('administrator') && !is_super_admin($userObj->ID)) {
                        $chk = ($user_data['cap']==1)? 'checked="checked"' : '' ;
                        echo '
                         <table class="'.$this->plugin_prefix.'internal'.'" >
                         <tr><td>'.(__('Cooperative site manager')).'</td>
                             <td><input type="checkbox" name="'.$this->plugin_prefix.$this->plugin_capability.'" '.$chk.' /></td>
                             <td>'.(__('Check if subscriber can manage Cooperative site',$this->plugin_textdomain)).'</td>
                         </tr>
                         </table>';
                    }
*/
                    //echo '</table>';
                    submit_button( __( 'Record', $this->plugin_textdomain ), 'primary', $this->plugin_prefix.'record', true);
                    echo '</form>';

                }

            } // post && wp_nonce


            // first display, no submit done
            if(!isset($_POST[$this->plugin_prefix.'choose']) && !isset($_POST[$this->plugin_prefix.'record']) && !isset($_POST[$this->plugin_prefix.'search'])) {

                ?>

                <form action="<?php echo admin_url('admin.php?page=subscribers') ?>" method="post" >
                <?php echo wp_nonce_field( 'wpcoopsubscribers', $this->plugin_prefix.'wpnonce', true, false );
                echo '<table>
                <tr><th>'.__('Find User/Member', $this->plugin_textdomain).'</th></tr>
                <tr><td><input type="text" name="'.$this->plugin_prefix.'search" value="'.esc_attr($sstr?? '').'"></td></tr>
                <tr><td>';
                submit_button( __( 'Find', $this->plugin_textdomain), 'primary', $this->plugin_prefix.'find', true);
                echo '</td></tr>
                </table>
                </form>';

                // no button pressed yet, display dropdown box in form
                ?>
                <form action="<?php echo admin_url('admin.php?page=subscribers') ?>" method="post" >
                <?php echo wp_nonce_field( 'wpcoopsubscribers', $this->plugin_prefix.'wpnonce', true, true );
                echo '<table>
                <tr><th>'.__('Create or select member', $this->plugin_textdomain).'</th></tr><tr><td>';

                // display select box of all users beginnig by add new subscriber message
                $this->dropdown_users( array( 'name'=>$this->plugin_prefix."user_id",
                                                      'show_option_none' =>__('Create new member',$this->plugin_textdomain),
                                                      'selected'=>get_current_user_id()
                                             )
                                      );
                echo '</td></tr><tr><td>';
                submit_button( __( 'Choose "Create" or Select User to edit',$this->plugin_textdomain ), 'primary', $this->plugin_prefix.'choose', true);
                echo '
                    </td></tr></table
                </form>';
            } // no buttons pressed ?
        }

        public function display_found_users($site, $users, $sstr, $button_lib) {
         $siteusers=array();
         if (count($users)>0) {
            $found=false;
            $str='
            <table border="1"><caption>'.sprintf(__("Found on site %s",$this->plugin_textdomain), ((is_object($site))? $site->domain.$site->path : get_bloginfo('url'))).'</caption>
                <tr><th>'.__('Login',$this->plugin_textdomain).'</th>
                    <th>'.__('Nice Name',$this->plugin_textdomain).'</th>
                    <th>'.__('Display Name',$this->plugin_textdomain).'</th>
                    <th>'.__('Company',$this->plugin_textdomain).'</th>
                    <th>'.__('Email',$this->plugin_textdomain).'</th>
                    <th>'.__('Action',$this->plugin_textdomain).'</th>
                </tr>';
            foreach ($users as $user) {
             if ($this->find_user($user, $sstr) || empty($sstr)) {
                $found=true;
                $siteusers[]=$user->ID;
                $str.='
                <form action="'.admin_url('admin.php?page=subscribers').'" method="post" >
                '.wp_nonce_field( 'wpcoopsubscribers', $this->plugin_prefix.'wpnonce', true, false ).'
              <input type="hidden" name="'.$this->plugin_prefix.'user_id" value="'.$user->ID.'" />
                <tr><td>'.esc_html($user->user_login).'</td><td>'.esc_html($user->nice_name).'</td>
                    <td>'.esc_html($user->display_name).'</td><td>'.esc_html($user->company).'</td>
                    <td>'.esc_html($user->user_email).'</td><td>'.
                get_submit_button($button_lib, 'primary', $this->plugin_prefix.'choose', false).'</td></tr></form>';
             }
            }
            $str.='
            </table>';
            if ($found) echo $str; else {
              echo sprintf(__('Not found on %s',$this->plugin_textdomain), (is_object($site))? $site->domain.$site->path : get_bloginfo('url')).'<br>';
            }
         }//count>0
         return $siteusers;
        }


        public function find_user($user, $sstr) {
            $sstr=remove_accents(strtolower($sstr));
            $user->company = get_user_meta($user->ID, $this->plugin_prefix.'company', true);
            //print_tab($user);
            if (strpos(remove_accents(strtolower($user->nice_name)), $sstr)!==false ||
                strpos(remove_accents(strtolower($user->display_name)), $sstr)!==false ||
                strpos(remove_accents(strtolower($user->user_email)), $sstr)!==false ||
                strpos(remove_accents(strtolower($user->user_login)), $sstr)!==false ||
                strpos(remove_accents(strtolower($user->company)), $sstr)!==false
                ) {
                    return true;
                }
            return false;
        }

        public function get_company_created() {
           $options_coop = get_option($this->plugin_prefix.'options_coop');
           return apply_filters($this->plugin_prefix.'get_company_created', $options_coop['created']);
         }

        public function admin_add_actions() {
           if ( ( @include 'actions.php' ) === FALSE ) _e('actions.php file not found', $this->plugin_textdomain);
        }

        public function actions_help() {
            $profile_help = '<p>' . __('Actions',$this->plugin_textdomain) . '</p>' .
                            '<p>' . __('Select subscriptions on which apply action',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Permits action on multiple subscription',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Usage is to validate new subscriptions',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Or to validate new shareholders after a General Assembly',$this->plugin_textdomain) . '</p>';

            get_current_screen()->add_help_tab( array(
	           'id'      => 'overview',
	           'title'   => __('Overview'),
	           'content' => $profile_help,
            ) );

            get_current_screen()->set_help_sidebar(
                '<p><strong>' . __('For more information:') . '</strong></p>' .
                '<p>' . __('<a href="https://codex.wordpress.org/Users_Your_Profile_Screen" target="_blank">Documentation on User Profiles</a>') . '</p>' .
                '<p>' . __('<a href="https://wordpress.org/support/" target="_blank">Support Forums</a>') . '</p>'
            );

        }

        public function get_select_options($values) {
            if (is_array($values) && count($values)==2 && is_object($values[0]) && is_string($values[1]) && method_exists($values[0], $values[1])) {
               return (array) call_user_func($values);
            } else {
               return array();
            }
        }

        public function get_cats($scope='') {
          $cats=get_option($this->plugin_prefix.'options_categories',array());
          if (empty($cats)) $cats=array(
            0=>array('a'=>'-',
                     's'=>'----',
                     'n'=>__('No category defined yet, see administrator', $this->plugin_textdomain)));
          switch($scope){
            case 'f': // retrieve full data
             $ret=$cats;
            case 'a':   // a only
             foreach($cats as $ix=>$cat){
              $ret[$ix]= ($cat['a'])?? '?';
             }
             break;
            case 's':   // s only
             foreach($cats as $ix=>$cat){
              $ret[$ix]= ($cat['s'])?? '????';
             }
             break;
            case 'n':   // n only
            default:
             foreach($cats as $ix=>$cat){
              $ret[$ix]= ($cat['n'])?? __('No Name, see administrator', $this->plugin_textdomain);
             }
          }
          return(apply_filters($this->plugin_prefix.'get_cats', $ret, $cats, $scope));
        }

        public function get_cols($scope='') {
          $cols=get_option($this->plugin_prefix.'options_colleges',array());
          if (empty($cols)) $cols=array(
            0=>array('a'=>'-',
                     's'=>'----',
                     'n'=>__('No college defined yet, see administrator', $this->plugin_textdomain)));
          switch($scope){
            case 'f': // retrieve full data
             $ret=$cols;
            case 'a':   // a only
             foreach($cols as $ix=>$col){
              $ret[$ix]= ($col['a'])?? '?';
             }
             break;
            case 's':   // s only
             foreach($cols as $ix=>$col){
              $ret[$ix]= ($col['s'])?? '????';
             }
             break;
            case 'n':   // n only
            default:
             foreach($cols as $ix=>$col){
              $ret[$ix]= ($col['n'])?? __('No Name, see administrator', $this->plugin_textdomain);
             }
          }
          return(apply_filters($this->plugin_prefix.'get_cols', $ret, $cols, $scope));
        }

        public function get_member_types() {
           $types= array(
                       '0'=>'Choisir un type de membre',
                       'c'=>'Personne physique capable',
                       'i'=>'Personne morale',
                       'm'=>'Mineur ou personne sous représentation légale',
                        );
           return $types;
        }


        public function dropdown_users($options) {
                global $wpcoop;
                // defaults args
                $defaults=array('name'=>'dropdown', 'show_option_none'=>'', 'selected'=>0);
                $options=wp_parse_args($options,$defaults);
                $ops = $wpcoop->members->get_ordered_users('all');
                //print_tab($ops);
                echo '<select name="'.$options['name'].'">';
                if ($options['show_option_none']!='') echo '<option value="-1">'.$options['show_option_none'].'</option>';
                foreach ($ops as $id=>$user) {
                    $sel = ($options['selected']==$id)? 'selected="selected"' : '' ;
                    if (empty($user[$this->plugin_prefix.'company'])) {
                     echo '<option value="'.$id.'" '.$sel.'>'.$user['last_name'].' '.$user['first_name'].'</option>';
                    } else {
                     echo '<option value="'.$id.'" '.$sel.'>'.$user[$this->plugin_prefix.'company'].' ('.$user['last_name'].' '.$user['first_name'].')</option>';
                    }
                }
                echo '</select>';
        }


        public function admin_add_subpage2() {
          if ( ( @include 'subscriptions.php' )=== FALSE ) _e('subscriptions.php file not found', $this->plugin_textdomain);
        }

        // display subscription form to create operation or edit step
        // if admin, access to more functions are granted
        // $step: userid_operation_step
        public function display_subscription_form($userid, $newstatus, $newqty, $newdate, $step, $submit ) {
            //echo "$userid, $newstatus, $newqty, $newdate, $step, $submit";
            $ar_step=$this->get_step_array($step);
            //print_tab($ar_step);
            ?>
            <form action="<?php echo admin_url('admin.php?page=add2') ?>" method="post" >
            <?php echo wp_nonce_field( 'wpcoopsubpage2', $this->plugin_prefix.'wpnonce', true, false ); ?>
            <input type="hidden" name="<?php echo esc_attr($this->plugin_prefix.'userid'); ?>" value="<?php echo esc_attr($userid) ?>" />
            <input type="hidden" name="<?php echo esc_attr($this->plugin_prefix.'step'); ?>" value="<?php echo esc_attr($step) ?>" />
            <label><?php echo ($submit=='submit')? __('Nouvelle Opération de Souscription', $this->plugin_textdomain) : __('Modification souscription', $this->plugin_textdomain) ; ?> <br />
             <?php
           if ($submit!='submit') {
            ?>
                <label><?php _e("Numero d'opération.", $this->plugin_textdomain); ?><br>
                    <input name="<?php echo esc_attr($this->plugin_prefix.'operation'); ?>" value="<?php echo esc_attr($ar_step[1]) ?>" /><br />
                </label>
            <?php
            }


            ?>
             <select name="<?php echo esc_attr($this->plugin_prefix.'newstatus'); ?>" >
                <option value="none"    <?php echo ($newstatus=="none" || empty($newstatus))? 'selected="selected"' : ''; ?> ><?php echo $this->possible_statuses['none'] ?></option>
                <option value="subswft" <?php echo ($newstatus=="subswft")? 'selected="selected"' : ''; ?> ><?php echo $this->possible_statuses['subswft'] ?></option>
                <option value="subsnok" <?php echo ($newstatus=="subsnok")? 'selected="selected"' : ''; ?> ><?php echo $this->possible_statuses['subsnok'] ?></option>
                <option value="subsok"  <?php echo ($newstatus=="subsok")? 'selected="selected"' : ''; ?> ><?php echo $this->possible_statuses['subsok'] ?></option>
             </select>
           </label>
            <?php
            $date = (strlen($newdate)==8)? substr($newdate,0,2).'/'.substr($newdate,2,2).'/'.substr($newdate,4,4) : '';

            ?>
            <br/>
            <label><?php _e('Montant', $this->plugin_textdomain); ?><br>
                <input name="<?php echo esc_attr($this->plugin_prefix.'newqty'); ?>" value="<?php echo esc_attr($newqty) ?>" />
            </label>
            <br/>
            <label><?php _e('Date (jj/mm/aaaa)', $this->plugin_textdomain); ?><br>
            <input name="<?php echo esc_attr($this->plugin_prefix.'newdate'); ?>" value="<?php echo esc_attr($date) ?>" />
            </label>
            <br />
            <label><?php _e('Note', $this->plugin_textdomain); ?><br>
            <input name="<?php echo esc_attr($this->plugin_prefix.'newnote'); ?>" value="<?php echo esc_attr($note) ?>" />
            </label>
            <br />
            <input type="submit" name="<?php echo esc_attr($this->plugin_prefix.$submit); ?>" value="OK" />
            </form>
            <?php
        }
        // convert userid_operation_step -> array(int userid, int operation, int step)
        public function get_step_array($step) {
          $ar_step=explode('_',$step);
          if (count($ar_step)!=3) return array(); else return array(intval($ar_step[0]), intval($ar_step[1]), intval($ar_step[2]));
        }

        public function get_action_keys() {
            global $wpcoop;
            $ak=array();
            foreach($this->workflow as $wf) {
                foreach($wf as $a) {
                  $ak[]=$a['action'];
                }
            }
            return array_unique($ak);
        }

        public function page_help() {
          $overview_help = '<p>' . __('Gestion de la coopérative',$this->plugin_textdomain) . '</p>' .
                           '<p>' . __('Cette page donne la liste des souscripteurs, et permet de générer les documents associés en pdf ',$this->plugin_textdomain) . '</p>'.
                           '<p>' . __("Terminologie: un souscripteur a souscrit des parts qui peuvent ne pas être encore validées, il n'est donc pas encore formellement sociétaire",$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Le tableau récapitulatif donne les montants souscrits et les parts validées ',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("Le registre officiel ne liste que les sociétaires (parts validées)",$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("La validation des parts peut se faire, suivant les statuts et les cas, par une AG, un CA ou le président",$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Le document obtenu par les boutons de droite sont les mêmes que ceux qui peuvent être obtenus par les soucripteurs dans la page "mon compte"',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Attention, générer les documents pour tous les souscripteurs peut donner lieu à une grosse charges du serveurs, si les souscripteurs sont très nombreux',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Pour la liste des souscripteurs et la feuille de présence, on peut donner un titre (par exemple liste des souscripteurs à telle date, AG de telle date)',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Pour la feuille de présence, on peut ajouter des pages vides (avec les cases), si des personnes non inscrites peuvent se présenter',$this->plugin_textdomain) . '</p>';

            $search_help = '<p>' . __("Recherche d'utilisateur",$this->plugin_textdomain) . '</p>' .
                           '<p>' . __("La recherche se fait sur l'ensemble des sites de la plateforme (site principal, sociétaire, intranet,etc)" ,$this->plugin_textdomain) . '</p>'.
                           '<p>' . __('Il suffit de tapper quelques lettres du login, nom ou prénom, adresse mél et de cliquer sur "Trouver"' ,$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Les résultats du site "sociétaires" sont présentés en premier, on peut directement modifier les données de ces comptes en cliquant surle bouton "Modifier" à droite',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("Les résultats des autres sites sont présentés ensuite; pour ajouter l'utilisateur comme sociétaire et le modifier, il suffit d'ajouter sur le bouton \"Ajouter et modifier\"",$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("S'il est trouvé sur un autre site, cliquer sur le bouton \"Ajouter et modifier\", le compte utilisateur sera validé sur le site \"sociétaire\"",$this->plugin_textdomain) . '</p>';

            $edit_help   = '<p>' . __("Création/modification d'un sociétaire",$this->plugin_textdomain) . '</p>' .
                           '<p>' . __('cocher la case si on veut que le nouveau souscripteur puisse gérer la coopérative',$this->plugin_textdomain) . '</p>';

            $delete_help = '<p>' . __("Suppression d'un sociétaire",$this->plugin_textdomain) . '</p>' .
                           '<p>' . __("Pas possible dans Wpcoop, demander à l'administrateur du site" ,$this->plugin_textdomain) . '</p>'.
                           '<p>' . __('Mais on peut supprimer toutes les souscriptions du sociétaire' ,$this->plugin_textdomain) . '</p>';

            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'overview',
	           'title'   => __('Overview'),
	           'content' => $overview_help,
                ));
            /*
            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'search',
	           'title'   => __('Search'),
	           'content' => $search_help,
                ));
            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'edit',
	           'title'   => __('Edit member'),
	           'content' => $edit_help,
                ));
            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'delete',
	           'title'   => __('Delete member'),
	           'content' => $delete_help,
                ));
            */
            get_current_screen()->set_help_sidebar(
                '<p><strong>' . __('For more information:') . '</strong></p>' .
                '<p>' . __('<a href="http://pep2a.fr/societaires/wp-content/uploads/sites/2/2017/06/statuts_scic_pep2a.pdf" target="_blank">Statuts PEP2A</a>') . '</p>'
            );


        }

        public function parameters_page_help(){
            if (file_exists($this->includes_path.'classes_includes/parameters_page_help.php')){
               include($this->includes_path.'classes_includes/parameters_page_help.php');
            } else {
              $overview_help = '<p>' . __('Contact site administrator',$this->plugin_textdomain) . '</p>
              <p>' . __('File not found : classes_includes/parameters_page_help.php',$this->plugin_textdomain) . '</p>' ;
              get_current_screen()->add_help_tab( array(
               'id'      => 'overview',
               'title'   => __('Help Error'),
               'content' => $overview_help,
              ) );
             }
        }


        public function subscribers_help() {
            $overview_help = '<p>' . __('Ajout de sociétaires',$this->plugin_textdomain) . '</p>' .
                            '<p>' . __('Un sociétaire doit avoir un compte validé sur le site "sociétaires" ',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Attention, un sociétaire peut avoir un compte sur un autre site du réseau, il faut le valider sur le site "sociétaire" ',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Il faut éviter les doublons, donc rechercher si le sociétaire est défini comme utilisateur sur un autre site (principal, intranet, extranet, boutique ...) " ',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("Pour cela, commencer par rechercher le sociétaire; s'il est trouvé sur le site sociétaire, il est possible de le modifier directement en cliquant sur le bouton de droite",$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("S'il est trouvé sur un autre site, cliquer sur le bouton \"Ajouter et modifier\", le compte utilisateur ser avalidé sur le site \"sociétaire\"",$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Sinon sélectionner Ajouter et valider ',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Il faut ajouter le souscripteur avant d\'ajouter une souscription',$this->plugin_textdomain) . '</p>';

            $search_help = '<p>' . __("Recherche d'utilisateur",$this->plugin_textdomain) . '</p>' .
                           '<p>' . __("La recherche se fait sur l'ensemble des sites de la plateforme (site principal, sociétaire, intranet,etc)" ,$this->plugin_textdomain) . '</p>'.
                           '<p>' . __('Il suffit de tapper quelques lettres du login, nom ou prénom, adresse mél et de cliquer sur "Trouver"' ,$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Les résultats du site "sociétaires" sont présentés en premier, on peut directement modifier les données de ces comptes en cliquant surle bouton "Modifier" à droite',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("Les résultats des autres sites sont présentés ensuite; pour ajouter l'utilisateur comme sociétaire et le modifier, il suffit d'ajouter sur le bouton \"Ajouter et modifier\"",$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("S'il est trouvé sur un autre site, cliquer sur le bouton \"Ajouter et modifier\", le compte utilisateur sera validé sur le site \"sociétaire\"",$this->plugin_textdomain) . '</p>';

            $edit_help   = '<p>' . __("Création/modification d'un sociétaire",$this->plugin_textdomain) . '</p>' .
                           '<p>' . __('cocher la case si on veut que le nouveau souscripteur puisse gérer la coopérative',$this->plugin_textdomain) . '</p>';

            $delete_help = '<p>' . __("Suppression d'un sociétaire",$this->plugin_textdomain) . '</p>' .
                           '<p>' . __("Pas possible dans Wpcoop, demander à l'administrateur du site" ,$this->plugin_textdomain) . '</p>'.
                           '<p>' . __('Mais on peut supprimer toutes les souscriptions du sociétaire' ,$this->plugin_textdomain) . '</p>';

            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'overview',
	           'title'   => __('Overview'),
	           'content' => $overview_help,
                ));
            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'search',
	           'title'   => __('Search'),
	           'content' => $search_help,
                ));
            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'edit',
	           'title'   => __('Edit member'),
	           'content' => $edit_help,
                ));
            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'delete',
	           'title'   => __('Delete member'),
	           'content' => $delete_help,
                ));

            get_current_screen()->set_help_sidebar(
                '<p><strong>' . __('For more information:') . '</strong></p>' .
                '<p>' . __('<a href="https://codex.wordpress.org/Users_Your_Profile_Screen" target="_blank">Documentation on User Profiles</a>') . '</p>' .
                '<p>' . __('<a href="https://wordpress.org/support/" target="_blank">Support Forums</a>') . '</p>'
            );
        }

        public function subpage2_help() {
            $profile_help = '<p>' . __('Ajout de souscriptions',$this->plugin_textdomain) . '</p>' .
                      '<p>' . __('Il faut ajouter le souscripteur avant d\'ajouter la souscription',$this->plugin_textdomain) . '</p>'.
                      '<p>' . __('Les souscriptions passent par plusieurs étapes:',$this->plugin_textdomain) . '</p>'.
                      '<p>' . __('Dossier de souscription reçu (complet ou incomplet - manque de pièces ou paiement pas encaissé ou délai de rétraction pas passé) ',$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("On ne peut saisir que des souscriptions (complètes ou incomplètes), les étapes suivantes se font à l'aide des boutons",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __('Souscription en attente de validation: le dossier est transmis pour validation en CA ou AG ou président',$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Souscription effective: validation faite, le souscripteur devient sociétaire s'il ne l'était déjà et obtient X parts sociales",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Montant est à entrer en euros sans l'unités (nombre entier multiple du montant de la part)",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __('La date est à entrer: j=jour, m=mois, a=année, par exemple 21/12/2016 pour le 21 décembre 2016',$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Attention, le format de la date est vérifié mais pas la chronologie",$this->plugin_textdomain) . '</p>';

            $actions_help = '<p>' . __('Actions',$this->plugin_textdomain) . '</p>' .
                      '<p>' . __('Une fois la souscription saisie, les étapes suivantes sont générées en cliquant sur les boutons "Actions"',$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Les boutons sont générés en fonction des opérations possibles suivant l'état actuel de la souscription",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("On peut supprimer les souscriptions tant qu'elles ne sont pas validées en parts",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Subs. Ok fait passer de dossier incomplet à complet",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Att. Val fait passer de dossier complet à en attente de validation (transmis à l'instance décisionnelle)",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Il faut entrer la date correspondant à la décision de l'action (CA, AG etc...)",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Attention, le format de la date esst vérifié mais pas la chronologie",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("En cas d'erreur de saisie, seul l'administrateur du site peut modifier les données",$this->plugin_textdomain) . '</p>';

            get_current_screen()->add_help_tab( array(
	           'id'      => 'overview',
	           'title'   => __('Overview'),
	           'content' => $profile_help,
            ) );

            get_current_screen()->add_help_tab( array(
	           'id'      => 'actions',
	           'title'   => __('Actions'),
	           'content' => $actions_help,
            ) );

            get_current_screen()->set_help_sidebar(
                '<p><strong>' . __('For more information:') . '</strong></p>' .
                '<p>' . __('<a href="https://codex.wordpress.org/Users_Your_Profile_Screen" target="_blank">Documentation on User Profiles</a>') . '</p>' .
                '<p>' . __('<a href="https://wordpress.org/support/" target="_blank">Support Forums</a>') . '</p>'
            );
        }

         public function display_page() {
            global $wpcoop;
            // get subscribers, that is, users with a status
            echo '<h3>'.__('Display all subscribers', $this->plugin_textdomain).'</h3>';
            echo '<h4>'.sprintf(__('Version: %s', $this->plugin_textdomain), $this->plugin_version).'</h4>';

            // read options for map from settings
            $maps_options=get_option($this->plugin_prefix.'options_maps');

            if(isset($maps_options['url_full_map']) && !empty($maps_options['url_full_map'])) {
             echo '<span><a href="'.$maps_options['url_full_map'].'">Carte des sociétaires</a><span>';
            }
            $ops=$wpcoop->members->get_ordered_users( 'all');

            if (!empty($ops)) {
                ?>
                <form name="post" action="<?php echo admin_url('admin.php?page='.$this->class_shareholding_slug.'&noheader=true'); ?>" method="post" id="post">
                    <table>
                        <tr><th><?php _e('ID', $this->plugin_textdomain); ?></th><th><?php _e('Login', $this->plugin_textdomain); ?></th>
                            <th><?php _e('Nom Usuel', $this->plugin_textdomain); ?></th>
                            <th><?php _e('Raison sociale', $this->plugin_textdomain); ?></th>
                            <th><?php _e('Amount', $this->plugin_textdomain); ?></th>
                            <th><?php _e('Validated Shares', $this->plugin_textdomain); ?></th>
                            <th colspan="2"><?php _e('Documents', $this->plugin_textdomain); ?></th>
                        </tr>
                <?php
                // counts
            $tv=0; // total value
            $ts=0; // total number of shares
            $n=0;  // number of subscribers
            // data for usermap
            $usermap=array();
            foreach($ops as $id=>$user) {

                $member = new WPCOOP_Member($id, $user);

                $wpcoop->members->prepare_update_members_table($member);

                if (empty($user['usersubs'])) continue;

                 $data=$user['shares_data'];
                 $s=$data['shares'];     //quantity of validated shares detained
                 $v=$data['value'];      //value subscribed for this user
                 $d=$data['date'];       //date of first membership

                 echo '<tr>
                 <td>'.$id.'</td>
                 <td style="text-align: left;">'.$user['user_login'].'</td>';
                 $prefix=$this->get_subscriber_prefix($id, $user);
                 $thedisplayname=$this->get_thedisplayname($id,$user,$prefix, true);
                 echo'
                 <td>'.$thedisplayname.'</td>
                 <td>'.$this->get_thecompany($id,$user,$prefix).'</td>
                 <td width="10%" style="text-align: right;">'.$v.'</td>
                 <td style="text-align: right;">'.$s.'</td>
                 <td><input type="submit" name ="'.$this->plugin_prefix.'get_user_docs'.$id.'" value="'.__('Relevé de situation', $this->plugin_textdomain).'" /></td>
                 <td><input type="submit" name ="'.$this->plugin_prefix.'get_user_doccnil'.$id.'" value="'.__('Infos CNIL', $this->plugin_textdomain).'" /></td></tr>';
                 $tv+=$v;
                 $ts+=$s;
                 if ($v!=0) $n++;
                 // fill users map data
                    //print_tab($user);
                 $zip='?? type?';
                 $city='?? type?';
                 if ($user['wpcoop_userdata_membertype_type']=='c') {
                     $zip = $user['wpcoop_userdata_memberperson_zip'];
                     $city= $user['wpcoop_userdata_memberperson_city'];
                 }
                 if ($user['wpcoop_userdata_membertype_type']=='i') {
                     $zip = $user['wpcoop_userdata_memberinstitution_zip'];
                     $city = $user['wpcoop_userdata_memberinstitution_city'];
                 }
                 if ($user['wpcoop_userdata_membertype_type']=='m') {
                     $zip = $user['wpcoop_userdata_representative_zip'];
                     $city = $user['wpcoop_userdata_representative_city'];
                 }
                 //$city= $user[$this->plugin_prefix.'city'];
                 $display_name=$user['display_name'];

                 $usermap[$zip][$id]=array('name'=>$user['display_name'], 'city'=>$city);

            }

            $wpcoop->members->do_update_members_table();

            // make markers file for users map
            // open markers file
            $outh=false;
            $outa=false;
            $outd=true;
            if (!file_exists($this->plugin_markers_file_path)) {
                $outd=mkdir($this->plugin_markers_file_path, 0755);
            }
            if ($outd) {
                $outh=fopen($this->plugin_markers_file_path.$this->subs_geo_markers_filename,"w"); //ouvre en w et cree
                $outa=fopen($this->plugin_markers_file_path.'an_'.$this->subs_geo_markers_filename,"w"); //ouvre en w et cree
            }
            if(!$outh || !$outa) {
                    wlog (LOG, 'ERROR: creating file or directory for wpcoop markers');
            } else {
                fputs ($outh, "lat\tlon\ttitle\tdescription\ticon\ticonSize\ticonOffset\r\n");
                fputs ($outa, "lat\tlon\ttitle\tdescription\ticon\ticonSize\ticonOffset\r\n");
                $out=array();
                if (!empty($usermap)) {
                   global $wpdb;

                   //$iconurl="https://pep2a.fr/intranet/wp-content/uploads/sites/3/2018/11/smiley_icone.jpg";
                   $iconurl=$maps_options['url_map_icon']?? '';
                   foreach ($usermap as $zip=>$users){
                     //echo 'ZIP: '.$zip.'<br>';
                     //print_tab($users);
                     if (strlen($zip)!=5) continue;
                     $qry="SELECT latitude AS lat, longitude AS lon, nom_commune FROM communes WHERE codes_postaux like '%".$zip."%' AND latitude <>'' AND longitude <>''";
                     //echo $qry;
                     //$res=$wpdb->get_row($qry, ARRAY_A);
                     $res=$wpdb->get_results($qry, ARRAY_A);
                     //print_tab($res);
                     //$tag= $zip."\t";
                     $count=0;
                     //$lastcity='';
                     foreach($users as $id=>$user) {
                         //echo 'user name: '.$user['name'].'<br>';
                         $found=false;
                         foreach($res as $k=>$re) {
                             $possible=substr(str_replace(array(' ','-','_','/'), '', strtolower(remove_accents($re['nom_commune']))),0,4);
                             $searched=substr(str_replace(array(' ','-','_','/'), '', strtolower(remove_accents($user['city']))),0,4);
                             //echo 'commune possible: '.$possible.'<br>';
                             //echo 'commune cherchée: '.$searched.'<br>';

                             if (!empty($searched) && strpos($possible, $searched)!==false) {
                                //echo 'found: '.$res[$k]['nom_commune'].'<br>';
                                $found=true;
                                break;
                             }
                         }
                         if ($found) {
                           if (!isset($out[$res[$k]['nom_commune']])) {
                             $out[$res[$k]['nom_commune']]=array('count'=>0);
                             $out[$res[$k]['nom_commune']]['lat']=$res[$k]['lat'];
                             $out[$res[$k]['nom_commune']]['lon']=$res[$k]['lon'];
                             $out[$res[$k]['nom_commune']]['zip']=$zip;
                             $lastcity=$res[$k]['nom_commune'];
                           }
                           $out[$res[$k]['nom_commune']]['name'][]=$user['name'];
                           $out[$res[$k]['nom_commune']]['count']++;
                         } else{
                           //wlog(LOG, 'wpcoop display_page() city not found for user : '.$id);
                           write_log('wpcoop admin display_page() city not found for user : '.$id);
                         }
                     }
                   }
                   //print_tab($out);
                   foreach ($out as $nom_commune=>$data) {
                      $tag='';
                      foreach ($data['name'] as $name) {
                         $tag.=$name."<br />";
                      }
                      fputs($outh, $data['lat']."\t".$data['lon']."\t<small>$nom_commune\t".$data['zip']."<br />".$tag."</small>\t$iconurl\t20,16\t0,-16\r\n");
                      fputs($outa, $data['lat']."\t".$data['lon']."\t<small>$nom_commune\t".$data['count']."</small>\t$iconurl\t20,16\t0,-16\r\n");
                   }


                }
                // close markers file
                if($outh)  fclose($outh);
                if($outa)  fclose($outa);
             }

                // number of solar panels (500€)
                $nsp=floor($tv/500);

                $spl=212-$nsp;
                update_option($this->plugin_prefix.'coop_values', array('date'=>date('Ymd'), 'subs_number'=>$n, 'subs_amount'=>$tv,
                                                                        'shares_number'=>$ts, 'solar_panels'=>$nsp, "sp_left"=>$spl ));


                echo '<tr>
                <td colspan="2">'.__('Number of subscribers:', $this->plugin_textdomain ).'</td>
                <td>'.$n.'</td>
                <td>'.__('Total amounts', $this->plugin_textdomain).'</td>
                <td style="text-align: right;">'.$tv.'</td>
                <td style="text-align: right;">'.$ts.'</td>
                <td><input type="submit" name ="'.$this->plugin_prefix.'get_all_user_docs'.'" value="'.__('Get All Users Docs', $this->plugin_textdomain).'" /></td></tr>';

                echo '<tr>
                    <td >'.__('Official register of shareholders', $this->plugin_textdomain).'
                    <td colspan="3"></td>
                    </td><td><input type="submit" name ="'.$this->plugin_prefix.'get_subs_oreg'.'" value="'.__('Get Official Register', $this->plugin_textdomain).'" /></td></tr>';

                echo '<tr>
                    <td >'.__('Idem sorted by initial date', $this->plugin_textdomain).'
                    <td colspan="3"></td>
                    </td><td><input type="submit" name ="'.$this->plugin_prefix.'get_subs_oreg_date'.'" value="'.__('Get Official Register', $this->plugin_textdomain).'" /></td></tr>';

                echo '<tr>
                    <td >'.__('Liste des Pouvoirs pour l\'AG ', $this->plugin_textdomain).'
                    <td colspan="3"></td>
                    </td><td><input type="submit" name ="'.$this->plugin_prefix.'get_subs_proxy'.'" value="'.__('Liste des Pouvoirs pour l\'AG', $this->plugin_textdomain).'" /></td></tr>';

                echo '<tr>
                    <td colspan="4">'.__('List of subscripions to validate', $this->plugin_textdomain).'
                    </td><td><input type="submit" name ="'.$this->plugin_prefix.'get_subs2val_list'.'" value="'.__('Get list of subscripions to validate', $this->plugin_textdomain).'" /></td></tr>';

                echo '<tr>
                    <td colspan="4">'.__('List of incomplete subscriptions', $this->plugin_textdomain).'
                    </td><td><input type="submit" name ="'.$this->plugin_prefix.'get_incsubs_list'.'" value="'.__('Get list of incomplete subscriptions', $this->plugin_textdomain).'" /></td></tr>';

                echo '<tr>
                    <td colspan="4">'.__('Title', $this->plugin_textdomain).'
                    <input type="text" name ="'.$this->plugin_prefix.'list_sheet_title'.'" value="" />
                    </td><td><input type="submit" name ="'.$this->plugin_prefix.'get_subs_list'.'" value="'.__('Get subscribers list', $this->plugin_textdomain).'" /></td></tr>';

                echo '<tr>
                    <td colspan="4">'.__('Title', $this->plugin_textdomain).'
                    <input type="text" name ="'.$this->plugin_prefix.'att_sheet_title'.'" value="" />'
                    .__('Empty pages', $this->plugin_textdomain).'
                    <input type="text" name ="'.$this->plugin_prefix.'att_sheet_ne'.'" value="" /></td>
                    <td><input type="submit" name ="'.$this->plugin_prefix.'get_att_sheet'.'" value="'.__('Get attendance sheet', $this->plugin_textdomain).'" /></td>
                    </tr>';
                echo '<tr>
                    <td colspan="4">'.__('Title', $this->plugin_textdomain).'
                    <input type="text" name ="'.$this->plugin_prefix.'att_raise_title'.'" value="" /></td>
                    <td><input type="submit" name ="'.$this->plugin_prefix.'get_att_raise'.'" value="'.__('Get raise sheet', $this->plugin_textdomain).'" /></td>
                    </tr>';

                echo '<tr>
                    <td colspan="4">'.__('Export csv files of all users', $this->plugin_textdomain).'
                    </td><td><input type="submit" name ="'.$this->plugin_prefix.'get_csv_list'.'" value="'.__('Export csv files of all users', $this->plugin_textdomain).'" /></td></tr>';
                ?>
                </table>
                </form>
                <?php
            } else {

              _e('No subscribers yet', $this->plugin_textdomain);

            }


        }

        public function get_subscriber_representative_prefix($id, $user) {
          return $this->get_subscriber_prefix($id, $user, true);
        }


        public function get_subscriber_prefix($id, $user, $rep=false) {
            $type = $this->get_member_type($id,$user);
            //print_tab($user);
            switch ($type) {
                // person with capability
                case 'c':
                    $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberperson_';
                    break;
                //institution
                case 'i':
                    $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberinstitution_';
                    if ($rep) $prefix=$this->plugin_prefix.$this->usersdata_prefix.'representative_';
                    break;
                // person with legal representative
                case 'm':
                    $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberperson_';
                    if ($rep) $prefix=$this->plugin_prefix.$this->usersdata_prefix.'representative_';
                    break;
                // type not set or unknown
                default:
                    $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberperson_';
            }
            return $prefix;

        }

         // issue documents
         // $ID user id
         // $lits true list type
         // $att attendance sheet
         // $title document title
         // $ne number of empty pages to add
         // $output output type default to doc (document), may be email or both (documentt+ email)
         public function issue_documents($ID, $list=false, $att=false, $title="", $ne=0, $out='doc') {

           global $wpcoop;
           // read options
           $coop_options = get_option($this->plugin_prefix.'options_coop');
           $shares_options = get_option($this->plugin_prefix.'options_shares');
           $management_options = get_option($this->plugin_prefix.'options_management');
           // get_option return false if option not exits or has no value : if so redirect to parameters
           if ( $coop_options===false || $shares_options===false || $management_options===false) {
               wp_redirect(admin_url().'admin.php?page=wpcoopshareholding');
           }
           //$logo = $coop_options['logo'];
           //$logourl=get_option($this->plugin_prefix.'options_coop_logo_url') ;
           $company = $coop_options['name']?? 'XXX';
           $created = $coop_options['created']?? 'XXX';
           $emb_company_name = $coop_options['embeded_name']?? 'XXX';
           $address = $coop_options['address']?? '// XXX: ';
           $town = $coop_options['town']?? 'XXX';
           $policies = $coop_options['policies']?? 'XXX';
           $pps = $wpcoop->shares->get_share_price();
           $auth_title = $management_options['title']?? 'XXX';
           $auth_name = $management_options['name']?? 'XXX';
           //$auth_signature = $management_options['signature'];

             // create read images authorization token
           $token=wp_create_nonce('coop_get_image');
           // have to authentify image request source without cookies -> use options
           update_option($wpcoop->plugin_prefix.'getimagetoken',$token);

           ini_set('user_agent',apply_filters( 'http_headers_useragent', $this->plugin_prefix.'plugin_@_'. get_bloginfo( 'url' ) ));

$old_method=false;
if ($old_method){
           //get company logo
           $url= get_option($wpcoop->plugin_prefix.'options_coop_logo_url');
           $url_logo = str_replace('TOKEN','getimagetoken='.$token, $url);
           wlog(LOG, 'issue_documents url_logo '.$url_logo);

           //get authority signature
           $url= get_option($wpcoop->plugin_prefix.'options_management_signature_url');
           $url_signature = str_replace('TOKEN','getimagetoken='.$token, $url);
           wlog(LOG, 'issue_documents url_signature '.$url_signature);
write_log('----------------------------------');
write_log($wpcoop->functions->get_secured_image_url('options_coop_logo_file','options_coop_logo_file_name',$token));
write_log('----------------------------------');


} else {

  //get company logo
  $url_logo =$wpcoop->functions->get_secured_image_url('options_coop_logo_file','options_coop_logo_file_name',$token);
  //echo $url_logo.'<br>';
  //write_log('issue_documents url_logo '.$url_logo);
  //get authority signature
  $url_signature =$wpcoop->functions->get_secured_image_url('options_authority_signature_file','options_authority_signature_file_name',$token);
  //write_log('issue_documents url_signature '.$url_signature);

}
           //
           if ($att==1) {
            include('gen-att.php');
           } elseif ($att==2) {
            include('gen-att-raise.php');
           } elseif ($list==1) {
            include('gen-list.php');
           } elseif ($list==2) {
            $order='';
            include('gen-oreg.php');
           } elseif ($list==21) {
            $order='date';
            include('gen-oreg.php');
           } elseif ($list==3) {
            $lt='v';
            include('gen-subs2val.php');
           } elseif ($list==4) {
            $lt='i';
            include('gen-subs2val.php');
           } elseif ($list==5) {
            include('gen-doc_cnil.php');
           } elseif ($list==6) {
            include('gen-export_csv.php');
           } elseif ($list==7) {
            include('gen-proxies_list.php');
           } else {
            include('gen-doc.php');
           }

           update_option($wpcoop->plugin_prefix.'getimagetoken','');

         }


        public function get_users($ID, $select='') {
            // $id==0 -> all users
            // select='' -> subscribers and not yet subscribers
            // select= 'subs -> subscribers only
            if ($ID==0) {
                $options=array();
                if ($select=='subs') {
                 $options=array( 'meta_key'=>$this->plugin_usersubs_meta);
                }
            } else {
                $options=array('include'=>array($ID));
                if ($select=='subs') {
                 $options=array( 'include'=>array($ID), 'meta_key'=>$this->plugin_usersubs_meta);
                }
            }
            return get_users( $options  );
        }

        // gestion des champs supplementaires

        public function get_user_data_fields() {

            return array(
             // xxx string exists in WP -> __('xxx')
             // xxx string doesn't exist in WP, translate it in plugin and -> __('xxx', $this->plugin_textdomain)
             'user_login'=>array('name'=>'pre_user_login',
                                 'label'=>__('Username'),
                                 'desc'=>__('Username')),
             'user_url'=>array('name'=>'pre_user_url',
                                 'label'=>__('Website'),
                                 'desc'=>__('Website')),
             'user_email'=>array('name'=>'pre_user_email',
                                 'label'=>__('Email'),
                                 'desc'=>__('User Email')),
             'display_name'=>array('name'=>'displayname',
                                 'label'=>__('Display Name'),
                                 'desc'=>__('Display Name')),
             'nickname'=>array('name'=>'pre_nickname',
                                 'label'=>__('Nickname'),
                                 'desc'=>__('Nickname')),
             'first_name'=>array('name'=>'pre_first_name',
                                 'label'=>__('First Name'),
                                 'desc'=>__('First Name')),
             'last_name'=>array('name'=>'pre_last_name',
                                 'label'=>__('Last Name'),
                                 'desc'=>__('Last Name')),
             'description'=>array('name'=>'pre_description',
                                 'label'=>__('Description'),
                                 'desc'=>__('Description'))
            /*
             'user_registered'=>array('name'=>$this->plugin_prefix.'pre_login',
                                 'label'=>__('Login', $this->plugin_textdomain),
                                 'desc'=>__('Id', $this->plugin_textdomain)),
             'role'=>      array('name'=>$this->plugin_prefix.'pre_login',
                                 'label'=>__('Login', $this->plugin_textdomain),
                                 'desc'=>__('Id', $this->plugin_textdomain)),
             'display_name'=>array('name'=>$this->plugin_prefix.'pre_display_name',
                                 'label'=>__('Display Name', $this->plugin_textdomain),
                                 'desc'=>__('Id', $this->plugin_textdomain)),
            */

            );

        }
      ////////////////////////////////////////////////////////////

        public function get_users_added_fields() {

            return apply_filters($this->plugin_prefix.'get_users_added_fields',
             array('tabs'=>array(
               array(
                 'slug'=>'membertype',
                 'class'=>'membertype',
                 'caption'=>__('Type of member', $this->plugin_textdomain),
                 'fields'=> array(
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'select',
                    'type'=>'',
                    'name'=>'type',
                    'id'=>'',
                    'caption'=>__('Type of member', $this->plugin_textdomain),
                    'desc'=>__('Personne: Physique majeure / Mineure/ sous administration légale| Institution / personne Morale', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'values'=>array($this, 'get_member_types')
                    ),
                   )
                 ),
               array(
                 'slug'=>'wp',
                 'class'=>'wp',
                 'caption'=>__('Wordpress account informations', $this->plugin_textdomain),
                 // as these are standard WP names, translation exists in WP -> no textdomain
                 'fields'=> array(
                     array(
                    'class'=>'',
                    'dis'=>'y',  // disabled, display only
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'user_login',
                    'id'=>'',
                    'caption'=>__('Username'),
                    'desc'=>__('auto-generated 3 first letters of lastname and firstname - read only', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''             // value
                    ),
                     array(
                    'class'=>'',
                    'dis'=>'y',  // disabled, display only
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'user_url',
                    'id'=>'',
                    'caption'=>__('Website'),
                    'desc'=>__('Web site url, if any - read only, see member', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'dis'=>'y',  // disabled, display only
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'user_email',
                    'id'=>'',
                    'caption'=>__('Email', $this->plugin_textdomain),
                    'desc'=>__('you@somewhere.tld  - read only, see member', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'dis'=>'y',  // disabled, display only
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'nickname',
                    'id'=>'',
                    'caption'=>__('Nickname', $this->plugin_textdomain),
                    'desc'=>__('same as username - read only', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'dis'=>'y',  // disabled, display only
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'first_name',
                    'id'=>'',
                    'caption'=>__('First Name', $this->plugin_textdomain),
                    'desc'=>__('First Name  - read only, see member', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''             // default value or comma separated select values
                    ),
                     array(
                    'class'=>'',
                    'dis'=>'y',  // disabled, display only
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'last_name',
                    'id'=>'',
                    'caption'=>__('Last Name', $this->plugin_textdomain),
                    'desc'=>__('Last Name - read only, see member', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''             // default value or comma separated select values
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'description',
                    'id'=>'',
                    'caption'=>__('Description'),
                    'desc'=>__('Description, of account if something specific', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                   )
                    //not in form: 'user_registered','role','display_name'
                    ),
               array(
                 'slug'=>'memberperson',
                 'class'=>'memberperson',
                 'caption'=>__('Coop Member (person)', $this->plugin_textdomain),
                 'fields'=> $this->get_person_fields()
                     ),
                 array(
                 'slug'=>'memberinstitution',
                 'class'=>'memberinstitution',
                 'caption'=>__('Coop Member (institution)',$this->plugin_textdomain),
                 'fields'=> array(
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'legalform',
                    'id'=>'',
                    'caption'=>__('Legal form', $this->plugin_textdomain),
                    'desc'=>__('Type of institution', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'name',
                    'id'=>'',
                    'caption'=>__('Name', $this->plugin_textdomain),
                    'desc'=>__('Institution name', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'siret',
                    'id'=>'',
                    'caption'=>__('Registration Number', $this->plugin_textdomain),
                    'desc'=>__('Registration Number', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'website',
                    'id'=>'',
                    'caption'=>__('Web Site', $this->plugin_textdomain),
                    'desc'=>__('Web site', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'user_email',
                    'id'=>'',
                    'caption'=>__('Email', $this->plugin_textdomain),
                    'desc'=>__('you@somewhere.tld', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'phone',
                    'id'=>'',
                    'caption'=>__('Phone', $this->plugin_textdomain),
                    'desc'=>__('international +xxx +33XXX without leading 0 for France', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'adr1',
                    'id'=>'',
                    'caption'=>__('Address', $this->plugin_textdomain),
                    'desc'=>__('Postal Address', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'adr2',
                    'id'=>'',
                    'caption'=>__('Address', $this->plugin_textdomain),
                    'desc'=>__('Postal Address', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'zip',
                    'id'=>'',
                    'caption'=>__('Zip code', $this->plugin_textdomain),
                    'desc'=>__('Postal Zip code', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'city',
                    'id'=>'',
                    'caption'=>__('City', $this->plugin_textdomain),
                    'desc'=>__('Postal City', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'country',
                    'id'=>'',
                    'caption'=>__('Country', $this->plugin_textdomain),
                    'desc'=>__('Country', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'textarea',
                    'type'=>'',
                    'name'=>'comments',
                    'id'=>'',
                    'caption'=>__('Comments', $this->plugin_textdomain),
                    'desc'=>__('Comments', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                   )
                 ),
                 array(
                 'slug'=>'representative',
                 'class'=>'representative',
                 'caption'=>__('Legal representative',$this->plugin_textdomain),
                 'fields'=> $this->get_person_fields()
                 ),
                 array(
                 'slug'=>'internal',
                 'class'=>'internal',
                 'caption'=>__('Coop Internal data', $this->plugin_textdomain),
                 'fields'=> array(
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'select',
                    'type'=>'',
                    'name'=>'category',
                    'id'=>'',
                    'caption'=>__('Category', $this->plugin_textdomain),
                    'desc'=>__('Category of membership', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'values'=>array($this, 'get_cats') // array of (keys values or function to get them)
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'select',
                    'type'=>'text',
                    'name'=>'college',
                    'id'=>'',
                    'caption'=>__('College', $this->plugin_textdomain),
                    'desc'=>__('College of membership', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'values'=> array($this, 'get_cols') // array of (keys values or function to get them)
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'checkbox',
                    'name'=>'edocok',
                    'id'=>'',
                    'caption'=>__('E-Documents OK', $this->plugin_textdomain),
                    'desc'=>__('Check if member is Ok to receive electronic documents ', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>'y'
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'firstcontact',
                    'id'=>'',
                    'caption'=>__('First contact', $this->plugin_textdomain),
                    'desc'=>__('Source of contact', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'textarea',
                    'type'=>'',
                    'name'=>'comments',
                    'id'=>'',
                    'caption'=>__('Comments', $this->plugin_textdomain),
                    'desc'=>__('Comments', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
/*
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'checkbox',
                    'name'=>'coop_admin',
                    'id'=>'',
                    'caption'=>__('Coop administrator', $this->plugin_textdomain),
                    'desc'=>__('Check if member is Coop administrator', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>'y'
                    ),
*/
                   ) // fields
                 ) // tab
                ) //tabs
             ) // array
          ); // apply filters

        }

        public function get_person_fields() {
            return array(
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'title',
                    'id'=>'',
                    'caption'=>__('Title', $this->plugin_textdomain),
                    'desc'=>__('M. Mme Dr.  ...', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'first_name',
                    'id'=>'',
                    'caption'=>__('First Name', $this->plugin_textdomain),
                    'desc'=>__('First Name', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'last_name',
                    'id'=>'',
                    'caption'=>__('Last Name', $this->plugin_textdomain),
                    'desc'=>__('Last Name', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'user_url',
                    'id'=>'',
                    'caption'=>__('Website', $this->plugin_textdomain),
                    'desc'=>__('Web site url, if any', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'user_email',
                    'id'=>'',
                    'caption'=>__('Email', $this->plugin_textdomain),
                    'desc'=>__('someone@somewhere.tld', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'birthname',
                    'id'=>'',
                    'caption'=>__('Birth Name', $this->plugin_textdomain),
                    'desc'=>__('if different of Lastname', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'birthdate',
                    'id'=>'',
                    'caption'=>__('Birth date', $this->plugin_textdomain),
                    'desc'=>__('Enter Birth Date as DD/MM/YYYY', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'validate'=>'date',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'birthplace',
                    'id'=>'',
                    'caption'=>__('Birth place', $this->plugin_textdomain),
                    'desc'=>__('Department (City) for France or City (Country) for abroad', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'nationality',
                    'id'=>'',
                    'caption'=>__('Nationality', $this->plugin_textdomain),
                    'desc'=>__('Nationality', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'phone',
                    'id'=>'',
                    'caption'=>__('Phone', $this->plugin_textdomain),
                    'desc'=>__('international +xxx +33XXX without leading 0 for France', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'mobile',
                    'id'=>'',
                    'caption'=>__('Mobile', $this->plugin_textdomain),
                    'desc'=>__('international +xxx +33XXX without leading 0 for France', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'adr1',
                    'id'=>'',
                    'caption'=>__('Address', $this->plugin_textdomain),
                    'desc'=>__('Street name', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'adr2',
                    'id'=>'',
                    'caption'=>__('Address', $this->plugin_textdomain),
                    'desc'=>__('Additional information', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'zip',
                    'id'=>'',
                    'caption'=>__('Zip code', $this->plugin_textdomain),
                    'desc'=>__('Zip code of residence', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'city',
                    'id'=>'',
                    'caption'=>__('City', $this->plugin_textdomain),
                    'desc'=>__('City of residence (Uppercases)', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'country',
                    'id'=>'',
                    'caption'=>__('Country', $this->plugin_textdomain),
                    'desc'=>__('Whole name: France...', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'input',
                    'type'=>'text',
                    'name'=>'job',
                    'id'=>'',
                    'caption'=>__('Job', $this->plugin_textdomain),
                    'desc'=>__('Job or activity', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                     array(
                    'class'=>'',
                    'wkfo'=>'',
                    'tag'=>'textarea',
                    'type'=>'',
                    'name'=>'comments',
                    'id'=>'',
                    'caption'=>__('Comments', $this->plugin_textdomain),
                    'desc'=>__('Comments', $this->plugin_textdomain),
                    'help'=>'',
                    'defvalue'=>'',
                    'value'=>''
                    ),
                   );
        }

        public function modify_contactmethods($profile_fields) {
            // Add new fields
            foreach($this->get_added_profile_fields() as $k=>$v) {
              $profile_fields[$k]=$v;
            }
	        return $profile_fields;
        }

        public function get_added_profile_fields() {
            return apply_filters('added_profile_fields', array(
                $this->plugin_prefix.'phone'    => __('Phone', $this->plugin_textdomain),
                $this->plugin_prefix.'adr1'     => __('Address', $this->plugin_textdomain),
                $this->plugin_prefix.'adr2'     => __('Address', $this->plugin_textdomain),
                $this->plugin_prefix.'zip'      => __('Postal Code', $this->plugin_textdomain),
                $this->plugin_prefix.'city'     => __('City', $this->plugin_textdomain),
                $this->plugin_prefix.'country'  => __('Country', $this->plugin_textdomain),

            ));


        }

        public function get_added_profile_category_fields() {
            return apply_filters('wpcoop_added_profile_category_fields', array(
                 array('id' => $this->plugin_prefix.'forme', 'name'=>$this->plugin_prefix.'forme', 'defvalue'=> __('_',$this->plugin_textdomain),
                       'label'=>__('Forme', $this->plugin_textdomain), 'desc'=>__('M., Mme, Société, Association...', $this->plugin_textdomain)),
                 array('id' => $this->plugin_prefix.'company', 'name'=>$this->plugin_prefix.'company', 'defvalue'=> __('_',$this->plugin_textdomain),
                       'label'=>__('Raison sociale', $this->plugin_textdomain), 'desc'=>__('Pour les personnes morales', $this->plugin_textdomain)),
                 array('id' => $this->plugin_prefix.'birthname', 'name'=>$this->plugin_prefix.'birthname', 'defvalue'=> __('_',$this->plugin_textdomain),
                       'label'=>__('Birth Name', $this->plugin_textdomain), 'desc'=>__('Enter you Birth Name if different from your name', $this->plugin_textdomain)),
                 array('id' => $this->plugin_prefix.'birthdate', 'name'=>$this->plugin_prefix.'birthdate', 'defvalue'=> __('_',$this->plugin_textdomain),
                       'label'=>__('Birth date', $this->plugin_textdomain), 'desc'=>__('Enter you Birth Date', $this->plugin_textdomain)),
                 array('id' => $this->plugin_prefix.'birthcountry', 'name'=>$this->plugin_prefix.'birthcountry', 'defvalue'=> __('_',$this->plugin_textdomain),
                       'label'=>__('Birth place', $this->plugin_textdomain), 'desc'=>__('Enter you Birth place', $this->plugin_textdomain)),
                 array('id' => $this->plugin_prefix.'nationality', 'name'=>$this->plugin_prefix.'nationality', 'defvalue'=> __('_',$this->plugin_textdomain),
                       'label'=>__('Nationality', $this->plugin_textdomain), 'desc'=>__('Nationality', $this->plugin_textdomain)),
                 array('id' => $this->plugin_prefix.'job', 'name'=>$this->plugin_prefix.'job', 'defvalue'=> __('_',$this->plugin_textdomain),
                       'label'=>__('Job', $this->plugin_textdomain), 'desc'=>__('Enter your job', $this->plugin_textdomain))

            ));
        }

        public function save_profile_category_fields( $ID ) {

             if ( !current_user_can( 'edit_user', $user_id ) ) { return false; }
                $fields=$this->get_added_profile_category_fields();
                foreach ($fields as $k=>$v) {
                 wlog(LOG, $v['name']. $_POST[$v['name']]);
                 update_user_meta( $ID, $v['name'], $_POST[$v['name']] );
                }

        }

        public function add_profile_category_fields($user) {
            wlog(LOG,$user->ID);
            ?>
            <h3><?php _e('Etat civil', $this->plugin_textdomain) ?></h3>
                <table class="form-table">
            <?php

            foreach ($this->get_added_profile_category_fields() as $k=>$v) {
            ?>
                    <tr>
                    <th><label for="<?php echo esc_attr($v['id']); ?>"><?php echo $v['label']; ?></label></th>
                    <td>
                    <input type="text" id="<?php echo esc_attr($v['id']); ?>"
                           name="<?php echo esc_attr($v['name']); ?>"
                           size="20"
                           value="<?php echo esc_attr( get_the_author_meta( $v['name'], $user->ID )); ?>">
                    <span class="description"><?php echo sanitize_text_field( $v['desc']); ?></span>
                    </td>
                    </tr>
            <?php
            }
            ?>
            </table>
            <?php

        }

        public function get_stepdata($i, $step) {
           global $wpcoop;
           //  'none'=>'Pas de nouvelle opération',
           //  'subsnok'=>'Dossier souscription incomplet',
           //  'subsok'=>'Dossier souscription complet',
           //  'pending'=>'Souscription en attente de validation',
             // all share relative status must begin with 'share'
           //  'shareok'=>'Parts validées',
           //  'sharenok'=>'Rachat de part(s) demandé',
           //  'sharenokack'=>'Rachat de part(s) validé',
           //  'sharenokexe'=>'Rachat de part(s) exécuté', // suppression des parts, fin eventuelle du societariat si pas d'autre part
           //  'sharenokdone'=>'Rachat de part(s) payé',
           //  'sharecessreq' => 'Demande de cession faite',
           //  'sharecessok' => 'Demande de cession accordee',
           //  'sharecessnok'=> 'Demande de cession refusee',  //-> doit generer sharenokexe article 12 des statuts
           //  'sharecessdone' => 'Cession faite' // -> fin eventuelle du societariat si pas d'autre part
            $pps=$wpcoop->shares->get_share_price();
            $val=$step['q'];
            if (strpos($step['s'],'share')!==false) {
             $unit='Parts';
             $val=$step['q']/$pps;
            } else {
             $unit='Euros';
            }

            $cv=0;
            $cs=0;
            switch ($step['s']) {
                case 'subsnok':
                    $cv+=$step['q'];
                    break;
                case 'subsok':
                    if ($i==0) $cv+=$step['q'];
                    break;
                case 'shareok':
                    $cs+=$step['q']/$pps;
                    break;
                case 'sharetok':
                    $cv+=$step['q'];
                    $cs+=$step['q']/$pps;
                    break;
                case 'sharenokexe':
                    $cs-=$step['q']/$pps;
                    $cv-=$step['q'];
                    break;
                case 'sharecessdone':
                    $cs-=$step['q']/$pps;
                    $cv-=$step['q'];
                    break;
            }

            return array('cs'=>$cs, 'cv'=>$cv, 'val'=>$val, 'unit'=>$unit);
        }

        public function get_user_shares_data($userid, $usersubs) {
          global $wpcoop;
			/*
		array('none'=>'Pas de nouvelle opération',
		*	 'subswft'=>'Souscription en attente de transfert',
		*	 'substok'=>'Dossier transfert complet',
			 'subsnok'=>'Dossier souscription incomplet',
			 'subsok'=>'Dossier souscription complet',
		*	 'pending'=>'Souscription en attente de validation', (ne sert a rien, a supprimer ?)
			 // all share relative status must begin with 'share'
		*	 'shareok'=>'Parts validées',
		*	 'sharetok'=>'Transfert de Parts effectué', (la souscription et les parts apparaissent au compte destinataire, doit correspondre à un sharecessdone à la même date)
		*	 'sharenok'=>'Rachat de part(s) demandé',
		*	 'sharenokack'=>'Rachat de part(s) validé',
		*	 'sharenokexe'=>'Rachat de part(s) exécuté',// -> fin eventuelle du societariat si pas d'autre part
		*	 'sharenokdone'=>'Rachat de part(s) payé', (opération trésorerie uniquement)
		*	 'sharecessreq' => 'Demande de cession faite',
		*	 'sharecessok' => 'Demande de cession accordée',
		*	 'sharecessnok'=> 'Demande de cession refusée',
		*	 'sharecesscanceled'=> 'Demande de cession annulée',
		*	 'sharecessdone' => 'Cession faite' // -> fin du eventuelle du societariat
		ATTENTION tant que pas automatique

			*/
            $created=$this->get_company_created();
            $createdok=$created!='' && $this->validate_date($created);
            // get yyyymmdd from dd/mm/yyyy
            $createdinv=substr($created,6,4).substr($created,3,2).substr($created,0,2);
            $pps=$wpcoop->shares->get_share_price();
            $datebeg='';
            $shares=0;
            $value=0;
            // parse operations; operations are ordered in time (that is: first operation first step is before second operation first step and so on)
            $value=0;
            if (empty($usersubs)) {
              $shares=0;
              $value=0;
              $datebeg='';
             } else {
				//if ($userid==1) print_tab($usersubs);
				foreach($usersubs as $o=>$steps) {
				  $recordval=false;
				  foreach($steps as $n=>$step){
				   if (in_array($step['s'],array('subsnok', 'subsok'))){
					  // new subscription begin with 'subsnok' or 'subsok'
					  // date is registered then
					  // add value only if not already registered
					  if (!$recordval){
						  if (empty($datebeg)) $datebeg=$step['d'];
						  $value+=$step['q'];
						  //if ($userid==1) echo '+'.$step['q'].'<br>';
						  $recordval=true;
					  }
				   } elseif ($step['s']=='shareok'){
					  // add shares only when validated
					  $shares+=$step['q']/$pps;
				   } elseif ($step['s']=='sharetok'){
		        // transfert done, record date, value, share
            if (empty($datebeg)) $datebeg=$step['d'];
		        $value+=$step['q'];
  					$shares+=$step['q']/$pps;
				   } elseif (in_array($step['s'],array('sharenokexe', 'sharecessdone'))){
					        // substract shares and subscription value, remove date if 0
					        $value-=$step['q'];
					        $shares-=$step['q']/$pps;
                  if ($value==0) $datebeg='';
				   } elseif (in_array($step['s'], array('subswft', 'substok', 'pending',
								  'sharenok', 'sharenokack', 'sharenokdone',
								  'sharecessreq', 'sharecessok', 'sharecessnok',
								  'sharecesscanceled'))){
					// do nothing
				   }
				  }
            	}
            	// subscription date cannot be before company was created
            	if($createdok) {
               		// get yyyymmdd from ddmmyyyy
               		$datebeginv=substr($datebeg,4,4).substr($datebeg,2,2).substr($datebeg,0,2);
               		if (!empty($datebeg) && $datebeginv < $createdinv ) {
						// if company created after, set date to company creation date
						// set to ddmmyyyy from yyyymmdd
						$datebeg=substr($created,0,2).substr($created,3,2).substr($created,6,4);
               		}
            	}


            }
            return array('shares'=>$shares, 'value'=>$value, 'date'=>$datebeg);
        }

        public function get_user_shares_data_old($userid, $usersubs) {
            global $wpcoop;
            $created=$this->get_company_created();
            $createdok=$created!='' && $wpcoop->function->validate_date($created);
            // get yyyymmdd from dd/mm/yyyy
            $createdinv=substr($created,6,4).substr($created,3,2).substr($created,0,2);
            $pps=$wpcoop->shares->get_share_price();
            $datebeg='';
            $shares=0;
            $value=0;
            // parse operations; operations are ordered in time (that is: first operation first step is before second operation first step and so on)
            $value=0;
            if (empty($usersubs)) {
              $shares=0;
              $value=0;
              $datebeg='';
             } else {
            foreach($usersubs as $o=>$steps) {
               $fs=reset($steps);
               $ls=end($steps);
               // test status of LAST status
               // subscriptions added
               if ($ls['s']=='subsok' || $ls['s']=='subsnok' || $ls['s']=='pending'){
                   $value+=$ls['q'];
                   if (empty($datebeg)) $datebeg=$fs['d'];
               } elseif ($ls['s']=='shareok' || $ls['s']=='sharenok' || $ls['s']=='sharenokack'
                                             || $ls['s']=='sharecessreq' || $ls['s']=='sharecessok' || $ls['s']=='sharecessnok'  ) {
                   // shares and subscription added
                   $value+=$ls['q'];
                   $shares+=$ls['q']/$pps;
                   if (empty($datebeg)) $datebeg=$fs['d'];
               } elseif ($ls['s']=='sharenokexe' || $ls['s']=='sharenokdone' || $ls['s']=='sharecessdone') {
               // shares and subscription NOT added date reset
               // sharenokexe sharenokdone sharecessdone
                 $datebeg='';
               }
            }
            // subscription date cannot be before company was created
            if($createdok) {
               // get yyyymmdd from ddmmyyyy
               $datebeginv=substr($datebeg,4,4).substr($datebeg,2,2).substr($datebeg,0,2);
               if (!empty($datebeg) && $datebeginv < $createdinv ) {
                 // if company created after, set date to company creation date
                 // set to ddmmyyyy from yyyymmdd
                 $datebeg=substr($created,0,2).substr($created,3,2).substr($created,6,4);
               }
            }


            }
            return array('shares'=>$shares, 'value'=>$value, 'date'=>$datebeg);
        }

        public function senduserdoc($userid, $usersubs) {
         $this->issue_documents($userid, null, null, null, null, $out='email');
        }

        public function get_member_type($id, $user) {
            return apply_filters( $this->plugin_prefix.'get_member_type',
                (isset($user[$this->plugin_prefix.$this->usersdata_prefix.'membertype_type'])
                && in_array($user[$this->plugin_prefix.$this->usersdata_prefix.'membertype_type'], array_keys($this->get_member_types()) )) ?
                $user[$this->plugin_prefix.$this->usersdata_prefix.'membertype_type'] : '0', $id, $user);
        }

        public function get_member_category($id, $user) {
            return apply_filters( $this->plugin_prefix.'get_member_category',
                (isset($user[$this->plugin_prefix.$this->usersdata_prefix.'internal_category'])
                && in_array($user[$this->plugin_prefix.$this->usersdata_prefix.'internal_category'], array_keys($this->get_cats()) )) ?
                $user[$this->plugin_prefix.$this->usersdata_prefix.'internal_category'] : '0', $id, $user);
        }

        public function get_thedisplayname($id,$user,$prefix, $np=false) {
            // with $prefix representative prefix
            //print_tab($user);
            if (!$np) {
                $thedisplayname= ($user[$prefix.'first_name'])?? '';
                $thedisplayname= (empty($thedisplayname))? ($user[$prefix.'last_name'])?? '' : $thedisplayname.' '.($user[$prefix.'last_name'])?? '';
                $thedisplayname2=(empty($thedisplayname))? sprintf(__('User ID %1$s, %2$s', $this->plugin_textdomain), $id, $user['display_name']) : $thedisplayname;
                $thedisplayname= (empty($thedisplayname))? $thedisplayname2 : ((empty($user[$prefix.'title']))? $thedisplayname : $user[$prefix.'title'].' '.$thedisplayname);
            } else {
                $thedisplayname= ($user[$prefix.'last_name'])?? '';
                $thedisplayname= (empty($thedisplayname))? ($user[$prefix.'first_name'])?? '' : $thedisplayname.' '.($user[$prefix.'first_name'])?? '';
                $thedisplayname2=(empty($thedisplayname))? sprintf(__('User ID %1$s, %2$s', $this->plugin_textdomain), $id, $user['display_name']) : $thedisplayname;
                $thedisplayname= (empty($thedisplayname))? $thedisplayname2 : $thedisplayname;
            }
            return $thedisplayname;
        }

        public function get_thecity($id,$user,$prefix){
            return $user[$prefix.'city'];
        }

        public function get_thephones($id,$user,$prefix){
            return $user[$prefix.'phone'].'/'.$user[$prefix.'mobile'];
        }

        public function get_theemail($id,$user,$prefix){
            return $user[$prefix.'user_email'];
        }

        public function get_thecompany($id, $user, $prefix, $full=true) {
            return (isset($user[$prefix.'legalform']) && isset($user[$prefix.'name']))?
            (($full)? $user[$prefix.'legalform'].' '.$user[$prefix.'name'] : $user[$prefix.'name']) : '';
        }

        public function get_thedisplaydata($id, $user, $np=false) {
            $cat = $this->get_member_category($id,$user);
            switch ($cat) {
             //1 producteurs/salariés
                case '1';
                    $dcat='p';
                    break;
                case '2':
                    $dcat='b';
                    break;
                case '3':
                    $dcat='s';
                    break;
                case '4':
                    $dcat='c';
                    break;
                default:
                    $dcat='?';
            }

            $type = $this->get_member_type($id,$user);
            $representing='';
            $institution = '';
            switch ($type) {
                // person with capability
                case 'c':
                    $dtype='p';
                    $prefix=$this->get_subscriber_prefix($id,$user);
                    $thedisplayname=$this->get_thedisplayname($id,$user,$prefix, true);
                    break;
                //institution
                case 'i':
                    $dtype='m';
                    $prefix=$this->get_subscriber_representative_prefix($id,$user);
                    $thedisplayname=$this->get_thedisplayname($id,$user,$prefix, true);
                    $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberinstitution_';
                    $institution = $user[$prefix.'legalform']." ".$user[$prefix.'name']."\n";
                    $representing=$institution;
                    break;
                // person with legal representative
                case 'm':
                    $dtype='a';
                    $prefix=$this->get_subscriber_prefix($id,$user);
                    $thedisplayname=$this->get_thedisplayname($id,$user,$prefix, true);
                    $prefix=$this->get_subscriber_representative_prefix($id,$user);
                    $representing=$this->get_thedisplayname($id,$user,$prefix, true);
//                    $thedisplayname=$this->get_thedisplayname($id,$user,$prefix, true);
                    break;
                // type not set or unknown
                default:
                    $dtype='?';
                    $prefix=$this->get_subscriber_representative_prefix($id,$user);
                    $thedisplayname=$this->get_thedisplayname($id,$user,$prefix, true);
            }
            $city=$this->get_thecity($id,$user,$prefix);
            $phones=$this->get_thephones($id,$user,$prefix);
            $email=$this->get_theemail($id,$user,$prefix);
            return array('dcat'=>$dcat, 'dtype'=>$dtype, 'thedisplayname'=>$thedisplayname, 'institution'=>$institution, 'phones'=>$phones, 'city'=>$city, 'email'=>$email, 'representing'=>$representing);
        }

  } //class
} // if class exits
