<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( class_exists( 'WPCOOP_Admin' ) &&
    !class_exists( 'WPCOOP_Admin_Parameters' )) {

 class WPCOOP_Admin_Parameters extends WPCOOP_Admin {

   public function __construct(){
     //parent::__construct();
     global $wpcoop;
     $this->plugin_version = $wpcoop->plugin_version;
     $this->plugin_prefix = $wpcoop->plugin_prefix;
     //$this->usersdata_prefix = $wpcoop->usersdata_prefix;
     $this->plugin_dir_path = $wpcoop->plugin_dir_path;
     $this->includes_path = $wpcoop->includes_path;

     //$this->plugin_markers_file_path = $wpcoop->plugin_markers_file_path;
     //$this->subs_geo_markers_filename = $wpcoop->subs_geo_markers_filename;

     $this->plugin_textdomain = $wpcoop->plugin_textdomain;

     //$this->plugin_read_capability=$wpcoop->plugin_read_capability;
     //$this->plugin_edit_capability=$wpcoop->plugin_edit_capability;
     //$this->plugin_parameters_capability=$wpcoop->plugin_parameters_capability;
     $this->plugin_settings_capability=$wpcoop->plugin_settings_capability;

//            $this->possible_statuses = $wpcoop->shares->get_possible_statuses();

     //$this->plugin_usersubs_meta=$wpcoop->plugin_usersubs_meta;

     // some parameters for this class
     // admin page slug name
     $this->class_slug = 'wpcoop';
     // paramaters & shareholding & events pages slugs names
     //$this->class_events_slug= $this->class_slug.'events';
     $this->class_parameters_slug = $this->class_slug.'parameters';
     //$this->class_shareholding_slug= $this->class_slug.'shareholding';

     if (!$this->load_config()) {
         add_action( 'admin_notices', array($this,'dashboard_error_notice'));
     }

     add_action( 'admin_init', array( $this, 'init_parameters_options' ));
     //$this->load_parameters_page();
   }

   public function dashboard_error_notice(){
     ?>
       <div class="error notice is-dismissible">
       <p><?php _e( $this->plugin_prefix.'config.php not found for wpcoop plugin, contact site administrator', $this->plugin_textdomain ); ?></p>
       </div>
       <?php
   }

   public function load_config(){
     if (file_exists($this->plugin_dir_path.$this->plugin_prefix.'config.php')){
        include($this->plugin_dir_path.$this->plugin_prefix.'config.php');
        return true;
     }
     return false;
   }

   public function load_parameters_page(){
     if (file_exists($this->includes_path.'classes_includes/parameters_page.php')){
        include($this->includes_path.'classes_includes/parameters_page.php');
        return true;
     }
     return false;
   }

   function init_parameters_options() {
       // get options
       $options=$this->get_options_tabs('options');
       // registers options groups
       foreach($options as $option) {
         if(!is_array($option['group'])) {
           register_setting($option['group'],$option['name'],$option['callback']);
         } else {
             //print_tab($option);
          foreach($option['group'] as $i=>$group){
              //echo 'register_settings '.$group.'<br>';
              //echo 'register_settings '.$option['name'][$i].'<br>';
              //echo 'register_settings '.$option['callback'][$i][1].'<br>';
              register_setting($group,$option['name'][$i],$option['callback'][$i]);
          }
         }
       }
   }

   public function get_coop_parameters_active_tabs(){
     return apply_filters($this->plugin_prefix.'coop_parameters_active_tabs', $this->coop_parameters_active_tabs);
   }

   public function get_coop_types_options(){
    return apply_filters($this->plugin_prefix.'get_coop_types_options', $this->coop_types_options);
   }

   public function get_coop_legal_forms_options(){
        return apply_filters($this->plugin_prefix.'get_coop_legal_forms_options', $this->coop_legal_forms);
   }

   public function display_sel_options($selopts, $selopt=''){
     foreach ($selopts as $val=>$lib){
                echo '<option value="'.esc_attr($val).'" '.(($selopt==$val)? 'selected="selected"' : '').'>'.esc_html($lib).'</option>';
     }
   }




   public function get_options_tabs($info='') {
     $medias=
           array(
                  'tabs'=> array(
           array( 'slug'=>'coop', 'caption'=>__('Cooperative',$this->plugin_textdomain)),
           array( 'slug'=>'shares', 'caption'=>__('Shareholding',$this->plugin_textdomain)),
           array( 'slug'=>'cats', 'caption'=>__('Categories',$this->plugin_textdomain)),
           array( 'slug'=>'cols', 'caption'=>__('Colleges',$this->plugin_textdomain)),
           array( 'slug'=>'management', 'caption'=>__('Management',$this->plugin_textdomain)),
           array( 'slug'=>'councils', 'caption'=>__('Councils',$this->plugin_textdomain)),
           array( 'slug'=>'ags', 'caption'=>__('AGS',$this->plugin_textdomain)),
           array( 'slug'=>'meetings', 'caption'=>__('Meetings',$this->plugin_textdomain)),
           array( 'slug'=>'projects', 'caption'=>__('Projects',$this->plugin_textdomain)),
           array( 'slug'=>'promositems', 'caption'=>__('Promos Items',$this->plugin_textdomain)),
           array( 'slug'=>'subs', 'caption'=>__('Subscriptions',$this->plugin_textdomain)),
           array( 'slug'=>'inlineitems', 'caption'=>__('In line Items',$this->plugin_textdomain)),
                                ),
                 'options'=> array(
           array( 'group'=>
                 array(
                     $this->plugin_prefix.'options_coop_group',
                     $this->plugin_prefix.'options_coop_logo_file_group',
                     ),
                 'name'=>
                 array(
                     $this->plugin_prefix.'options_coop',
                     $this->plugin_prefix.'options_coop_logo_file_name',
                     ),
                 'callback'=>
                 array(
                     array($this, 'validate_options_coop'),
                     array($this, 'validate_options_coop_logo_file_name'),
                     ),
                ),
           array( 'group'=>$this->plugin_prefix.'options_cats_group', 'name'=>$this->plugin_prefix.'options_cats','callback'=>array($this, 'validate_options_cats')),
           array( 'group'=>$this->plugin_prefix.'options_cols_group', 'name'=>$this->plugin_prefix.'options_cols','callback'=>array($this, 'validate_options_cols')),
           array( 'group'=>$this->plugin_prefix.'options_shares_group', 'name'=>$this->plugin_prefix.'options_shares','callback'=>array($this, 'validate_options_shares')),
           array( 'group'=>$this->plugin_prefix.'options_councils_group', 'name'=>$this->plugin_prefix.'options_councils', 'callback'=>array($this, 'validate_options_councils')),
           array( 'group'=>$this->plugin_prefix.'options_ags_group', 'name'=>$this->plugin_prefix.'options_ags', 'callback'=>array($this, 'validate_options_ags')),
           array( 'group'=>
                 array(
                     $this->plugin_prefix.'options_management_group',
                     $this->plugin_prefix.'options_authority_signature_file_group',
                     ),
                 'name'=>
                 array(
                     $this->plugin_prefix.'options_management',
                     $this->plugin_prefix.'options_authority_signature_file_name',
                     ),
                 'callback'=>
                 array(
                     array($this, 'validate_options_management'),
                     array($this, 'validate_options_authority_signature_file_name'),
                     )
                 ),
           array( 'group'=>$this->plugin_prefix.'options_meetings_group', 'name'=>$this->plugin_prefix.'options_meetings', 'callback'=>array($this, 'validate_options_meetings')),
           array( 'group'=>$this->plugin_prefix.'options_projects_group', 'name'=>$this->plugin_prefix.'options_projects', 'callback'=>array($this, 'validate_options_projects')),
           array( 'group'=>$this->plugin_prefix.'options_promositems_group', 'name'=>$this->plugin_prefix.'options_promositems', 'callback'=>array($this, 'validate_options_promositems')),
           array( 'group'=>$this->plugin_prefix.'options_inlineitems_group', 'name'=>$this->plugin_prefix.'options_inlineitems', 'callback'=>array($this, 'validate_options_inlineitems')),
           array(
               'group'=>
               array(
                   $this->plugin_prefix.'options_bs1_file_group',
                   $this->plugin_prefix.'options_bs2_file_group',
                   $this->plugin_prefix.'options_dis1_file_group',
                   $this->plugin_prefix.'options_dis2_file_group',
                   ),
               'name'=>
               array(
                   $this->plugin_prefix.'options_bs1_file',
                   $this->plugin_prefix.'options_bs2_file',
                   $this->plugin_prefix.'options_dis1_file',
                   $this->plugin_prefix.'options_dis2_file',
                   ),
                   'callback'=>
               array(
                   array($this, 'validate_options_bs1_file'),
                   array($this, 'validate_options_bs2_file'),
                   array($this, 'validate_options_dis1_file'),
                   array($this, 'validate_options_dis2_file'),
                   )
                )),
                  'actions'=> array(
           array( 'slug'=>'coop'),
           array( 'slug'=>'management')
                )
         );
   $medias=apply_filters('wpcoop_options_tabs',$medias);
   switch($info) {
    case 'tabs':
     $ret=$medias['tabs'];
     break;
    case 'options':
     $ret=$medias['options'];
     break;
    case 'actions':
     $ret=$medias['actions'];
     break;
    default:
     $ret=$medias;
   }
   return $ret;
 }

 public function validate_options_coop($input) {
   //write_log('WPCOOP validate_options_coop');
   //write_log($input);
  foreach($input as $k=>$v) {
     if ($k=='created') write_log('WPCOOP created '.$k.' '.$v);
     $input[$k]= (string) $v;
     if ($k=='type' && !in_array($v, array_keys($this->get_coop_types_options())))  {
         add_settings_error( $this->plugin_prefix.'options_coop', 'invalid-type', __("Invalid company type", $this->plugin_textdomain ));
         $input[$k]=$this->get_coop_types_options()[0];
     }
     if ($k=='form' && !in_array($v, array_keys($this->get_coop_legal_forms_options()))) {
          add_settings_error( $this->plugin_prefix.'options_coop', 'invalid-legal-form', __("Invalid company legal form", $this->plugin_textdomain ));
         $input[$k]=$this->get_coop_legal_forms_options()[0];
     }
     if ($k=='created' && !$this->validate_date($v)) {
       add_settings_error( $this->plugin_prefix.'options_coop', 'invalid-date', __("Invalid date", $this->plugin_textdomain ));
     }
     if (empty($v)) {
       add_settings_error( $this->plugin_prefix.'options_coop', 'empty-field', sprintf(__("Empty field !!!!%s", $this->plugin_textdomain ), ''));
       //write_log('WPCOOP PARAMS empty '.$k.' '.$v);
     }
   }
   return apply_filters($this->plugin_prefix.'validate_options_coop', $input);
 }

 // display and permits update of image given by options
  public function display_secured_image_update_form($args) {

  $defs=array(//'option'=>'xxxx',
           'title'=>__("Image to change (max size %sk)",$this->plugin_textdomain),
           'change'=>__('Change image ',$this->plugin_textdomain),
           'name'=>'options_xxxx_file', // name of file select button
           'max_file_size'=>'102400',
           'update'=>__('Update image',$this->plugin_textdomain),
           'store_option'=>'xxxx'// option where to store file
          );
  $args=wp_parse_args($args, $defs);
  $komax=floor(((int) $args['max_file_size'])/1024);
  $ar_image=get_option($this->plugin_prefix.$args['store_option']);
  ?>
  <div>
  <table class="form-table">
   <tr>
       <td><?php echo esc_html(sprintf($args['title'],$komax)); ?></td>
       <td><?php
  echo (empty($ar_image) || !isset($ar_image['type'])
                      || !isset($ar_image['data']))?
   '' : '<img width="100px"  src="data:'.$ar_image['type'].';base64,'.$ar_image['data'].'"/>' ?></td>
       <td><?php echo esc_html($args['change']); ?>
        <input type="hidden" name="MAX_FILE_SIZE" value="<?php echo $args['max_file_size']; ?>" />
        <input type="file" name="<?php echo $this->plugin_prefix.$args['name']; ?>" />
       </td>
   </tr>
  </table>
  <p class="submit">
   <input type="submit" class="button-primary" value="<?php echo esc_html($args['update']); ?>" />
  </p>
  </div>
  <?php
  }

  public function validate_options_bs1_file($input) {
    $ret = $this->validate_uploaded_file(array(
      'option'      =>$this->plugin_prefix.'options_bs1',
    ));
    return ($ret===false)? get_option($this->plugin_prefix.'options_bs1') : $ret;
  }

  public function validate_options_bs2_file($input) {
    $ret = $this->validate_uploaded_file(array(
      'option'      =>$this->plugin_prefix.'options_bs2',
    ));
    return ($ret===false)? get_option($this->plugin_prefix.'options_bs2') : $ret;
  }

  public function validate_options_dis1_file($input) {
    $ret = $this->validate_uploaded_file(array(
      'option'      =>$this->plugin_prefix.'options_dis1',
    ));
    return ($ret===false)? get_option($this->plugin_prefix.'options_dis1') : $ret;
  }

  public function validate_options_dis2_file($input) {
    $ret = $this->validate_uploaded_file(array(
      'option'      =>$this->plugin_prefix.'options_dis2',
    ));
    return ($ret===false)? get_option($this->plugin_prefix.'options_dis2') : $ret;
  }


  public function validate_options_coop_logo_file_name($input){
    // on submit $input contains nothing, date is in $_FILES
    // validate_uploaded_file store file and return file name
    $ret = $this->validate_uploaded_file(array(
      'store_option'=>$this->plugin_prefix.'options_coop_logo_file',
    ));
    return ($ret===false)? get_option($this->plugin_prefix.'options_coop_logo_file_name') : $ret;
  }

  public function validate_options_authority_signature_file_name($input){
    // on submit $input contains nothing, date is in $_FILES
    // validate_uploaded_file store file and return file name
    $ret = $this->validate_uploaded_file(array(
      'store_option'=>$this->plugin_prefix.'options_authority_signature_file',
    ));
    return ($ret===false)? get_option($this->plugin_prefix.'options_authority_signature_file_name') : $ret;
  }

  public function validate_uploaded_file($args){
     // on submit $input contains nothing, date is in $_FILES
     // validate_uploaded_file store file and return file name
     $optionname=$args['store_option'];
     if (isset($_FILES[$optionname]) && is_array($_FILES[$optionname])) {
           $tmp=$_FILES[$optionname];
           if (isset($tmp['tmp_name']) && is_file($tmp['tmp_name']) && (!isset($tmp['error']) || $tmp['error']==UPLOAD_ERR_OK) && is_uploaded_file($tmp['tmp_name'])) {
            // is_uploaded_file
            if ($r=@fopen($tmp['tmp_name'], "r")) {
             //$data=fread($r, $tmp['size']);
             update_option($optionname,
             array('name'=>$tmp['name'],
                          'type'=>$tmp['type'],
                          'size'=>$tmp['size'],
                          'data'=>base64_encode(fread($r, $tmp['size']))),'no'); // no autoload option
             write_log($tmp['tmp_name']);
             return $tmp['name'];
            } else {
              add_settings_error( $optionname,'TMP_FILE_NOT_READ', __("The temporary file could not be read", $this->plugin_textdomain ));
            }
           } else {
            if (!isset($tmp['tmp_name']))  {
              add_settings_error( $optionname,'TMP_FILE_NAME_NOT_SET',__("The temporary file name was not set", $this->plugin_textdomain ));
            }
            if (isset($tmp['tmp_name']) && !empty($tmp['tmp_name']) && !is_file($temp['tmp_name']))  {
              add_settings_error( $optionname,'TMP_FILE_NOT_FOUND',__("The temporary file name was not found", $this->plugin_textdomain ));
            }
            if (isset($tmp['tmp_name']) && !empty($tmp['tmp_name']) && is_file($temp['tmp_name']) && !is_uploaded_file($tmp['tmp_name']))  {
              add_settings_error( $optionname,'TMP_FILE_NOT_UPLOADED',sprintf(__("Temporary file name was not uploaded -security break?- : %s", $this->plugin_textdomain ),$tmp['name']));
            }

            if (isset($tmp['error']) && $tmp['error']!=0) {
               switch ($tmp['error']) {
                  case UPLOAD_ERR_INI_SIZE:
                      add_settings_error( $optionname,'UPLOAD_ERR_INI_SIZE',__("The uploaded file exceeds the upload_max_filesize directive in php.ini", $this->plugin_textdomain ));
                      break;
                  case UPLOAD_ERR_FORM_SIZE:
                      add_settings_error( $optionname,'UPLOAD_ERR_FORM_SIZE',__("The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form", $this->plugin_textdomain ));
                      break;
                  case UPLOAD_ERR_PARTIAL:
                      add_settings_error( $optionname,'UPLOAD_ERR_PARTIA',__("The uploaded file was only partially uploaded", $this->plugin_textdomain ));
                      break;
                  case UPLOAD_ERR_NO_FILE:
                      add_settings_error( $optionname,'UPLOAD_ERR_NO_FILE',__("No file was uploaded", $this->plugin_textdomain ));
                      break;
                  case UPLOAD_ERR_NO_TMP_DIR:
                      add_settings_error( $optionname,'UPLOAD_ERR_NO_TMP_DIR',__("Missing a temporary folder", $this->plugin_textdomain ));
                      break;
                  case UPLOAD_ERR_CANT_WRITE:
                      add_settings_error( $optionname,'UPLOAD_ERR_CANT_WRITE',__("Failed to write file to disk", $this->plugin_textdomain ));
                      break;
                  case UPLOAD_ERR_EXTENSION:
                      add_settings_error( $optionname,'UPLOAD_ERR_EXTENSION',__("File upload stopped by extension", $this->plugin_textdomain ));
                      break;
                  default:
                      add_settings_error( $optionname,'UPLOAD_ERR_UNKNOWN',__("Unknown upload error", $this->plugin_textdomain ));
                      break;
              }
            } // error #
           } // read error
          }
       return false;
      }

      public function manage_secured_pdf($args) {
          $defs=array(
                      'option_group'=>'xxxx',
                      'option'=>'xxxx',
                      'title'=>__("Image to change",$this->plugin_textdomain),
                      'change'=>__('Change image: ',$this->plugin_textdomain),
                      'name'=>'options_xxxx_file',
                      'max_file_size'=>'500000',
                      'update'=>__('Update image',$this->plugin_textdomain),
                     );

          $args=wp_parse_args($args, $defs);

          $ar_file=get_option($args['option']);

          //print_tab($ar_file);

          echo '<form enctype="multipart/form-data" method="post" action="options.php" >';
          settings_fields($args['option_group']);
          echo '<input type="hidden" name="MAX_FILE_SIZE" value="'.esc_attr($args['max_file_size']).'" />';

          ?>
           <div>
             <table class="form-table">
              <tr>
                  <td><?php echo esc_html($args['title']); ?></td>
                  <td><?php echo (empty($ar_file))? '<span style="color: red;">AUCUN</span>' : esc_html($ar_file['name']) ?></td>
                  <td><?php echo esc_html($args['change']) ?>
                   <input type="file" name="<?php echo esc_attr($args['option']) ?>" />
                  </td>
              </tr>
             </table>
             <p class="submit">
              <input type="submit" class="button-primary" value="<?php echo esc_html($args['update']); ?>" />
             </p>
           </div>
          <?php
          echo '</form>';
      }


      public function validate_options_promositems($input) {
        foreach($input as $k=>$v) {
          if (in_array($k, array('monkitsolaire'))) { $input[$k]= 'y'; } else { unset($input[$k]); }
        }
        return apply_filters($this->plugin_prefix.'validate_options_promositems', $input);
      }

      public function validate_options_ags($input) {
        $wrongdates=false;
        foreach($input as $k=>$v) {
          if (! $this->validate_date($v)){
            $wrongdates=true;
            add_settings_error( $optionname,'invalid-date',__("Date invalide", $this->plugin_textdomain ));
          }
        }
        if (!$wrongdates && $input['datepouvoir']>=$input['dateag'] )  add_settings_error( $optionname,'invalid-dates',__("La date des pouvoirs doit être avant la date de l'AG", $this->plugin_textdomain ));
        return apply_filters($this->plugin_prefix.'validate_options_ags', $input);
      }


      // date : dd/mm/yyyy
      public function validate_date($maybedate) {
        return ( empty($maybedate) || strlen($maybedate)!=10 ||
                !checkdate( (int) substr($maybedate, 3, 2), (int) substr($maybedate, 0, 2), (int) substr($maybedate, 6, 4) ) )? false : true;

      }


 }
}
