<?php
/**
 * Exit if accessed directly
 */

/// alm 20210419 14:16


if ( !defined( 'ABSPATH' ) ) {
    exit;
}
if ( !class_exists( 'WPCOOP_Functions' ) ) {

    class WPCOOP_Functions {

      public function __construct() {
          global $wpcoop;
          // copy some parameters from wpcoop
          $this->plugin_version = $wpcoop->plugin_version;
          $this->plugin_prefix = $wpcoop->plugin_prefix;
          //$this->usersdata_prefix = $wpcoop->usersdata_prefix;
          //$this->plugin_dir_path = $wpcoop->plugin_dir_path;
          //$this->includes_path = $wpcoop->includes_path;

          $this->plugin_textdomain = $wpcoop->plugin_textdomain;

          $this->plugin_usersubs_meta=$wpcoop->plugin_usersubs_meta;
      }

      public function get_company_created() {
         $options_coop = get_option($this->plugin_prefix.'options_coop');
         return apply_filters($this->plugin_prefix.'get_company_created', $options_coop['created']);
       }

      public function admin_add_actions() {
         if ( ( @include 'actions.php' ) === FALSE ) _e('actions.php file not found', $this->plugin_textdomain);
      }

        public function get_possible_actions() {

            return apply_filters ('wpcoop_get_possible_actions',
                   array('regsubsnok'=>'Enregistrement dossier souscription incomplet',
                         'delsubs'=>'Suppression souscription',
                         'regsubsok'=>'Energistrement dossier souscription complet',
                         'subsnokok'=>"Validation d'un dossier de souscription incomplet",
                         'subsok'=>"Validation d'un dossier de souscription complet",
                         'subsokack'=>'Prise en compte du dossier de souscription',
                         'subswait'=>'Souscription en attente de validation',
                         'shareval'=>'Parts validées',
                         'sharenok'=>'Rachat de part(s) demandé',
                         'sharenokack'=>'Rachat de part(s) validé',
                         'sharenokdone'=>'Rachat de part(s) exécuté', //
                         'sharenokpaid'=>'Rachat de part(s) payé',
                         'sharecessreq' => 'Demande de cession faite',
                         'sharecessok' => 'Demande de cession accordee', //-> fin du eventuelle du societariat si pas d'autre part
                         'sharecessnok'=> 'Demande de cession refusee',  //-> doit generer sharenokexe article 12 des statuts
                         'sharecessdone' => 'Cession faite' // -> fin du eventuelle du societariat si pas d'autre part
                       ));


        }
// quel est le bon get_workflow get_workflow2
        public function get_workflow3() {
            return apply_filters ('wpcoop_get_worflow',
                   array(
                       'none'=>array(
                                    array(
                                        'nextstate'=>'subsnok',         // next state possible
                                        'action'=>'regsubsnok',         // action to do
                                        'lib'=> __('Register incomplete application', $this->plugin_textdomain),
                                        'button'=> __('Subs. Nok', $this->plugin_textdomain),
                                        'requires'=>'none',             // status required?
                                        'role'=>''),         // who can do it?
                                    array(
                                        'nextstate'=>'subsok',          // next state possible
                                        'action'=>'regsubsok',          // action to do
                                        'lib'=> __('Register complete application', $this->plugin_textdomain),
                                        'button'=> __('Subs. Ok', $this->plugin_textdomain),
                                        'requires'=>'none',             // status required?
                                        'role'=>'wpcoopadmin'),         // who can do it?
                                      ),

                        'subsnok'=>array(
                                    array(
                                        'nextstate'=>'none',       // next state possible
                                        'action'=>'delsubs',             // action to do
                                        'lib'=> __('Supprime le dossier de souscription', $this->plugin_textdomain),
                                        'button'=> __('Delete!', $this->plugin_textdomain),
                                        'requires'=>'none',             // status required?
                                        'role'=>'wpcoopadmin'),         // who can do it?
                                    array(
                                        'nextstate'=>'subsok',          // next state possible
                                        'action'=>'subsnokok',          // action to do
                                        'lib'=> __('Dossier de souscription complété', $this->plugin_textdomain),
                                        'button'=> __('Subs. OK', $this->plugin_textdomain),
                                        'requires'=>'none',             // status required?
                                        'role'=>'wpcoopadmin'),         // who can do it?
                                      ),

                        'subsok'=>array(
                                    array(
                                        'nextstate'=>'none',            // next state possible
                                        'action'=>'delsubs',            // action to do
                                        'lib'=> __('Supprime le dossier de souscription', $this->plugin_textdomain),
                                        'button'=> __('Delete!', $this->plugin_textdomain),
                                        'requires'=>'none',             // status required?
                                        'role'=>'wpcoopadmin'),         // who can do it?
                                    array(
                                        'nextstate'=>'pending',       // next state possible
                                        'action'=>'subsokack',        // action to do
                                        'lib'=> __('Dossier de souscription pris en compte', $this->plugin_textdomain),
                                        'button'=> __('Att. Val', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'president'),         // who can do it?
                                      ),

                        'pending'=>array(
                                    array(
                                        'nextstate'=>'none',         // next state possible
                                        'action'=>'delsubs',         // action to do
                                        'lib'=> __('Supprime le dossier de souscription', $this->plugin_textdomain),
                                        'button'=> __('Delete!', $this->plugin_textdomain),
                                        'requires'=>'none',          // status required?
                                        'role'=>'president'),        // who can do it?
                                    array(
                                        'nextstate'=>'shareok',       // next state possible
                                        'action'=>'sharevala',         // action to do
                                        'lib'=> __('Validation de la souscription par le CA ou l\'AG - nouveau souscripteur -art 15', $this->plugin_textdomain),
                                        'button'=> __('Ok CA/AG', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'CA,AG'),             // who can do it? art 15

                                    array(
                                        'nextstate'=>'shareok',       // next state possible
                                        'action'=>'sharevalp',         // action to do
                                        'lib'=> __('Validation de la souscription par le président -souscripteur existant - art 9', $this->plugin_textdomain),
                                        'button'=> __('OK President', $this->plugin_textdomain),
                                        'requires'=>'shareholder',    // status required? art 9
                                        'role'=>'president'),         // who can do it?   art 9
                                      ),

                          'shareok'=>array(
                                      array(
                                        'nextstate'=>'sharenok',         // next state possible
                                        'action'=>'sharereclaim',         // action to do
                                        'lib'=> __('Demande de rachat de part', $this->plugin_textdomain),
                                        'button'=> __('Demande de rachat', $this->plugin_textdomain),
                                        'requires'=>'none',            // status required?
                                        'role'=>'shareholder'),        // who can do it?
                                      array(
                                        'nextstate'=>'sharecessreq',         // next state possible
                                        'action'=>'sharecessreq',         // action to do
                                        'lib'=> __('Demande de cession de part', $this->plugin_textdomain),
                                        'button'=> __('Demande de cession', $this->plugin_textdomain),
                                        'requires'=>'none',            // status required?
                                        'role'=>'shareholder'),        // who can do it?
                                     ),


                           // sharenok -> demande de rachat faite
                           // sharenokack -> demande de rachat prise en compte
                           // sharenokdone -> demande de rachat acceptee -> fin du eventuelle du societariat si pas d'autre part
                           // sharenokpaid -> demande de rachat effectuee (remboursement fait)

                           // sharecessreq -> demande de cession faite
                           // sharecessok-> demande de cession accordee
                           // sharecessnok-> demande de cession refusee -> doit generer sharenokexe article 12 des statuts ou cesscancel
                           // sharecessdone-> cession faite -> fin du eventuelle du societariat si pas d'autre part
                           // sharecesscancel-> cession annullee

                          'sharecessreq'=>array(
                                    array(
                                        'nextstate'=>'sharecessok',      // next state possible
                                        'action'=>'sharecessok',         // action to do
                                        'lib'=> __('Demande de cession OK CA', $this->plugin_textdomain),
                                        'button'=> __('Demande de cession OK CA', $this->plugin_textdomain),
                                        'requires'=>'none',          // status required?
                                        'role'=>'CA,AG'),        // who can do it?
                                    array(
                                        'nextstate'=>'sharecessnok',       // next state possible
                                        'action'=>'shareval',         // action to do
                                        'lib'=> __('Demande de cession NOK CA', $this->plugin_textdomain),
                                        'button'=> __('Demande de cession NOK CA', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'CA,AG'),             // who can do it? art 15
                                      ),

                          'sharecessok'=>array(
                                    array(
                                        'nextstate'=>'sharecessdone',      // next state possible
                                        'action'=>'sharecessdone',         // action to do
                                        'lib'=> __('Cession faite', $this->plugin_textdomain),
                                        'button'=> __('Cession faite', $this->plugin_textdomain),
                                        'requires'=>'none',          // status required?
                                        'role'=>'shareholder'),        // who can do it?
                                    array(
                                        'nextstate'=>'sharecesscancel',       // next state possible
                                        'action'=>'shareval',         // action to do
                                        'lib'=> __('Annulation cession', $this->plugin_textdomain),
                                        'button'=> __('Annulation cession', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'shareholder'),             // who can do it? art 15
                                      ),
                           'sharecessnok'=>array(
                                    array(
                                        'nextstate'=>'sharenok',       // next state possible
                                        'action'=>'sharenok',         // action to do
                                        'lib'=> __('Demande Rachat', $this->plugin_textdomain),
                                        'button'=> __('Demande Rachat', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'shareholder'),             // who can do it? art 15
                                    array(
                                        'nextstate'=>'sharecesscancel',       // next state possible
                                        'action'=>'shareval',         // action to do
                                        'lib'=> __('Annulation cession', $this->plugin_textdomain),
                                        'button'=> __('Annulation cession', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'shareholder'),             // who can do it? art 15
                                      ),


/*
                        'sharenok'=>array(
                                    array(
                                        'nextstate'=>'sharenok',         // next state possible
                                        'action'=>'sharereclaim',         // action to do
                                        'lib'=> __('Demande de rachat de part', $this->plugin_textdomain),
                                        'requires'=>'none',          // status required?
                                        'role'=>'shareholder'),        // who can do it?
                                    array(
                                        'nextstate'=>'shareok',       // next state possible
                                        'action'=>'shareval',         // action to do
                                        'lib'=> __('Validation de la souscription par le CA ou l\'AG - nouveau souscripteur -art 15', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'CA,AG'),             // who can do it? art 15

                                    array(
                                        'nextstate'=>'shareok',       // next state possible
                                        'action'=>'shareval',         // action to do
                                        'lib'=> __('Validation de la souscription par le président -souscripteur existant - art 9', $this->plugin_textdomain),
                                        'requires'=>'shareholder',    // status required? art 9
                                        'role'=>'president'),         // who can do it?   art 9
                                      ),

                        'sharenokack'=>array(
                                    array(
                                        'nextstate'=>'sharenok',         // next state possible
                                        'action'=>'sharereclaim',         // action to do
                                        'lib'=> __('Demande de rachat de part', $this->plugin_textdomain),
                                        'requires'=>'none',          // status required?
                                        'role'=>'shareholder'),        // who can do it?
                                    array(
                                        'nextstate'=>'shareok',       // next state possible
                                        'action'=>'shareval',         // action to do
                                        'lib'=> __('Validation de la souscription par le CA ou l\'AG - nouveau souscripteur -art 15', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'CA,AG'),             // who can do it? art 15

                                    array(
                                        'nextstate'=>'shareok',       // next state possible
                                        'action'=>'shareval',         // action to do
                                        'lib'=> __('Validation de la souscription par le président -souscripteur existant - art 9', $this->plugin_textdomain),
                                        'requires'=>'shareholder',    // status required? art 9
                                        'role'=>'president'),         // who can do it?   art 9
                                      ),
                        'sharenokexe'=>array(
                                    array(
                                        'nextstate'=>'sharenok',         // next state possible
                                        'action'=>'sharereclaim',         // action to do
                                        'lib'=> __('Demande de rachat de part', $this->plugin_textdomain),
                                        'requires'=>'none',          // status required?
                                        'role'=>'shareholder'),        // who can do it?
                                    array(
                                        'nextstate'=>'shareok',       // next state possible
                                        'action'=>'shareval',         // action to do
                                        'lib'=> __('Validation de la souscription par le CA ou l\'AG - nouveau souscripteur -art 15', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'CA,AG'),             // who can do it? art 15

                                    array(
                                        'nextstate'=>'shareok',       // next state possible
                                        'action'=>'shareval',         // action to do
                                        'lib'=> __('Validation de la souscription par le président -souscripteur existant - art 9', $this->plugin_textdomain),
                                        'requires'=>'shareholder',    // status required? art 9
                                        'role'=>'president'),         // who can do it?   art 9
                                      ),

                        'sharenokdone'=>array(
                                    array(
                                        'nextstate'=>'sharenok',         // next state possible
                                        'action'=>'sharereclaim',         // action to do
                                        'lib'=> __('Demande de rachat de part', $this->plugin_textdomain),
                                        'requires'=>'none',          // status required?
                                        'role'=>'shareholder'),        // who can do it?
                                    array(
                                        'nextstate'=>'shareok',       // next state possible
                                        'action'=>'shareval',         // action to do
                                        'lib'=> __('Validation de la souscription par le CA ou l\'AG - nouveau souscripteur -art 15', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'CA,AG'),             // who can do it? art 15

                                    array(
                                        'nextstate'=>'shareok',       // next state possible
                                        'action'=>'shareval',         // action to do
                                        'lib'=> __('Validation de la souscription par le président -souscripteur existant - art 9', $this->plugin_textdomain),
                                        'requires'=>'shareholder',    // status required? art 9
                                        'role'=>'president'),         // who can do it?   art 9
                                      ),
*/
                        )
                    );
        }
// a priori le 3 n'est pas le bon
        public function get_workflow() {
            return apply_filters ('wpcoop_get_worflow',
                   array(
                       'none'=>array(
					array(
						'nextstate'=>'subswft',         // next state possible
						'action'=>'regsubswft',         // action to do
						'lib'=> __('Register subscription waiting for tranfert', $this->plugin_textdomain),
						'button'=> __('Subs. Waiting', $this->plugin_textdomain),
						'requires'=>'none',             // status required?
						'role'=>''),         // who can do it?
                                    array(
                                        'nextstate'=>'subsnok',         // next state possible
                                        'action'=>'regsubsnok',         // action to do
                                        'lib'=> __('Register incomplete application', $this->plugin_textdomain),
                                        'button'=> __('Subs. Nok', $this->plugin_textdomain),
                                        'requires'=>'none',             // status required?
                                        'role'=>''),         // who can do it?
                                    array(
                                        'nextstate'=>'subsok',          // next state possible
                                        'action'=>'regsubsok',          // action to do
                                        'lib'=> __('Register complete application', $this->plugin_textdomain),
                                        'button'=> __('Subs. Ok', $this->plugin_textdomain),
                                        'requires'=>'none',             // status required?
                                        'role'=>'wpcoopadmin'),         // who can do it?
                                      ),

				'subswft'=>array(  // subscription waiting for tranfert
					array(
						'nextstate'=>'none',       // next state possible
						'action'=>'delsubs',             // action to do
						'lib'=> __('Supprime le transfert en attente', $this->plugin_textdomain),
						'button'=> __('Delete!', $this->plugin_textdomain),
						'requires'=>'none',             // status required?
						'role'=>'wpcoopadmin'),         // who can do it?
					array(
						'nextstate'=>'substok',          // next state possible
						'action'=>'subswftok',          // action to do
						'lib'=> __('Dossier Tranfert Ok', $this->plugin_textdomain),
						'button'=> __('Dossier Transf. OK', $this->plugin_textdomain),
						'requires'=>'none',             // status required?
						'role'=>'wpcoopadmin'),         // who can do it?
					  ),

				'substok'=>array(  // subscription waiting for tranfert dossier complet
					array(
						'nextstate'=>'none',       // next state possible
						'action'=>'delsubstok',             // action to do
						'lib'=> __('Supprime le transfert en attente', $this->plugin_textdomain),
						'button'=> __('Delete!', $this->plugin_textdomain),
						'requires'=>'none',             // status required?
						'role'=>'wpcoopadmin'),         // who can do it?
					array(
						'nextstate'=>'sharetok',          // next state possible
						'action'=>'sharetok',          // action to do
						'lib'=> __('Tranfert validé', $this->plugin_textdomain),
						'button'=> __('Val. Tranfert', $this->plugin_textdomain),
						'requires'=>'none',             // status required?
						'role'=>'wpcoopadmin'),         // who can do it?
					  ),

				'subsnok'=>array(  // souscription dossier incomplet
                                    array(
                                        'nextstate'=>'none',       // next state possible
                                        'action'=>'delsubs',             // action to do
                                        'lib'=> __('Supprime le dossier de souscription', $this->plugin_textdomain),
                                        'button'=> __('Delete!', $this->plugin_textdomain),
                                        'requires'=>'none',             // status required?
                                        'role'=>'wpcoopadmin'),         // who can do it?
                                    array(
                                        'nextstate'=>'subsok',          // next state possible
                                        'action'=>'subsnokok',          // action to do
                                        'lib'=> __('Dossier de souscription complété', $this->plugin_textdomain),
                                        'button'=> __('Subs. OK', $this->plugin_textdomain),
                                        'requires'=>'none',             // status required?
                                        'role'=>'wpcoopadmin'),         // who can do it?
                                      ),

                        'subsok'=>array(
                                    array(
                                        'nextstate'=>'none',            // next state possible
                                        'action'=>'delsubs',            // action to do
                                        'lib'=> __('Supprime le dossier de souscription', $this->plugin_textdomain),
                                        'button'=> __('Delete!', $this->plugin_textdomain),
                                        'requires'=>'none',             // status required?
                                        'role'=>'wpcoopadmin'),         // who can do it?
                                    array(
                                        'nextstate'=>'pending',       // next state possible
                                        'action'=>'subsokack',        // action to do
                                        'lib'=> __('Dossier de souscription pris en compte', $this->plugin_textdomain),
                                        'button'=> __('Att. Val', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'president'),         // who can do it?
                                      ),

                        'pending'=>array(
                                    array(
                                        'nextstate'=>'none',         // next state possible
                                        'action'=>'delsubs',         // action to do
                                        'lib'=> __('Supprime le dossier de souscription', $this->plugin_textdomain),
                                        'button'=> __('Delete!', $this->plugin_textdomain),
                                        'requires'=>'none',          // status required?
                                        'role'=>'president'),        // who can do it?
                                    array(
                                        'nextstate'=>'shareok',       // next state possible
                                        'action'=>'sharevala',         // action to do
                                        'lib'=> __('Validation de la souscription par le CA ou l\'AG - nouveau souscripteur -art 15', $this->plugin_textdomain),
                                        'button'=> __('Ok CA/AG', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'CA,AG'),             // who can do it? art 15

                                    array(
                                        'nextstate'=>'shareok',       // next state possible
                                        'action'=>'sharevalp',         // action to do
                                        'lib'=> __('Validation de la souscription par le président -souscripteur existant - art 9', $this->plugin_textdomain),
                                        'button'=> __('OK President', $this->plugin_textdomain),
                                        'requires'=>'shareholder',    // status required? art 9
                                        'role'=>'president'),         // who can do it?   art 9
                                      ),

                          'shareok'=>array(
						  array(
							'nextstate'=>'sharenok',         // next state possible
							'action'=>'sharereclaim',         // action to do
							'lib'=> __('Demande de rachat de part', $this->plugin_textdomain),
							'button'=> __('Demande de rachat', $this->plugin_textdomain),
							'requires'=>'none',            // status required?
						'onlyone'=>'y',  // only available for first subscription shareok
							'aqtyreq'=>'y',  // action quantity field required
							'requires'=>'none',          // status required?
							'role'=>'shareholder'),        // who can do it?
						  array(
							'nextstate'=>'sharecessreq',         // next state possible
							'action'=>'sharecessreq',         // action to do
							'lib'=> __('Demande de cession de part', $this->plugin_textdomain),
							'button'=> __('Demande de cession', $this->plugin_textdomain),
							'requires'=>'none',            // status required?
						'onlyone'=>'y',  // only available for first subscription shareok
							'aqtyreq'=>'y',  // action quantity field required
							'requires'=>'none',          // status required?
							'role'=>'shareholder'),        // who can do it?
						 ),

				  'sharetok'=>array(
                                      array(
                                        'nextstate'=>'sharenok',         // next state possible
                                        'action'=>'sharereclaim',         // action to do
                                        'lib'=> __('Demande de rachat de part', $this->plugin_textdomain),
                                        'button'=> __('Demande de rachat', $this->plugin_textdomain),
							'requires'=>'none',            // status required?
						'onlyone'=>'y',  // only available for first subscription shareok
							'aqtyreq'=>'y',  // action quantity field required
                                        'requires'=>'none',            // status required?
                                        'role'=>'shareholder'),        // who can do it?
                                      array(
                                        'nextstate'=>'sharecessreq',         // next state possible
                                        'action'=>'sharecessreq',         // action to do
                                        'lib'=> __('Demande de cession de part', $this->plugin_textdomain),
                                        'button'=> __('Demande de cession', $this->plugin_textdomain),
                                        'requires'=>'none',            // status required?
						'onlyone'=>'y',  // only available for first subscription shareok
							'aqtyreq'=>'y',  // action quantity field required
							'requires'=>'none',          // status required?
                                        'role'=>'shareholder'),        // who can do it?
                                     ),


                           // sharenok -> demande de rachat faite
                           // sharenokack -> demande de rachat prise en compte
                           // sharenokdone -> demande de rachat acceptee -> fin du eventuelle du societariat si pas d'autre part
                           // sharenokpaid -> demande de rachat effectuee (remboursement fait)

                           // sharecessreq -> demande de cession faite
                           // sharecessok-> demande de cession accordee
                           // sharecessnok-> demande de cession refusee -> doit generer sharenokexe article 12 des statuts ou cesscancel
                           // sharecessdone-> cession faite -> fin du eventuelle du societariat si pas d'autre part
				   // sharecesscanc-> cession annullee

                          'sharecessreq'=>array(
                                    array(
                                        'nextstate'=>'sharecessok',      // next state possible
                                        'action'=>'sharecessok',         // action to do
                                        'lib'=> __('Demande de cession OK CA', $this->plugin_textdomain),
                                        'button'=> __('Demande de cession OK CA', $this->plugin_textdomain),
//					'onlyone'=>'y',  // only available for first subscription shareok
//					'aqtyreq'=>'y',  // action quantity field required
                                        'requires'=>'none',          // status required?
                                        'role'=>'CA,AG'),        // who can do it?
                                    array(
                                        'nextstate'=>'sharecessnok',       // next state possible
					'action'=>'sharecessnok',         // action to do
                                        'lib'=> __('Demande de cession NOK CA', $this->plugin_textdomain),
                                        'button'=> __('Demande de cession NOK CA', $this->plugin_textdomain),
//					'aqtyreq'=>'y',  // action quantity field required
                                        'requires'=>'none',           // status required?
                                        'role'=>'CA,AG'),             // who can do it? art 15
                                      ),

                          'sharecessok'=>array(
                                    array(
                                        'nextstate'=>'sharecessdone',      // next state possible
                                        'action'=>'sharecessdone',         // action to do
                                        'lib'=> __('Cession faite', $this->plugin_textdomain),
                                        'button'=> __('Cession faite', $this->plugin_textdomain),
                                        'requires'=>'none',          // status required?
					'aqtyreq'=>'y',  // action quantity field required
                                        'role'=>'shareholder'),        // who can do it?
                                    array(
                                        'nextstate'=>'sharecesscancel',       // next state possible
					'action'=>'sharecesscancel',      // action to do
                                        'lib'=> __('Annulation cession', $this->plugin_textdomain),
                                        'button'=> __('Annulation cession', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'shareholder'),             // who can do it? art 15
                                      ),
                           'sharecessnok'=>array(
                                    array(
					'nextstate'=>'sharecessreq',       // next state possible
                                        'action'=>'sharenok',         // action to do
					'lib'=> __('Demande cession refusée', $this->plugin_textdomain),
					'button'=> __('Demande cession refusée', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
				 	'role'=>'CA,AG'),
                                    array(
                                        'nextstate'=>'sharecesscancel',       // next state possible
					'action'=>'sharecesscancel',         // action to do
					'lib'=> __('Annulation demande de cession', $this->plugin_textdomain),
					'button'=> __('Annulation demande de cession', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'shareholder'),             // who can do it? art 15
                                      ),

			    'sharecessdone'=>array(),


                        'sharenok'=>array(
                                    array(
								'nextstate'=>'sharenokack',  // next state possible
								'action'=>'sharenotokack',   // action to do
								'lib'=> __('Demande de rachat de part(s) prise en compte', $this->plugin_textdomain),
								'button'=> __('Rachat part(s) Energistré', $this->plugin_textdomain),
                                        'requires'=>'none',          // status required?
								'role'=>'CA,AG'),        // who can do it?
                                    array(
								'nextstate'=>'sharenokcanc',  // next state possible
								'action'=>'sharenokcanc',     // action to do
								'lib'=> __('Annulation Demande de rachat', $this->plugin_textdomain),
								'button'=> __('Annulation', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
								'role'=>'shareholder'),             // who can do it? art 15

                                      ),

                        'sharenokack'=>array(
                                    array(
								'nextstate'=>'sharenokdone',         // next state possible
								'action'=>'sharenotokdone',         // action to do
								'lib'=> __('Demande rachat enregistrée', $this->plugin_textdomain),
								'button'=> __('Demande enregistrée', $this->plugin_textdomain),
                                        'requires'=>'none',          // status required?
								'role'=>'admin'),        // who can do it?
                                      ),

				'sharenokdone'=>array(
                                    array(
								'nextstate'=>'sharenokpaid',         // next state possible
								'action'=>'sharenokpaid',         // action to do
								'lib'=> __('Rachat validé', $this->plugin_textdomain),
								'requires'=>'none',          // status required?
								'role'=>'CA,AG'),        // who can do it?
                                      ),

			   	'sharenokpaid'=>array(
                                    array(
								'nextstate'=>'none',         // next state possible
                                        'action'=>'sharereclaim',         // action to do
								'lib'=> __('Rachat de part(s) payé', $this->plugin_textdomain),
								'button'=> __('Payé', $this->plugin_textdomain),
                                        'requires'=>'none',          // status required?
								'role'=>'admin'),        // who can do it?
                                      ),

                        )
                    );
        }




        public function simulate_settings_messages($index, $text){
          // when sending data directly (not to options.php) validate and error messages don't fire
          echo '<div id="'.$index.'" class="notice notice-error settings-error is-dismissible"
                    <p><strong>'.$text.'</strong></p>
                    <button class="notice-dismiss" type="button">
                    <span class="screen-reader-text">Ne pas tenir compte de ce message</span>
                    </button>
                </div>';
        }

        function set_error_messages_after_uploading_file(){



        }
/*
        public function update_secured_image($args) {
            $defs=array(//'option_group'=>'xxxx',
                        'max_file_size'=>'300000',
                        //'name'=>'options_XXXX',
                        //'url_option'=>'xxxxx'
                        'store_option'=>'yyyyy'// where is stored image (site option)
                       );

            $args=wp_parse_args($args, $defs);


            settings_fields($this->plugin_prefix.$args['option_group']);
            ?>
            <input type="hidden" name="MAX_FILE_SIZE" value="<?php echo $args['max_file_size']; ?>" />
            <?php
            $message='';

            if (isset($_FILES[$this->plugin_prefix.$args['name']]) && is_array($_FILES[$this->plugin_prefix.$args['name']])) {
             $tmp=$_FILES[$this->plugin_prefix.$args['name']];
             if (isset($tmp['tmp_name']) && is_file($tmp['tmp_name']) && (!isset($tmp['error']) || $tmp['error']==UPLOAD_ERR_OK)) {
              if ($r=@fopen($tmp['tmp_name'], "r")) {
               update_option($this->plugin_prefix.$args['store_option'],
                                array('name'=>$tmp['name'],
                                      'type'=>$tmp['type'],
                                      'size'=>$tmp['size'],
                                      'data'=>base64_encode(fread($r, $tmp['size']))));
               // TOKEN to be replaced with true token=xxx when url called
               //update_option($this->plugin_prefix.$args['url_option'], get_site_url().'/image/?//image='.$args['name'].'&TOKEN&filename='.$tmp['name']);

              } else {
                $message.=' File not read ';
              }
             } else {

              if (!isset($tmp['tmp_name']))  {
               $message .= "Temporary file not set";
              }
              if (isset($tmp['tmp_name']) && !empty($tmp['tmp_name']) && !is_file($temp['tmp_name']))  {
               $message .= "Temporary file not found";
              }

              if (isset($tmp['error']) && $tmp['error']!=0) {
                 switch ($tmp['error']) {
                    case UPLOAD_ERR_INI_SIZE:
                        $message.= "The uploaded file exceeds the upload_max_filesize directive in php.ini";
                        break;
                    case UPLOAD_ERR_FORM_SIZE:
                        $message.= "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form";
                        break;
                    case UPLOAD_ERR_PARTIAL:
                        $message.= "The uploaded file was only partially uploaded";
                        break;
                    case UPLOAD_ERR_NO_FILE:
                        $message.= "No file was uploaded";
                        break;
                    case UPLOAD_ERR_NO_TMP_DIR:
                        $message.= "Missing a temporary folder";
                        break;
                    case UPLOAD_ERR_CANT_WRITE:
                        $message.= "Failed to write file to disk";
                        break;
                    case UPLOAD_ERR_EXTENSION:
                        $message.= "File upload stopped by extension";
                        break;

                    default:
                        $message.= "Unknown upload error";
                        break;
                }
              } // error #
              echo $message;
             } // read error
            }

        }
*/

        function init_options_page() {
            // get options
            $options=$this->get_options_tabs('options');
            // registers options groups
            foreach($options as $option) {
             register_setting($option['group'],$option['name'],$option['callback']);
            }
        }

        // date : dd/mm/yyyy
        public function validate_date($maybedate) {
          return ( empty($maybedate) || strlen($maybedate)!=10 ||
                  !checkdate( (int) substr($maybedate, 3, 2), (int) substr($maybedate, 0, 2), (int) substr($maybedate, 6, 4) ) )? false : true;

        }

        public function validate_user($id){
            $id=(int) $id;
             if (get_user_by('id', $id)){
              return $id;
             } else {
              return 0;
             }
        }

        public function get_capability_from_operator_type($type){
            switch ($type){
                case 'setter':
                    $cap=$this->plugin_parameters_capability;
                    break;
                case 'editor':
                    $cap=$this->plugin_edit_capability;
                    break;
                case 'read':
                default:
                    $cap=$this->plugin_read_capability;
            }
            return $cap;
        }

        public function get_secured_image_url($fileoption, $filenameoption, $token){
         // return image script must contain defeult image default.png
         return apply_filters($this->plugin_prefix.'get_secured_image_url',site_url().(($this->api_endpoints['image'])?? '/image').'/?image='.$fileoption.'&getimagetoken='.$token.'&name='.urlencode(get_option($this->plugin_prefix.$filenameoption, 'default.png')), $fileoption, $filenameoption, $token);
        }


    } // end class
} // end if class exists
