<?php
/**
 * Exit if accessed directly
 */

// alm 20210419 13:53


if ( !defined( 'ABSPATH' ) ) {
    exit;
}
if ( !class_exists( 'WPCOOP_Members' ) ) {
  class WPCOOP_Members {

   public function __construct() {
        global $wpcoop;
        // copy some parameters from wpcoop
        $this->plugin_version = $wpcoop->plugin_version;
        $this->plugin_prefix = $wpcoop->plugin_prefix;
        $this->usersdata_prefix = $wpcoop->usersdata_prefix;

        $this->plugin_textdomain = $wpcoop->plugin_textdomain;

        //$this->plugin_usersubs_meta=$wpcoop->plugin_usersubs_meta;

        $this->plugin_usersubs_meta=$wpcoop->plugin_usersubs_meta;

        $this->workflow = $wpcoop->functions->get_workflow();

        $this->members_table=$wpcoop->subscribers_table;

   }

   public function do_update_members_table() {
      global $wpdb;
      //INSERT INTO t1 (a,b,c) VALUES (1,2,3),(4,5,6) ON DUPLICATE KEY UPDATE c=VALUES(a)+VALUES(b);
      $qry="TRUNCATE TABLE ".$wpdb->prefix.$this->members_table;
      $wpdb->get_results($qry);

      $qry='INSERT INTO '.$wpdb->prefix.$this->members_table.'
      (id, firstname, lastname, email, birthdate, zip, datecreated, datemodified) VALUES ';
      $qryend='';
      foreach($this->members_array as $id=>$member_array){
         if ($member_array['id']==0 || !is_email($member_array['email']) ) continue;
         $qryend.='('.esc_sql($member_array['id']).",'"
                  .esc_sql($member_array['first_name'])."','"
                  .esc_sql($member_array['last_name'])."','"
                  .esc_sql($member_array['email'])."','"
                  .esc_sql($member_array['birthdate'])."','"
                  .esc_sql($member_array['zip'])."',
                  NOW(),
                  NOW()),";
      }
      if (!empty($qryend)){
        $qry=$qry.substr($qryend,0,-1);
        $res=$wpdb->get_results($qry);
      }
   }

   public function prepare_update_members_table($member) {
      // print_tab($member);
      //echo '------------------------------------'.$member->id.'<br>';
      //print_tab($member);
      $this->members_array[$member->id]=array(
          'id'=>$member->id,
          'first_name'=>$member->first_name,
          'last_name'=>$member->last_name,
          'email'=>$member->email,
          'birthdate'=>$member->birthdate,
          'zip'=>$member->zip,
          'type'=>$member->type,
          'cat'=>$member->cat,
          'col'=>$member->col,
      );
   }

   public static function date_to_mysql($date) {
       $mysqldate='';
       // dd/mm/yyyy -> yyyy-mm-dd else ''
       $ar_date=explode('/',$date);
       if (strlen($date)==10
           && count($ar_date)==3
           && strlen($ar_date[0])==2 && strlen($ar_date[1])==2 && strlen($ar_date[2])==4
           && checkdate($ar_date[1],$ar_date[0],$ar_date[2] )) {
           $mysqldate=$ar_date[2].'-'.$ar_date[1].'-'.$ar_date[0];
       }
       return $mysqldate;
   }
   public function get_users($ID, $select='') {
       // $id==0 -> all users
       // select='' -> subscribers and not yet subscribers
       // select= 'subs -> subscribers only
       if ($ID==0) {
           $options=array();
           if ($select=='subs') {
            $options=array( 'meta_key'=>$this->plugin_usersubs_meta);
           }
       } else {
           $options=array('include'=>array($ID));
           if ($select=='subs') {
            $options=array( 'include'=>array($ID), 'meta_key'=>$this->plugin_usersubs_meta);
           }
       }
       return get_users( $options  );
   }

   public function get_ordered_users($select="all", $order="lastname") {
       // $select='all' -> all users, 'subs' subscriber only, int userid
       // $created optionnal company creation date, use with order =date to set minimum date to creation date
       // set some data
       $users=$this->get_users(($select=="all" || $select=="subs")? 0 : intval($select), ($select=="all")? '' : 'subs');
       //print_tab($users);
       //will be remove
       $profields=$this->get_added_profile_fields();
       //print_tab($profields);
       // will be remove
       $category_fields=$this->get_added_profile_category_fields();
       //print_tab($category_fields);
       // asof 0.23
       $wpcoop_fields=$this->get_users_added_fields();

       $opst=array();
       foreach($users as $user) {
        //echo $user->ID.' '.$user->login.' '.$user->display_name.'<br>';
        $opst[$user->ID]['usersubs']=get_user_meta($user->ID, $this->plugin_usersubs_meta, true);
        $opst[$user->ID]['last_name']=get_user_meta($user->ID, 'last_name', true);
        $opst[$user->ID]['first_name']=get_user_meta($user->ID, 'first_name', true);
        $opst[$user->ID]['display_name']=$user->display_name;
        $opst[$user->ID]['user_login']=$user->user_login;
        $opst[$user->ID]['user_email']=$user->user_email;
         //$opst[$user->ID][$opst[$user->ID]];

        foreach($profields as $k=>$v) {
         $opst[$user->ID][$k]=get_user_meta($user->ID,$k, true);
        }

        foreach($category_fields as $k=>$field) {
         $opst[$user->ID][$field['name']] = get_user_meta($user->ID, $field['name'], true);

        }
        $slug='';
        foreach($wpcoop_fields['tabs'] as $tab) {
           if($tab['slug']!=$slug) {
               $slug=$tab['slug'];
               if ($slug=='wp') {
                 continue;
               }
               $prefix = ($slug=='wp')? '' : $this->plugin_prefix.$this->usersdata_prefix.$slug.'_';

           }
          foreach($tab['fields'] as $field) {
           $opst[$user->ID][$prefix.$field['name']]= get_user_meta($user->ID, $prefix.$field['name'], true);
          }
        }
        // add shares data to user
        $opst[$user->ID]['shares_data']=$this->get_user_shares_data($user->ID, $opst[$user->ID]['usersubs']);

       }//each user

       //print_tab($opst);

       //sort according parameter $order
       //$order='date';
       $subs=array();
       if($order=='date') {
           foreach($opst as $id=>$user) {
              //print_tab($user);
              //$s=$opst[$id]['shares_data']['shares'];
              //$v=$opst[$id]['shares_data']['value'];
              //$s=$opst[$id]['shares_data']['date'];
              //datebeg : ddmmyyyy
              $datebeg=$user['shares_data']['date'];
              //if ($user['shares_data']['shares']>0)
              $subs[$id]=substr($datebeg,4,4).substr($datebeg,2,2).substr($datebeg,0,2).$user['last_name'].' '.$user['first_name'];
           }
        } else {
           //sort by name
           foreach($opst as $id=>$user) {
              // space is ignored, causing false sorting; use chr('#8776') instead last char value?
              //$subs[$id]=$user['last_name'].chr('#8776').$user['first_name'];
              // chr needs integer 7.4
              $subs[$id]=$user['last_name'].' '.$user['first_name'];
           }
        }
        // sort array
        //print_tab($subs);

        natcasesort($subs);
        //print_tab($subs);
        // put data according sorted values
        $ops=array();
        foreach($subs as $k=>$n ) {
         $ops[$k]= $opst[$k];
        }

        //print_tab($ops);
        return $ops;
   }

   public function get_added_profile_fields() {
       return apply_filters('added_profile_fields', array(
           $this->plugin_prefix.'phone'    => __('Phone', $this->plugin_textdomain),
           $this->plugin_prefix.'adr1'     => __('Address', $this->plugin_textdomain),
           $this->plugin_prefix.'adr2'     => __('Address', $this->plugin_textdomain),
           $this->plugin_prefix.'zip'      => __('Postal Code', $this->plugin_textdomain),
           $this->plugin_prefix.'city'     => __('City', $this->plugin_textdomain),
           $this->plugin_prefix.'country'  => __('Country', $this->plugin_textdomain),

       ));


   }

   public function get_added_profile_category_fields() {
       return apply_filters('wpcoop_added_profile_category_fields', array(
            array('id' => $this->plugin_prefix.'forme', 'name'=>$this->plugin_prefix.'forme', 'defvalue'=> __('_',$this->plugin_textdomain),
                  'label'=>__('Forme', $this->plugin_textdomain), 'desc'=>__('M., Mme, Société, Association...', $this->plugin_textdomain)),
            array('id' => $this->plugin_prefix.'company', 'name'=>$this->plugin_prefix.'company', 'defvalue'=> __('_',$this->plugin_textdomain),
                  'label'=>__('Raison sociale', $this->plugin_textdomain), 'desc'=>__('Pour les personnes morales', $this->plugin_textdomain)),
            array('id' => $this->plugin_prefix.'birthname', 'name'=>$this->plugin_prefix.'birthname', 'defvalue'=> __('_',$this->plugin_textdomain),
                  'label'=>__('Birth Name', $this->plugin_textdomain), 'desc'=>__('Enter you Birth Name if different from your name', $this->plugin_textdomain)),
            array('id' => $this->plugin_prefix.'birthdate', 'name'=>$this->plugin_prefix.'birthdate', 'defvalue'=> __('_',$this->plugin_textdomain),
                  'label'=>__('Birth date', $this->plugin_textdomain), 'desc'=>__('Enter you Birth Date', $this->plugin_textdomain)),
            array('id' => $this->plugin_prefix.'birthcountry', 'name'=>$this->plugin_prefix.'birthcountry', 'defvalue'=> __('_',$this->plugin_textdomain),
                  'label'=>__('Birth place', $this->plugin_textdomain), 'desc'=>__('Enter you Birth place', $this->plugin_textdomain)),
            array('id' => $this->plugin_prefix.'nationality', 'name'=>$this->plugin_prefix.'nationality', 'defvalue'=> __('_',$this->plugin_textdomain),
                  'label'=>__('Nationality', $this->plugin_textdomain), 'desc'=>__('Nationality', $this->plugin_textdomain)),
            array('id' => $this->plugin_prefix.'job', 'name'=>$this->plugin_prefix.'job', 'defvalue'=> __('_',$this->plugin_textdomain),
                  'label'=>__('Job', $this->plugin_textdomain), 'desc'=>__('Enter your job', $this->plugin_textdomain))

       ));
   }

   ////////////////////////////////////////////////////////////

   public function get_user_data_fields() {

       return array(
        // xxx string exists in WP -> __('xxx')
        // xxx string doesn't exist in WP, translate it in plugin and -> __('xxx', $this->plugin_textdomain)
        'user_login'=>array('name'=>'pre_user_login',
                            'label'=>__('Username'),
                            'desc'=>__('Username')),
        'user_url'=>array('name'=>'pre_user_url',
                            'label'=>__('Website'),
                            'desc'=>__('Website')),
        'user_email'=>array('name'=>'pre_user_email',
                            'label'=>__('Email'),
                            'desc'=>__('User Email')),
        'display_name'=>array('name'=>'displayname',
                            'label'=>__('Display Name'),
                            'desc'=>__('Display Name')),
        'nickname'=>array('name'=>'pre_nickname',
                            'label'=>__('Nickname'),
                            'desc'=>__('Nickname')),
        'first_name'=>array('name'=>'pre_first_name',
                            'label'=>__('First Name'),
                            'desc'=>__('First Name')),
        'last_name'=>array('name'=>'pre_last_name',
                            'label'=>__('Last Name'),
                            'desc'=>__('Last Name')),
        'description'=>array('name'=>'pre_description',
                            'label'=>__('Description'),
                            'desc'=>__('Description'))
       /*
        'user_registered'=>array('name'=>$this->plugin_prefix.'pre_login',
                            'label'=>__('Login', $this->plugin_textdomain),
                            'desc'=>__('Id', $this->plugin_textdomain)),
        'role'=>      array('name'=>$this->plugin_prefix.'pre_login',
                            'label'=>__('Login', $this->plugin_textdomain),
                            'desc'=>__('Id', $this->plugin_textdomain)),
        'display_name'=>array('name'=>$this->plugin_prefix.'pre_display_name',
                            'label'=>__('Display Name', $this->plugin_textdomain),
                            'desc'=>__('Id', $this->plugin_textdomain)),
       */

       );
     }

     public function get_members_types() {
       // voir get_member_types dans admin?
        $types= array(
                    '0'=>'Choisir un type de membre',
                    'c'=>'Personne physique capable',
                    'i'=>'Personne morale',
                    'm'=>'Mineur ou personne sous représentation légale',
                     );
        return $types;
     }

     public function get_cols($scope='') {
       $cols=get_option($this->plugin_prefix.'options_cols',array());
       if (empty($cols)) $cols=array(
         0=>array('a'=>'-',
                  's'=>'----',
                  'n'=>__('No college defined yet, see administrator', $this->plugin_textdomain)));
       switch($scope){
         case 'f': // retrieve full data
          $ret=$cols;
         case 'a':   // a only
          foreach($cols as $ix=>$col){
           $ret[$ix]= ($col['a'])?? '?';
          }
          break;
         case 's':   // s only
          foreach($cols as $ix=>$col){
           $ret[$ix]= ($col['s'])?? '????';
          }
          break;
         case 'n':   // n only
         default:
          foreach($cols as $ix=>$col){
           $ret[$ix]= ($col['n'])?? __('No Name, see administrator', $this->plugin_textdomain);
          }
       }
       return(apply_filters($this->plugin_prefix.'get_cols', $ret, $cols, $scope));
     }

     public function get_cats($scope='') {
       $cats=get_option($this->plugin_prefix.'options_cats',array());
       if (empty($cats)) $cats=array(
         0=>array('a'=>'-',
                  's'=>'----',
                  'n'=>__('No category defined yet, see administrator', $this->plugin_textdomain)));
       switch($scope){
         case 'f': // retrieve full data
          $ret=$cats;
         case 'a':   // a only
          foreach($cats as $ix=>$cat){
           $ret[$ix]= ($cat['a'])?? '?';
          }
          break;
         case 's':   // s only
          foreach($cats as $ix=>$cat){
           $ret[$ix]= ($cat['s'])?? '????';
          }
          break;
         case 'n':   // n only
         default:
          foreach($cats as $ix=>$cat){
           $ret[$ix]= ($cat['n'])?? __('No Name, see administrator', $this->plugin_textdomain);
          }
       }
       return(apply_filters($this->plugin_prefix.'get_cats', $ret, $cats, $scope));
     }

     public function get_users_added_fields() {

         return apply_filters($this->plugin_prefix.'get_users_added_fields',
          array('tabs'=>array(
            array(
              'slug'=>'membertype',
              'class'=>'membertype',
              'caption'=>__('Type of member', $this->plugin_textdomain),
              'fields'=> array(
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'select',
                 'type'=>'',
                 'name'=>'type',
                 'id'=>'',
                 'caption'=>__('Type of member', $this->plugin_textdomain),
                 'desc'=>__('Personne: Physique majeure / Mineure/ sous administration légale| Institution / personne Morale', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'values'=>array($this, 'get_members_types')
                 ),
                )
              ),
            array(
              'slug'=>'wp',
              'class'=>'wp',
              'caption'=>__('Wordpress account informations', $this->plugin_textdomain),
              // as these are standard WP names, translation exists in WP -> no textdomain
              'fields'=> array(
                  array(
                 'class'=>'',
                 'dis'=>'y',  // disabled, display only
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'user_login',
                 'id'=>'',
                 'caption'=>__('Username'),
                 'desc'=>__('auto-generated 3 first letters of lastname and firstname - read only', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''             // value
                 ),
                  array(
                 'class'=>'',
                 'dis'=>'y',  // disabled, display only
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'user_url',
                 'id'=>'',
                 'caption'=>__('Website'),
                 'desc'=>__('Web site url, if any - read only, see member', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                  array(
                 'class'=>'',
                 'dis'=>'y',  // disabled, display only
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'user_email',
                 'id'=>'',
                 'caption'=>__('Email', $this->plugin_textdomain),
                 'desc'=>__('you@somewhere.tld  - read only, see member', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                  array(
                 'class'=>'',
                 'dis'=>'y',  // disabled, display only
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'nickname',
                 'id'=>'',
                 'caption'=>__('Nickname', $this->plugin_textdomain),
                 'desc'=>__('same as username - read only', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                  array(
                 'class'=>'',
                 'dis'=>'y',  // disabled, display only
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'first_name',
                 'id'=>'',
                 'caption'=>__('First Name', $this->plugin_textdomain),
                 'desc'=>__('First Name  - read only, see member', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''             // default value or comma separated select values
                 ),
                  array(
                 'class'=>'',
                 'dis'=>'y',  // disabled, display only
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'last_name',
                 'id'=>'',
                 'caption'=>__('Last Name', $this->plugin_textdomain),
                 'desc'=>__('Last Name - read only, see member', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''             // default value or comma separated select values
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'description',
                 'id'=>'',
                 'caption'=>__('Description'),
                 'desc'=>__('Description, of account if something specific', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                )
                 //not in form: 'user_registered','role','display_name'
                 ),
            array(
              'slug'=>'memberperson',
              'class'=>'memberperson',
              'caption'=>__('Coop Member (person)', $this->plugin_textdomain),
              'fields'=> $this->get_person_fields()
                  ),
            array(
              'slug'=>'memberinstitution',
              'class'=>'memberinstitution',
              'caption'=>__('Coop Member (institution)',$this->plugin_textdomain),
              'fields'=> array(
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'legalform',
                 'id'=>'',
                 'caption'=>__('Legal form', $this->plugin_textdomain),
                 'desc'=>__('Type of institution', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'name',
                 'id'=>'',
                 'caption'=>__('Name', $this->plugin_textdomain),
                 'desc'=>__('Institution name', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'siret',
                 'id'=>'',
                 'caption'=>__('Registration Number', $this->plugin_textdomain),
                 'desc'=>__('Registration Number', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'website',
                 'id'=>'',
                 'caption'=>__('Web Site', $this->plugin_textdomain),
                 'desc'=>__('Web site', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'user_email',
                 'id'=>'',
                 'caption'=>__('Email', $this->plugin_textdomain),
                 'desc'=>__('you@somewhere.tld', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'phone',
                 'id'=>'',
                 'caption'=>__('Phone', $this->plugin_textdomain),
                 'desc'=>__('international +xxx +33XXX without leading 0 for France', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'adr1',
                 'id'=>'',
                 'caption'=>__('Address', $this->plugin_textdomain),
                 'desc'=>__('Postal Address', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'adr2',
                 'id'=>'',
                 'caption'=>__('Address', $this->plugin_textdomain),
                 'desc'=>__('Postal Address', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'zip',
                 'id'=>'',
                 'caption'=>__('Zip code', $this->plugin_textdomain),
                 'desc'=>__('Postal Zip code', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'city',
                 'id'=>'',
                 'caption'=>__('City', $this->plugin_textdomain),
                 'desc'=>__('Postal City', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'country',
                 'id'=>'',
                 'caption'=>__('Country', $this->plugin_textdomain),
                 'desc'=>__('Country', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'textarea',
                 'type'=>'',
                 'name'=>'comments',
                 'id'=>'',
                 'caption'=>__('Comments', $this->plugin_textdomain),
                 'desc'=>__('Comments', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                )
              ),
              array(
              'slug'=>'representative',
              'class'=>'representative',
              'caption'=>__('Legal representative',$this->plugin_textdomain),
              'fields'=> $this->get_person_fields()
              ),
              array(
              'slug'=>'internal',
              'class'=>'internal',
              'caption'=>__('Coop Internal data', $this->plugin_textdomain),
              'fields'=> $this->get_internal_fields()
              ),
/*              array(
              'slug'=>'internal',
              'class'=>'internal',
              'caption'=>__('Coop Internal data', $this->plugin_textdomain),
              'fields'=> array(
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'select',
                 'type'=>'',
                 'name'=>'category',
                 'id'=>'',
                 'caption'=>__('Category', $this->plugin_textdomain),
                 'desc'=>__('Category of membership', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'values'=>array($this, 'get_cats') // array of (keys values or function to get them)
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'select',
                 'type'=>'text',
                 'name'=>'college',
                 'id'=>'',
                 'caption'=>__('College', $this->plugin_textdomain),
                 'desc'=>__('College of membership', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'values'=> array($this, 'get_cols') // array of (keys values or function to get them)
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'checkbox',
                 'name'=>'edocok',
                 'id'=>'',
                 'caption'=>__('E-Documents OK', $this->plugin_textdomain),
                 'desc'=>__('Check if member is Ok to receive electronic documents ', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>'y'
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'text',
                 'name'=>'firstcontact',
                 'id'=>'',
                 'caption'=>__('First contact', $this->plugin_textdomain),
                 'desc'=>__('Source of contact', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'textarea',
                 'type'=>'',
                 'name'=>'comments',
                 'id'=>'',
                 'caption'=>__('Comments', $this->plugin_textdomain),
                 'desc'=>__('Comments', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>''
                 ),
*/
/*
                  array(
                 'class'=>'',
                 'wkfo'=>'',
                 'tag'=>'input',
                 'type'=>'checkbox',
                 'name'=>'coop_admin',
                 'id'=>'',
                 'caption'=>__('Coop administrator', $this->plugin_textdomain),
                 'desc'=>__('Check if member is Coop administrator', $this->plugin_textdomain),
                 'help'=>'',
                 'defvalue'=>'',
                 'value'=>'y'
                 ),
*/
//                ) // fields
//              ) // tab
             ) //tabs
          ) // array
       ) ; // apply filters

     }

   public function get_internal_fields(){
     $ar_cats=
     array(
      'class'=>'',
      'wkfo'=>'',
      'tag'=>'select',
      'type'=>'',
      'name'=>'category',
      'id'=>'',
      'caption'=>__('Category', $this->plugin_textdomain),
      'desc'=>__('Category of membership', $this->plugin_textdomain),
      'help'=>'',
      'defvalue'=>'',
      'values'=>array($this, 'get_cats') // array of (keys values or function to get them)
     );

     $ar_cols=
     array(
      'class'=>'',
      'wkfo'=>'',
      'tag'=>'select',
      'type'=>'text',
      'name'=>'college',
      'id'=>'',
      'caption'=>__('College', $this->plugin_textdomain),
      'desc'=>__('College of membership', $this->plugin_textdomain),
      'help'=>'',
      'defvalue'=>'',
      'values'=> array($this, 'get_cols') // array of (keys values or function to get them)
     );

     $ar_others=
     array(
         array(
        'class'=>'',
        'wkfo'=>'',
        'tag'=>'input',
        'type'=>'checkbox',
        'name'=>'edocok',
        'id'=>'',
        'caption'=>__('E-Documents OK', $this->plugin_textdomain),
        'desc'=>__('Check if member is Ok to receive electronic documents ', $this->plugin_textdomain),
        'help'=>'',
        'defvalue'=>'',
        'value'=>'y'
        ),
         array(
        'class'=>'',
        'wkfo'=>'',
        'tag'=>'input',
        'type'=>'text',
        'name'=>'firstcontact',
        'id'=>'',
        'caption'=>__('First contact', $this->plugin_textdomain),
        'desc'=>__('Source of contact', $this->plugin_textdomain),
        'help'=>'',
        'defvalue'=>'',
        'value'=>''
        ),
         array(
        'class'=>'',
        'wkfo'=>'',
        'tag'=>'textarea',
        'type'=>'',
        'name'=>'comments',
        'id'=>'',
        'caption'=>__('Comments', $this->plugin_textdomain),
        'desc'=>__('Comments', $this->plugin_textdomain),
        'help'=>'',
        'defvalue'=>'',
        'value'=>''
        ),
     );

     $ar_internal=array();

     $options=get_option($this->plugin_prefix.'options_shares');

     if (!empty($options) && is_array($options)){
       if (isset($options['cats']) && $options['cats']=='y') $ar_internal[]=$ar_cats;
       if (isset($options['cols']) && $options['cols']=='y') $ar_internal[]=$ar_cols;
     }

     $ar_internal = $ar_internal + $ar_others;


     return apply_filters($this->plugin_prefix.'get_internal_fields', $ar_internal);

   }

   public function get_person_fields() {
       return array(
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'title',
               'id'=>'',
               'caption'=>__('Title', $this->plugin_textdomain),
               'desc'=>__('M. Mme Dr.  ...', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'first_name',
               'id'=>'',
               'caption'=>__('First Name', $this->plugin_textdomain),
               'desc'=>__('First Name', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'last_name',
               'id'=>'',
               'caption'=>__('Last Name', $this->plugin_textdomain),
               'desc'=>__('Last Name', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'user_url',
               'id'=>'',
               'caption'=>__('Website', $this->plugin_textdomain),
               'desc'=>__('Web site url, if any', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'user_email',
               'id'=>'',
               'caption'=>__('Email', $this->plugin_textdomain),
               'desc'=>__('someone@somewhere.tld', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'birthname',
               'id'=>'',
               'caption'=>__('Birth Name', $this->plugin_textdomain),
               'desc'=>__('if different of Lastname', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'birthdate',
               'id'=>'',
               'caption'=>__('Birth date', $this->plugin_textdomain),
               'desc'=>__('Enter Birth Date as DD/MM/YYYY', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'validate'=>'date',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'birthplace',
               'id'=>'',
               'caption'=>__('Birth place', $this->plugin_textdomain),
               'desc'=>__('Department (City) for France or City (Country) for abroad', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'nationality',
               'id'=>'',
               'caption'=>__('Nationality', $this->plugin_textdomain),
               'desc'=>__('Nationality', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'phone',
               'id'=>'',
               'caption'=>__('Phone', $this->plugin_textdomain),
               'desc'=>__('international +xxx +33XXX without leading 0 for France', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'mobile',
               'id'=>'',
               'caption'=>__('Mobile', $this->plugin_textdomain),
               'desc'=>__('international +xxx +33XXX without leading 0 for France', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'adr1',
               'id'=>'',
               'caption'=>__('Address', $this->plugin_textdomain),
               'desc'=>__('Street name', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'adr2',
               'id'=>'',
               'caption'=>__('Address', $this->plugin_textdomain),
               'desc'=>__('Additional information', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'zip',
               'id'=>'',
               'caption'=>__('Zip code', $this->plugin_textdomain),
               'desc'=>__('Zip code of residence', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'city',
               'id'=>'',
               'caption'=>__('City', $this->plugin_textdomain),
               'desc'=>__('City of residence (Uppercases)', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'country',
               'id'=>'',
               'caption'=>__('Country', $this->plugin_textdomain),
               'desc'=>__('Whole name: France...', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'input',
               'type'=>'text',
               'name'=>'job',
               'id'=>'',
               'caption'=>__('Job', $this->plugin_textdomain),
               'desc'=>__('Job or activity', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
                array(
               'class'=>'',
               'wkfo'=>'',
               'tag'=>'textarea',
               'type'=>'',
               'name'=>'comments',
               'id'=>'',
               'caption'=>__('Comments', $this->plugin_textdomain),
               'desc'=>__('Comments', $this->plugin_textdomain),
               'help'=>'',
               'defvalue'=>'',
               'value'=>''
               ),
              );
   }

   public function display_user_subs_table($userid, $usersubs, $form=false) {
     global $wpcoop;

     if (is_array($usersubs) && !empty($usersubs)) {

        echo '
        <table border="1">
        <caption>Historique des opérations</caption>
        <thead>
            <tr><th>'.__('Date (jj/mm/aaaa)', $this->plugin_textdomain).'</th>
                <th>'.__('Opération', $this->plugin_textdomain).'</th>
                <th>'.__('Note', $this->plugin_textdomain).'</th>
                <th style="text-align: right">'.__('Montant/Parts', $this->plugin_textdomain).'</th>';
        if ($form) {
            echo '
                <th>'.__('Actions', $this->plugin_textdomain).'</th>';
        }
        echo ($form && is_admin() &&  current_user_can('administrator'))? '<th>'.__('Admin actions', $this->plugin_textdomain).'</th></tr>' : '</tr>';

        echo'
        </tr>
        </thead>';
        if ($form) {
            echo'
            <form action="'.admin_url('admin.php?page=add2').'" method="post" >';
            echo wp_nonce_field( 'wpcoopsubpage2', $this->plugin_prefix.'wpnonce', true, false );
            echo '
            <input type="hidden" name="'.esc_attr($this->plugin_prefix.'userid').'" value="'.esc_attr($userid).'" />';
        }
        $p=0;
        $v=0;
        $s=0;

  $buttondone=array(); // init to display only one buttos according to action displayed
  foreach($usersubs as $o=>$steps) {
      foreach($steps as $i=>$step) {
          $avail='';
          $unit= (strlen($step['s'])>5 && substr($step['s'],0,5)=='share')? 'Part(s)' : '€';
          if ($unit=='€') {
           $q= $step['q'];
           $v+=$q;
          } else {
           //adjust number of shares accordind to step
           //echo 'operation: '.$o.', step: '.$i.' parts: '.$s;
           //print_tab($step);
           $s=$wpcoop->shares->adjust_shares_from_step($step, $s);
           //echo 'parts : '.$s.'<br>';
           $q=$step['q']/$wpcoop->shares->get_share_price();
           $r=(isset($step['r']))? $step['r']/$wpcoop->shares->get_share_price() : '';
           $avail=($r=='')? '' : sprintf(__('(Avail. : %d)', $this->plugin_textdomain),$r);
          }
          if ($form) {
            // possible next steps, only if step is the last in this operation or isset remaining qty
            $buttons='';
            if (count($usersubs[$o])-1==$i || (isset($step['r']) && !empty($step['r']))) {
              $pns=$this->workflow[$step['s']];
              foreach($pns as $si=>$ns) { // step index
               $buttons.=(!isset($buttondone[$ns['action']]))? '<input type="submit" name="'.$this->plugin_prefix.$ns['action'].$userid.'_'.$o.'_'.$i.'" value="'.esc_attr($ns['button']).'" />' : '';
               if (isset($ns['onlyone']) && $ns['onlyone']=='y') $buttondone[$ns['action']]='y';
              }
            }
          }
                /*
                // reverse date
                $d=substr($l['d'],4,4).substr($l['d'],2,2).substr($l['d'],0,2);
                $temp[$d][$o][]=$l;*/
                echo '<tr>  <td>'.esc_html(substr($step['d'],0,2).'/'.substr($step['d'],2,2).'/'.substr($step['d'],4,4)).'</td><td>'.esc_html($o).'- '.esc_html($wpcoop->shares->get_possible_statuses()[$step['s']]).'</td><td>'.wp_kses_stripslashes(esc_html($step['n']?? '')).'</td>
                        <td style="text-align: right">'.esc_html($q).' '.esc_html($unit).$avail.'</td>';
                if ($form) {
                  echo '<td>
                            '.$buttons.'
                        </td>';
                }
                echo ($form && is_admin() && current_user_can('administrator'))?
                        '<td>
                         <input type="submit" name="'.$this->plugin_prefix.'edit'.$userid.'_'.$o.'_'.$i.'" value="'.esc_attr(__('Edit!',$this->plugin_textdomain)).'" />
                         <input type="submit" name="'.$this->plugin_prefix.'delete'.$userid.'_'.$o.'_'.$i.'" value="'.esc_attr(__('Delete!',$this->plugin_textdomain)).'" />
                        </td>
                      </tr>' :
                     '</tr>';
            }



        }
            /*
            ksort($temp);
            //print_tab($temp);

        foreach($temp as $d=>$us) {
            echo '<tr>  <td>'.substr($d,7,2).'/'.substr($d,5,2).'/'.substr($d,0,4).'</td><td>'.$this->possible_statuses[$us['s']].'</td>
                        <td style="text-align: right">'.$us['q'].' '.$unit.'</td>
                 </tr>';


        }
        */

        $add = ($form && is_admin() && current_user_can('administrator'))? '<td></td>' : '';
        if ($form) {
            $add.='<td></td>';
            echo '
                <tr><td colspan="3" style="text-align: right">'.__('Date Action (jj/mm/aaaa)', $this->plugin_textdomain).'</td>
                <td><input type="input" name="'.$this->plugin_prefix.'newdate" /></td>'.$add.'</tr>
                <tr><td colspan="3" style="text-align: right">'.__('Montant pour rachat/cession', $this->plugin_textdomain).'</td>
                <td><input type="input" name="'.$this->plugin_prefix.'aqty" /></td>'.$add.'</tr>
                <tr><td colspan="3" style="text-align: right">'.__('Note Action', $this->plugin_textdomain).'</td>
                <td><input type="input" name="'.$this->plugin_prefix.'newnote" /></td>'.$add.'</tr>
                </form>';
    // aqty quantité de parts affectées par l'opération
        }
        echo '
        <tfoot>
            <tr><td colspan="2" >'.__("Number of validated shares", $this->plugin_textdomain).'</td><td style="text-align: right">'.$s.' Part(s)</td>'.$add.'</tr>
        </tfoot>
        </table>';

        }// display table if there are subscriptions

    } // display user subs table

    public function is_shareholder($usersubs=array()) {
       if (empty($usersubs) || !is_array($usersubs)) return false;
       $sh=false;
       foreach($usersubs as $o=>$steps) {
         //if last step in any operation indicates user owns share -> shareholder with q>0
           // see get_workflow - functions
         $ls=end($steps);
         if ($ls['q']>0 && ($ls['s']=='shareok' || $ls=='sharenok' || $ls=='sharenokack'
                         || $ls=='sharecessreq'|| $ls=='sharecessok'|| $ls=='sharecessnok' )) {
             $sh=true;
             break;
         }
       }
       return $sh;
    }

    public function get_user_shares_data($userid, $usersubs) {
      global $wpcoop;
      /*
array('none'=>'Pas de nouvelle opération',
*	 'subswft'=>'Souscription en attente de transfert',
*	 'substok'=>'Dossier transfert complet',
   'subsnok'=>'Dossier souscription incomplet',
   'subsok'=>'Dossier souscription complet',
*	 'pending'=>'Souscription en attente de validation', (ne sert a rien, a supprimer ?)
   // all share relative status must begin with 'share'
*	 'shareok'=>'Parts validées',
*	 'sharetok'=>'Transfert de Parts effectué', (la souscription et les parts apparaissent au compte destinataire, doit correspondre à un sharecessdone à la même date)
*	 'sharenok'=>'Rachat de part(s) demandé',
*	 'sharenokack'=>'Rachat de part(s) validé',
*	 'sharenokexe'=>'Rachat de part(s) exécuté',// -> fin eventuelle du societariat si pas d'autre part
*	 'sharenokdone'=>'Rachat de part(s) payé', (opération trésorerie uniquement)
*	 'sharecessreq' => 'Demande de cession faite',
*	 'sharecessok' => 'Demande de cession accordée',
*	 'sharecessnok'=> 'Demande de cession refusée',
*	 'sharecesscanceled'=> 'Demande de cession annulée',
*	 'sharecessdone' => 'Cession faite' // -> fin du eventuelle du societariat
ATTENTION tant que pas automatique

  */
        $created=$wpcoop->functions->get_company_created();
        $createdok=$created!='' && $wpcoop->functions->validate_date($created);
        // get yyyymmdd from dd/mm/yyyy
        $createdinv=substr($created,6,4).substr($created,3,2).substr($created,0,2);
        $pps=$wpcoop->shares->get_share_price();
        $datebeg='';
        $shares=0;
        $value=0;
        // parse operations; operations are ordered in time (that is: first operation first step is before second operation first step and so on)
        $value=0;
        if (empty($usersubs)) {
          $shares=0;
          $value=0;
          $datebeg='';
         } else {
    //if ($userid==1) print_tab($usersubs);
    foreach($usersubs as $o=>$steps) {
      $recordval=false;
      foreach($steps as $n=>$step){
       if (in_array($step['s'],array('subsnok', 'subsok'))){
        // new subscription begin with 'subsnok' or 'subsok'
        // date is registered then
        // add value only if not already registered
        if (!$recordval){
          $datebeg=$step['d'];
          $value+=$step['q'];
         //if ($userid==1) echo '+'.$step['q'].'<br>';
          $recordval=true;
        }
       } elseif ($step['s']=='shareok'){
       // add shares only when validated
       $shares+=$step['q']/$pps;
       } elseif ($step['s']=='sharetok'){
       // transfert done, record date, value, share
                 if (empty($datebeg)) $datebeg=$step['d'];
       $value+=$step['q'];
       $shares+=$step['q']/$pps;
       } elseif (in_array($step['s'],array('sharenokexe', 'sharecessdone'))){
       // substract shares and subscription value, remove date if 0
       $value-=$step['q'];
       $shares-=$step['q']/$pps;
                       if ($value==0) $datebeg='';
       } elseif (in_array($step['s'], array('subswft', 'substok', 'pending',
              'sharenok', 'sharenokack', 'sharenokdone',
              'sharecessreq', 'sharecessok', 'sharecessnok',
              'sharecesscanceled'))){
      // do nothing
       }
      }
          }
          // subscription date cannot be before company was created
          if($createdok) {
              // get yyyymmdd from ddmmyyyy
              $datebeginv=substr($datebeg,4,4).substr($datebeg,2,2).substr($datebeg,0,2);
              if (!empty($datebeg) && $datebeginv < $createdinv ) {
        // if company created after, set date to company creation date
        // set to ddmmyyyy from yyyymmdd
        $datebeg=substr($created,0,2).substr($created,3,2).substr($created,6,4);
              }
          }


        }
        return array('shares'=>$shares, 'value'=>$value, 'date'=>$datebeg);
    }




  } //class
} // if class exits
