<?php
/**
 * Exit if accessed directly
 */
if ( !defined( 'ABSPATH' ) ) {
    exit; 
}
if ( !class_exists( 'WPCOOP_Admin_Settings' ) ) {

    class WPCOOP_Admin_Settings {

        public function __construct() {
            global $wpcoop;
            // copy some parameters from wpcoop
            //$this->plugin_version = $wpcoop->plugin_version; // not yet available
            $this->plugin_prefix = $wpcoop->plugin_prefix;
            $this->plugin_textdomain = $wpcoop->plugin_textdomain; 
            $this->plugin_version = $wpcoop->plugin_version; 
            
            $this->plugin_capability = $wpcoop->plugin_capability;
            $this->plugin_settings_capability=$wpcoop->plugin_settings_capability;
            //$this->plugin_read_capability=$wpcoop->plugin_read_capability;
            //$this->plugin_lists_capability=$wpcoop->plugin_lists_capability;
            
            $this->plugin_options_page = 'wpcoop_options';

            $this->plugin_metakey_options_coop_roles=$this->plugin_prefix.'options_coop_roles';

            // when admin initialisation, add settings
            add_action( 'admin_init', array( $this, 'init_options_page' ));
            
            // when in admin menu, add admin pages subpage and settings
            add_action( 'admin_menu', array( $this, 'setup_options_page' ));
            
        }
       /*
        private function get_plugin_version() {
          global $wpcoop;
          return $wpcoop->plugin_version;    
        }
        */
        public function get_possible_statuses() {
        
            return apply_filters ('wpcoop_get_possible_statuses',
                   array('none'=>'Pas de nouvelle opération',
                         'subswft'=>'Souscription en attente de transfert',
                         'substok'=>'Dossier transfert complet',
                         'subsnok'=>'Dossier souscription incomplet',
                         'subsok'=>'Dossier souscription complet',
                         'pending'=>'Souscription en attente de validation',
                         // all share relative status must begin with 'share'
                         'shareok'=>'Parts validées', 
			 'sharetok'=>'Transfert de Parts effectué', //(la souscription et les parts apparaissent au compte destinataire, doit correspondre à un sharecessdone à la même date) 
                         'sharenok'=>'Rachat de part(s) demandé',
                         'sharenokack'=>'Rachat de part(s) validé',
                         'sharenokexe'=>'Rachat de part(s) exécuté',// -> fin eventuelle du societariat si pas d'autre part
                         'sharenokdone'=>'Rachat de part(s) payé',
                         'sharecessreq' => 'Demande de cession faite',
                         'sharecessok' => 'Demande de cession accordée', 
                         'sharecessnok'=> 'Demande de cession refusée', 
                         'sharecesscanceled'=> 'Demande de cession annulée', 
                         'sharecessdone' => 'Cession faite' // -> fin du eventuelle du societariat si pas d'autre part
                       ));

        
        }
 /*       
        public function get_possible_actions() {
        
            return apply_filters ('wpcoop_get_possible_actions',
                   array('regsubsnok'=>'Enregistrement dossier souscription incomplet',
                         'delsubs'=>'Suppression souscription',
                         'regsubsok'=>'Energistrement dossier souscription complet',
                         'subsnokok'=>"Validation d'un dossier de souscription incomplet",
                         'subsok'=>"Validation d'un dossier de souscription complet", 
                         'subsokack'=>'Prise en compte du dossier de souscription', 
                         'subswait'=>'Souscription en attente de validation',
                         'shareval'=>'Parts validées',
                         'sharenok'=>'Rachat de part(s) demandé',
                         'sharenokack'=>'Rachat de part(s) validé',
                         'sharenokdone'=>'Rachat de part(s) exécuté', // 
                         'sharenokpaid'=>'Rachat de part(s) payé',                       
                         'sharecessreq' => 'Demande de cession faite',
                         'sharecessok' => 'Demande de cession accordee', //-> fin du eventuelle du societariat si pas d'autre part
                         'sharecessnok'=> 'Demande de cession refusee',  //-> doit generer sharenokexe article 12 des statuts
                         'sharecessdone' => 'Cession faite' // -> fin du eventuelle du societariat si pas d'autre part
                       ));

        
        }
   */     
        public function get_workflow() {
            return apply_filters ('wpcoop_get_worflow',
                   array(
                       'none'=>array(
					array(                       
						'nextstate'=>'subswft',         // next state possible
						'action'=>'regsubswft',         // action to do
						'lib'=> __('Register subscription waiting for tranfert', $this->plugin_textdomain),
						'button'=> __('Subs. Waiting', $this->plugin_textdomain),
						'requires'=>'none',             // status required?
						'role'=>''),         // who can do it?
                                    array(                       
                                        'nextstate'=>'subsnok',         // next state possible
                                        'action'=>'regsubsnok',         // action to do
                                        'lib'=> __('Register incomplete application', $this->plugin_textdomain),
                                        'button'=> __('Subs. Nok', $this->plugin_textdomain),
                                        'requires'=>'none',             // status required?
                                        'role'=>''),         // who can do it?
                                    array(
                                        'nextstate'=>'subsok',          // next state possible
                                        'action'=>'regsubsok',          // action to do
                                        'lib'=> __('Register complete application', $this->plugin_textdomain),
                                        'button'=> __('Subs. Ok', $this->plugin_textdomain),
                                        'requires'=>'none',             // status required?
                                        'role'=>'wpcoopadmin'),         // who can do it?
                                      ),
                   
				'subswft'=>array(  // subscription waiting for tranfert
					array(                       
						'nextstate'=>'none',       // next state possible
						'action'=>'delsubs',             // action to do
						'lib'=> __('Supprime le transfert en attente', $this->plugin_textdomain),
						'button'=> __('Delete!', $this->plugin_textdomain),
						'requires'=>'none',             // status required?
						'role'=>'wpcoopadmin'),         // who can do it?
					array(
						'nextstate'=>'substok',          // next state possible
						'action'=>'subswftok',          // action to do
						'lib'=> __('Dossier Tranfert Ok', $this->plugin_textdomain),
						'button'=> __('Dossier Transf. OK', $this->plugin_textdomain),
						'requires'=>'none',             // status required?
						'role'=>'wpcoopadmin'),         // who can do it?
					  ),

				'substok'=>array(  // subscription waiting for tranfert dossier complet
					array(                       
						'nextstate'=>'none',       // next state possible
						'action'=>'delsubstok',             // action to do
						'lib'=> __('Supprime le transfert en attente', $this->plugin_textdomain),
						'button'=> __('Delete!', $this->plugin_textdomain),
						'requires'=>'none',             // status required?
						'role'=>'wpcoopadmin'),         // who can do it?
					array(
						'nextstate'=>'sharetok',          // next state possible
						'action'=>'sharetok',          // action to do
						'lib'=> __('Tranfert validé', $this->plugin_textdomain),
						'button'=> __('Val. Tranfert', $this->plugin_textdomain),
						'requires'=>'none',             // status required?
						'role'=>'wpcoopadmin'),         // who can do it?
					  ),

				'subsnok'=>array(  // souscription dossier incomplet
                                    array(                       
                                        'nextstate'=>'none',       // next state possible
                                        'action'=>'delsubs',             // action to do
                                        'lib'=> __('Supprime le dossier de souscription', $this->plugin_textdomain),
                                        'button'=> __('Delete!', $this->plugin_textdomain),
                                        'requires'=>'none',             // status required?
                                        'role'=>'wpcoopadmin'),         // who can do it?
                                    array(
                                        'nextstate'=>'subsok',          // next state possible
                                        'action'=>'subsnokok',          // action to do
                                        'lib'=> __('Dossier de souscription complété', $this->plugin_textdomain),
                                        'button'=> __('Subs. OK', $this->plugin_textdomain),
                                        'requires'=>'none',             // status required?
                                        'role'=>'wpcoopadmin'),         // who can do it?
                                      ),
                         
                        'subsok'=>array(
                                    array(                       
                                        'nextstate'=>'none',            // next state possible
                                        'action'=>'delsubs',            // action to do
                                        'lib'=> __('Supprime le dossier de souscription', $this->plugin_textdomain),
                                        'button'=> __('Delete!', $this->plugin_textdomain),
                                        'requires'=>'none',             // status required?
                                        'role'=>'wpcoopadmin'),         // who can do it?
                                    array(
                                        'nextstate'=>'pending',       // next state possible
                                        'action'=>'subsokack',        // action to do
                                        'lib'=> __('Dossier de souscription pris en compte', $this->plugin_textdomain),
                                        'button'=> __('Att. Val', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'president'),         // who can do it?
                                      ),
                         
                        'pending'=>array(
                                    array(                       
                                        'nextstate'=>'none',         // next state possible
                                        'action'=>'delsubs',         // action to do
                                        'lib'=> __('Supprime le dossier de souscription', $this->plugin_textdomain),
                                        'button'=> __('Delete!', $this->plugin_textdomain),
                                        'requires'=>'none',          // status required?
                                        'role'=>'president'),        // who can do it?
                                    array(
                                        'nextstate'=>'shareok',       // next state possible
                                        'action'=>'sharevala',         // action to do
                                        'lib'=> __('Validation de la souscription par le CA ou l\'AG - nouveau souscripteur -art 15', $this->plugin_textdomain),
                                        'button'=> __('Ok CA/AG', $this->plugin_textdomain),
                                        'requires'=>'none',           // status required?
                                        'role'=>'CA,AG'),             // who can do it? art 15
                            
                                    array(
                                        'nextstate'=>'shareok',       // next state possible
                                        'action'=>'sharevalp',         // action to do
                                        'lib'=> __('Validation de la souscription par le président -souscripteur existant - art 9', $this->plugin_textdomain),
                                        'button'=> __('OK President', $this->plugin_textdomain),
                                        'requires'=>'shareholder',    // status required? art 9
                                        'role'=>'president'),         // who can do it?   art 9
                                      ),
                       
                          'shareok'=>array(
						  array(
							'nextstate'=>'sharenok',         // next state possible
							'action'=>'sharereclaim',         // action to do
							'lib'=> __('Demande de rachat de part', $this->plugin_textdomain),
							'button'=> __('Demande de rachat', $this->plugin_textdomain), 
							'requires'=>'none',            // status required?
						'onlyone'=>'y',  // only available for first subscription shareok
							'aqtyreq'=>'y',  // action quantity field required
							'requires'=>'none',          // status required?
							'role'=>'shareholder'),        // who can do it?
						  array(
							'nextstate'=>'sharecessreq',         // next state possible
							'action'=>'sharecessreq',         // action to do
							'lib'=> __('Demande de cession de part', $this->plugin_textdomain),
							'button'=> __('Demande de cession', $this->plugin_textdomain), 
							'requires'=>'none',            // status required?
						'onlyone'=>'y',  // only available for first subscription shareok
							'aqtyreq'=>'y',  // action quantity field required
							'requires'=>'none',          // status required?
							'role'=>'shareholder'),        // who can do it?
						 ),

				  'sharetok'=>array(
                                      array(
                                        'nextstate'=>'sharenok',         // next state possible
                                        'action'=>'sharereclaim',         // action to do
                                        'lib'=> __('Demande de rachat de part', $this->plugin_textdomain),
                                        'button'=> __('Demande de rachat', $this->plugin_textdomain), 
							'requires'=>'none',            // status required?
						'onlyone'=>'y',  // only available for first subscription shareok
							'aqtyreq'=>'y',  // action quantity field required
                                        'requires'=>'none',            // status required?
                                        'role'=>'shareholder'),        // who can do it?
                                      array(
                                        'nextstate'=>'sharecessreq',         // next state possible
                                        'action'=>'sharecessreq',         // action to do
                                        'lib'=> __('Demande de cession de part', $this->plugin_textdomain),
                                        'button'=> __('Demande de cession', $this->plugin_textdomain), 
                                        'requires'=>'none',            // status required?
						'onlyone'=>'y',  // only available for first subscription shareok
							'aqtyreq'=>'y',  // action quantity field required
							'requires'=>'none',          // status required?
                                        'role'=>'shareholder'),        // who can do it?
                                     ),
                     
                       
                           // sharenok -> demande de rachat faite
                           // sharenokack -> demande de rachat prise en compte
                           // sharenokdone -> demande de rachat acceptee -> fin du eventuelle du societariat si pas d'autre part
                           // sharenokpaid -> demande de rachat effectuee (remboursement fait)
                       
                           // sharecessreq -> demande de cession faite
                           // sharecessok-> demande de cession accordee
                           // sharecessnok-> demande de cession refusee -> doit generer sharenokexe article 12 des statuts ou cesscancel
                           // sharecessdone-> cession faite -> fin du eventuelle du societariat si pas d'autre part
				   // sharecesscanc-> cession annullee 
          
                          'sharecessreq'=>array(
                                    array(                       
                                        'nextstate'=>'sharecessok',      // next state possible
                                        'action'=>'sharecessok',         // action to do
                                        'lib'=> __('Demande de cession OK CA', $this->plugin_textdomain),
                                        'button'=> __('Demande de cession OK CA', $this->plugin_textdomain), 
//					'onlyone'=>'y',  // only available for first subscription shareok
//					'aqtyreq'=>'y',  // action quantity field required
                                        'requires'=>'none',          // status required?
                                        'role'=>'CA,AG'),        // who can do it?
                                    array(
                                        'nextstate'=>'sharecessnok',       // next state possible
					'action'=>'sharecessnok',         // action to do
                                        'lib'=> __('Demande de cession NOK CA', $this->plugin_textdomain),
                                        'button'=> __('Demande de cession NOK CA', $this->plugin_textdomain), 
//					'aqtyreq'=>'y',  // action quantity field required
                                        'requires'=>'none',           // status required?
                                        'role'=>'CA,AG'),             // who can do it? art 15
                                      ),
                       
                          'sharecessok'=>array(
                                    array(                       
                                        'nextstate'=>'sharecessdone',      // next state possible
                                        'action'=>'sharecessdone',         // action to do
                                        'lib'=> __('Cession faite', $this->plugin_textdomain),
                                        'button'=> __('Cession faite', $this->plugin_textdomain), 
                                        'requires'=>'none',          // status required?
					'aqtyreq'=>'y',  // action quantity field required
                                        'role'=>'shareholder'),        // who can do it?
                                    array(
                                        'nextstate'=>'sharecesscancel',       // next state possible
					'action'=>'sharecesscancel',      // action to do
                                        'lib'=> __('Annulation cession', $this->plugin_textdomain),
                                        'button'=> __('Annulation cession', $this->plugin_textdomain), 
                                        'requires'=>'none',           // status required?
                                        'role'=>'shareholder'),             // who can do it? art 15
                                      ),
                           'sharecessnok'=>array(
                                    array(
					'nextstate'=>'sharecessreq',       // next state possible
                                        'action'=>'sharenok',         // action to do
					'lib'=> __('Demande cession refusée', $this->plugin_textdomain),
					'button'=> __('Demande cession refusée', $this->plugin_textdomain), 
                                        'requires'=>'none',           // status required?
				 	'role'=>'CA,AG'),  
                                    array(
                                        'nextstate'=>'sharecesscancel',       // next state possible
					'action'=>'sharecesscancel',         // action to do
					'lib'=> __('Annulation demande de cession', $this->plugin_textdomain),
					'button'=> __('Annulation demande de cession', $this->plugin_textdomain), 
                                        'requires'=>'none',           // status required?
                                        'role'=>'shareholder'),             // who can do it? art 15
                                      ),
                       
			    'sharecessdone'=>array(),
                      
                      
                        'sharenok'=>array(
                                    array(                       
								'nextstate'=>'sharenokack',  // next state possible
								'action'=>'sharenotokack',   // action to do
								'lib'=> __('Demande de rachat de part(s) prise en compte', $this->plugin_textdomain),
								'button'=> __('Rachat part(s) Energistré', $this->plugin_textdomain), 
                                        'requires'=>'none',          // status required?
								'role'=>'CA,AG'),        // who can do it?
                                    array(
								'nextstate'=>'sharenokcanc',  // next state possible
								'action'=>'sharenokcanc',     // action to do
								'lib'=> __('Annulation Demande de rachat', $this->plugin_textdomain),
								'button'=> __('Annulation', $this->plugin_textdomain), 
                                        'requires'=>'none',           // status required?
								'role'=>'shareholder'),             // who can do it? art 15
                            
                                      ),
            
                        'sharenokack'=>array(
                                    array(                       
								'nextstate'=>'sharenokdone',         // next state possible
								'action'=>'sharenotokdone',         // action to do
								'lib'=> __('Demande rachat enregistrée', $this->plugin_textdomain),
								'button'=> __('Demande enregistrée', $this->plugin_textdomain), 
                                        'requires'=>'none',          // status required?
								'role'=>'admin'),        // who can do it?
                                      ),
                            
				'sharenokdone'=>array(
                                    array(
								'nextstate'=>'sharenokpaid',         // next state possible
								'action'=>'sharenokpaid',         // action to do
								'lib'=> __('Rachat validé', $this->plugin_textdomain),
								'requires'=>'none',          // status required?
								'role'=>'CA,AG'),        // who can do it?
                                      ),
                       
			   	'sharenokpaid'=>array(
                                    array(                       
								'nextstate'=>'none',         // next state possible
                                        'action'=>'sharereclaim',         // action to do
								'lib'=> __('Rachat de part(s) payé', $this->plugin_textdomain),
								'button'=> __('Payé', $this->plugin_textdomain), 
                                        'requires'=>'none',          // status required?
								'role'=>'admin'),        // who can do it?
                                      ),
	                         
                        )
                    );
        }
        
        
        public function setup_options_page() {            
            // add options page (parameters setup)
            add_options_page( __( 'WP Coop setup', $this->plugin_textdomain ),
                              __( 'WP Coop setup', $this->plugin_textdomain ),
                              //only multisite superuser has all capabilities unless specifically denied
                              $this->plugin_settings_capability,
                              $this->plugin_options_page, 
                              array($this, 'display_options_page')
                            );                       
        }
        // options settings
            
    
        public function get_options_tabs($info='') {
          $medias=array(
                         'tabs'=> array(
                  array( 'slug'=>'roles', 'caption'=>__('Roles',$this->plugin_textdomain)),
                  array( 'slug'=>'coop', 'caption'=>__('Cooperative',$this->plugin_textdomain)),
                  array( 'slug'=>'cats', 'caption'=>__('Categories',$this->plugin_textdomain)),
                  array( 'slug'=>'coll', 'caption'=>__('Colleges',$this->plugin_textdomain)),
                  array( 'slug'=>'shares', 'caption'=>__('Shares',$this->plugin_textdomain)),
                  array( 'slug'=>'management', 'caption'=>__('Management',$this->plugin_textdomain)),
                  array( 'slug'=>'councils', 'caption'=>__('Councils',$this->plugin_textdomain)),
                  array( 'slug'=>'meetings', 'caption'=>__('Meetings',$this->plugin_textdomain)),
                  array( 'slug'=>'maps', 'caption'=>__('Maps',$this->plugin_textdomain)),
                  array( 'slug'=>'promos', 'caption'=>__('Promos',$this->plugin_textdomain)),
                  array( 'slug'=>'subs', 'caption'=>__('Subscriptions',$this->plugin_textdomain))
                                       ),
                        'options'=> array(
                  array( 'group'=>$this->plugin_metakey_options_coop_roles.'_group', 'name'=>$this->plugin_metakey_options_coop_roles,'callback'=>array($this, 'validate_options_coop_roles')),
                  array( 'group'=>$this->plugin_prefix.'options_coop_group', 'name'=>$this->plugin_prefix.'options_coop','callback'=>array($this, 'validate_options_coop')),
                  array( 'group'=>$this->plugin_prefix.'options_cats_group', 'name'=>$this->plugin_prefix.'options_cats','callback'=>array($this, 'validate_options_cats')),
                  array( 'group'=>$this->plugin_prefix.'options_coll_group', 'name'=>$this->plugin_prefix.'options_coll','callback'=>array($this, 'validate_options_coll')),
                  array( 'group'=>$this->plugin_prefix.'options_shares_group', 'name'=>$this->plugin_prefix.'options_shares','callback'=>array($this, 'validate_options_shares')),
                  array( 'group'=>$this->plugin_prefix.'options_councils_group', 'name'=>$this->plugin_prefix.'options_councils', 'callback'=>array($this, 'validate_options_councils')),
                  array( 'group'=>$this->plugin_prefix.'options_management_group', 'name'=>$this->plugin_prefix.'options_management', 'callback'=>array($this, 'validate_options_management')),
                  array( 'group'=>$this->plugin_prefix.'options_meetings_group', 'name'=>$this->plugin_prefix.'options_meetings', 'callback'=>array($this, 'validate_options_meetings')),
                  array( 'group'=>$this->plugin_prefix.'options_maps_group', 'name'=>$this->plugin_prefix.'options_maps', 'callback'=>array($this, 'validate_options_maps')),
                  array( 'group'=>$this->plugin_prefix.'options_promos_group', 'name'=>$this->plugin_prefix.'options_promos', 'callback'=>array($this, 'validate_options_promos')),
                  array( 'group'=>$this->plugin_prefix.'options_subs_group', 'name'=>$this->plugin_prefix.'options_subs', 'callback'=>array($this, 'validate_options_subs'))
                                         ),
                         'actions'=> array(
                  array( 'slug'=>'coop'),
                  array( 'slug'=>'management')
                                          )
                        );
          $medias=apply_filters('wpcoop_options_tabs',$medias);
          switch($info) {
           case 'tabs':
            $ret=$medias['tabs'];
            break;
           case 'options':
            $ret=$medias['options'];
            break;
           case 'actions':
            $ret=$medias['actions'];
            break;
           default:
            $ret=$medias;
          }
          return $ret;
        } 
        
        public function simulate_settings_messages($index, $text){
          // when sending data directly (not to options.php) validate and error messages don't fire
          echo '<div id="'.$index.'" class="notice notice-error settings-error is-dismissible"
                    <p><strong>'.$text.'</strong></p>
                    <button class="notice-dismiss" type="button">
                    <span class="screen-reader-text">Ne pas tenir compte de ce message</span>
                    </button>
                </div>';                   
        }
        
        function set_error_messages_after_uploading_file(){
            
            
            
        }
        
        public function manage_secured_pdf($args) { 
            $defs=array('option_item'=>'xxxx',
                        'option'=>'options_xxx_file',
                        'max_file_size'=>'300000',
                        'title'=>__("XXX actuel",$this->plugin_textdomain),
                        'change'=>__('Changer le XXX: ',$this->plugin_textdomain),
                        'update'=>__('Mettre à jour le XXX',$this->plugin_textdomain),
                       );
            $args=wp_parse_args($args, $defs);
            //print_tab($args);
            //print_tab($_FILES);
            if (isset($_POST['option_page']) && $_POST['option_page']==$this->plugin_prefix.$args['option_item']) {
                // ok this item!
            //print_tab($_FILES);
                
                //if (isset($_FILES[$this->plugin_prefix.$args['name']]) && is_array($_FILES[$this->plugin_prefix.$args['name']])) { 
                // $tmp=$_FILES[$this->plugin_prefix.$args['name']];
                if (isset($_FILES[$this->plugin_prefix.$args['option']]) && is_array($_FILES[$this->plugin_prefix.$args['option']])) { 
                 $tmp=$_FILES[$this->plugin_prefix.$args['option']];
                 if (isset($tmp['tmp_name']) && is_file($tmp['tmp_name']) && (!isset($tmp['error']) || $tmp['error']==UPLOAD_ERR_OK)) {   
                  if ($r=@fopen($tmp['tmp_name'], "r")) { 
                   update_option($this->plugin_prefix.$args['option'],
                                    array('name'=>$tmp['name'],
                                          'type'=>$tmp['type'],
                                          'size'=>$tmp['size'],
                                          'data'=>base64_encode(fread($r, $tmp['size']))));
                  } else {
                    $this->simulate_settings_messages('TMP_FILE_NOT_READ',__("The temporary file could not be read", $this->plugin_textdomain ));   
                  }
                 } else {
                  if (!isset($tmp['tmp_name']))  {
                    $this->simulate_settings_messages('TMP_FILE_NAME_NOT_SET',__("The temporary file name was not set", $this->plugin_textdomain )); 
                  } 
                  if (isset($tmp['tmp_name']) && !empty($tmp['tmp_name']) && !is_file($temp['tmp_name']))  {
                    $this->simulate_settings_messages('TMP_FILE_NOT_FOUND',__("The temporary file name was not found", $this->plugin_textdomain )); 
                  } 

                  if (isset($tmp['error']) && $tmp['error']!=0) {
                     switch ($tmp['error']) {
                        case UPLOAD_ERR_INI_SIZE:
                            $this->simulate_settings_messages('UPLOAD_ERR_INI_SIZE',__("The uploaded file exceeds the upload_max_filesize directive in php.ini", $this->plugin_textdomain ));
                            break;
                        case UPLOAD_ERR_FORM_SIZE:
                            $this->simulate_settings_messages('UPLOAD_ERR_FORM_SIZE',__("The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form", $this->plugin_textdomain ));
                            break;
                        case UPLOAD_ERR_PARTIAL:
                            $this->simulate_settings_messages('UPLOAD_ERR_PARTIA',__("The uploaded file was only partially uploaded", $this->plugin_textdomain ));
                            break;
                        case UPLOAD_ERR_NO_FILE:
                            $this->simulate_settings_messages('UPLOAD_ERR_NO_FILE',__("No file was uploaded", $this->plugin_textdomain ));
                            break;
                        case UPLOAD_ERR_NO_TMP_DIR:
                            $this->simulate_settings_messages('UPLOAD_ERR_NO_TMP_DIR',__("Missing a temporary folder", $this->plugin_textdomain ));
                            break;
                        case UPLOAD_ERR_CANT_WRITE:
                            $this->simulate_settings_messages('UPLOAD_ERR_CANT_WRITE',__("Failed to write file to disk", $this->plugin_textdomain ));
                            break;
                        case UPLOAD_ERR_EXTENSION:
                            $this->simulate_settings_messages('UPLOAD_ERR_EXTENSION',__("File upload stopped by extension", $this->plugin_textdomain ));
                            break;
                        default:
                            $this->simulate_settings_messages('UPLOAD_ERR_UNKNOWN',__("Unknown upload error", $this->plugin_textdomain ));
                            break;
                    }                           
                  } // error # 
                 } // read error 
                }
            }
            $defs=array('option'=>'xxxx',
                        'title'=>__("Image to change",$this->plugin_textdomain),
                        'change'=>__('Change image: ',$this->plugin_textdomain),
                        'name'=>'options_xxxx_file',
                        'update'=>__('Update image',$this->plugin_textdomain)
                       );
            
            $args=wp_parse_args($args, $defs);
            
            $ar_file=get_option($this->plugin_prefix.$args['option']);
            
            //print_tab($ar_file);
            
            echo '<form enctype="multipart/form-data" method="post" action="'.admin_url('options-general.php?page=wpcoop_options&tab=subs').'" >';
            settings_fields($this->plugin_prefix.$args['option_item']); 
            echo '<input type="hidden" name="MAX_FILE_SIZE" value="'.$args['max_file_size'].'" />';
           
            ?>
             <div>
               <table class="form-table">
                <tr>
                    <td><?php echo esc_html($args['title']); ?></td>
                    <td><?php echo (empty($ar_file))? '' : $ar_file['name'] ?></td>
                    <td><?php echo esc_html($args['change']); ?>
                     <input type="file" name="<?php echo $this->plugin_prefix.$args['option']; ?>" />
                    </td>
                </tr>
               </table>
               <p class="submit">
                <input type="submit" class="button-primary" value="<?php echo esc_html($args['update']); ?>" />
               </p>
             </div>
            <?php
            echo '</form>';
            
            
            
            
            
        }
        
        
        public function update_secured_image($args) {
            $defs=array('option_group'=>'xxxx',
                        'max_file_size'=>'300000',
                        'name'=>'options_XXXX',
                        'url_option'=>'xxxxx'
                       );
           
            $args=wp_parse_args($args, $defs);
            
            
            settings_fields($this->plugin_prefix.$args['option_group']); 
            ?>
            <input type="hidden" name="MAX_FILE_SIZE" value="<?php echo $args['max_file_size']; ?>" />
            <?php
            $message='';
         
            if (isset($_FILES[$this->plugin_prefix.$args['name']]) && is_array($_FILES[$this->plugin_prefix.$args['name']])) { 
             $tmp=$_FILES[$this->plugin_prefix.$args['name']];
             if (isset($tmp['tmp_name']) && is_file($tmp['tmp_name']) && (!isset($tmp['error']) || $tmp['error']==UPLOAD_ERR_OK)) {   
              if ($r=@fopen($tmp['tmp_name'], "r")) { 
               update_option($this->plugin_prefix.$args['name'],
                                array('name'=>$tmp['name'],
                                      'type'=>$tmp['type'],
                                      'size'=>$tmp['size'],
                                      'data'=>base64_encode(fread($r, $tmp['size']))));
               // TOKEN to be replaced with true token=xxx when url called      
               update_option($this->plugin_prefix.$args['url_option'], get_site_url().'/image/?image='.$args['name'].'&TOKEN&filename='.$tmp['name']);   

              } else {
                $message.=' File not read ';    
              }
             } else {

              if (!isset($tmp['tmp_name']))  {
               $message .= "Temporary file not set";   
              } 
              if (isset($tmp['tmp_name']) && !empty($tmp['tmp_name']) && !is_file($temp['tmp_name']))  {
               $message .= "Temporary file not found";   
              } 

              if (isset($tmp['error']) && $tmp['error']!=0) {
                 switch ($tmp['error']) {
                    case UPLOAD_ERR_INI_SIZE:
                        $message.= "The uploaded file exceeds the upload_max_filesize directive in php.ini";
                        break;
                    case UPLOAD_ERR_FORM_SIZE:
                        $message.= "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form";
                        break;
                    case UPLOAD_ERR_PARTIAL:
                        $message.= "The uploaded file was only partially uploaded";
                        break;
                    case UPLOAD_ERR_NO_FILE:
                        $message.= "No file was uploaded";
                        break;
                    case UPLOAD_ERR_NO_TMP_DIR:
                        $message.= "Missing a temporary folder";
                        break;
                    case UPLOAD_ERR_CANT_WRITE:
                        $message.= "Failed to write file to disk";
                        break;
                    case UPLOAD_ERR_EXTENSION:
                        $message.= "File upload stopped by extension";
                        break;

                    default:
                        $message.= "Unknown upload error";
                        break;
                }                           
              } // error # 
              echo $message;   
             } // read error 
            }
    
        }
        
        // display and permits update of image given by options
        public function display_secured_image_update_form($args) {
            
            $defs=array('option'=>'xxxx',
                        'title'=>__("Image to change",$this->plugin_textdomain),
                        'change'=>__('Change image: ',$this->plugin_textdomain),
                        'name'=>'options_xxxx_file',
                        'update'=>__('Update image',$this->plugin_textdomain)
                       );
            
            $args=wp_parse_args($args, $defs);

            $ar_image=get_option($this->plugin_prefix.$args['option']);
            
            ?>
             <div>
               <table class="form-table">
                <tr>
                    <td><?php echo esc_html($args['title']); ?></td>
                    <td><?php echo (empty($ar_image))? '' : '<img src="data:'.$ar_image['type'].';base64,'.$ar_image['data'].'"/>' ?></td>
                    <td><?php echo esc_html($args['change']); ?>
                     <input type="file" name="<?php echo $this->plugin_prefix.$args['name']; ?>" />
                    </td>
                </tr>
               </table>
               <p class="submit">
                <input type="submit" class="button-primary" value="<?php echo esc_html($args['update']); ?>" />
               </p>
             </div>
            <?php
        }
  
        public function get_options_coop_roles(){
           return get_option($this->plugin_metakey_options_coop_roles); 
        }
        
        public function get_plugin_operators($type) {
           $option = $this->get_options_coop_roles();
           return (isset($option[$type]))? $option[$type] : array();  
        }
        
        public function get_plugin_readers(){
          return $this->get_plugin_operators('reader'); 
        }
        
        public function get_plugin_editors(){
          return $this->get_plugin_operators('editor'); 
        }
        
        public function get_plugin_setters(){
          return $this->get_plugin_operators('setter'); 
      }
        
        public function return_plugin_operators_lines($ids, $type) {
            // $ids is array of valid user ids, not empty
            $lines='';
            foreach ($ids as $id){
             $ud=get_userdata($id);
             $lines.='<tr><td>'.$id.'</td><td>'.esc_html($ud->user_login).'</td><td>'.esc_html($ud->display_name).'</td><td>'.esc_html($ud->user_nicename).'</td>'."\n";   
             $lines.='<td><input type="submit" name="'.$this->plugin_metakey_options_coop_roles.'[revoke_'.$type.']['.$id.']" value="'.__("Revoke",$this->plugin_textdomain).'"</td></tr>'."\n";   
            }
            return $lines;
        }
        
        public function return_plugin_operators_headers(){
            return  '<tr>
                      <th>'.__("ID",$this->plugin_textdomain).'</th>
                      <th>'.__("Login",$this->plugin_textdomain).'</th>
                      <th>'.__("Display Name",$this->plugin_textdomain).'</th>
                      <th>'.__("Nice Name",$this->plugin_textdomain).'</th>
                     </tr>';
          
            
        }
        
        public function get_plugin_add_operator($type){
            $operators=$this->get_plugin_operators($type);
            return '<tr>
            <td colspan="3"  style="border-width: 1px; border-style: solid none none none" >'.__("Ajouter un opérateur",$this->plugin_textdomain).'</td>
            <td style="border-width: 1px; border-style: solid none none none">'.
            //https://developer.wordpress.org/reference/functions/wp_dropdown_users/
            wp_dropdown_users(array('echo'=>0, 'multi'=>1, 'exclude'=>$operators, 'name'=>$this->plugin_metakey_options_coop_roles.'['.$type.']')).'
            </td>
            <td style="border-width: 1px; border-style: solid none none none"><input type="submit" name="'.$this->plugin_metakey_options_coop_roles.'[add_'.$type.']" value="'.__("Add",$this->plugin_textdomain).'"></td></tr>';
        }
        
        // Renders the options page. Uses the settings API (options validation, checking and storing by WP).
        public function display_options_page() {
          /////// get active tab
          if (!current_user_can($this->plugin_settings_capability)) {
            _e('Les réglages de WPCOOP vous sont inaccessibles, consultez votre webmaster',$this->plugin_textdomain);
          } else {
          $tabs= $this->get_options_tabs('tabs');
          $active_tab='roles';
          if( isset( $_GET[ 'tab' ] ) ) {
            foreach($tabs as $tab) {
              if($_GET[ 'tab' ]==$tab['slug']) $active_tab=$tab['slug'];
            }
          }
  
            /////// displays tabs
            ?>
            <div class="wrap">
                <div class="icon32" id="icon-options-general"><br /></div>
                <h2>
                    <?php _e('WpCoop V: '.$this->plugin_version, $this->plugin_textdomain) ?>
                </h2>
                <h2 class="nav-tab-wrapper">
                <?php
                if (!empty($tabs)) {
                  foreach ($tabs as $tab) {
                    $addclass= ($tab['slug']==$active_tab)? 'nav-tab-active' : '';
                    ?>
                    <a href="?page=<?php echo $this->plugin_options_page; ?>&tab=<?php echo $tab['slug']; ?>" class="nav-tab <?php echo $addclass; ?>"><?php echo $tab['caption']; ?> </a>
                    <?php
                  }
                }
                ?>
                </h2>
            </div>
            <?php
            switch ($active_tab) {
                 case 'roles':
                    $options = get_option($this->plugin_metakey_options_coop_roles);
                    
                    //print_r($options);
                    ?>
                    <form method="post" action="options.php" >
                      <?php settings_fields($this->plugin_metakey_options_coop_roles.'_group'); ?>
                      <h3><?php _e('Roles', $this->plugin_textdomain) ?></h3>
                      <div>
                         <table width="100%" style="border: solid 1px">
                          <tr><th colspan="5"><?php _e("Opérateurs pouvant lire les données",$this->plugin_textdomain) ?></th></tr>
                        <?php 
                         if (!empty($this->get_plugin_readers())) {      
                           echo $this->return_plugin_operators_headers();
                           echo $this->return_plugin_operators_lines($this->get_plugin_readers(), 'reader');
                         }
                         echo $this->get_plugin_add_operator('reader');                          
                        ?>
                         </table><br/>
                         <table width="100%" style="border: solid 1px">
                          <tr><th colspan="5"><?php _e("Opérateurs pouvant modifier les données",$this->plugin_textdomain) ?></th></tr>     
                            <?php 
                             if (!empty($this->get_plugin_editors())) {      
                               echo $this->return_plugin_operators_headers();
                               echo $this->return_plugin_operators_lines($this->get_plugin_editors(), 'editor');
                             }
                             echo $this->get_plugin_add_operator('editor');         
                            ?>
                        </table><br/>                  
                        <table width="100%" style="border: solid 1px">
                          <tr><th colspan="5"><?php _e("Opérateurs pouvant paramétrer la société",$this->plugin_textdomain) ?></th></tr>
                            <?php
                             if (!empty($this->get_plugin_setters())) {       
                              echo $this->return_plugin_operators_headers();
                              echo $this->return_plugin_operators_lines($this->get_plugin_setters(), 'setter');
                             }
                              echo $this->get_plugin_add_operator('setter');
                            ?>
                        </table><br/>        
                      </div>
                     </form>    
                     <?php
                     break;  
                 case 'coop':
                     $options = get_option($this->plugin_prefix.'options_coop');
                    ?>
                    <form method="post" action="options.php" >
                      <?php settings_fields($this->plugin_prefix.'options_coop_group'); ?>
                      <h3><?php _e('Company options', $this->plugin_textdomain) ?></h3>
                      <div>
                        <table class="form-table">
                         <tr>
                            <td><?php _e("Cooperative type",$this->plugin_textdomain) ?></td>
                             <td><select name="<?php echo $this->plugin_prefix.'options_coop[type]'; ?>" >
                                    <option value="scop" <?php echo (isset($options['type']) && $options['type']=='scop')? 'selected="selected"' : '' ?> >SCOP</option>
                                    <option value="scic" <?php echo (isset($options['type']) && $options['type']=='scic')? 'selected="selected"' : '' ?> >SCIC</option>
                                 </select>
                             </td>
                         </tr>
                         <tr>    
                           <td><?php _e("Legal form",$this->plugin_textdomain) ?></td>
                             <td><select name="<?php echo $this->plugin_prefix.'options_coop[form]'; ?>" >
                                    <option value="sa" <?php echo ($options['form']=='sa')? 'selected="selected"' : '' ?> >SA</option>
                                    <option value="sarl" <?php echo ($options['form']=='sarl')? 'selected="selected"' : '' ?> >SARL</option>
                                    <option value="sas" <?php echo ($options['form']=='sas')? 'selected="selected"' : '' ?> >SAS</option>
                                 </select>
                             </td> 
                         </tr>
                         <tr>
                            <td><?php _e("Date Created (dd/mm/yyyy)",$this->plugin_textdomain) ?></td>
                            <td><input type="text" name="<?php echo $this->plugin_prefix.'options_coop[created]'; ?>" value="<?php echo esc_attr($options['created']); ?>" /></td>
                         </tr>
                         <tr>
                         <tr>
                            <td><?php _e("Company name",$this->plugin_textdomain) ?></td>
                            <td><input type="text" name="<?php echo $this->plugin_prefix.'options_coop[name]'; ?>" value="<?php echo esc_attr($options['name']); ?>" /></td>
                         </tr>
                         <tr>
                            <td><?php _e("The xx Company",$this->plugin_textdomain) ?></td>
                            <td><input type="text" name="<?php echo $this->plugin_prefix.'options_coop[embeded_name]'; ?>" value="<?php echo esc_attr($options['embeded_name']); ?>" /></td>
                         </tr>
                         <tr>
                            <td><?php _e("Address",$this->plugin_textdomain) ?></td>
                            <td><input type="text" name="<?php echo $this->plugin_prefix.'options_coop[address]'; ?>" value="<?php echo esc_attr($options['address']); ?>" /></td>
                         </tr>
                         <tr>
                            <td><?php _e("Town",$this->plugin_textdomain) ?></td>
                            <td><input type="text" name="<?php echo $this->plugin_prefix.'options_coop[town]'; ?>" value="<?php echo esc_attr($options['town']); ?>" /></td>
                         </tr>
                         <tr>
                            <td><?php _e("Policies",$this->plugin_textdomain) ?></td>
                            <td><input type="text" name="<?php echo $this->plugin_prefix.'options_coop[policies]'; ?>" value="<?php echo esc_attr($options['policies']); ?>" /></td>
                         </tr>
                         <tr>
                            <td><?php _e("Company Logo name",$this->plugin_textdomain) ?></td>
                            <td><input type="text" name="<?php echo $this->plugin_prefix.'options_coop[logo]'; ?>" value="<?php echo esc_attr($options['logo']); ?>" /></td>
                         </tr>
                        </table>
                        <p class="submit">
                            <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
                        </p>
                       </div>
                    </form>
                    <form enctype="multipart/form-data" method="post" action="<?php echo admin_url('options-general.php?page=wpcoop_options&tab=coop'); ?>" >
                        <span>Attention: vérifier que le "user_agent" est bien défini, qu'un modèle de page "image" exsite dans votre thème</span>
                        <p></p>
                        <span>Voir votre administrateur</span>
                    <?php 
                    
                    $this->update_secured_image(array('option_group'=>'options_coop_group',
                                                      'max_file_size'=>'300000',
                                                      'name'=>'options_coop_logo_file',
                                                      'url_option'=>'options_coop_logo_url'
                                                ));
 
                    $this->display_secured_image_update_form(array('option'=>'options_coop_logo_file',
                                                                   'title'=>__("Company Logo",$this->plugin_textdomain),
                                                                   'change'=>__('Change logo: ',$this->plugin_textdomain),
                                                                   'name'=>'options_coop_logo_file',
                                                                   'update'=>__('Update Logo',$this->plugin_textdomain)
                                                            ));
                    ?>
                    </form>
                  <?php
                  break;
                 case 'cats':
                     $options = get_option($this->plugin_prefix.'options_cats'); ?>
                    <h3><?php _e('Categories', $this->plugin_textdomain) ?></h3>
                      <div>
                        <table class="form-table">
                            <tr><th>Abridged name</th><th>Short name</th><th>Name</th><th>&nbsp;</th><th>&nbsp;</th> </tr>   
                        <?php    
                        
                        $k=0;
                        if (is_array($options) && !empty($options)) {
                           foreach($options as $k=>$cat){?>
                            <form method="post" action="options.php" > <?php
                            settings_fields($this->plugin_prefix.'options_cats_group'); 
                            $dis = ($cat['deleted']=='y')?  'disabled="disabled"' : '';   
                                
                           ?>   
                          <tr>                       
<td><input <?php echo $dis; ?> type="text" name="<?php echo $this->plugin_prefix.'options_cats['.$k.'][abridg]'; ?>" value="<?php echo esc_attr($cat['abridg']); ?>" /></td>
<td><input <?php echo $dis; ?>type="text" name="<?php echo $this->plugin_prefix.'options_cats['.$k.'][shortname]'; ?>" value="<?php echo esc_attr($cat['shortname']); ?>" /></td>
<td><input <?php echo $dis; ?>type="text" name="<?php echo $this->plugin_prefix.'options_cats['.$k.'][name]'; ?>" value="<?php echo esc_attr($cat['name']); ?>" /></td>
                          <?php if (empty($dis)) : ?>
<td><input type="submit" name="<?php echo $this->plugin_prefix.'options_cats['.$k.'][delcat]'; ?>" value="<?php _e('Delete Category'); ?>" /></td>
<td><input type="submit" name="<?php echo $this->plugin_prefix.'options_cats['.$k.'][modcat]'; ?>" value="<?php _e('Modify Category'); ?>" /></td>
                         <?php else : ?> 
                              <td>Category deleted</td>                              
                              <td></td>
                         <?php endif; ?>     
                          </tr>
                          </form>      
                        <?php
                            }                            
                            $k++;    
                        } ?>   
                        <form method="post" action="options.php" >
                          <?php settings_fields($this->plugin_prefix.'options_cats_group'); ?>                        
                         <tr>
<td><input type="text" name="<?php echo $this->plugin_prefix.'options_cats['.$k.'][abridg]'; ?>" value="<?php echo esc_attr($options['abridg']); ?>" /></td>
<td><input type="text" name="<?php echo $this->plugin_prefix.'options_cats['.$k.'][shortname]'; ?>" value="<?php echo esc_attr($options['shortname']); ?>" /></td>
<td><input type="text" name="<?php echo $this->plugin_prefix.'options_cats['.$k.'][name]'; ?>" value="<?php echo esc_attr($options['name']); ?>" /></td>
<td><input type="submit" name="<?php echo $this->plugin_prefix.'options_cats['.$k.'][addcat]'; ?>" value="<?php _e('Add Category'); ?>" /></td>
                          </tr>
                        </form>    
                        </table>
                  <?php
                  break;                
                 case 'coll':
                     $options = get_option($this->plugin_prefix.'options_coll'); ?>
                    <h3><?php _e('Coolèges', $this->plugin_textdomain) ?></h3>
                      <div>
                        <table class="form-table">
                            <tr><th>Abridged name</th><th>Short name</th><th>Name</th><th>&nbsp;</th><th>&nbsp;</th> </tr>   
                        <?php    
                        
                        $k=0;
                        if (is_array($options) && !empty($options)) {
                           foreach($options as $k=>$col){?>
                            <form method="post" action="options.php" > <?php
                            settings_fields($this->plugin_prefix.'options_coll_group'); 
                            $dis = ($cat['deleted']=='y')?  'disabled="disabled"' : '';   
                                
                           ?>   
                          <tr>                       
<td><input <?php echo $dis; ?> type="text" name="<?php echo $this->plugin_prefix.'options_coll['.$k.'][abridg]'; ?>" value="<?php echo esc_attr($col['abridg']); ?>" /></td>
<td><input <?php echo $dis; ?>type="text" name="<?php echo $this->plugin_prefix.'options_coll['.$k.'][shortname]'; ?>" value="<?php echo esc_attr($col['shortname']); ?>" /></td>
<td><input <?php echo $dis; ?>type="text" name="<?php echo $this->plugin_prefix.'options_coll['.$k.'][name]'; ?>" value="<?php echo esc_attr($col['name']); ?>" /></td>
                          <?php if (empty($dis)) : ?>
<td><input type="submit" name="<?php echo $this->plugin_prefix.'options_cats['.$k.'][delcol]'; ?>" value="<?php _e('Delete College'); ?>" /></td>
<td><input type="submit" name="<?php echo $this->plugin_prefix.'options_cats['.$k.'][modcol]'; ?>" value="<?php _e('Modify College'); ?>" /></td>
                         <?php else : ?> 
                              <td>College deleted</td>                              
                              <td></td>
                         <?php endif; ?>     
                          </tr>
                          </form>      
                        <?php
                            }                            
                            $k++;    
                        } ?>   
                        <form method="post" action="options.php" >
                          <?php settings_fields($this->plugin_prefix.'options_coll_group'); ?>                        
                         <tr>
<td><input type="text" name="<?php echo $this->plugin_prefix.'options_coll['.$k.'][abridg]'; ?>" value="<?php echo esc_attr($options['abridg']); ?>" /></td>
<td><input type="text" name="<?php echo $this->plugin_prefix.'options_coll['.$k.'][shortname]'; ?>" value="<?php echo esc_attr($options['shortname']); ?>" /></td>
<td><input type="text" name="<?php echo $this->plugin_prefix.'options_coll['.$k.'][name]'; ?>" value="<?php echo esc_attr($options['name']); ?>" /></td>
<td><input type="submit" name="<?php echo $this->plugin_prefix.'options_coll['.$k.'][addcat]'; ?>" value="<?php _e('Add College'); ?>" /></td>
                          </tr>
                        </form>    
                        </table>
                  <?php
                  break;                
                 case 'shares':
                    /// display form for shares options
                    $options = get_option($this->plugin_prefix.'options_shares');
                    //print_tab($options);
                    ?>
                    <div>
                      <form method="post" action="options.php">
                        <?php settings_fields($this->plugin_prefix.'options_shares_group'); ?>
                        <h3><?php _e('Shares options', $this->plugin_textdomain) ?></h3>
                        <div>
                         <table class="form-table">
                           <tr>
                            <td><?php _e("Share price",$this->plugin_textdomain) ?></td>
                            <td><input type="text" name="<?php echo $this->plugin_prefix.'options_shares[price]'; ?>" value="<?php echo esc_attr($options['price']); ?>" /></td>
                           </tr>
                           <tr>
                            <td><?php _e("Colleges",$this->plugin_textdomain); ?></td>
                            <td>
                             <select name="<?php echo $this->plugin_prefix.'options_shares[colleges]'; ?>" >
                                <option value="n"><?php _e("No",$this->plugin_textdomain); ?></option>
                                <option value="y"><?php _e("Yes",$this->plugin_textdomain); ?></option>
                             </select>
                            </td>  
                           </tr>
                           <tr>
                             <td><?php _e("Categories",$this->plugin_textdomain); ?></td>
                            <td>   
                              <select name="<?php echo $this->plugin_prefix.'options_shares[categories]'; ?>" >
                                <option value="n"><?php _e("No",$this->plugin_textdomain); ?></option>
                                <option value="y"><?php _e("Yes",$this->plugin_textdomain); ?></option>
                              </select>   
                             </td>
                            </tr>
                         </table>  
                         <p class="submit">
                            <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
                         </p>
                        </div>  
                       </form>      
                    </div>
                    <?php
                    break;
                case 'management':
                   /// display form for management
                   $options=get_option($this->plugin_prefix.'options_management');
                   $options_coop=get_option($this->plugin_prefix.'options_coop');
                   ?>
                   <div>
                    <form method="post" action="options.php">
                        <?php settings_fields($this->plugin_prefix.'options_management_group'); ?>
                        <h3><?php _e('Management options', $this->plugin_textdomain) ?></h3>
                        <?php if ($options_coop['type']!='scic') { _e('Not yet implemented', $this->plugin_textdomain); break; } ?>
                        <div>
                         <table class="form-table">
                            <?php
                            if ($options_coop['form']=='sa') {
                            ?>    
                            <tr>    
                             <td><?php _e("Management type",$this->plugin_textdomain) ?></td>
                             <td><select name="<?php echo $this->plugin_prefix.'options_management[type]'; ?>" >
                                <option value="1" <?php echo ($options['type']=='1')? 'selected="selected"' : '' ?> >President, Board of Directors, Chief Executive Officer</option>
                                <option value="2" <?php echo ($options['type']=='2')? 'selected="selected"' : '' ?> >Management and Supervisory boards</option>
                                </select>
                             </td> 
                            </tr>
                            <?php
                            }
                            if ($options_coop['form']=='sarl' || $options_coop['form']=='sas' || ($options_coop['form']=='sa' && $options_management['type']=='2')) {
                            ?>    
                            <tr>
                             <td><?php _e("Authority title",$this->plugin_textdomain) ?></td>   
                             <td><input type="text" name="<?php echo $this->plugin_prefix.'options_management[title]'; ?>" value="<?php echo esc_attr($options['title']); ?>" /></td>
                            </tr>
                            <tr>
                             <td><?php _e("Authority name",$this->plugin_textdomain) ?></td>
                             <td><input type="text" name="<?php echo $this->plugin_prefix.'options_management[name]'; ?>" value="<?php echo esc_attr($options['name']); ?>" /></td>
                            <tr>    
                             <td><?php _e("Authority signature",$this->plugin_textdomain) ?></td>
                             <td><input type="text" name="<?php echo $this->plugin_prefix.'options_management[signature]'; ?>" value="<?php echo esc_attr($options['signature']); ?>" /></td>    
                            </tr>
                            <?php   
                            }
                            if ($options_coop['form']=='sarl' || $options_coop['form']=='sas' || ($options_coop['form']=='sa' && $options['type']=='1')) { 
                            ?>
                            <tr>
                             <td><?php _e("Council name",$this->plugin_textdomain) ?></td>   
                             <td><input type="text" name="<?php echo $this->plugin_prefix.'options_management[council_name]'; ?>" value="<?php echo esc_attr($options['council_name']); ?>" /></td>
                            </tr>
                            <tr>
                             <td><?php _e("Short Council name",$this->plugin_textdomain) ?></td>   
                             <td><input type="text" name="<?php echo $this->plugin_prefix.'options_management[short_council_name]'; ?>" value="<?php echo esc_attr($options['short_council_name']); ?>" /></td>
                            </tr>
                            <tr>
                             <td><?php _e("Minimum number of members",$this->plugin_textdomain) ?></td>   
                             <td><input type="text" name="<?php echo $this->plugin_prefix.'options_management[council_min]'; ?>" value="<?php echo esc_attr($options['council_min']); ?>" /></td>
                            </tr>
                            <tr>
                             <td><?php _e("Maximum number of members",$this->plugin_textdomain) ?></td>   
                             <td><input type="text" name="<?php echo $this->plugin_prefix.'options_management[council_max]'; ?>" value="<?php echo esc_attr($options['council_max']); ?>" /></td>
                            </tr>
                            <tr>
                             <td><?php _e("Members must be shareholders",$this->plugin_textdomain) ?></td>   
                             <td><select name="<?php echo $this->plugin_prefix.'options_management[council_shareholders]'; ?>" >
                                <option value="y" <?php echo ($options['council_shareholders']=='y')? 'selected="selected"' : '' ?> ><?php _e('Yes', $this->plugin_textdomain); ?></option>
                                <option value="n" <?php echo ($options['council_shareholders']=='n')? 'selected="selected"' : '' ?> ><?php _e('No', $this->plugin_textdomain); ?></option>
                                </select>
                             </td>    
                            </tr>
                            <tr>    
                             <td><?php _e("Auditor",$this->plugin_textdomain) ?></td>
                             <td><select name="<?php echo $this->plugin_prefix.'options_management[auditor]'; ?>" >
                                <option value="y" <?php echo ($options['auditor']=='y')? 'selected="selected"' : '' ?> ><?php _e('Yes', $this->plugin_textdomain); ?></option>
                                <option value="n" <?php echo ($options['auditor']=='n')? 'selected="selected"' : '' ?> ><?php _e('No', $this->plugin_textdomain); ?></option>
                                </select>
                             </td>    
                            </tr>
                             <tr>    
                             <td><?php _e("Auditor name",$this->plugin_textdomain) ?></td>
                             <td><input type="text" name="<?php echo $this->plugin_prefix.'options_management[auditor_name]'; ?>" value="<?php echo esc_attr($options['auditor_name']); ?>" /></td>    
                            </tr>
                             <tr>    
                             <td><?php _e("Auditor @email",$this->plugin_textdomain) ?></td>
                             <td><input type="text" name="<?php echo $this->plugin_prefix.'options_management[auditor_email]'; ?>" value="<?php echo esc_attr($options['auditor_email']); ?>" /></td>    
                            </tr>
                            <?php 
                            } elseif ($options_coop['type']=='scic' && $options_coop['form']=='sa' && $options['type']=='2') {
                                // management board && supervisory board
                             ?>
                             <tr>
                                 <td colspan="2">option pas encore implantée</td>
                             </tr>
                             <?php
                            }
                            ?>    
                    </table>
                    </div>
                    <p class="submit">
                            <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
                    </p>
                    </form>
                    <form enctype="multipart/form-data" method="post" action="<?php echo admin_url('options-general.php?page=wpcoop_options&tab=management'); ?>" >
                     <?php
                     $this->update_secured_image(array('option_group'=>'options_management_group',
                                                       'max_file_size'=>'300000',
                                                       'name'=>'options_management_signature_file',
                                                       'url_option'=>'options_management_signature_url'
                                                ));
                     $this->display_secured_image_update_form(array('option'=>'options_management_signature_file',
                                                                   'title'=>__("Authority signature",$this->plugin_textdomain),
                                                                   'change'=>__('Change signature: ',$this->plugin_textdomain),
                                                                   'name'=>'options_management_signature_file',
                                                                   'update'=>__('Update Signature',$this->plugin_textdomain)
                                                             ));
                    ?>
                    </form>
                    <?php
                 break;
                case 'councils':
                   /// display form for meetings
                   global $wpcoop;    
                   $opts_man=get_option($this->plugin_prefix.'options_management');
                   if (empty($opts_man['council_name']) || empty($opts_man['short_council_name'])) {_e('Please set council names',$this->plugin_textdomain); break;}
                   $options=get_option($this->plugin_prefix.'options_councils');
                   $users=$wpcoop->members->get_ordered_users();
                   ?>
                   <div>
                    <form method="post" action="options.php">
                        <?php settings_fields($this->plugin_prefix.'options_councils_group'); ?>
                        <h3><?php _e('Councils options', $this->plugin_textdomain) ?></h3>
                        <div>
                         <table class="form-table">
                           <?php
                            $i=0; 
                            foreach($options['council_members'] as $i=>$member) {
                             ?><tr>
                                <td><?php _e("Council member",$this->plugin_textdomain) ?></td>
                                <td><?php echo $users[$member['uid']]['display_name']; ?></td>
                                <td><?php _e("Role",$this->plugin_textdomain) ?></td>
                                <td><?php echo esc_html($member['role']); ?></td>    
                                <td><input type="submit" name="<?php echo $this->plugin_prefix.'options_councils[council_members_delete]['.$i.']'; ?>" class="button-secondary" value="<?php _e('Delete') ?>" /></td>    
                             </tr>
                             <?php  
                            }
                            if (count($options['council_members'])<$opts_man['council_max']) {
                            ?>
                            <tr>    
                             <td><?php _e("Add Council member",$this->plugin_textdomain) ?></td>
                             <td><?php $wpcoop->admin->dropdown_users(array('name'=>$this->plugin_prefix.'options_councils[council_members][uid]')); ?></td>    
                             <td><?php _e("Role",$this->plugin_textdomain) ?></td>
                             <td><input type="text" name="<?php echo $this->plugin_prefix.'options_councils[council_members][role]'; ?>" /></td>    
                             <td><input type="submit" name="<?php echo $this->plugin_prefix.'options_councils[council_members_add]'; ?>" class="button-secondary" value="<?php _e('Add') ?>" /></td>    
                            </tr>
                            <?php
                            } elseif (count($options['council_members'])>$opts_man['council_max']) {
                            ?>    
                            <tr>    
                             <td colspan="5" class="message-error"><?php _e("!!! Number is greater than number permitted, delete one or more member(s) !!!",$this->plugin_textdomain) ?></td>
                            </tr>
                            <?php
                            add_settings_error( $this->plugin_prefix.'options_councils', 'number-exeeds', __('Number of members exeeds maximum number.', $this->plugin_textdomain ));

                            }
                            ?>
                         </table>  
                         <p class="submit">
                            <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
                         </p>
                        </div>  
                   </form>
                   </div>
                   <?php
                 break;
                case 'meetings':
                   /// display form for meetings
                   $options=get_option($this->plugin_prefix.'options_meetings');
                   ?>
                   <div>
                    <form method="post" action="options.php">
                        <?php settings_fields($this->plugin_prefix.'options_meetings_group'); ?>
                        <h3><?php _e('Meetings options', $this->plugin_textdomain) ?></h3>
                        <div>
                         <table class="form-table">
                            <tr>
                            </tr>
                            <tr>
                            <tr>     
                            </tr>
                         </table>  
                         <p class="submit">
                            <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
                         </p>
                        </div>  
                   </form>
                   </div>
                   <?php
                 break;
                case 'maps':
                   /// display form for maps
                   $options=get_option($this->plugin_prefix.'options_maps');
                   ?>
                   <div>
                    <form method="post" action="options.php">
                        <?php settings_fields($this->plugin_prefix.'options_maps_group'); ?>
                        <h3><?php _e('Maps options', $this->plugin_textdomain) ?></h3>
                        <div>
                         <table class="form-table">
                            <tr>    
                             <td><?php _e("URL map icon",$this->plugin_textdomain) ?></td>
                             <td><input type="text" name="<?php echo $this->plugin_prefix.'options_maps[url_map_icon]'; ?>" value="<?php echo esc_attr($options['url_map_icon']); ?>" /></td>    
                            </tr>
                            <tr>    
                             <td><?php _e("URL anonymous map",$this->plugin_textdomain) ?></td>
                             <td><input type="text" name="<?php echo $this->plugin_prefix.'options_maps[url_anonymous_map]'; ?>" value="<?php echo esc_attr($options['url_anonymous_map']); ?>" /></td>    
                            </tr>
                            <tr>    
                             <td><?php _e("URL full map",$this->plugin_textdomain) ?></td>
                             <td><input type="text" name="<?php echo $this->plugin_prefix.'options_maps[url_full_map]'; ?>" value="<?php echo esc_attr($options['url_full_map']); ?>" /></td>    
                            </tr>
                            <tr>
                            <tr>     
                            </tr>
                         </table>  
                         <p class="submit">
                            <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
                         </p>
                        </div>  
                   </form>
                   </div>
                   <?php
                 break;
                 case 'subs':
                   /// display form for promos
                   $options=get_option($this->plugin_prefix.'options_subs');
                   $this->manage_secured_pdf(array('option_item'=>'dis1',
                                                   'option'=>'options_dis1_file',
                   //                                'name'=>'options_dis1_file',
                                                   'max_file_size'=>'500000',
                                                   'title'=>__("DIS actuel pour parts",$this->plugin_textdomain),
                                                   'change'=>__('Changer le DIS: ',$this->plugin_textdomain),
                                                   'update'=>__('Mettre à jour le DIS',$this->plugin_textdomain),
                   //                                'url_option'=>'options_dis1_url',
                                                ));
                   $this->manage_secured_pdf(array('option_item'=>'bs1',
                                                   'option'=>'options_bs1_file',
                   //                                'name'=>'options_bs1_file',
                                                   'max_file_size'=>'500000',
                                                   'title'=>__("Bulletin de souscription actuel pour les parts",$this->plugin_textdomain),
                                                   'change'=>__('Changer le bulletin: ',$this->plugin_textdomain),
                                                   'update'=>__('Mettre à jour le bulletin',$this->plugin_textdomain),
                   //                                'url_option'=>'options_bs1_url',
                                                ));
                   $this->manage_secured_pdf(array('option_item'=>'dis2',
                                                   'option'=>'options_dis2_file',
                   //                                'name'=>'options_dis2_file',
                                                   'max_file_size'=>'500000',
                                                   'title'=>__("DIS actuel pour CCA",$this->plugin_textdomain),
                                                   'change'=>__('Changer le DIS: ',$this->plugin_textdomain),
                                                   'update'=>__('Mettre à jour le DIS',$this->plugin_textdomain),
                   //                                'url_option'=>'options_dis2_url',
                                                ));
                   $this->manage_secured_pdf(array('option_item'=>'bs2',
                                                   'option'=>'options_bs2_file',
                   //                                'name'=>'options_bs2_file',
                                                   'max_file_size'=>'500000',
                                                   'title'=>__("Bulletin de souscription actuel pour les CCA",$this->plugin_textdomain),
                                                   'change'=>__('Changer le bulletin: ',$this->plugin_textdomain),
                                                   'update'=>__('Mettre à jour le bulletin',$this->plugin_textdomain),
                   //                                'url_option'=>'options_bs2_url',
                                                )); 
                   break;
                    case 'promos':
                       /// display form for promos
                       $options=get_option($this->plugin_prefix.'options_promos');
                       ?>
                       <div>
                        <form method="post" action="options.php">
                            <?php settings_fields($this->plugin_prefix.'options_promos_group'); ?>
                            <h3><?php _e('Promos options', $this->plugin_textdomain) ?></h3>
                            <div>
                             <table class="form-table">
                               <tr>
                                <td><?php _e("Mon Kit Solaire",$this->plugin_textdomain) ?></td>
                                <?php
                                $checked=($options['monkitsolaire']=='y')? 'checked="checked"' : ''; 
                                ?>
                                <td><input type="checkbox" name="<?php echo $this->plugin_prefix.'options_promos[monkitsolaire]'; ?>" <?php echo $checked; ?>/></td>
                                <td><?php _e("Activer la promo dans la page mon compte",$this->plugin_textdomain) ?></td>              
                               </tr>
                               <tr>
                                   <td colspan="3"><?php _e('La désactivation d\'une promo ne supprimera pas les infos energistrées pour le sociétaire',$this->plugin_textdomain) ?></td>
                               </tr>     
                             </table>  
                             <p class="submit">
                                <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
                             </p>
                            </div>  
                       </form>
                       </div>
                       <?php
                     break;
            }//switch
         }//no rights to display settings page
        }//display options page
        
        function init_options_page() {
            // get options
            $options=$this->get_options_tabs('options');
            // registers options groups
            foreach($options as $option) {
             register_setting($option['group'],$option['name'],$option['callback']);
            }
        }
        
        // TODO admin messages
        
        // TODO merge with admin function
        public function validate_date($maybedate) {
          return ( empty($maybedate) || strlen($maybedate)!=10 || 
                  !checkdate( (int) substr($maybedate, 3, 2), (int) substr($maybedate, 0, 2), (int) substr($maybedate, 6, 4) ) )? false : true;   
                        
        }

        public function validate_options_subs($input) {
          // not usable becaus $_FILES empty
          return apply_filters($this->plugin_prefix.'validate_options_subs', $input);  
        }
        
        public function validate_user($id){
            $id=(int) $id;
             if (get_user_by('id', $id)){
              return $id;   
             } else {
              return 0;   
             }            
        }  
        
        public function validate_options_coop_roles($input){
          //write_log($input);
          $option = get_option($this->plugin_metakey_options_coop_roles); 
          //$option = get_option($this->plugin_prefix.'options_coop_roles'); 
          if(!is_array($option)) $option=array();
          if(isset($option['reader']) && !is_array($option['reader'])) $option['reader']=array();
          if(isset($option['editor']) && !is_array($option['editor'])) $option['editor']=array();
          if(isset($option['setter']) && !is_array($option['setter'])) $option['setter']=array();
          $id=0;
          $type='';
          $ok=false;
          if (isset($input['add_reader']) && isset($input['reader'])){
             $type='reader';  
             $id=$this->validate_user($input['reader']);             
          } elseif (isset($input['add_editor']) && isset($input['editor'])){
             $type='editor';  
             $id=$this->validate_user($input['editor']);              
          } elseif (isset($input['add_setter']) && isset($input['setter'])){
             $type='setter'; 
             $id=$this->validate_user($input['setter']);              
          } else {
           $ok=true;   
           if (isset($input['revoke_reader'])) {
            $option['reader']=array_diff($option['reader'], array_keys($input['revoke_reader']));     
           } elseif (isset($input['revoke_editor'])) {
            $option['editor']=array_diff($option['editor'], array_keys($input['revoke_editor']));                
           } elseif (isset($input['revoke_setter'])) {
            $option['setter']=array_diff($option['setter'], array_keys($input['revoke_setter']));                            
           }
          }
          if($id && !empty($type)) {
             (isset($option[$type]) && !in_array($id, $option[$type]))? $option[$type][]=$id : $option[$type]=array($id);
          } elseif(!$ok) {
              add_settings_error( $this->plugin_metakey_options_coop_roles, 'invalid-user', __("Invalid User", $this->plugin_textdomain ));
          }
          //write_log($option);  
          return $option;    
        }
        
        public function validate_options_coop($input) {
          //wlogt(LOG, '$input', $input);
          foreach($input as $k=>$v) {
           //wlog(LOG, $k);   
           if ($k=='logo_file') {
               
               wlogt(LOG, '$_FILES', $_FILES);
               
           } else {     
            if (!is_string($v)) $input[$k]= (string) $v;  
            if ($k=='type' && !in_array($v, array('scic','scop')))  $input[$k]='scop';      
            if ($k=='form' && !in_array($v, array('sa','sarl', 'sas')))  $input[$k]='sa'; 
            if ($k=='created') $input[$k]= ( $this->validate_date($v) )?  $v : ''; 
           }
          }  
            
          return apply_filters($this->plugin_prefix.'validate_options_coop', $input);  
        }
        
        public function validate_options_cats($input) {
          $options = get_option($this->plugin_prefix.'options_cats');                                
          //wlogt(LOG, '$input', $input);
          //$catindex = (!isset($input['catindex']))? 0 : (int) $input['catindex']; 
          //$catindex=array_key_first($input);
          $catindex=array_keys($input)[0];
          if (isset($input[$catindex]['delcat'])) {
              $options[$catindex]['deleted']='y';   
          } else {
              foreach($input[$catindex] as $k=>$v) {
                wlog(LOG, $k); 
                if($k=='addcat' || $k=='delcat' || $k=='modcat' ) continue; 
                $options[$catindex][$k]= (string) $v;  
              }
          }
          return apply_filters($this->plugin_prefix.'validate_options_cats', $options);  
        }
        
        public function validate_options_shares($input) {
          foreach($input as $k=>$v) {
            if (!is_string($v)) $input[$k]= (string) $v;  
          }  
          $input['price']= ($input['price']==0 || empty($input['price']) || intval($input['price'])!=$input['price'])? 100 : $input['price'];
          return apply_filters($this->plugin_prefix.'validate_options_shares', $input); 
        }
        
        public function validate_options_management($input) {
            
          foreach($input as $k=>$v) {
              if (!is_string($v)) $input[$k]= (string) $v;

              if ( $k== 'council_min' || $k== 'council_max') {
                    $input[$k]= (string) absint($v);
              }
              if ( $k== 'council_min' && isset($input['council_min']) && isset($input['council_max']) && !( absint($input['council_max'])+1 > absint($input['council_min']) ) ) {
                 add_settings_error( $this->plugin_prefix.'options_management', 'invalid-council', __("Maximum number must be greater or equal to minimum", $this->plugin_textdomain ));
                 $input['council_min']=absint($input['council_max']);
              }
              if ( $k== 'council_shareholders' && $input['council_shareholders']!='y' && $input['council_shareholders']!='n'){
                 add_settings_error( $this->plugin_prefix.'options_management', 'invalid-council', __("Choice must be Yes or No", $this->plugin_textdomain ));
                 $input[$k]='y'; 
              }
              
              if ( $k== 'auditor' && $input['auditor']!='y' && $input['auditor']!='n'){
                 add_settings_error( $this->plugin_prefix.'options_management', 'invalid-auditor', __("Auditor choice must be Yes or No", $this->plugin_textdomain ));
                 $input[$k]='y'; 
              }
              if ( $k== 'auditor' && $input['auditor']=='y' && (empty($input['auditor_name']) || empty($input['auditor_email']) )) {
                 add_settings_error( $this->plugin_prefix.'options_management', 'invalid-auditor', __("Auditor name or email can't be empty.", $this->plugin_textdomain ));
               }
              if ( $k== 'auditor_email' && !is_email($v) ) {
                if (!empty($input['auditor_name']) && !empty($v)) {  
                 add_settings_error( $this->plugin_prefix.'options_management', 'invalid-email', __('You have entered an invalid e-mail address.', $this->plugin_textdomain ));
                }
                $input[$k]='';  
              } 
          }  
          return apply_filters($this->plugin_prefix.'validate_options_management', $input); 
        }
        
        public function validate_options_meetings($input) {
          foreach($input as $k=>$v) {
            if (!is_string($v)) $input[$k]= (string) $v;  
          }  
            
          return apply_filters($this->plugin_prefix.'validate_options_meetings', $input); 
        }
        
        public function validate_options_councils($input) {
          $opts_man=get_option($this->plugin_prefix.'options_management');
          $options=get_option($this->plugin_prefix.'options_councils'); 
          // delete council member     
          if (isset($input['council_members_delete'])) {
                unset ($options['council_members'][intval(key($input['council_members_delete']))] );
          } elseif (isset($input['council_members_add'])) { 
          // add council member
            //@TODO verify uid is ok (existing user or partner) && uid is not already present
            $isin=false;  
            foreach($options['council_members'] as $m) {
                if ($m['uid']==intval($input['council_members']['uid'])) {
                    $isin=true;
                }
            } 
            if (count($options['council_members'])<$opts_man['council_max'] && !$isin) {
              $options['council_members'][]=array('role' => (string) $input['council_members']['role'], 'uid'=>intval($input['council_members']['uid']));
            } else {
              if(count($options['council_members'])==$opts_man['council_max']) {
                  add_settings_error( $this->plugin_prefix.'options_councils', 'council_max_exceeded', __('Maximum number of members exceeded.', $this->plugin_textdomain ));
              }
              if ($isin) {
                  add_settings_error( $this->plugin_prefix.'options_councils', 'user_isin', __('Already member of council.', $this->plugin_textdomain ));
              }
            }
          }
          return apply_filters($this->plugin_prefix.'validate_options_councils', $options); 
        }
        
        public function validate_options_maps($input) {
          foreach($input as $k=>$v) {
            $input[$k]= (string) $v;   
            if ( ! wp_http_validate_url( $input[$k] )) {
               add_settings_error( $this->plugin_prefix.'options_map', 'invalid-url', __('You have entered an invalid URL.', $this->plugin_textdomain ));
            } 
          }  
          return apply_filters($this->plugin_prefix.'validate_options_maps', $input); 
        }
        
        public function validate_options_promos($input) {
          wlogt(LOG, 'input', $input);    
          foreach($input as $k=>$v) {
            if (in_array($k, array('monkitsolaire'))) { $input[$k]= 'y'; } else { unset($input[$k]); } 
            //if ( ! wp_http_validate_url( $input[$k] )) {
            //   add_settings_error( $this->plugin_prefix.'options_map', 'invalid-url', __('You have entered an invalid URL.', $this->plugin_textdomain ));
            //}
          }
            //update_option($this->plugin_prefix.'options_promos', $promos);    
          return apply_filters($this->plugin_prefix.'validate_options_promos', $input); 
        }

    } // end class
} // end if class exists
