<?php
/**
 * Exit if accessed directly
 */

// alm 20210408


if ( !defined( 'ABSPATH' ) ) {
    exit;
}
if ( !class_exists( 'WPCOOP_Shares' ) ) {

  class WPCOOP_Shares {
        public function __construct() {
            global $wpcoop;
            // copy some parameters from wpcoop
            $this->plugin_version = $wpcoop->plugin_version;
            $this->plugin_prefix = $wpcoop->plugin_prefix;
            $this->usersdata_prefix = $wpcoop->usersdata_prefix;

            $this->plugin_markers_file_path = $wpcoop->plugin_markers_file_path;
            $this->subs_geo_markers_filename = $wpcoop->subs_geo_markers_filename;

            $this->plugin_textdomain = $wpcoop->plugin_textdomain;

            $this->plugin_usersubs_meta=$wpcoop->plugin_usersubs_meta;

        }

        public function get_share_price() {
           $options_shares = get_option($this->plugin_prefix.'options_shares');
           return apply_filters($this->plugin_prefix.'get_share_price', $options_shares['price']);
        }

        public function adjust_shares_from_step($step, $s){
            $q= $step['q'] / $this->get_share_price();
            if ($step['s']=='shareok' || $step['s']=='sharetok')  $s+=$q;
            if ($step['s']=='sharecessdone' || $step['s']=='sharenokexe' ) $s-=$q;
            return $s;
        }

        public function get_possible_statuses() {

            return apply_filters ('wpcoop_get_possible_statuses',
                   array('none'=>'Pas de nouvelle opération',
                         'subswft'=>'Souscription en attente de transfert',
                         'substok'=>'Dossier transfert complet',
                         'subsnok'=>'Dossier souscription incomplet',
                         'subsok'=>'Dossier souscription complet',
                         'pending'=>'Souscription en attente de validation',
                         // all share relative status must begin with 'share'
                         'shareok'=>'Parts validées',
			 'sharetok'=>'Transfert de Parts effectué', //(la souscription et les parts apparaissent au compte destinataire, doit correspondre à un sharecessdone à la même date)
                         'sharenok'=>'Rachat de part(s) demandé',
                         'sharenokack'=>'Rachat de part(s) validé',
                         'sharenokexe'=>'Rachat de part(s) exécuté',// -> fin eventuelle du societariat si pas d'autre part
                         'sharenokdone'=>'Rachat de part(s) payé',
                         'sharecessreq' => 'Demande de cession faite',
                         'sharecessok' => 'Demande de cession accordée',
                         'sharecessnok'=> 'Demande de cession refusée',
                         'sharecesscanceled'=> 'Demande de cession annulée',
                         'sharecessdone' => 'Cession faite' // -> fin du eventuelle du societariat si pas d'autre part
                       ));


        }

        public function get_stepdata($i, $step) {
           //  'none'=>'Pas de nouvelle opération',
           //  'subsnok'=>'Dossier souscription incomplet',
           //  'subsok'=>'Dossier souscription complet',
           //  'pending'=>'Souscription en attente de validation',
             // all share relative status must begin with 'share'
           //  'shareok'=>'Parts validées',
           //  'sharenok'=>'Rachat de part(s) demandé',
           //  'sharenokack'=>'Rachat de part(s) validé',
           //  'sharenokexe'=>'Rachat de part(s) exécuté', // suppression des parts, fin eventuelle du societariat si pas d'autre part
           //  'sharenokdone'=>'Rachat de part(s) payé',
           //  'sharecessreq' => 'Demande de cession faite',
           //  'sharecessok' => 'Demande de cession accordee',
           //  'sharecessnok'=> 'Demande de cession refusee',  //-> doit generer sharenokexe article 12 des statuts
           //  'sharecessdone' => 'Cession faite' // -> fin eventuelle du societariat si pas d'autre part
            $pps=$this->get_share_price();
            $val=$step['q'];
            if (strpos($step['s'],'share')!==false) {
             $unit='Parts';
             $val=$step['q']/$pps;
            } else {
             $unit='Euros';
            }

            $cv=0;
            $cs=0;
            switch ($step['s']) {
                case 'subsnok':
                    $cv+=$step['q'];
                    break;
                case 'subsok':
                    if ($i==0) $cv+=$step['q'];
                    break;
                case 'shareok':
                    $cs+=$step['q']/$pps;
                    break;
                case 'sharetok':
                    $cv+=$step['q'];
                    $cs+=$step['q']/$pps;
                    break;
                case 'sharenokexe':
                    $cs-=$step['q']/$pps;
                    $cv-=$step['q'];
                    break;
                case 'sharecessdone':
                    $cs-=$step['q']/$pps;
                    $cv-=$step['q'];
                    break;
            }

            return array('cs'=>$cs, 'cv'=>$cv, 'val'=>$val, 'unit'=>$unit);
        }







  } //class
} // if class exits
