<?php
/**
 * Exit if accessed directly
 */

// alm 20191022


if ( !defined( 'ABSPATH' ) ) {
    exit;
}
if ( !class_exists( 'WordPress_Cooperative_Stripe' ) ) {
  class WordPress_Cooperative_Stripe {
        public function __construct() {
            global $wpcoop;
            // copy some parameters from wpcoop
            $this->plugin_version = $wpcoop->plugin_version;
            $this->plugin_prefix = $wpcoop->plugin_prefix;
            $this->usersdata_prefix = $wpcoop->usersdata_prefix;

            $this->plugin_markers_file_path = $wpcoop->plugin_markers_file_path;
            $this->subs_geo_markers_filename = $wpcoop->subs_geo_markers_filename;

            $this->plugin_textdomain = $wpcoop->plugin_textdomain;

            $this->plugin_capability = $wpcoop->plugin_capability;

            $this->possible_statuses = $wpcoop->shares->get_possible_statuses();

            $this->plugin_usersubs_meta=$wpcoop->plugin_usersubs_meta;

            // some parameters for this class
            // admin page slug name
            $this->class_slug = 'stripe';

            add_filter ($this->plugin_prefix .'endpoints', array($this,'add_stripe_endpoint'));

            // when in admin menu, add admin pages subpage and settings
            add_action( 'admin_menu', array( $this, 'setup_admin_pages' ));


        }

        public function add_stripe_endpoint($endpoints) {
          // endpoint value (swh must be declared in stripe dashboard as stripe webhook)
          $endpoints['stripe']=get_option( $this->plugin_prefix . 'stripe_endpoint', 'swh' );
          return $endpoints;
        }

        public function setup_admin_pages() {
            // Add settings page for users who can edit plugins
            // add_menu_page( string $page_title,
            //                   string $menu_title, string $capability, string $menu_slug, callable $function = '', string $icon_url = '', int $position = null )
            $mp=add_menu_page( __('WpCoop Coop Stripe',$this->plugin_textdomain),
                           __('Stripe',$this->plugin_textdomain),
                           $this->plugin_capability,
                           $this->class_slug,
                           array($this, 'admin_main_page'),
                           '', // icone  url ?
                           '3' // position
                         );

            // add help to menu page
            add_action('load-'.$mp, array($this, 'page_help'));

            $smp=add_submenu_page($this->class_slug, __('WpCoop Stripe',$this->plugin_textdomain),
                             __('Payments',$this->plugin_textdomain),
                             $this->plugin_capability,
                             'payments',
                             array($this, 'admin_payments')
                             );
            // add help to subscribers page
            add_action('load-'.$smp, array($this, 'payments_help'));
        }


        public function print_notices($classes, $message) {
           printf( '<div class="%1$s"><p>%2$s</p></div>', esc_attr( $classes ), esc_html( $message ) );
        }

        public function admin_main_page() {

        }



  } //class
} // if class exits
