<?php
/**
* Exit if accessed directly
*/

// alm 20210314

if ( !defined( 'ABSPATH' ) ) {
  exit;
}
if (!class_exists( 'WPCOOP_Subscription' ) ) {
  class WPCOOP_Subscription {



    public function __construct($thispageurl) {
      global $wpcoop;
      $this->plugin_prefix=$wpcoop->plugin_prefix;
      $this->includes_path=$wpcoop->includes_path;
      $this->plugin_textdomain=$wpcoop->plugin_textdomain;
      $this->usersdata_prefix=$wpcoop->usersdata_prefix; // usefull in wpcoop?

      $this->user = wp_get_current_user();
      $this->userid=$this->user->ID;
      $this->useremail=(get_userdata($this->userid)->user_email)?? '';
      $this->cookie_timeout=86400; // in seconds, set 24h = 86400s

      $this->page_url=$thispageurl; // OU souscrire ???
      $this->login_url=network_site_url()."wp-login.php";
      $this->blogid=get_current_blog_id();

      $this->transient_expiration=1800; //
      // code to verify response origins
      $this->code=12457812450;
      // from address
      // TODO put in parameters
      $this->fromemail='souscriptions pep2a <souscriptions@pep2a.fr>';

      if (!class_exists('WPCOOP_Member')) include_once( $this->includes_path.'class-wpcoop-member.php' );

      $this->payment_done=false; // init payment_done
      $this->docs_uploaded=false; // init docs uploaded

    }

    public function subscribe(){
      // called from template decoder
      if (isset($_REQUEST['subscribe'])) {
        $this->subscription_subscribe();
      }
      $this->subscription_first_steps();

      exit;
    }

    private function subscription_first_steps(){

      $unknown=($this->user->ID==0)? '<li>L\'adresse email avec laquelle vous voulez souscrire (éventuellement adresse email ou identifiant et mot de passe si vous êtes déjà sociétaire ou avez un compte sur un des sites pep2a -pep2a.fr, pep2a.fr/societaires, ou pep2a.fr/intranet. Si vous ne savez plus, une procédure de récupération sera tentée )</li>' : '';
      $unknown='<li>L\'adresse email avec laquelle vous voulez souscrire (celle avec laquelle vous êtes inscrit si vous êtes déjà sociétaire)</li>';

      $connected=($this->user->ID==0)? '' : 'Vous êtes connecté sur un site PEP2A, restez connecté pour poursuivre votre souscription';


      if (!isset($_COOKIE[$this->plugin_prefix.'subscribe_step1']) ) {
        // no cookie set
        setcookie($this->plugin_prefix.'subscribe_step1',time(), time()+$this->cookie_timeout); // 24h left
        get_header();
        echo '<h2>Souscrire des parts de PEP2A : 1ère étape</h2>';
        //echo '<div><span>'.$connected.'</span></div>';
        echo '
        <div><span>Le processus de souscription se fait en deux étapes ; vous devez disposer de : </span>
        <ul>
        '.$unknown.'
        <li>Une pièce d\'identité (CNI recto/verso, passeport...) et un justificatif de domicile (facture électricité, téléphone... de moins de 3 mois), de préférence sous forme numérique (scan, photo)</li>
        <li>Un moyen de paiement, virement si possible, sinon Carte Bancaire, vous pourrez également régler votre souscription par chèque (à éviter)</li>
        </ul>
        <!-- <div><span>Le processus de souscription durera environ 15 minutes ; il peut être interrompu et repris dans les 24 heures</span></div> -->
        <p/>
        <div><span>Conformément à la réglementation, merci de télécharger le Document d\'Information Synthétique (DIS) afin de prendre connaissance  des risques associés à la souscription de parts PEP2A</span>. Le DIS comporte des liens vers les articles significatifs des statuts, <a href="https://pep2a.fr/societaires/wp-content/uploads/sites/2/2020/07/20190401-Statuts_SCIC_PEP2A_2019-03-23_statuts-modifies-suite-AGE.pdf">mais les statuts complets sont ici (pdf).</a><p/></div>
          <form method="post">
          <a href="">Téléchargement du DIS</a>
          <div><span>Après avoir téléchargé le document, veuillez confirmez que vous en avez bien pris connaissance</span>
          <input type="submit" name="'.$this->plugin_prefix.'subscribe_step2'.'" value="Je confirme"/>
          </form>
          </div>
          ';
          get_footer();
          exit;
        } elseif (isset($_COOKIE[$this->plugin_prefix.'subscribe_step1'])
        && !isset($_COOKIE[$this->plugin_prefix.'subscribe_step2'])
        && !isset($_POST[$this->plugin_prefix.'subscribe_step2'])) {
          // download dis
          setcookie($this->plugin_prefix.'subscribe_step2',time(), time()+$this->cookie_timeout); // 24h left to acknowlege
          $dis=get_option('wpcoop_options_dis1_file');
          header("Content-type: application/force-download");
          header("Content-Disposition: attachment;filename=".urlencode($dis['name']));
          echo base64_decode($dis['data']);
          //exit;

        } elseif (isset($_COOKIE[$this->plugin_prefix.'subscribe_step1'])
        &&  !isset($_COOKIE[$this->plugin_prefix.'subscribe_step2'])
        &&   isset($_POST[$this->plugin_prefix.'subscribe_step2'])) {
          // validated without having downloaded dis
          get_header();
          echo '<h2>Souscrire des parts de PEP2A : 1ère étape </h2>';
          echo '
          <div><span>Conformément à la réglementation, </span><span style="color: red">VOUS DEVEZ</span> télécharger le DIS afin de prendre connaissance  des risques associés à la souscription de parts PEP2A</span></div>
          <form method="post">
          <a href="">Téléchargement du DIS</a>
          <div><span>Après avoir téléchargé le document, veuillez confirmez que vous en avez bien pris connaissance</span>
          <input type="submit" name="'.$this->plugin_prefix.'subscribe_step2'.'" value="Je confirme"/>
          </form>
          </div>
          ';
          get_footer();
          exit;

        } elseif (isset($_COOKIE[$this->plugin_prefix.'subscribe_step1'])
        &&  isset($_COOKIE[$this->plugin_prefix.'subscribe_step2'])
        &&  !isset($_REQUEST['bs1'])) {
          // dis downloaded and validation done
          get_header();
          // ajout de la classe survol pour RIB apparence/personnaliser/css additionnel
          /*
          a.survol {
          position:relative;
          border-bottom:1px dashed #808080;
          text-decoration: none;
        }
        a:hover.survol {
        text-decoration: none;
        background: none;
      }
      a.survol span {display: none;}

      a:hover.survol span {
      display: block;
      position: relative;
      top: -20px;
      left: 10px;
      z-index: 20;
      width:100%;
      padding:2px 4px;
    }
    */

    echo '<h2>Souscrire des parts de PEP2A : 2ième étape</h2>';
    echo 'La souscription en ligne ne fonctionne pas encore, vous devez donc télécharger et remplir le bulletin de souscription, puis le retourner avec les justificatifs demandés à l\'adresse email <a href="mailto:souscription@pep2a.fr">souscription@pep2a.fr</a>. <br />
    <ul>
    <li>Vous pouvez régler votre souscription par virement en utilisant <a class="survol" href="#">ce rib (passer la souris ici)<span><img src="https://pep2a.fr/societaires/wp-content/uploads/sites/2/2020/07/20200720-image_rib_pep2a.jpg" alt=""></span></a></li>
    <li>Vous pouvez également régler en ligne par <a href="https://secure.payplug.com/p/Xy6jr">Carte Bancaire sur le site sécurisé Payplug</a> (et donc vos données ne transitent pas par le site PEP2A)</li>
    <li>Vous pouvez aussi envoyer vos documents et un chèque à l\'adresse
    postale de pep2a, mais nous ne conseillons pas cette option, qui occasionnera un temps de traitement plus long car demandera plus de travail et de déplacement à nos bénévoles (n\'oubliez pas que notre coopérative fonctionne essentiellement grâce au bénévolat des sociétaires, qui sont répartis sur le département).</li></ul>
    <a href="?bs1">Téléchargement du Bulletin de souscription</a><p/>';


    if ($this->userid!=0){
      // user logged in

      $this->subscription_subscribe();

    }elseif(isset($_REQUEST['find']) ){
      // user not logged in and has to find good @email
      echo 'user not logged in and  has to find good @email<br>';
      $message='';
      print_tab($_REQUEST);
      if (isset($_REQUEST['find2'])) {
        if($this->received_form_data_ok()){
          $emails=array();
          if (isset($_REQUEST['email1']) && !empty($_REQUEST['email1']) && sanitize_email($_REQUEST['email1'])==$_REQUEST['email1'] && is_email($_REQUEST['email1'])) {
            $emails[]=$_REQUEST['email1'];
          }else{
           $message.=__("No valid email adresse : ".esc_html($_REQUEST['email1']), $this->plugin_textdomain).'<br />';
          }
          if (isset($_REQUEST['email2'])  && !empty($_REQUEST['email2']) && sanitize_email($_REQUEST['email2'])==$_REQUEST['email2'] && is_email($_REQUEST['email2']) ){
            $emails[]=$_REQUEST['email2'];
          }else{
           $message.=__("No valid email adresse : ".esc_html($_REQUEST['email2']), $this->plugin_textdomain).'<br />';
          }
          if (isset($_REQUEST['email3'])  && !empty($_REQUEST['email3'])&& sanitize_email($_REQUEST['email3'])==$_REQUEST['email3'] && is_email($_REQUEST['email3'])){
            $emails[].=$_REQUEST['email3'];
          }else{
           $message.=__("No valid email adresse : ".esc_html($_REQUEST['email3']), $this->plugin_textdomain).'<br />';
          }
          print_tab($emails);
          if(!empty($emails)) {
            $users=array();
            foreach($emails as $email){
              $coop=false; // user has no account on wpcoop site
              if($user=get_user_by('email', $email)){
                // if $user!==false, $user userObject and has account on at least one of our sites
                // see if user has account on this site
                if (in_array($this->blogid, get_blogs_of_user($user->ID, true))) {
                  $coop=true;
                }
              }
              $this->send_subscribe_link_email($email, $user, $coop);
            }
            if (empty($message)){
              get_footer();
              exit;
            }
          } else {
            $message=__("No valid email adresses", $this->plugin_prefix);
          }
        } else {
          $message=__("Erreur de transmission, recommencez ou contactez nous si l'erreur persiste!", $this->plugin_prefix);
        }
      }
      echo '<h3>'.esc_html(__("Vous cherchez si vous avez un compte sur un site pep2a", $this->plugin_textdomain)).'</h3>
      <span style="color: red">'.$message.'</span>
      <form action="'.$this->page_url.'">';
      echo $this->get_verification_form(array('find','find2'));
      $email1=$_REQUEST['email1']?? '';
      $email2=$_REQUEST['email2']?? '';
      $email3=$_REQUEST['email3']?? '';
      echo __(
        "<ul>
        <li>Entrez jusqu'à trois adresses email ci-dessous, puis cliquez sur envoyez :</li>".'
        <form>
        <input type="hidden" name="find" value="" />
        <input name="email1"value="'.esc_attr($email1).'"/><input name="email2" value="'.esc_attr($email2).'"/><input name="email3" value="'.esc_attr($email3).'"/>
        <input type="submit" value="Envoyez" />
        </form>
        ', $this->plugin_textdomain);
      }elseif(isset($_REQUEST['new'])) {
        echo 'user not logged in and has entered or want to enter @email<br>';
        $message='';
        if (isset($_REQUEST['new2'])) {
           if ( $this->received_form_data_ok() ) {
              // check if received
              if (isset($_REQUEST['email']) && sanitize_email($_REQUEST['email'])==$_REQUEST['email'] && is_email($_REQUEST['email']) ) {
                $site=false;
                $coop=false;
                if($user= get_user_by('email', $_REQUEST['email'])){
                   // if $user!==false, $user userObject and has account on at least one of our sites
                   // see if user has account on this site
                   $site=true;
                   if (in_array($this->blogid, get_blogs_of_user($user->ID, true))) {
                     $coop=true;
                   }
                }
                if ( !$this->send_subscribe_link_email($_REQUEST['email'], $site , $coop )) {
                  $message=__("message could not be sent, retry, verify or contact us", $this->plugin_textdomain);
                } else{
                  $message=__("Vous allez revevoir un message contenant un lien vous permettant de souscrire avec l'adresse email donnée, si vous ne le recevez pas, vérifiez votre dossier spam.");
                  get_footer();
                  exit;
                }
              } elseif (isset($_REQUEST['email'])) {
                $message=__("Adresse email incorrecte, merci de recommencer ou de nous contacters", $this->plugin_textdomain);
              }
           } else {
            $message=__("Erreur de transmission, recommencez ou contactez nous si l'erreur persiste!", $this->plugin_prefix);
           }
        }
        $email=$_REQUEST['email']?? '';
        echo '<h3>'.esc_html(__("Vous allez souscrire et ouvrir un compte sur le site pep2a", $this->plugin_textdomain))."</h3>";
        echo
        "<ul>
        <li>Entrez l'adresse email avec laquelle vous voulez souscrire, puis cliquez sur envoyez :</li>".'
        <span style="color: red">'.$message.'</span>
        <form action="'.$this->page_url.'">';
        echo $this->get_verification_form(array('new', 'new2'));
        echo'
        <input name="email" value="'.esc_attr($email).'"/>
        <input type="submit" value="Envoyez" />
        </form>
        ';
      } else {
        // user not logged in

        echo '<h3>'.esc_html(__("Vous n'êtes pas connecté sur le site", $this->plugin_textdomain))."</h3>";
        echo __(
          "<ul>
          <li>Si vous êtes déjà sociétaire :</li>
          <ul>
          <li>Connectez vous avec l'adresse email ou l'identifiant de votre compte societaires : ".'<a href="'.$this->login_url.'/?redirect_to='.$this->page_url.'">cliquez ici</a></li>'."
          </ul></ul>
          <ul>
          <li>Si vous n'êtes pas encore sociétaire (y compris si vous avez débuté une souscription):</li>
          <ul>
          <li>Si vous avez un compte sur un site pep2a et que vous voulez utiliser ce compte pour souscrire, connectez vous avec l'adresse email ou l'identifiant de ce compte :  ".'<a href="'.$this->login_url.'/?redirect_to='.$this->page_url.'">cliquez ici</a>'."
          <li>Si vous n'avez aucun compte ".'<a href="'.$this->page_url.'?new">cliquez ici</a>'."</li>
          <li>Si vous ne savez plus, ".'<a href="'.$this->page_url.'?find">cliquez ici</a>'.", vous pourrez entrer jusqu'à 3 adresses mél et nous vous indiquerons (par mél) si vous avez un compte ou pas, sociétaire ou pas.</li>
          </ul></ul>", $this->plugin_textdomain);
        }


        /*echo 'RIB PEP2A : <br>
        La Nef<br>
        IMMEUBLE WOOPA<br>8 AVENUE DES CANUTS,<br>
        CS 60032<br>
        69517 VAULX EN VELIN CEDEX<br>
        IBAN: FR76 2157 0000 0100 5166 3000 135<br>
        BIC: STFEFR21XXX';*/

        echo '<p/>';


        get_footer();
        exit;

      } elseif (isset($_COOKIE[$this->plugin_prefix.'subscribe_step1'])
      &&  isset($_COOKIE[$this->plugin_prefix.'subscribe_step2'])
      &&  isset($_REQUEST['bs1'])) {
        $dis=get_option('wpcoop_options_bs1_file');
        header("Content-type: application/force-download");
        header("Content-Disposition: attachment;filename=".urlencode($dis['name']));
        echo base64_decode($dis['data']);
      }
    }


    public function get_step(){

      return 1;
    }

    public function is_shareholder_by_id($id){




      return false;
    }

    public function send_subscribe_link_email($email, $site=false, $coop=false){
      // send an email to $email : $site=true if this @email matches an account on one of coop site, $coop true if @email matches an account of site coop
      echo "begin send_subscribe_link_email<br>";
      // check if transient already exists that is, user has no memory or someone try something
      $transient_exists=false;
      //echo 'xxxxxx '.get_transient($this->plugin_prefix.'subscribe_'.$email).'xxxxxxx<br>';

      if (get_transient($this->plugin_prefix.'subscribe_'.$email) !== false ){
        $transient_exists=true;
        //echo 'xxxxxxxxxxx transient exists xxxxxxxxxxxxxxxxx<br>';
      }
      $key=wp_hash(wp_rand(1000000,9999999),'auth');
      // set or reset transient
      set_transient($this->plugin_prefix.'subscribe_'.$email, $key, 1800);
      //echo 'xxxxxx '.get_transient($this->plugin_prefix.'subscribe_'.$email).'xxxxxxx<br>';

      $subject=__('Souscription à la coopérative pep2a', $this->plugin_textdomain);

      if($transient_exists){
        $link= $this->page_url.'/?subscribe&email='.$email.'&key='.$key;

        $content="<p>Vous avez débuté une souscription pour la coopérative PEP2A avec cette adresse email ; pour continuer, cliquez sur le lien ci-dessous.</p>\n";
      } else {
        $link= (!$site)? $this->page_url.'/?subscribe&email='.$email.'&key='.$key : $this->login_url.'/?redirect_to='.$this->page_url.'&subscribe&addcoop&email='.$email.'&key='.$key;

        $content="<p>Quelqu'un, sans doute vous, a initié une souscription pour la coopérative PEP2A avec cette adresse email ; si ce n'est pas vous, vous pouvez simplement ignorer cet email.</p>\n";

        if (!$site){
          $content.=__("Vous n'avez aucun compte sur nos sites avec cette l'adresse email : ".esc_html($email)."; si vous avez soumis d'autres adresses email, vérifiez les emails arrivant sur ces autres adresses<br/>Si vous n'avez aucun compte sous aucune de ces adresses email, vous pouvez souscrire à partir du lien de souscription donné dans chaque email, suivant l'adresse email avec laquelle vous voulez souscrire.",$this->plugin_textdomain);
        } elseif($site && !$coop){
          $content.=__("Vous avez un compte sur un de nos sites avec l'adresse email : ".esc_html($email)."; si vous avez soumis d'autres adresses email, vérifiez les emails arrivant sur ces autres adresses<br/>Si vous n'avez aucun autre compte sous aucune de ces autres adresses email, vous pouvez souscrire de préférence à partir du lien de souscription donné dans cet email, afin de souscrire avec cette adresse email et n'avoir qu'un seul compte. Si vous recevez un email indiquant que vous avez un compte sur le site sociétaires avec une autre adresse email, merci de souscrire à partir de celle-ci, en utilisant le lien de souscription de l'email en question.",$this->plugin_textdomain);
        } else {
          $content.=__("Vous avez déjà un compte sur notre site sociétaire avec cette adresse email ".esc_html($email)." ; merci de souscrire avec cette adresse en suivant le lien de souscription ci-dessous.",$this->plugin_textdomain);
        }
      }

      $content.=($site)? '<br/><a href="'.$link.'">Lien de souscription, cliquez-ici si besoin (voir ci-dessus)</a><br/>
      si vous avez oublié votre mot de passe, utilisez la procédure de changement de mot de passe en cliquant <a href="'.$this->change_password_url.'sur ce lien.'
      :
      '<br/><a href="'.$link.'">Lien de souscription, cliquez-ici si besoin (voir ci-dessus)</a><br/>';

      $headers =  array(
           'Content-Type: text/html; charset=UTF-8',
           //'From: '.__('Rappel Email-', PDER_DOMAIN) . "<{$tofrom}>"
           'From: '.$this->fromemail
      );

      if (wp_mail($email, 'instructions pour souscription pep2a', $content, $headers)) {
        $str= '<span>Un email a été envoyé à '.esc_html($email).', vérifiez votre boite email et votre dossier spam, cliquez sur le lien contenu dans l\'email pour continuer la souscription </span>';
      } else {
        $str= '<span style="color: red;">Un email n\'a pu être envoyé à '.esc_html($email).'</span>, vérifier que cette adresse email est correcte et ré-essayer plus tard, sinon contactez nous.';
      }
      echo $str;
      echo "end send_subscribe_link_email<br>";
      return $str;
    }

    public function check_key() {
      if (!isset($_REQUEST['email']) || !is_email($_REQUEST['email']) || !isset($_REQUEST['key']) || $_REQUEST['key']!=get_transient($this->plugin_prefix.'subscribe_'.$_REQUEST['email'])) {
        return false;
      } else {
        // uncomment next line to use transient as nonce
        //delete_transient($this->plugin_prefix.'subscribe_'.$_REQUEST['email']);
        return true;
      }
    }

    public function ok_or_new_email($email, $newemail=''){
      $str = 'vous êtes connecté sur ce site avec l\'email: '.esc_html($email).'<br>';
      $str.= 'voulez-vous utiliser cet email pour souscrire ?<br>
      Si oui, laissez vide/effacer l\'email ci-dessous et cliquez sur le bouton ok, sinon entrez une autre de vos adresse email, puis cliquez sur le bouton ok, vous recevrez à cet adresse un lien pour poursuivre la souscription';
      $str.='
      <form>
      <span>Email</span><input type="text" name="'.$this->plugin_prefix.'new_email" value="'.esc_attr($newemail).'" />
      <input type="submit" name="'.$this->plugin_prefix.'submit_new_email" value="OK"/>
      </form>';
      return $str;
    }

    public function get_verification_form($steps=array()){
      $str='';
      if (empty($steps)) return $str;
      foreach($steps as $step){
        $str.='<input type="hidden" name="'.$step.'" value="" />';
      }
      $str.=wp_nonce_field( $this->plugin_prefix.'subscribe', $this->plugin_prefix.'wpnonce', true, false );
      $val1=random_int(0,10);$val2=random_int(0,10);$val3=random_int(0,10);
      $sum=$val1+$val2+$val3;
      $str.='
      <p class="'.$this->plugin_prefix.'captcha'.'">Combien font ('.$val1.'+'.$val2.'+'.$val3.')? <input type="text" name="'.$this->plugin_prefix.'captcha'.'" value="" /></p>
      <input type="hidden" name="'.$this->plugin_prefix.'" value="" />
      <input type="hidden" name="'.$this->plugin_prefix.'hash'.'" value="'.wp_hash($sum, 'nonce').'" />';
      return $str;
    }

    private function received_form_data_ok(){
      echo 'TODO received_form_data_ok<br>';
      $ok=true;
      if (!isset($_REQUEST[$this->plugin_prefix.'captcha']) || !isset($_REQUEST[$this->plugin_prefix.'hash'])
        || $_REQUEST[$this->plugin_prefix.'hash'] != wp_hash($_REQUEST[$this->plugin_prefix.'captcha'], 'nonce') ) {
        $ok=false;
      }
      if (!isset($_REQUEST[$this->plugin_prefix.'wpnonce']) || !wp_verify_nonce($_REQUEST[$this->plugin_prefix.'wpnonce'],$this->plugin_prefix.'subscribe')){
        $ok=false;
      }
      return $ok;
    }

    public function wp_coop_get_blogs_from_email($email){
      //$email must be validated email
      $user=get_user_by('email',$email);
      $userblogs=false;
      if (!empty($user)) {
        $userblogs=get_blogs_of_user($user->ID);
      }
      return $userblogs; // false if user is not registered, array of blogs user is registered on, empty if user exits but not registered on any blogs,
    }

    public function subscription_subscribe(){
      // received a link to subscribe or connected to one of our site, add to coop site if not already belonging
      $this->user_had_account=false;
      $this->user_docs_are_ok=false;
      get_header();
      echo '<div id="primary" class="content-area">';
      if ($this->check_key()) {
        if ($this->user->ID!=0 && $this->useremail==$_REQUEST['email']){
          if (!in_array($this->blogid, get_blogs_of_user($this->user->ID, true))) {
            add_user_to_blog($this->user->ID);
          }
          //proceeds with subscription form
          $this->user_had_account=true;
        } elseif ($this->user->ID!=0 && $this->useremail!=$_REQUEST['email']) {
          // bad email, log and end
          echo esc_html('<h3>'.sprintf(__("L'adresse email du lien ne correspond pas, ".'<a href="%s">recommencez le processus en cliquant ici</a> ou contactez nous', $this->plugin_textdomain),$this->page_url).'</h3>');
        } else {
          // user not loggin have to register with email given and checked by check_password_reset_key()
          // so force email
          $this->useremail=$_REQUEST['email'];
        }
        $this->subscribe_form();
        $this->choose_payment_method();
        $this->do_payment();
        $this->upload_docs();
        $this->subscription_end();
      } else {
        // bad key message, log and end
        echo '<h3>'.sprintf(__("Le décodage de la clef d'authentification a échoué, ".'<a href="%s">recommencez le processus en cliquant ici</a> ou contactez nous', $this->plugin_textdomain),$this->page_url).'</h3>';
      }
      echo '</div>';
      get_sidebar();
      get_footer();
      exit;
    }

    private function choose_payment_method(){
      if (isset($_REQUEST['subscribe']) && isset($_REQUEST['payment_method'])){


      }

      __("Choisisssez votre moyen de paiement", $this->plugin_textdomain);
      echo'
      <form action="'.$this->page_url.'">



      </form>
      ';


    }

    private function do_payment(){


    }

    private function upload_docs(){


    }

    private function subscription_end(){
      if ($this->payment_done && $this->docs_uploaded){
        $docs_ok = ($this->user_docs_are_ok)? '' : 'sous reserve de vérification des documents';
        if($this->user_had_account()){
          echo 'Souscription enregistrée, '.$docs_ok.', vous pouvez suivre votre souscription sur votre page mon-compte...';
        } else {
          echo 'Votre compte est créé, Souscription enregistrée sous reserve de vérification des documents,vous pouvez suivre votre souscription sur votre page mon-compte...';
        }
      } elseif ($this->payment_done && !$this->docs_uploaded) {
        if($this->user_had_account()){
          echo 'Souscription enregistrée, vous devez fournir les justificatifs, vous pourrez le faire et suivre votre souscription sur votre page mon-compte...';
        } else {
          echo 'Votre compte est créé,Souscription enregistrée vous devez fournir les justificatifs, vous pourrez le faire et vous pouvez suivre votre souscription sur votre page mon-compte...';
        }
      }

      if ($this->docs_uploaded) {
        if($this->user_had_account()){
          echo 'Souscription enregistrée sous reserve de paiement et de vérification des documents, vous pouvez suivre votre souscription sur votre page mon-compte...';
          if($this->payment_online) echo 'Vous pouvez régler votre souscription en ligne ou changer de mode de paiement à partir de la page mon-compte du site';
        } else {
          echo 'Souscription enregistrée sous reserve de paiement et de vérification des documents,vous pouvez suivre votre souscription sur votre page mon-compte...';
          if($this->payment_online) echo 'vous allez recevoir un lien pour pouvoir régler votre souscription en ligne';
        }
        // nopayment done and no docs uploaded
        if($this->user_had_account()){
          echo 'Souscription enregistrée sous reserve de paiement et de fourniture des justificatifs des documents, vous pouvez suivre votre souscription sur votre page mon-compte...';
          if($this->payment_online) echo 'Vous pouvez régler votre souscription en ligne ou changer de mode de paiement à partir de la page mon-compte du site';
        } else {
          echo 'Souscription enregistrée sous reserve de paiement et de vérification des documents,vous pouvez suivre votre souscription sur votre page mon-compte...';
          if($this->payment_online) echo 'vous allez recevoir un lien pour pouvoir régler votre souscription en ligne';
        }
       echo 'merci !!!';
      }
    }

    private function validate_subscribe_form(){


    }

    public function subscribe_form() {
      global $wpcoop;
      //$this->userid=1;
      //print_tab($wpcoop);
      $user_data_fields=$wpcoop->members->get_user_data_fields();
      //print_tab($user_data_fields);
      $wpcoop_fields=$wpcoop->members->get_users_added_fields();
      //print_tab($wpcoop_fields);
      // init user_data
      $user_data=array();
      // no userObj yet
      $userObj=false;

      // see class wpcoop_admin admin_subscribers()
      // fill user_data in case user exists
      $user_data['ID']= $this->userid;
      // fill   user_data with old values
      $userObj = get_userdata( $this->userid );
      $user_data['roles']= $userObj->roles?? '';
      $meta=get_user_meta($this->userid);
      foreach($user_data_fields as $k=>$field) {
        //echo 'user_data_field: '.$k.'<br>';
        //$user_data[$k]= (isset($meta[$this->plugin_prefix.$k]))? $meta[$this->plugin_prefix.$k][0] : '';
        $user_data[$k]= (isset($userObj->{$k}))? $userObj->{$k} : '';
      }
      $slug='';
      foreach($wpcoop_fields['tabs'] as $tab) {
        if($tab['slug']!=$slug) {
          $slug=$tab['slug'];
          if ($slug=='wp') {
            continue;
          }
          $prefix = ($slug=='wp')? '' : $this->plugin_prefix.$this->usersdata_prefix.$slug.'_';
        }
        foreach($tab['fields'] as $field) {
          $user_data[$prefix.$field['name']]= (isset($meta[$prefix.$field['name']]))? $meta[$prefix.$field['name']][0] : '';
          switch($field['tag']) {
            case 'input':
            switch($field['type']){
              case 'checkbox':
              //echo $prefix.$field['name'].': '.meta[$prefix.$field['name']].'<br>';
              $user_data[$prefix.$field['name']] = (isset($meta[$prefix.$field['name']]) && $meta[$prefix.$field['name']][0]=='y') ? 'y' : 'n';
              break;
              case 'text':
              default:
            }
            break;
            case 'textarea':
            case 'select':
            default:
          }
        }
      } //$wpcoop_fields
      //print_tab($user_data);

      // copy wp fields
      $pluginprefix=$this->plugin_prefix;
      if ($user_data[$pluginprefix.$this->usersdata_prefix.'membertype_type']=='c') {
        $prefix=$pluginprefix.$this->usersdata_prefix.'memberperson_';
      } else {
        $prefix=$pluginprefix.$this->usersdata_prefix.'representative_';
      }
      $user_data[$prefix.'first_name']=$user_data['first_name'];
      $user_data[$prefix.'last_name']=$user_data['last_name'];
      $user_data[$prefix.'user_email']=$user_data['user_email'];
      $user_data[$prefix.'user_url']=$user_data['user_url'];
      //echo '----userdata--current data--<br>';
      //$user_data['cap'] =($userObj->has_cap($this->plugin_capability))? 1 : 0;
      //print_tab($user_data);


      // user form
      ?>
      <form  method="post" >
      <?php //echo wp_nonce_field( 'wpcoopsubscribers', $pluginprefix.'wpnonce', true, false );
      //echo '<table>';
      if (isset($user_data['ID']) && $user_data['ID']!=-1) {
        //echo '<input type="hidden" name="'.$pluginprefix.'user_id'.'" value="'.$user_data['ID'].'"   />';
      }
      $slug='';
      foreach($wpcoop_fields['tabs'] as $tab) {
        if($tab['slug']!=$slug) {
          if ($tab['slug']=='internal') continue;
          echo '<table class="'.$pluginprefix.$tab['class'].'" >';
          $slug=$tab['slug'];
          $prefix = ($slug=='wp')? '' : $pluginprefix.$this->usersdata_prefix.$slug.'_';
          echo '<tr><th class="'.$pluginprefix.$tab['class'].'" >'.$tab['caption'].'</th></tr>';
        }
        foreach($tab['fields'] as $field) {
          //echo $prefix.$field['name'].': '.$user_data[$prefix.$field['name']].'<br>';
          $dis= (isset($field['dis']) && $field['dis']=='y')? 'disabled="disabled"' : '';
          switch ($field['tag']) {
            case 'textarea':
            echo '<tr>
            <td>'.esc_html($field['caption']).'</td>
            <td><textarea  '.$dis.' name="'.esc_attr($prefix.$field['name']).'">'.esc_attr($user_data[$prefix.$field['name']]).'</textarea></td>
            <td>'.esc_html($field['desc']).'</td>
            </tr>';
            break;
            case 'select':
            $options= (isset($field['values']))? self::get_select_options($field['values']) : array() ;
            if (!empty($options)) {
              echo  '<tr>
              <td>'.esc_html($field['caption']).'</td>
              <td>
              <select '.$dis.' name="'.esc_attr($prefix.$field['name']).'" >';
              foreach($options as $k=>$option) {
                $sel= ($user_data[$prefix.$field['name']]==$k)? 'selected="selected"' : '';
                echo '<option value="'.esc_attr($k).'" '.$sel.' >'.esc_html($option).'</option>';
              }
              echo '
              </select>
              </td>
              <td>'.esc_html($field['desc']).'</td>
              </tr>';
            }
            break;
            case 'input':
            $type="text";
            $checked='';
            $value='value="'.esc_attr($user_data[$prefix.$field['name']]).'"';
            switch ($field['type']) {
              case 'checkbox':
              $type="checkbox";
              if($user_data[$prefix.$field['name']]=='y') $checked='checked="checked"';
              $value='';
              break;
            }
            echo  '<tr>
            <td>'.esc_html($field['caption']).'</td>
            <td><input '.$dis.'type="'.$type.'" name="'.esc_attr($prefix.$field['name']).'" '.$value.' '.$checked.' /></td>
            <td>'.esc_html($field['desc']).'</td>
            </tr>';
            break;
          } // switch tag
        } // field

        echo '</table>';
      }
      //echo '</table>';
      //submit_button( __( 'Record', $this->plugin_textdomain ), 'primary', $pluginprefix.'record', true);
      echo '</form>';

      //echo 'fin';


    }

    public static function get_select_options($values) {
      if (is_array($values) && count($values)==2 && (is_object($values[0]) || class_exists($values[0])) && is_string($values[1]) && method_exists($values[0], $values[1])) {
        return (array) call_user_func($values);
      } else {
        return array();
      }
    }

    ///////////////////////////////////////// MAIN ////////////////////////////////////////
    /*
    $user='coco';
    $user_email="hubic@pep2a.fr";

    $meta=array(
      'add_to_blog'=>2,
      'new_role'=>'subscriber');


      remove_filter('after_signup_user', 'wpmu_signup_user_notification');
      wpmu_signup_user($user,$user_email,$meta);
      //voir after_signup_user
      //global $wp_filter;
      //print_tab($wp_filter['after_signup_user']);

      //print_tab($wp_errors);
      /*
      [callbacks] => Array
      (
        [10] => Array
        (
          [wpmu_signup_user_notification] => Array
          (
            [function] => wpmu_signup_user_notification
            [accepted_args] => 4
            )

            )

            )
            die('stop');


            */



          } //class
        } // if class exits
