<?php
/**
 * Exit if accessed directly
 */

// alm 20200931


if ( !defined( 'ABSPATH' ) ) {
    exit;
}
if (!class_exists( 'WPCOOP_Subscription' ) ) {
  class WPCOOP_Subscription {



   public function __construct($thispageurl) {
     global $wpcoop;
     $this->plugin_prefix=$wpcoop->plugin_prefix;
     $this->includes_path=$wpcoop->includes_path;
     $this->plugin_textdomain=$wpcoop->plugin_textdomain;
     $this->usersdata_prefix=$wpcoop->usersdata_prefix; // usefull in wpcoop?

     $this->user = wp_get_current_user();
     $this->userid=$this->user->ID;
     $this->cookie_timeout=300; // in seconds, set 24h = 86400s

     $this->page_url=$thispageurl;
     $this->login_url=network_site_url()."wp-login.php";
     // code to verify response origins
     $this->code=12457812450;

     if (!class_exists('WPCOOP_Member')) include_once( $this->includes_path.'class-wpcoop-member.php' );

   }

   public function subscribe(){
        if (isset($_REQUEST['step'])) {
           $this->subscription_steps();
        }
        $this->subscription_first_step();

        exit;
   }

   private function subscription_first_step(){

        $unknown=($this->user->ID==0)? '<li>L\'adresse email avec laquelle vous voulez souscrire (éventuellement adresse email ou identifiant et mot de passe si vous êtes déjà sociétaire ou avez un compte sur un des sites pep2a -pep2a.fr, pep2a.fr/societaires, ou pep2a.fr/intranet. Si vous ne savez plus, une procédure de récupération sera tentée )</li>' : '';
        $unknown='<li>L\'adresse email avec laquelle vous voulez souscrire (celle avec laquelle vous êtes inscrit si vous êtes déjà sociétaire)</li>';

        $connected=($this->user->ID==0)? '' : 'Vous êtes connecté sur un site PEP2A, restez connecté pour poursuivre votre souscription';


        if (!isset($_COOKIE[$this->plugin_prefix.'subscribe_step1']) ) {
            // no cookie set
            setcookie($this->plugin_prefix.'subscribe_step1',time(), time()+$this->cookie_timeout); // 24h left
            get_header();
            echo '<h2>Souscrire des parts de PEP2A : 1ère étape</h2>';
            //echo '<div><span>'.$connected.'</span></div>';
            echo '
            <div><span>Le processus de souscription se fait en deux étapes ; vous devez disposer de : </span>
            <ul>
            '.$unknown.'
            <li>Une pièce d\'identité (CNI recto/verso, passeport...) et un justificatif de domicile (facture électricité, téléphone... de moins de 3 mois), de préférence sous forme numérique (scan, photo)</li>
            <li>Un moyen de paiement, virement si possible, sinon Carte Bancaire, vous pourrez également régler votre souscription par chèque (à éviter)</li>
            </ul>
            <!-- <div><span>Le processus de souscription durera environ 15 minutes ; il peut être interrompu et repris dans les 24 heures</span></div> -->
            <p/>
            <div><span>Conformément à la réglementation, merci de télécharger le Document d\'Information Synthétique (DIS) afin de prendre connaissance  des risques associés à la souscription de parts PEP2A</span>. Le DIS comporte des liens vers les articles significatifs des statuts, <a href="https://pep2a.fr/societaires/wp-content/uploads/sites/2/2020/07/20190401-Statuts_SCIC_PEP2A_2019-03-23_statuts-modifies-suite-AGE.pdf">mais les statuts complets sont ici (pdf).</a><p/></div>
            <form method="post">
            <a href="">Téléchargement du DIS</a>
            <div><span>Après avoir téléchargé le document, veuillez confirmez que vous en avez bien pris connaissance</span>
            <input type="submit" name="'.$this->plugin_prefix.'subscribe_step2'.'" value="Je confirme"/>
            </form>
            </div>
            ';
            get_footer();
            exit;
        } elseif (isset($_COOKIE[$this->plugin_prefix.'subscribe_step1'])
              && !isset($_COOKIE[$this->plugin_prefix.'subscribe_step2'])
              && !isset($_POST[$this->plugin_prefix.'subscribe_step2'])) {
            // download dis
            setcookie($this->plugin_prefix.'subscribe_step2',time(), time()+$this->cookie_timeout); // 24h left to acknowlege
            $dis=get_option('wpcoop_options_dis1_file');
            header("Content-type: application/force-download");
            header("Content-Disposition: attachment;filename=".urlencode($dis['name']));
            echo base64_decode($dis['data']);
            //exit;

        } elseif (isset($_COOKIE[$this->plugin_prefix.'subscribe_step1'])
              &&  !isset($_COOKIE[$this->plugin_prefix.'subscribe_step2'])
              &&   isset($_POST[$this->plugin_prefix.'subscribe_step2'])) {
            // validated without having downloaded dis
            get_header();
            echo '<h2>Souscrire des parts de PEP2A : 1ère étape </h2>';
            echo '
            <div><span>Conformément à la réglementation, </span><span style="color: red">VOUS DEVEZ</span> télécharger le DIS afin de prendre connaissance  des risques associés à la souscription de parts PEP2A</span></div>
            <form method="post">
            <a href="">Téléchargement du DIS</a>
            <div><span>Après avoir téléchargé le document, veuillez confirmez que vous en avez bien pris connaissance</span>
            <input type="submit" name="'.$this->plugin_prefix.'subscribe_step2'.'" value="Je confirme"/>
            </form>
            </div>
            ';
            get_footer();
            exit;

        } elseif (isset($_COOKIE[$this->plugin_prefix.'subscribe_step1'])
              &&  isset($_COOKIE[$this->plugin_prefix.'subscribe_step2'])
              &&  !isset($_REQUEST['bs1'])) {
            // dis downloaded and validation done
            get_header();
            // ajout de la classe survol pour RIB apparence/personnaliser/css additionnel
        /*
        a.survol {
          position:relative;
          border-bottom:1px dashed #808080;
          text-decoration: none;
        }
        a:hover.survol {
          text-decoration: none;
          background: none;
        }
        a.survol span {display: none;}

        a:hover.survol span {
          display: block;
          position: relative;
          top: -20px;
          left: 10px;
          z-index: 20;
          width:100%;
          padding:2px 4px;
        }
        */
            echo '<h2>Souscrire des parts de PEP2A : 2ième étape</h2>';
            echo 'La souscription en ligne ne fonctionne pas encore, vous devez donc télécharger et remplir le bulletin de souscription, puis le retourner avec les justificatifs demandés à l\'adresse email <a href="mailto:souscription@pep2a.fr">souscription@pep2a.fr</a>. <br />
            <ul>
            <li>Vous pouvez régler votre souscription par virement en utilisant <a class="survol" href="#">ce rib (passer la souris ici)<span><img src="https://pep2a.fr/societaires/wp-content/uploads/sites/2/2020/07/20200720-image_rib_pep2a.jpg" alt=""></span></a></li>
            <li>Vous pouvez également régler en ligne par <a href="https://secure.payplug.com/p/Xy6jr">Carte Bancaire sur le site sécurisé Payplug</a> (et donc vos données ne transitent pas par le site PEP2A)</li>
            <li>Vous pouvez aussi envoyer vos documents et un chèque à l\'adresse
         postale de pep2a, mais nous ne conseillons pas cette option, qui occasionnera un temps de traitement plus long car demandera plus de travail et de déplacement à nos bénévoles (n\'oubliez pas que notre coopérative fonctionne essentiellement grâce au bénévolat des sociétaires, qui sont répartis sur le département).</li></ul>
         <a href="?bs1">Téléchargement du Bulletin de souscription</a><p/>';

        if ($this->userid!=0){

        $this->subscribe_form('no',$this->userid);

        }elseif(isset($_REQUEST['find'])){
         // user not logged in and has to find good @email
         $message="";
         echo '<h3>'.esc_html(__("Vous cherchez si vous avez un compte surle site pep2a", $this->plugin_textdomain))."</h3>";
         // issue code to verify not a robot answering



         echo __(
            "<ul>
             <li>Entrez jusqu'à trois adresses email, puis cliquez sur envoyez :</li>".'
             <span style="color: red">'.$message.'</span>
             <form>
             <input name=""value=""/><input name="" value=""/><input name=value""/>

             <input type="submit" value="Envoyez" />
             </form>
             ', $this->plugin_textdomain);

        }elseif(isset($_REQUEST['new'])){
         // user not logged in and has to give @email
         $message='';
         // check if received
         if ($_REQUEST['new']=='set') &&  && $this->received_form_data_ok()){
           $sent=$this->send_subscribe_link_email();
           if (!sent()){
            $message=__("message could not be sent, retry, verify or contact us", $this->plugin_textdomain);
          } else{
           echo '<span class="'.$this->plugin_prefix.'infos">'.__("Vous allez revevoir un message contenant un lien vous permettant de souscrire avec l'adresse email donnée, si vous ne le recevez pas, vérifiez votre dossier spam.");
           get_footer();
           //exit;
          }
         } else {
           $message=__("Adresse email incorrecte ou problème dans son envoi, meric de recommencerou de nous contacters", $this->plugin_textdomain);
         }

         echo '<h3>'.esc_html(__("Vous allez souscrire et ouvrir un compte sur le site pep2a", $this->plugin_textdomain))."</h3>";
         echo
            "<ul>
             <li>Entrez l'adresse email avec laquelle vous voulez souscrire, puis cliquez sur envoyez :</li>".'
             <span style="color: red">'.$message.'</span>
             <form action="">';
         echo $this->get_verification_form();
         echo'
             <input name="" value=""/>

             <input type="submit" value="Envoyez" />
             </form>
             ';
        }elseif(isset($_REQUEST['newset'])){
         // user not logged in and has to give @email
        print_tab($_REQUEST);
         $message="";
         echo '<h3>'.esc_html(__("Vous alFDFRrir ua", $this->plugin_textdomain))."</h3>";
         echo __(
            "TEST", $this->plugin_textdomain);
        } else {
         // user not logged in

         echo '<h3>'.esc_html(__("Vous n'êtes pas connecté sur le site", $this->plugin_textdomain))."</h3>";
         echo __(
            "<ul>
             <li>Si vous êtes déjà sociétaire :</li>
             <ul>
             <li>Connectez vous avec l'adresse email ou l'identifiant de votre compte societaires : ".'<a href="'.$this->login_url.'/?redirect_to='.$this->page_url.'">cliquez ici</a></li>'."
             </ul></ul>
             <ul>
             <li>Si vous n'êtes pas encore sociétaire:</li>
             <ul>
             <li>Si vous avez un compte sur un site pep2a et que vous voulez utiliser ce compte pour souscrire, connectez vous avec l'adresse email ou l'identifiant de ce compte :  ".'<a href="'.$this->login_url.'/?redirect_to='.$this->page_url.'">cliquez ici</a>'."
             <li>Si vous n'avez aucun compte ".'<a href="'.$this->page_url.'?new">cliquez ici</a>'."</li>
             <li>Si vous ne savez plus, ".'<a href="'.$this->page_url.'?find">cliquez ici</a>'.", vous pourrez entrer jusqu'à 3 adresses mél et nous vous indiquerons (par mél) si vous avez un compte ou pas, sociétaire ou pas.</li>
            </ul></ul>", $this->plugin_textdomain);
        }


         /*echo 'RIB PEP2A : <br>
         La Nef<br>
         IMMEUBLE WOOPA<br>8 AVENUE DES CANUTS,<br>
         CS 60032<br>
         69517 VAULX EN VELIN CEDEX<br>
         IBAN: FR76 2157 0000 0100 5166 3000 135<br>
         BIC: STFEFR21XXX';*/

            echo '<p/>';


            get_footer();
            exit;

        } elseif (isset($_COOKIE[$this->plugin_prefix.'subscribe_step1'])
              &&  isset($_COOKIE[$this->plugin_prefix.'subscribe_step2'])
              &&  isset($_REQUEST['bs1'])) {
            $dis=get_option('wpcoop_options_bs1_file');
            header("Content-type: application/force-download");
            header("Content-Disposition: attachment;filename=".urlencode($dis['name']));
            echo base64_decode($dis['data']);
        }
  }


   public function get_step(){

     return 1;
   }

   public function is_shareholder_by_id($id){




     return false;
   }

   public function send_subscribe_link_email($email){
     $str='';

     if ($user=get_user_by('email', $email)!==false){
       // account exists for this email
       // send login link with redirect to subscribe

     } else {
       // no user with this email
       // send link to subscribe form
     }



     $content='contenu';

     if (wp_mail($email, 'instructions pour souscription pep2a', $content,     array('From: souscriptions pep2a <souscriptions@pep2a.fr>'))){
            $str.= '<span>Un email a été envoyé à '.esc_html($email).', vérifiez votre boite email et votre dossier spam, cliquez sur le lien contenu dans l\'email pour continuer la souscription </span>';
     } else {
            $str.= '<span style="color: red;">Un email n\'a pu être envoyé à '.esc_html($email).'</span>, vérifier que cette adresse email est correcte et ré-essayer plus tard, sinon contactez nous.';
     }
     return $str;
   }

   public function ok_or_new_email($email, $newemail=''){
       $str = 'vous êtes connecté sur ce site avec l\'email: '.esc_html($email).'<br>';
       $str.= 'voulez-vous utiliser cet email pour souscrire ?<br>
       Si oui, laissez vide/effacer l\'email ci-dessous et cliquez sur le bouton ok, sinon entrez une autre de vos adresse email, puis cliquez sur le bouton ok, vous recevrez à cet adresse un lien pour poursuivre la souscription';
       $str.='
          <form>
           <span>Email</span><input type="text" name="'.$this->plugin_prefix.'new_email" value="'.esc_attr($newemail).'" />
           <input type="submit" name="'.$this->plugin_prefix.'submit_new_email" value="OK"/>
          </form>';
    return $str;
   }

   public function get_verification_form(){
     $str=wp_nonce_field( $this->plugin_prefix.'subscribe', $this->plugin_prefix.'wpnonce', false );
     $val1=random_int(0,10);$val2=random_int(0,10);$val3=random_int(0,10);
     $sum=$val1+$val2+$val3;
     $hash=hash('md5', $sum+$this->code);
     $str.='
     <p class="'.$this->plugin_prefix.'captcha'.'">Combien font ('.$val1.'+'.$val2.'+'.$val3.')? <input type="text" name="'.$this->plugin_prefix.'captcha'.'" value="" /></p>
     <input type="hidden" name="'.$this->plugin_prefix.'hash'.'" value="'.$hash.'" />';
     return $str;
   }

   public function wp_coop_get_blogs_from_email($email){
      //$email must be validated email
      $user=get_user_by('email',$email);
      $userblogs=false;
      if (!empty($user)) {
        $userblogs=get_blogs_of_user($user->ID);
      }
      return $userblogs; // false if user is not registered, array of blogs user is registered on, empty if user exits but not registered on any blogs,
    }

    public function wpcoop_get_possible_user() {


    }

    public function wpcoop_check_key() {

      return 'no';
    }

    public function subscription_steps(){
    }

    public function subscribe_form() {
      global $wpcoop;
      //print_tab($wpcoop);
      $user_data_fields=$wpcoop->members->get_user_data_fields();
      //print_tab($user_data_fields);
      $wpcoop_fields=$wpcoop->members->get_users_added_fields();
      //print_tab($wpcoop_fields);
      // init user_data
      $user_data=array();
      // no userObj yet
      $userObj=false;

        // see class wpcoop_admin admin_subscribers()
        // fill user_data in case user exists
        $user_data['ID']= $this->userid;
        // fill   user_data with old values
        $userObj = get_userdata( $this->userid );
        $user_data['roles']= $userObj->roles;
        $meta=get_user_meta($this->userid);
        foreach($user_data_fields as $k=>$field) {
            //echo 'user_data_field: '.$k.'<br>';
            //$user_data[$k]= (isset($meta[$this->plugin_prefix.$k]))? $meta[$this->plugin_prefix.$k][0] : '';
            $user_data[$k]= (isset($userObj->{$k}))? $userObj->{$k} : '';
        }
        $slug='';
        foreach($wpcoop_fields['tabs'] as $tab) {
           if($tab['slug']!=$slug) {
                $slug=$tab['slug'];
                if ($slug=='wp') {
                  continue;
                }
                $prefix = ($slug=='wp')? '' : $this->plugin_prefix.$this->usersdata_prefix.$slug.'_';
           }
           foreach($tab['fields'] as $field) {
            $user_data[$prefix.$field['name']]= (isset($meta[$prefix.$field['name']]))? $meta[$prefix.$field['name']][0] : '';
            switch($field['tag']) {
                case 'input':
                    switch($field['type']){
                        case 'checkbox':
                            //echo $prefix.$field['name'].': '.meta[$prefix.$field['name']].'<br>';
                            $user_data[$prefix.$field['name']] = (isset($meta[$prefix.$field['name']]) && $meta[$prefix.$field['name']][0]=='y') ? 'y' : 'n';
                            break;
                        case 'text':
                        default:
                    }
                    break;
                case 'textarea':
                case 'select':
                default:
            }
           }
        } //$wpcoop_fields
        //print_tab($user_data);

        // copy wp fields
        $pluginprefix=$this->plugin_prefix;
        if ($user_data[$pluginprefix.$this->usersdata_prefix.'membertype_type']=='c') {
            $prefix=$pluginprefix.$this->usersdata_prefix.'memberperson_';
        } else {
            $prefix=$pluginprefix.$this->usersdata_prefix.'representative_';
        }
        $user_data[$prefix.'first_name']=$user_data['first_name'];
        $user_data[$prefix.'last_name']=$user_data['last_name'];
        $user_data[$prefix.'user_email']=$user_data['user_email'];
        $user_data[$prefix.'user_url']=$user_data['user_url'];
        //echo '----userdata--current data--<br>';
        //$user_data['cap'] =($userObj->has_cap($this->plugin_capability))? 1 : 0;
        //print_tab($user_data);


                    // user form
                ?>
                    <form  method="post" >
                    <?php //echo wp_nonce_field( 'wpcoopsubscribers', $pluginprefix.'wpnonce', true, false );
                    //echo '<table>';
                    if (isset($user_data['ID']) && $user_data['ID']!=-1) {
                     //echo '<input type="hidden" name="'.$pluginprefix.'user_id'.'" value="'.$user_data['ID'].'"   />';
                    }
                    $slug='';
                    foreach($wpcoop_fields['tabs'] as $tab) {
                        if($tab['slug']!=$slug) {
                            if ($tab['slug']=='internal') continue;
                            echo '<table class="'.$pluginprefix.$tab['class'].'" >';
                            $slug=$tab['slug'];
                            $prefix = ($slug=='wp')? '' : $pluginprefix.$this->usersdata_prefix.$slug.'_';
                            echo '<tr><th class="'.$pluginprefix.$tab['class'].'" >'.$tab['caption'].'</th></tr>';
                        }
                        foreach($tab['fields'] as $field) {
                          //echo $prefix.$field['name'].': '.$user_data[$prefix.$field['name']].'<br>';
                          $dis= (isset($field['dis']) && $field['dis']=='y')? 'disabled="disabled"' : '';
                          switch ($field['tag']) {
                                case 'textarea':
                                 echo '<tr>
                                        <td>'.esc_html($field['caption']).'</td>
                                        <td><textarea  '.$dis.' name="'.esc_attr($prefix.$field['name']).'">'.esc_attr($user_data[$prefix.$field['name']]).'</textarea></td>
                                        <td>'.esc_html($field['desc']).'</td>
                                       </tr>';
                                 break;
                                case 'select':
                                 $options= (isset($field['values']))? self::get_select_options($field['values']) : array() ;
                                 if (!empty($options)) {
                                     echo  '<tr>
                                             <td>'.esc_html($field['caption']).'</td>
                                             <td>
                                              <select '.$dis.' name="'.esc_attr($prefix.$field['name']).'" >';
                                              foreach($options as $k=>$option) {
                                                $sel= ($user_data[$prefix.$field['name']]==$k)? 'selected="selected"' : '';
                                                echo '<option value="'.esc_attr($k).'" '.$sel.' >'.esc_html($option).'</option>';
                                              }
                                      echo '
                                              </select>
                                             </td>
                                             <td>'.esc_html($field['desc']).'</td>
                                            </tr>';
                                 }
                                 break;
                                case 'input':
                                 $type="text";
                                 $checked='';
                                 $value='value="'.esc_attr($user_data[$prefix.$field['name']]).'"';
                                 switch ($field['type']) {
                                  case 'checkbox':
                                   $type="checkbox";
                                   if($user_data[$prefix.$field['name']]=='y') $checked='checked="checked"';
                                   $value='';
                                   break;
                                 }
                                 echo  '<tr>
                                         <td>'.esc_html($field['caption']).'</td>
                                         <td><input '.$dis.'type="'.$type.'" name="'.esc_attr($prefix.$field['name']).'" '.$value.' '.$checked.' /></td>
                                         <td>'.esc_html($field['desc']).'</td>
                                        </tr>';
                               break;
                          } // switch tag
                        } // field

                        echo '</table>';
                    }
                    //echo '</table>';
                    //submit_button( __( 'Record', $this->plugin_textdomain ), 'primary', $pluginprefix.'record', true);
                    echo '</form>';

     //echo 'fin';


    }

    public static function get_select_options($values) {
        if (is_array($values) && count($values)==2 && (is_object($values[0]) || class_exists($values[0])) && is_string($values[1]) && method_exists($values[0], $values[1])) {
           return (array) call_user_func($values);
        } else {
           return array();
        }
    }

    ///////////////////////////////////////// MAIN ////////////////////////////////////////
    /*
    $user='coco';
    $user_email="hubic@pep2a.fr";

    $meta=array(
    'add_to_blog'=>2,
    'new_role'=>'subscriber');


    remove_filter('after_signup_user', 'wpmu_signup_user_notification');
    wpmu_signup_user($user,$user_email,$meta);
    //voir after_signup_user
    //global $wp_filter;
    //print_tab($wp_filter['after_signup_user']);

    //print_tab($wp_errors);
    /*
    [callbacks] => Array
            (
                [10] => Array
                    (
                        [wpmu_signup_user_notification] => Array
                            (
                                [function] => wpmu_signup_user_notification
                                [accepted_args] => 4
                            )

                    )

            )
    die('stop');


    */



  } //class
} // if class exits
