<?php

// must only be called when wpcoop plugin active

define('EURO', chr(128) );
define('EURO_VAL', 6.55957 );

// Xavier Nicolay 2004
// Version 1.02
// alm 20160410
// Reste à faire :
// + Multipage (gestion automatique sur plusieurs pages)
// + Ajout de logo
//

class PDF_WpCoop_Document extends FPDF
{
// variables privées
var $colonnes;
var $table;
var $format;
var $angle=0;

// fonctions privées
function car_decode($str) {
   return utf8_decode($str);
}

function get_signatures_path() {
    // $wpcoop object wpcoop
    global $wpcoop;
    return $wpcoop->plugin_signatures_path;
}

function RoundedRect($x, $y, $w, $h, $r, $style = '')
{
    $k = $this->k;
    $hp = $this->h;
    if($style=='F')
        $op='f';
    elseif($style=='FD' || $style=='DF')
        $op='B';
    else
        $op='S';
    $MyArc = 4/3 * (sqrt(2) - 1);
    $this->_out(sprintf('%.2F %.2F m',($x+$r)*$k,($hp-$y)*$k ));
    $xc = $x+$w-$r ;
    $yc = $y+$r;
    $this->_out(sprintf('%.2F %.2F l', $xc*$k,($hp-$y)*$k ));

    $this->_Arc($xc + $r*$MyArc, $yc - $r, $xc + $r, $yc - $r*$MyArc, $xc + $r, $yc);
    $xc = $x+$w-$r ;
    $yc = $y+$h-$r;
    $this->_out(sprintf('%.2F %.2F l',($x+$w)*$k,($hp-$yc)*$k));
    $this->_Arc($xc + $r, $yc + $r*$MyArc, $xc + $r*$MyArc, $yc + $r, $xc, $yc + $r);
    $xc = $x+$r ;
    $yc = $y+$h-$r;
    $this->_out(sprintf('%.2F %.2F l',$xc*$k,($hp-($y+$h))*$k));
    $this->_Arc($xc - $r*$MyArc, $yc + $r, $xc - $r, $yc + $r*$MyArc, $xc - $r, $yc);
    $xc = $x+$r ;
    $yc = $y+$r;
    $this->_out(sprintf('%.2F %.2F l',($x)*$k,($hp-$yc)*$k ));
    $this->_Arc($xc - $r, $yc - $r*$MyArc, $xc - $r*$MyArc, $yc - $r, $xc, $yc - $r);
    $this->_out($op);
}

function _Arc($x1, $y1, $x2, $y2, $x3, $y3)
{
    $h = $this->h;
    $this->_out(sprintf('%.2F %.2F %.2F %.2F %.2F %.2F c ', $x1*$this->k, ($h-$y1)*$this->k,
                        $x2*$this->k, ($h-$y2)*$this->k, $x3*$this->k, ($h-$y3)*$this->k));
}

function Rotate($angle, $x=-1, $y=-1)
{
    if($x==-1)
        $x=$this->x;
    if($y==-1)
        $y=$this->y;
    if($this->angle!=0)
        $this->_out('Q');
    $this->angle=$angle;
    if($angle!=0)
    {
        $angle*=M_PI/180;
        $c=cos($angle);
        $s=sin($angle);
        $cx=$x*$this->k;
        $cy=($this->h-$y)*$this->k;
        $this->_out(sprintf('q %.5F %.5F %.5F %.5F %.2F %.2F cm 1 0 0 1 %.2F %.2F cm',$c,$s,-$s,$c,$cx,$cy,-$cx,-$cy));
    }
}

function _endpage()
{
    if($this->angle!=0)
    {
        $this->angle=0;
        $this->_out('Q');
    }
    parent::_endpage();
}

// fonctions publiques
function sizeOfText( $texte, $largeur )
{
    if ($largeur==0) return false;
    $index    = 0;
    $nb_lines = 0;
    $loop     = TRUE;
    while ( $loop )
    {
        $pos = strpos($texte, "\n");
        if (!$pos)
        {
            $loop  = FALSE;
            $ligne = $texte;
        }
        else
        {
            $ligne  = substr( $texte, $index, $pos);
            $texte = substr( $texte, $pos+1 );
        }
        $length = floor( $this->GetStringWidth( $ligne ) );
        $res = 1 + floor( $length / $largeur) ;
        $nb_lines += $res;
    }
    return $nb_lines;
}

// Cette fonction affiche en haut, a gauche,
// le nom de la societe dans la police Arial-12-Bold
// les coordonnees de la societe dans la police Arial-10
function addCompany( $logourl, $name, $address ) {
    $mt=10; // marge haute
    $ml=10; // marge gauche
    $hi=20; // hauteur image

    
    $this->Image($logourl, $ml, $mt, 0, $hi);
    $name=$this->car_decode($name);
    $address=$this->car_decode(str_replace('\n',"\n",$address));
    //down
    $x1=$ml;
    $y1=$mt+$hi+2;
    $this->SetXY( $x1, $y1 );
    if (!empty($name)) {
     $this->SetFont('Arial','B',12);
     $length = $this->GetStringWidth( $name );
     $this->Cell( $length, 2, $name);
     $this->SetXY( $x1, $y1 + 4 );
    }
    $this->SetFont('Arial','',10);
    $length = $this->GetStringWidth( $address );
    //Company data
    $lignes = $this->sizeOfText( $address, $length) ;
    $this->MultiCell($length, 4, $address);
}

    
// Affiche en haut, a droite les references du document
// (type, numero, date)
// et son numero
// La taille de la fonte est auto-adaptee au cadre
function addDocRefs($libelle, $num, $date, $dr=90, $y=10, $h=5, $w=80)
{
    $r1  = $this->w - $dr;
    $r2  = $r1 + $w;
    $y1=$y;
    $y2  = $y1 + 2;
    $mid = ($r1 + $r2 ) / 2;

    
    $texte  = utf8_decode($libelle) . $num;
    $szfont = 12;
    $loop   = 0;

  
    while ( $loop == 0 )
    {
       $this->SetFont( "Arial", "B", $szfont );
       $sz = $this->GetStringWidth( $texte );
       if ( ($r1+$sz) > $r2 )
          $szfont --;
       else
          $loop ++;
    }

    
    $this->SetLineWidth(0.1);
    $this->SetFillColor(230);
    $this->RoundedRect($r1, $y1, ($r2 - $r1), $y2+$h, 2.5, 'DF');
    $this->SetXY( $r1+1, $y1+2);
    $this->Cell($r2-$r1 -1,5, $texte, 0, 0, "C" );
    $this->SetXY( $r1+1, $y1+$szfont/2+1);
    $this->Cell($r2-$r1 -1,5, 'Date: '.$date, 0, 0, "C" );
}

// Affiche un cadre avec les references du client
// (en haut, a droite)
function addClient( $ref )
{
    $r1  = $this->w - 31;
    $r2  = $r1 + 19;
    $y1  = 17;
    $y2  = $y1;
    $mid = $y1 + ($y2 / 2);
    $this->RoundedRect($r1, $y1, ($r2 - $r1), $y2, 3.5, 'D');
    $this->Line( $r1, $mid, $r2, $mid);
    $this->SetXY( $r1 + ($r2-$r1)/2 - 5, $y1+3 );
    $this->SetFont( "Arial", "B", 10);
    $this->Cell(10,5, "CLIENT", 0, 0, "C");
    $this->SetXY( $r1 + ($r2-$r1)/2 - 5, $y1 + 9 );
    $this->SetFont( "Arial", "", 10);
    $this->Cell(10,5,$ref, 0,0, "C");
}


    
// Affiche un cadre avec le titre du document
// (titre marge haute,marge haute, largeur, hauteur
function addTitle( $title, $mg=60, $mh=20, $l=100, $h=10 )
{
    $this->SetFont( "Arial", "B", 10);
    $this->SetXY($mg,$mh);
    $this->MultiCell($l, $h, utf8_decode($title), 0, "C");
    $this->RoundedRect($mg, $mh, $l, $h, 3.5, 'D');
}






    
    
    
    
    
    
// Affiche un cadre avec un numero de page
// (en haut, a droite)
function addPageNumber( $page, $npt=0, $md=10, $mh=20, $l=10, $h=10 )
{
    $r1  = $this->w - $md - $l;
    $r2  = $r1 + $l;
    $y1  = $mh;
    $y2  = $h;
    $mid = $y1 + ($y2 / 2);
    $r=3.5;
    $this->RoundedRect($r1, $y1, ($r2 - $r1), $y2, $r, 'D');
    $this->Line( $r1, $mid, $r2, $mid);
    $this->SetXY( $r1, $y1+1 );
    $this->SetFont( "Arial", "B", 8);
    $this->Cell($l,$h/2, "PAGE", 0, 0, "C");
    $this->SetXY( $r1, $y1 + $h/2 );
    $this->SetFont( "Arial", "", 10);
    $this->Cell(10,5,($npt==0)? $page : $page.' / '.$npt, 0,0, "C");
}

// Affiche une adresse
// (en haut, a droite par defaut)
// sinon a la distance dr du bord droit
// et dt du haut de page
// taille $size(4 par defaut)
function addAddress( $address, $dr=90, $dt=30, $w=80, $h=17, $size=12 ) {

    
    $r1  = $this->w - $dr;
    $r2  = $r1 + $w;
    $y1  = $dt;
    $y2  = $y1;
    $mid = $y1 + ($y2 / 2);
    $this->RoundedRect($r1, $y1, ($r2 - $r1), $y2, 3.5, 'D');
    $this->SetFont( "Arial", "", $size);
    $r1     = $this->w - $dr;
    $y1     = $dt;
    $this->SetXY( $r1+$size/10, $y1+$size/10);
    $this->MultiCell( $w-$size, $size/2, utf8_decode($address));
}

function addReferences($label, $ref) {
    $x=10;
    $y=60;

    
    $this->RoundedRect($x, $y, 100, 35, 2);
    $label=$this->car_decode($label);
    $this->SetFont( "Arial", "", 6);
    $length = $this->GetStringWidth($label . $ref );
    $r1  = 10;
    $r2  = $r1 + $length;
    $y1  = 92;
    $y2  = $y1+4;
    $this->SetXY( $r1 , $y1 );
    $this->Cell($length,4, $label . $ref);
}

// trace le cadre de la table des items du document
function addTable( $cols, $r1=10, $y1=80, $mb=100 ) {

    $r2  = $this->w - ($r1 * 2) ;
    $y2  = $this->h - $mb - $y1;

    $this->SetXY( $r1, $y1 );
    $this->Rect( $r1, $y1, $r2, $y2, "D");
    $this->Line( $r1, $y1+6, $r1+$r2, $y1+6);
    $colX = $r1;
    foreach($cols as $col) {
        $this->SetXY( $colX, $y1+2 );
        $this->Cell( $col['len'], 1, $this->car_decode($col['lab']), 0, 0, "C");
        $colX += $col['len'];
        $this->Line( $colX, $y1, $colX, $y1+$y2);
    }
}


// mémorise le format (gauche, centre, droite) d'une colonne
function addLineFormat( $tab )
{
    global $format, $colonnes;

    
    while ( list( $lib, $pos ) = each ($colonnes) )
    {
        if ( isset( $tab["$lib"] ) )
            $format[ $lib ] = $tab["$lib"];
    }
}

function lineVert( $tab )
{
    global $colonnes;

    reset( $colonnes );
    $maxSize=0;
    while ( list( $lib, $pos ) = each ($colonnes) )
    {
        $texte = $tab[ $lib ];
        $longCell  = $pos -2;
        $size = $this->sizeOfText( $texte, $longCell );
        if ($size > $maxSize)
            $maxSize = $size;
    }
    return $maxSize;
}

// Affiche chaque "ligne" d'un devis / facture
/*    $ligne = array( "REFERENCE"    => $prod["ref"],
                      "DESIGNATION"  => $libelle,
                      "QUANTITE"     => sprintf( "%.2F", $prod["qte"]) ,
                      "P.U. HT"      => sprintf( "%.2F", $prod["px_unit"]),
                      "MONTANT H.T." => sprintf ( "%.2F", $prod["qte"] * $prod["px_unit"]) ,
                      "TVA"          => $prod["tva"] );
*/
function addLine( $ligne, $tab )
{
    global $colonnes, $format;

    $ordonnee     = 10;
    $maxSize      = $ligne;

    reset( $colonnes );
    while ( list( $lib, $pos ) = each ($colonnes) )
    {
        $longCell  = $pos -2;
        $texte     = $tab[ $lib ];
        $length    = $this->GetStringWidth( $texte );
        $tailleTexte = $this->sizeOfText( $texte, $length );
        $formText  = $format[ $lib ];
        $this->SetXY( $ordonnee, $ligne-1);
        $this->MultiCell( $longCell, 4 , $texte, 0, $formText);
        if ( $maxSize < ($this->GetY()  ) )
            $maxSize = $this->GetY() ;
        $ordonnee += $pos;
    }
    return ( $maxSize - $ligne );
}
// all lines of a table formatted against $cols colons
// $lines=array(idx=>line) 
//    
function printTable($lines, $cols, $y=90, $x=10) {
 $this->addTable($cols);
 $this->SetXY($x, $y);
 foreach($lines as $idx=>$line) {
  foreach($cols as $k=>$col) {
    //$this->MultiCell( $col[$k]['len'], 4 , $line['cols'][$k]['val'], 1, $col[$k]['jus']);
    //$this->Cell( $col[$k]['len'], 4 , $line['cols'][$k]['val'], 1, $col[$k]['jus']);
    //$this->Cell(10, 4 , $line['cols'][$k]['val'], 1, $col[$k]['jus']);
    $lh = (isset($line['cols'][$k]['size']) && !empty($line['cols'][$k]['size']))? $line['cols'][$k]['size'] : $line['height']*1.5;
    $this->SetFontSize($lh);
    $this->Cell($col['len'], $line['cols'][$k]['height'] , $this->car_decode($line['cols'][$k]['val']), 0, 0, $col['jus']);
    //$x+=$col[$k]['len'];
    //$this->SetXY($x, $y);
  }
    $x=10;
    $y+=$line['cols'][$k]['height']; // ignore all but last line height
    //$y+=8;
    $this->SetXY($x, $y);
 }
}

    
// all lines of a table formatted against $cols colons
// $lines=array(idx=>line)
//
function printTable2($lines, $cols, $mg=10, $mh=60, $sep=true) {
 //$this->addTable($cols);
 $defaultHeight=10;   
 $y=$mh;    
 $this->SetXY($mg, $y);
 foreach($lines as $idx=>$line) {
  foreach($cols as $k=>$col) {
    //$this->MultiCell( $col[$k]['len'], 4 , $line['cols'][$k]['val'], 1, $col[$k]['jus']);
    //$this->Cell( $col[$k]['len'], 4 , $line['cols'][$k]['val'], 1, $col[$k]['jus']);
    //$this->Cell(10, 4 , $line['cols'][$k]['val'], 1, $col[$k]['jus']);
    $lh = (isset($line['cols'][$k]['size']) && !empty($line['cols'][$k]['size']))? $line['cols'][$k]['size'] : ((isset($line['height']))? $line['height']*1.5 : $defaultHeight);
    $this->SetFontSize($lh);
    $this->Cell($col['len'], $line['cols'][$k]['height'] , $this->car_decode($line['cols'][$k]['val']), ($sep)? "B" : 0, 0, $col['jus']);
    //$x+=$col[$k]['len'];
    //$this->SetXY($x, $y);
  }
    $y+=(isset($line['height']))? $line['cols'][$k]['height'] : $defaultHeight; // ignore all but last line height
    $this->SetXY($mg, $y);
 }
}

    
// all lines of a table formatted against $cols colons
// $lines=array(idx=>line)
//
function printTable3($lines, $cols, $mg=10, $mh=60, $sep=true) {
 //$this->addTable($cols);
 $y=$mh;
 $this->SetXY($mg, $y);
 $x=$mg;
 $ymax=0;
 foreach($lines as $idx=>$line) {
  foreach($cols as $k=>$col) {
    //$this->MultiCell( $col[$k]['len'], 4 , $line['cols'][$k]['val'], 1, $col[$k]['jus']);
    //$this->Cell( $col[$k]['len'], 4 , $line['cols'][$k]['val'], 1, $col[$k]['jus']);
    //$this->Cell(10, 4 , $line['cols'][$k]['val'], 1, $col[$k]['jus']);
    $lh = (isset($line['cols'][$k]['size']) && !empty($line['cols'][$k]['size']))? $line['cols'][$k]['size'] : $line['height']*1.5;
    $this->SetFontSize($lh);
    $this->MultiCell($col['len'], $line['cols'][$k]['height'] , $this->car_decode($line['cols'][$k]['val']), ($sep)? "B" : 0);
    $x+=$col['len'];
    $ytemp=$this->GetY();
    if ($ytemp>$ymax)  $ymax=$ytemp;
    $this->SetXY($x, $y);

      
  }
    $x=$mg;
    $y=$ymax;
    $ytemp=$ymax=0;
    //$y+=$line['cols'][$k]['height']; // ignore all but last line height
    $this->SetXY($mg, $y);
 }
}


    
    

// Ajoute une remarque (en bas, a gauche)
// $lib libellé, $remarque: texte de la remarque
function addRemarque($remarque, $lib='Remarque') {
    $lib=$this->car_decode($lib);
    $remarque=$this->car_decode($remarque);
    $text=$lib." : " . $remarque;
    $this->SetFont( "Arial", "", 10);
    $length = $this->GetStringWidth( $text );
    $r1  = 10;
    $r2  = $r1 + $length;
    $y1  = $this->h - 45.5;
    $y2  = $y1+5;
    $this->SetXY( $r1 , $y1 );
    $this->Cell($length,4, $text);
}

    
// Ajoute un texte
// $lib libellé, $remarque: texte de la remarque
function addText($text,$x=10, $y=65, $font="Arial", $style="", $size=12) {
    $text=$this->car_decode($text);
    $this->SetFont( $font, $style, $size);
    $length = $this->GetStringWidth( $text );
    while ($length>$this->w-20) {
      $size-=1;
      $this->SetFont( $font, $style, $size);
      $length = $this->GetStringWidth( $text );
    }
    $this->SetXY( $x, $y);
    $this->Cell($length,$size/2, $text);
}



    
    
    

// ajoute la signature
function addSignature($file, $line1, $line2, $line3, $x=130, $y=207) {
    //$x=$this->w-80;
    //$y=$this->h-90;
    $w=50;
    //$lib=$this->car_decode($lib);
    //$name=$this->car_decode($name);
    $this->SetFont( "Arial", "", 10);
    $this->SetXY($x, $y);
    $h=5;
    $this->Cell($w, $h , $this->car_decode($line1), 0, 2);
    $this->Cell($w, $h , $this->car_decode($line2), 0, 2);
    $this->Cell($w, $h , $this->car_decode($line3), 0, 2);
    //$this->SetX($x);
    //$this->Cell($w, $h , $name);
    $this->Image($file, $x, $this->GetY(), $w);
}


// Permet de rajouter un commentaire (Devis temporaire, REGLE, DUPLICATA, ...)
// en sous-impression
// ATTENTION: APPELER CETTE FONCTION EN PREMIER
function addWaterMark( $texte )
{
    $this->SetFont('Arial','B',50);
    $this->SetTextColor(203,203,203);
    $this->Rotate(45,55,190);
    $this->Text(55,190,$texte);
    $this->Rotate(0);
    $this->SetTextColor(0,0,0);
}

 function addPoliciesConditions($str, $font="Arial", $style="", $size=6) {
    $str=$this->car_decode(str_replace('\n',"\n",$str));
    $this->SetFont( $font, $style, $size);
    $h=15;
    $r1  = 10;
    $r2  = $this->w - $r1;
    $y1  = $this->h - $r1-$h;
    $y2  = $y1+$h;
    $this->RoundedRect($r1, $y1, ($r2 - $r1), ($y2-$y1), 2.5, 'D');
    $this->SetXY($r1+1, $y1+1);
    $this->MultiCell($this->w- 2*$r1-1, 2, $str);

 }

}
?>
