<?php
/**
 * gen att template. generate attendance sheet
 *
 * alm 20170624
 *
 */

if ( !defined( 'ABSPATH' ) ) exit;

if (empty($title)) $title=__("Attendance raise",$wpcoop->plugin_textdomain);

// get subscribers data ordered by lastname
$ops = $wpcoop->members->get_ordered_users('subs');

//print_tab($ops);

//D: send to the browser and force a file download with the name given by filename.
//F: save to a local file with the name given by filename (may include a path).
//S: return the document as a string. filename is ignored.
$output_mode='D';

///alm
// The library for generating HTML PDF files
if (!require_once($wpcoop->plugin_pdf_path.'fpdf/fpdf.php')) {
 wlog(LOG,'fpdf not included: '.$wpcoop->plugin_pdf_path.'fpdf/fpdf.php');
}
if (!require('doc_template.php') ) {
 wlog(LOG,'doc_template.php: ');
}
// declaration page pdf
$pdf = new PDF_WpCoop_Document( 'L', 'mm', 'A4' );

// indique que le texte est en utf8, et donc a convertir ou pas
define ('WCDN_UTF8', true);
// indique que les infos sont a retourner en chaine et pas a imprimer
define ('WCDN_STR', true);
/*
'shareval'=>'Parts validées',
'sharenok'=>'Rachat de part(s) demandé',
'sharenokack'=>'Rachat de part(s) validé',
*/

$lines=array();
$n=0;
foreach ($ops as $id=>$user) {
    if (empty($user['usersubs'])) continue;

    // only validated shares make members
    //if (!$this->is_shareholder($ops[$id]['usersubs'])) continue;

    $data=$ops[$id]['shares_data'];
    $s=$data['shares'];     //quantity of shares detained
    if ($s<=0) continue;

    $ddata=$this->get_thedisplaydata($id, $user);

    $n++;
    $lines[]['cols']=array(
       array( 'size'=>10, 'height'=>10, 'val'=> $ddata['thedisplayname']),
       array( 'size'=>10, 'height'=>10, 'val'=> $ddata['representing']),
       array( 'size'=>10, 'height'=>10, 'val'=> $ddata['city']),
       array( 'size'=>10, 'height'=>10, 'val'=> $ddata['email']),
       array( 'size'=>10, 'height'=>10, 'val'=> $ddata['phones']),
       array( 'size'=>10, 'height'=>10, 'val'=> '')
                                );

}

$lines[]['cols']=array(
                   array('size'=>10, 'height'=>10, 'val'=> 'Nombre de sociétaires'),
                   array('len'=>50, 'size'=>10, 'height'=>10, 'val'=> $n),
                   array('len'=>20, 'size'=>10, 'height'=>10, 'val'=> ""),
                   array('len'=>50, 'size'=>10, 'height'=>10, 'val'=> ""),
                   array('len'=>50, 'size'=>10, 'height'=>10, 'val'=> ""),
                   array('len'=>55, 'size'=>10, 'height'=>10, 'val'=> "")
                                            );

$utf8=true;


// definition des colonnes du tableau
// somme doit etre = 190 pour A4 Portrait (210-2*10 de marge)
// somme doit etre = 277 pour A4 Landscape (297-2*10 de marge)
// lab for label
// jus for justification (L, C, R)
$cols=array(
        array('len'=>55, 'lab'=>'Nom Prénom', 'jus'=>'L'),
        array('len'=>50, 'lab'=>'Représentation', 'jus'=>'L'), // raison sociale personne morale ou représentant légal du sosiétaire personne physique minueur ou sous administration légale
        array('len'=>45, 'lab'=>'Ville', 'jus'=>'L'),
        array('len'=>67, 'lab'=>'@email', 'jus'=>'L'),
        array('len'=>50, 'lab'=>'Téléphones', 'jus'=>'L'),
        array('len'=>10, 'lab'=>'Rappel', 'jus'=>'L')
            );

$nbp=13; // nbre par page (20 pour P, 15 pour L)
$npi= intval((count($lines)%$nbp==0)? count($lines)/$nbp : (count($lines)/$nbp +1));
$np= $npi +$ne; // add empty pages

//split in pages
$plines=array();
$l=0;
if ($np!=0) {
    for($i=1;$i<$np+1;$i++) {

        $pdf->AddPage();
        // font par defaut
        $pdf->SetFont('Arial','B',12);
        // pas de saut de page automatique
        $pdf->SetAutoPageBreak(false);
        // watermark
        //$pdf->addWaterMark( 'test seulement!!!' );
        $pdf->addPageNumber( $i, $np);
        $pdf->addTitle($title);
        // entete
        //
        $pdf->addCompany($url_logo, $company, $address,10,25 );

        $pdf->addtext('Représentation : raison sociale pour personne morale ou représentant légal pour mineur ou adulte représenté', 10, 43.5, "Arial", "", 7);

        $j=0;
        while ($j<$nbp) {
            if ($l < count($lines)) {
             $plines[$l]=$lines[$l];
            } else {

             $plines[$l]['cols']= array(
               array('size'=>10, 'height'=>10, 'val'=> ""),
               array('size'=>10, 'height'=>10, 'val'=> ""),
               array('size'=>10, 'height'=>10, 'val'=> ""),
               array('size'=>10, 'height'=>10, 'val'=> ""),
               array('size'=>10, 'height'=>10, 'val'=> ""),
               array('size'=>10, 'height'=>10, 'val'=> "")
                                        );
            }

            $l++;
            $j++;
        }
        // cols, l&r margin, start high, end hight
        $pdf->addTable( $cols, 10, 50, 20 );
        $pdf->printTable2($plines, $cols);
        $plines=array();

    }
}





// Create filename.
$filename = date('Ymd') .'-'.sanitize_file_name( remove_accents( $title ) ).'.pdf';

// create destination
if ($output_mode=='I' || $output_mode=='D') {
 $dest = $filename;
} else {
 $dest = $uploads_dir.'/'.$filename;
}




/// output
$pdf->Output($output_mode, $filename);
exit();
