<?php
/**
 * gen doc template. This is the main file.
 *
 * alm 20210419 15:31
 *
 */

// wpcoop plugin must be active

if ( !defined( 'ABSPATH' ) ) exit;

$ops = $wpcoop->members->get_ordered_users('subs');

if (empty($title)) $title=__('Relevé de situation', $this->plugin_textdomain);

// issue for a single subscriber
$fileTitle=$title;
if (!empty($ID) && isset($ops[$ID])) {
    $ops= array($ID=>$ops[$ID]);
    $fileTitle=$title.' '.$ops[$ID]['last_name'].' '.$ops[$ID]['first_name'];
} else {
   wp_redirect(site_url());
}
$possible_statuses=$wpcoop->shares->get_possible_statuses();

//D: send to the browser and force a file download with the name given by filename.
//F: save to a local file with the name given by filename (may include a path).
//S: return the document as a string. filename is ignored.
$output_mode='D';

///alm
// The library for generating HTML PDF files

if (!require_once($wpcoop->plugin_pdf_path.'fpdf/fpdf.php' )) {
 write_log('gen-doc fpdf not included: '.$wpcoop->plugin_pdf_path.'fpdf/fpdf.php');
}
if (!require_once('doc_template.php') ) {
 write_log('gen-doc doc_template.php: not included');
}

// declaration page pdf
$pdf = new PDF_WpCoop_Document( 'P', 'mm', 'A4' );

//foreach ($users as $user) {
//if several users, do it for each
foreach ($ops as $id=>$user) {
        if (empty($ops[$id]['usersubs'])) continue;

        $pdf->AddPage();
        // indique que le texte est en utf8, et donc a convertir ou pas
        define ('WCDN_UTF8', true);
        // indique que les infos sont a retourner en chaine et pas a imprimer
        define ('WCDN_STR', true);

        $utf8=true;
        // font par defaut
        $pdf->SetFont('Arial','B',12);
        // pas de saut de page automatique
        $pdf->SetAutoPageBreak(false);
        // watermark
        //$pdf->addWaterMark( 'test seulement!!!' );

        // entete
        //

        $pdf->addCompany($url_logo, $company, str_replace('\n', chr(13).chr(10), $address),10,25 );
        //do_action( 'wpcoop_after_company', $order );

        $pdf->addDocRefs($title, '',date("d/m/Y"));

        $type = $this->get_member_type($id,$user);


        switch ($type) {
            // person with capability
            case 'c':
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberperson_';
                $thedisplayname=$this->get_thedisplayname($id,$user,$prefix);
                $pdf->addAddress($thedisplayname."\n".
                                 $user[$prefix.'adr1']."\n".
                                 $user[$prefix.'adr2']."\n".
                                 $user[$prefix.'zip']." ".$user[$prefix.'city']."\n".
                                 $user[$prefix.'country']
                                );
                $pdf->addtext(sprintf('%1$s a inscrit au compte de %2$s les opérations ci-après:', $emb_company_name, $thedisplayname));


                break;
            //institution
            case 'i':
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberinstitution_';
                $theaddress =    $user[$prefix.'legalform']." ".$user[$prefix.'name']."\n";
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'representative_';
                $thedisplayname=$this->get_thedisplayname($id,$user,$prefix);
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberinstitution_';
                $theaddress.=       sprintf(__('(attn: %s)',$this->plugin_textdomain), $thedisplayname)."\n".
                                 $user[$prefix.'adr1']."\n".
                                 $user[$prefix.'adr2']."\n".
                                 $user[$prefix.'zip']." ".$user[$prefix.'city']."\n".
                                 $user[$prefix.'country'];
                $pdf->addAddress($theaddress);
                $pdf->addtext(sprintf('%1$s a inscrit au compte de %3$s %2$s les opérations ci-après:', $emb_company_name, $user[$prefix.'name'], $user[$prefix.'legalform']));
                break;
            // person with legal representative
            case 'm':
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberperson_';
                $thedisplayname=$this->get_thedisplayname($id,$user,$prefix);
                $pdf->addAddress($thedisplayname."\n".
                                 $ops[$id][$prefix.'adr1']."\n".
                                 $ops[$id][$prefix.'adr2']."\n".
                                 $ops[$id][$prefix.'zip']." ".$ops[$id][$this->plugin_prefix.'city']."\n".
                                 $ops[$id][$prefix.'country']
                                );
                $pdf->addtext(sprintf('%1$s a inscrit au compte de %3$s %2$s les opérations ci-après:', $emb_company_name, $thedisplayname, $user[$prefix.'title']));
                break;
            // type not set or unknown
            default:
                $pdf->addAddress(__('Unknown', $this->plugin_textdomain)."\n");
                $pdf->addtext(sprintf(__('%1$s a inscrit au compte de l\'utilisateur %2$s, id: %3$s les opérations ci-après:', $this->plugin_textdomain), $emb_company_name,
                __('Unknown', $this->plugin_textdomain), $id));
        }




        // definition des colonnes du tableau
        // somme doit etre = 190 pour A4 (210-2*10 de marge)
        // lab for label
        // jus for justification (L, C, R)
        $cols=array(
                array('len'=>20, 'lab'=>'Date', 'jus'=>'R'),
                array('len'=>140, 'lab'=>'Opération', 'jus'=>'L'),
                array('len'=>30, 'lab'=>'Montant/Parts', 'jus'=>'R')
                    );

        //$pdf->addTable($cols);

        $lines=array();
        $k=0;
        $s=0; // # shares
        $v=0; // value
        foreach ($user['usersubs'] as $o=>$opers) {
           foreach($opers as $i=>$step) {
            $date=$step['d'];
            $fdate=substr($date,0,2).'/'.substr($date,2,2).'/'.substr($date,4,4);


            $stepdata=$wpcoop->shares->get_stepdata($i, $step);

            $s+=$stepdata['cs'];
            $v+=$stepdata['cv'];
            $val=$stepdata['val'];
            $unit=$stepdata['unit'];
            /*
            if (strpos($step['s'],'share')!==false) {
             $unit='Parts';
             $val=$step['q']/$pps;
             $s+=$val;
            } else {
             $unit='Euros';
             $val=$step['q'];
             if ($i==0) $v+=$step['q'];
            }
            */
            $lines[$k++]['cols']=array(
               array('len'=>20, 'size'=>10, 'height'=>6, 'val'=> $fdate),
               array('len'=>140,'size'=>10, 'height'=>6, 'val'=> $step['o'].'-'.$possible_statuses[$step['s']]),
               array('len'=>30, 'size'=>10, 'height'=>6, 'val'=> $val.' '.$unit)
                                    );
          }
        }


        $lines[$k++]['cols']=array(
               array('len'=>20, 'size'=>10, 'height'=>6, 'val'=> ''),
               array('len'=>140,'size'=>10, 'height'=>6, 'val'=> ''),
               array('len'=>30, 'size'=>10, 'height'=>6, 'val'=> '')
                                    );
        $lines[$k++]['cols']=array(
               array('len'=>20, 'size'=>10, 'height'=>6, 'val'=> ''),
               array('len'=>140,'size'=>10, 'height'=>6, 'val'=> 'Montant total souscrit: '.$v.' Euros'),
               array('len'=>30, 'size'=>10, 'height'=>6, 'val'=> '')
                                    );
        $lines[$k++]['cols']=array(
               array('len'=>20, 'size'=>10, 'height'=>6, 'val'=> ''),
               array('len'=>140,'size'=>10, 'height'=>6, 'val'=> 'Parts validées: '.$s),
               array('len'=>30, 'size'=>10, 'height'=>6, 'val'=> '')
                                    );

///////////////////////////////////////////////////
/*

        $pdf->printTable($lines, $cols, 87.5);

        $pdf->addPoliciesConditions(sprintf($policies, $user['user_login'], $user['user_email'] ));

        $pdf->addSignature($url_signature,
                           sprintf(__('Fait à %s', $this->plugin_textdomain), $town),
                           sprintf(__('le : %s', $this->plugin_textdomain), date("d/m/Y")),
                           sprintf(__('%1$s, %2$s', $this->plugin_textdomain), $auth_name, $auth_title),
                           130, 227);


*/
/////////////////////////////////////////////////////
/////////////////////////////////////////////////////
$nbp=22;
$np= intval((count($lines)%$nbp==0)? count($lines)/$nbp : (count($lines)/$nbp +1));

//split in pages
$plines=array();
$l=0;
if ($np!=0) {
    for($i=1;$i<$np+1;$i++) {
      if ($i!=1){
        $pdf->AddPage();
        // font par defaut
        $pdf->SetFont('Arial','B',12);
        // pas de saut de page automatique
        $pdf->SetAutoPageBreak(false);
        // watermark
        //$pdf->addWaterMark( 'test seulement!!!' );
        $pdf->addPageNumber( $i, $np);
        $pdf->addTitle($title);
        $pdf->addTitle( 'Mis à jour le '. date('d/m/Y') , 105, 30, 50, 8 );

        // entete
        //
        $pdf->addCompany($url_logo, $company, $address,10,25 );
//        do_action( 'wpcoop_after_branding', $order );
	  }
      $j=0;
      while ($j<$nbp && $l<count($lines)) {
            $plines[$l]=$lines[$l];
            $l++;
            $j++;
      }

      $pdf->SetFont('Arial','',12);

	  // cols, l&r margin, start high, end hight
      if ($i==1) {
		// first page
		//addTable $cols, l&r margin, start high, end hight
        $pdf->addTable( $cols, 10, 79, 70);
		//printTable2 ($lines, $cols, $mg=10, $mh=60, $sep=true)
        $pdf->printTable2($plines, $cols, 10, 84.5, false );
		//$pdf->printTable($lines, $cols, 87.5);
	  } elseif($i==$np) {
        $pdf->addTable( $cols, 10, 79, 70 );
        $pdf->printTable2($plines, $cols,10,84.5, false );
		//$pdf->printTable($lines, $cols, 87.5);
	  } else {
        $pdf->addTable( $cols, 10, 79, 70 );
        $pdf->printTable2($plines, $cols,10,84.5, false );
		//$pdf->printTable($lines, $cols, 87.5);
	  }
	  //$pdf->printTable($plines, $cols, 87.5);
      $plines=array();



		if ($i==$np){
		 	$pdf->addPoliciesConditions(sprintf($policies, $user['user_login'], $user['user_email'] ));

			$pdf->addSignature($url_signature,
					sprintf(__('Fait à %s', $this->plugin_textdomain), $town),
					sprintf(__('le : %s', $this->plugin_textdomain), date("d/m/Y")),
					sprintf(__('%1$s, %2$s', $this->plugin_textdomain), $auth_name, $auth_title),130, 227);
		}




    }
}

} // foreach user
///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////

// Create filename.
$filename = date('Ymd') .'-'.sanitize_file_name( remove_accents( $fileTitle ) ).'.pdf';

// create destination
if ($output_mode=='I' || $output_mode=='D') {
 $dest = $filename;
} else {
 $dest = $uploads_dir.'/'.$filename;
}


/// output
if (($out=='email' || $out=='both') && !empty($ID)) {

 $content=$pdf->Output('S', $filename);

 add_action('phpmailer_init', function($phpmailer) use (&$content, $filename) {

   $phpmailer->AddStringAttachment($content, $filename);

 } );

 $userdata=get_userdata($ID);
 //$to="'".$userdata->display_name." <".$userdata->user_email.">'";
 $to = get_option('admin_email');
 //   echo $to;
 if (!empty($to) && is_email($to)){
   wp_mail($to,'Nouveau relevé de situation de votre compte',
           "Bonjour,<br /><br />
           Nous vous remercions d'avoir rejoint PEP2A ; votre souscription a été validée par notre dernier Conseil d'Administration<br />
           Vous trouverez en attachement votre nouveau relevé de compte.<br /><br />
           Votre souscription conforte l'assise financière de votre coopérative ; en tant que sociétaire, vous pouvez également vous impliquer dans les actions de la coopérative, principalement animée par ses bénévoles.<br />
           N'hésitez pas à nous contacter à l'adresse d'expédition de ce mél.<br /><br />
           Vous pouvez retrouver ce document sur la page 'Mon Compte' de <a href='https://pep2a.fr/societaires'>notre site sociétaires</a><br />
           Pour vous connecter, consultez la page <a href='https://pep2a.fr/societaires/nousrejoindre/connexion-au-site/'>'connexion au site'</a>.<br />
           Vous en souhaitant bonne réception,<br /><br />
           l'équipe PEP2A",
            array( 'Content-Type: text/html; charset=UTF-8',
                   'From: PEP2A souscriptions <admin@pep2a.fr>')
          );
    }
}

if ($out=='doc' || $out=='both') {
  //$pdf->Output($output_mode, $filename);
  $pdf->Output('D', $filename, true);
 exit();
}
