<?php
/**
 * gen doc template. This is the main file.
 *
 * alm 20190419 15:15
 *
 */

// wpcoop plugin must be active

if ( !defined( 'ABSPATH' ) ) exit;

$ops = $wpcoop->members->get_ordered_users('all');

if (empty($title)) $title=__('Vos informations personnelles', $this->plugin_textdomain);

// issue for a single subscriber
$fileTitle=$title;
if (!empty($ID)) {
    $ops= array($ID=>$ops[$ID]);
    $fileTitle=$title.' '.$ops[$ID]['last_name'].' '.$ops[$ID]['first_name'];
}
$possible_statuses=$wpcoop->shares->get_possible_statuses();

//print_tab($ops);

//D: send to the browser and force a file download with the name given by filename.
//F: save to a local file with the name given by filename (may include a path).
//S: return the document as a string. filename is ignored.
$output_mode='D';

///alm
// The library for generating HTML PDF files

if (!require_once($wpcoop->plugin_pdf_path.'fpdf/fpdf.php' )) {
 wlog(LOG,'fpdf not included: '.$wpcoop->plugin_pdf_path.'fpdf/fpdf.php');
}
if (!require('doc_template.php') ) {
 wlog(LOG,'doc_template.php: ');
}
// declaration page pdf
$pdf = new PDF_WpCoop_Document( 'P', 'mm', 'A4' );

//foreach ($users as $user) {
foreach ($ops as $id=>$user) {
        /*
        if (empty($ops[$id]['usersubs'])) continue;

        $pdf->AddPage();
        // indique que le texte est en utf8, et donc a convertir ou pas
        define ('WCDN_UTF8', true);
        // indique que les infos sont a retourner en chaine et pas a imprimer
        define ('WCDN_STR', true);

        $utf8=true;
        // font par defaut
        $pdf->SetFont('Arial','B',12);
        // pas de saut de page automatique
        $pdf->SetAutoPageBreak(false);
        // watermark
        //$pdf->addWaterMark( 'test seulement!!!' );

        // entete
        //

        $pdf->addCompany($url_logo, $company, str_replace('\n', chr(13).chr(10), $address),10,25 );
        do_action( 'wpcoop_after_company', $order );

        $pdf->addDocRefs($title, '',date("d/m/Y"));

        // add address
*/

        $type = $this->get_member_type($id,$user);


        switch ($type) {
            // person with capability
            case 'c':
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberperson_';
                $thedisplayname=$this->get_thedisplayname($id,$user,$prefix);
                $theaddress =    $thedisplayname."\n".
                                 $user[$prefix.'adr1']."\n".
                                 $user[$prefix.'adr2']."\n".
                                 $user[$prefix.'zip']." ".$user[$prefix.'city']."\n".
                                 $user[$prefix.'country'];
                break;
            //institution
            case 'i':
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberinstitution_';
                $theaddress =    $user[$prefix.'legalform']." ".$user[$prefix.'name']."\n";
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'representative_';
                $thedisplayname=$this->get_thedisplayname($id,$user,$prefix);
                $theaddress.= sprintf(__('(attn: %s)',$this->plugin_textdomain), $thedisplayname)."\n".
                                 $user[$prefix.'adr1']."\n".
                                 $user[$prefix.'adr2']."\n".
                                 $user[$prefix.'zip']." ".$user[$prefix.'city']."\n".
                                 $user[$prefix.'country'];
                break;
            // person with legal representative
            case 'm':
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberperson_';
                $thedisplayname=$this->get_thedisplayname($id,$user,$prefix);
                $theaddress =    $thedisplayname."\n".
                                 $ops[$id][$prefix.'adr1']."\n".
                                 $ops[$id][$prefix.'adr2']."\n".
                                 $ops[$id][$prefix.'zip']." ".$ops[$id][$this->plugin_prefix.'city']."\n".
                                 $ops[$id][$prefix.'country'];
                 break;
            // type not set or unknown
            default:
                $theaddress = __('Unknown', $this->plugin_textdomain)."\n";
        }


        // definition des colonnes du tableau
        // somme doit etre = 190 pour A4 (210-2*10 de marge)
        // lab for label
        // jus for justification (L, C, R)
        $cols=array(
                array('len'=>40, 'lab'=>'Groupe', 'jus'=>'L'),
                array('len'=>60, 'lab'=>'Libellé', 'jus'=>'L'),
                array('len'=>90, 'lab'=>'Information', 'jus'=>'L')
                    );

        //$pdf->addTable($cols);

        $lines=array();
        $k=0;
        $wpcoop_fields=$this->get_users_added_fields();
        $meta=get_user_meta($id);
        $slug='';
        foreach($wpcoop_fields['tabs'] as $tab) {
            if($tab['slug']!=$slug) {
                $slug=$tab['slug'];
                if ($slug=='wp') {
                  continue;
                }
                $prefix = ($slug=='wp')? '' : $this->plugin_prefix.$this->usersdata_prefix.$slug.'_';

            }
           foreach($tab['fields'] as $field) {
            $user_data[$prefix.$field['name']]= (isset($meta[$prefix.$field['name']]))? $meta[$prefix.$field['name']][0] : '';
            switch($field['tag']) {
                case 'input':
                    switch($field['type']){
                        case 'checkbox':
                            //echo $prefix.$field['name'].': '.meta[$prefix.$field['name']].'<br>';
                            $user_data[$prefix.$field['name']] = (isset($meta[$prefix.$field['name']]) && $meta[$prefix.$field['name']][0]=='y') ? 'y' : 'n';
                            break;
                        case 'text':
                        default:
                    }
                    break;
                case 'textarea':
                case 'select':
                default:
            }

            $lines[$k++]['cols']=array(
               array('len'=>40, 'size'=>8, 'height'=>4, 'val'=> $tab['caption']),
               array('len'=>60, 'size'=>8, 'height'=>4, 'val'=> $field['caption']),
               array('len'=>90,'size'=>8, 'height'=>4, 'val'=> $user_data[$prefix.$field['name']])
                                    );
           }
        } //$wpcoop_fields


    $nbp=60;
    $np= intval((count($lines)%$nbp==0)? count($lines)/$nbp : (count($lines)/$nbp +1));

    //split in pages
    $plines=array();
    $l=0;
    if ($np!=0) {
        for($i=1;$i<$np+1;$i++) {

            $pdf->AddPage();
            // font par defaut
            $pdf->SetFont('Arial','B',12);
            // pas de saut de page automatique
            $pdf->SetAutoPageBreak(false);
            // watermark
            //$pdf->addWaterMark( 'test seulement!!!' );
            $pdf->addPageNumber( $i, $np);
            $pdf->addTitle($title);
            $pdf->addTitle( 'Mis à jour le '. date('d/m/Y') , 105, 30, 50, 8 );

            // entete
            //
            $pdf->addCompany($url_logo, $company, $address,10,25 );

            //$pdf->addAddress($address);
            //addText($text,$x=10, $y=65, $font="Arial", $style="", $size=12) {
            if ($i==1) $pdf->addtext(__('Vous trouverez ci dessous les informations personnelles dont nous disposons pour la gestion de votre compte', $this->plugin_textdomain),
                         10,45);


            $j=0;
            while ($j<$nbp) {
                if (isset($lines[$l])) $plines[$l]=$lines[$l];
                $l++;
                $j++;
            }
            // cols, l&r margin, start high, end hight
            $pdf->addTable( $cols, 10, 50, 20 );
            $pdf->printTable2($plines, $cols);

            if ($i==$np) $pdf->addtext(__('Pour modifier ou rectifier ces informations, merci de contacter PEP2A', $this->plugin_textdomain), 10, -20);


//            $pdf->addPoliciesConditions(sprintf($policies, $user['user_login'], $user['user_email'] ));

//            $pdf->addSignature($url_signature,
//                           sprintf(__('Fait à %s', $this->plugin_textdomain), $town),
//                           sprintf(__('le : %s', $this->plugin_textdomain), date("d/m/Y")),
//                           sprintf(__('%1$s, %2$s', $this->plugin_textdomain), $auth_name, $auth_title),
//                           130, 227);


            $plines=array();

        }
    }



}

// Create filename.
$filename = date('Ymd') .'-'.sanitize_file_name( remove_accents( $fileTitle ) ).'.pdf';

// create destination
if ($output_mode=='I' || $output_mode=='D') {
 $dest = $filename;
} else {
 $dest = $uploads_dir.'/'.$filename;
}


/// output
/*
if (($out=='email' || $out=='both') && !empty($ID)) {

 $content=$pdf->Output('S', $filename);

 add_action('phpmailer_init', function($phpmailer) use (&$content, $filename) {

   $phpmailer->AddStringAttachment($content, $filename);

 } );

 $to = get_option('admin_email');
 //   echo $to;
 if (!empty($to) && is_email($to)){

 wp_mail($to,'Nouveau relevé de situation de votre compte',
         "Bonjour,blabla",
          array( 'Content-Type: text/html; charset=UTF-8',
                 'From: PEP2A souscriptions <admin@pep2a.fr>')
        );

}
*/
if ($out=='doc' || $out=='both') {
 $pdf->Output($output_mode, $filename);
 exit();
}
