<?php
/**
 * gen-list. List of Subscribers
 *
 * alm 20161026
 *
 */

if ( !defined( 'ABSPATH' ) ) exit;

if (empty($title)) $title = __("Liste des souscripteurs", $this->plugin_textdomain);

// get subscribers data ordered by lastname
$ops = $wpcoop->members->get_ordered_users('subs');

//print_tab($ops);

//D: send to the browser and force a file download with the name given by filename.
//F: save to a local file with the name given by filename (may include a path).
//S: return the document as a string. filename is ignored.
$output_mode='D';

///alm
// The library for generating HTML PDF files
if (!require_once($wpcoop->plugin_pdf_path.'fpdf/fpdf.php' )) {
 wlog(LOG,'fpdf not included: '.$wpcoop->plugin_pdf_path.'fpdf/fpdf.php');
}
if (!require('doc_template.php') ) {
 wlog(LOG,'doc_template.php: ');
}
// declaration page pdf
$pdf = new PDF_WpCoop_Document( 'P', 'mm', 'A4' );

// indique que le texte est en utf8, et donc a convertir ou pas
define ('WCDN_UTF8', true);
// indique que les infos sont a retourner en chaine et pas a imprimer
define ('WCDN_STR', true);


$lines=array();

// calcul des parts et souscriptions
$tv=0; // reset total values
$ts=0; // reset total shares
$n=0;  // nbre souscripteur
foreach ($ops as $id=>$user) {

        if (empty($user['usersubs'])) continue;
                 $data=$user['shares_data'];
                 $s=$data['shares'];     //quantity of validated shares detained
                 $v=$data['value'];      //value subscribed for this user
                 $d=$data['date'];       //date of first membership
                 if ($v>0) $n++;
        $ddata=$this->get_thedisplaydata($id,$user);

        $width=40;
        $prfx='wpcoop_userdata_memberperson_';
        switch ($ops[$id]['wpcoop_userdata_membertype_type']) {
//                 case 'c'
//                  $prfx='wpcoop_userdata_memberperson_';
//                  break;
         case 'i':
          $prfx='wpcoop_userdata_memberinstitution_';
          break;
         case 'm':
          $prfx='wpcoop_userdata_representative_';
          break;
        }

        $lines[]['cols']=array(
               array('len'=>5, 'size'=>10, 'height'=>10, 'val'=> $ddata['dtype']),
               array('len'=>5, 'size'=>10, 'height'=>10, 'val'=> $ddata['dcat']),
               array('len'=>(2*$width-10), 'size'=>10, 'height'=>10, 'val'=> $ops[$id]['last_name'].' '.$ops[$id]['first_name']),
               array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> $ddata['institution']),
               array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> $ops[$id][$prfx.'city']),
               array('len'=>15, 'size'=>10, 'height'=>10, 'val'=> $v),
               array('len'=>15, 'size'=>10, 'height'=>10, 'val'=> $s)
                                        );
        $ts+=$s;
        $tv+=$v;
        if($ops[$id]['last_name']=='MAZARE') {wlogt(LOG,'ops', $ops[$id]);wlogt(LOG,'ddata', $ddata);}

} // each user

// ligne totaux
        $lines[]['cols']=array(
               array('len'=>5, 'size'=>10, 'height'=>10, 'val'=> ''),
               array('len'=>5, 'size'=>10, 'height'=>10, 'val'=> ''),
               array('len'=>(2*$width-10), 'size'=>10, 'height'=>10, 'val'=> $n." Souscripteurs"),
               array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> ""),
               //array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> ""),
               array('len'=>20, 'size'=>12, 'height'=>10, 'val'=> "Totaux"),
               array('len'=>20, 'size'=>12, 'height'=>10, 'val'=> $tv),
               array('len'=>30, 'size'=>12, 'height'=>10, 'val'=> $ts)
                                        );


$utf8=true;


// definition des colonnes du tableau
// somme doit etre = 190 pour A4 (210-2*10 de marge)
// lab for label
// jus for justification (L, C, R)
$cols=array(
        array('len'=>5, 'lab'=>'T', 'jus'=>'L'),
        array('len'=>5, 'lab'=>'C', 'jus'=>'L'),
        array('len'=>(2*$width-10), 'lab'=>'Nom Prénom', 'jus'=>'L'),
        array('len'=>$width, 'lab'=>'Raison Sociale', 'jus'=>'L'),
        array('len'=>$width, 'lab'=>'Ville', 'jus'=>'L'),
        array('len'=>15, 'lab'=>'Euros', 'jus'=>'R'),
        array('len'=>15, 'lab'=>'Parts', 'jus'=>'R')
            );

$nbp=20;
$np= intval((count($lines)%$nbp==0)? count($lines)/$nbp : (count($lines)/$nbp +1));

//split in pages
$plines=array();
$l=0;
if ($np!=0) {
    for($i=1;$i<$np+1;$i++) {

        $pdf->AddPage();
        // font par defaut
        $pdf->SetFont('Arial','B',12);
        // pas de saut de page automatique
        $pdf->SetAutoPageBreak(false);
        // watermark
        //$pdf->addWaterMark( 'test seulement!!!' );
        $pdf->addPageNumber( $i, $np);
        $pdf->addTitle($title);
        $pdf->addTitle( 'Mis à jour le '. date('d/m/Y') , 105, 30, 50, 8 );

        // entete
        //
        $pdf->addCompany($url_logo, $company, $address,10,25 );

        $j=0;
        while ($j<$nbp) {
            if (isset($lines[$l])) $plines[$l]=$lines[$l];
            $l++;
            $j++;
        }
        // cols, l&r margin, start high, end hight
        $pdf->addTable( $cols, 10, 50, 20 );
        $pdf->printTable2($plines, $cols);
        $plines=array();

    }
}





// Create filename.

$filename = date('Ymd') .'-'.sanitize_file_name( remove_accents( $title ) ).'.pdf';

// create destination
if ($output_mode=='I' || $output_mode=='D') {
 $dest = $filename;
} else {
 $dest = $uploads_dir.'/'.$filename;
}




/// output
$pdf->Output($output_mode, $filename);
exit();
