<?php
/**
 * gen doc template. This is the main file.
 *
 * alm 20200218
 *
 */

if ( !defined( 'ABSPATH' ) ) exit;
$order=(isset($order))?? $order;
$chrono=  ($order=='date')? 'chronologique' : '';
if (empty($title)) $title=sprintf(__('Registre %s des sociétaires (art-10 des statuts))',$wpcoop->plugin_textdomain), $chrono);

// pour mettre a jour les souscriptions avec un numero d'ordre

//$users= get_users(array( 'meta_key'=>$wpcoop->plugin_usersubs_meta));
//print_tab($users);

// get subscribers data ordered by name or date if $order='date'
$ops = $wpcoop->members->get_ordered_users('subs', $order);

//print_tab($ops);

//D: send to the browser and force a file download with the name given by filename.
//F: save to a local file with the name given by filename (may include a path).
//S: return the document as a string. filename is ignored.
$output_mode='D';

///alm
// The library for generating HTML PDF files
if (!require_once($wpcoop->plugin_pdf_path.'fpdf/fpdf.php' )) {
 wlog(LOG,'fpdf not included: '.$wpcoop->plugin_pdf_path.'fpdf/fpdf.php');
}
if (!require('doc_template.php') ) {
 wlog(LOG,'doc_template.php: ');
}
// declaration page pdf
$pdf = new PDF_WpCoop_Document( 'P', 'mm', 'A4' );

// indique que le texte est en utf8, et donc a convertir ou pas
define ('WCDN_UTF8', true);
// indique que les infos sont a retourner en chaine et pas a imprimer
define ('WCDN_STR', true);

$lines=array();

// calcul des parts et souscriptions
// ops -> users data
// pps -> price per share givan by including script
//$tv=0; // reset total values
$ts=0; // reset total shares
$n=0;  // nbre souscripteur

foreach ($ops as $id=>$user) {
    if (empty($user['usersubs'])) continue;
    $data=$user['shares_data'];
    //print_tab($data);
    $s=$data['shares'];     //quantity of shares detained
    //$v=$data['value'];    //subscriptions value for this user (even if not validated)
    $d=$data['date'];       //date
    // counters
    // n number of shareholders
    // ts total shares
    // tv total value
    if ($s>0) {
        $n++;
    }
    $ts+=$s;
    //


    $width=40; //default width
    if ($s!=0) {

        $cat = $this->get_member_category($id,$user);
        switch ($cat) {
         //1 producteurs/salariés
            case '1';
                $dcat='p';
                break;
            case '2':
                $dcat='b';
                break;
            case '3':
                $dcat='s';
                break;
            case '4':
                $dcat='c';
                break;
            default:
                $dcat='?';
        }

        $type = $this->get_member_type($id,$user);
        switch ($type) {
            // person with capability
            case 'c':
                $dtype='p';
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberperson_';
                $thedisplayname=$this->get_thedisplayname($id,$user,$prefix, true);

                $institution = '';
                break;
            //institution
            case 'i':
                $dtype='m';
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'representative_';
                $thedisplayname=$this->get_thedisplayname($id,$user,$prefix, true);
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberinstitution_';
                $institution = $user[$prefix.'legalform']." ".$user[$prefix.'name']."\n";
                break;
            // person with legal representative
            case 'm':
                $dtype='a';
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberperson_';
                $thedisplayname=$this->get_thedisplayname($id,$user,$prefix, true);
                $institution = '';
                break;
            // type not set or unknown
            default:
                $dtype='?';
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberperson_';
                $thedisplayname=$this->get_thedisplayname($id,$user,$prefix, true);
                $institution='';
        }

        $fdate=substr($d,0,2).'/'.substr($d,2,2).'/'.substr($d,4,4);
        $lines[]['cols']=array(
               array('len'=>5, 'size'=>10, 'height'=>10, 'val'=> $dtype),
               array('len'=>5, 'size'=>10, 'height'=>10, 'val'=> $dcat),
               array('len'=>(2*$width-10), 'size'=>10, 'height'=>10, 'val'=> $thedisplayname),
               array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> $institution),
               array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> $fdate),
               array('len'=>15, 'size'=>10, 'height'=>10, 'val'=> $wpcoop->shares->get_share_price()*$s),
               array('len'=>15, 'size'=>10, 'height'=>10, 'val'=> $s)
                                        );

    }
    // nobody issue empty line
}
if ($n==0) {
        $lines[]['cols']=array(
               array('len'=>5, 'size'=>10, 'height'=>10, 'val'=> ''),
               array('len'=>5, 'size'=>10, 'height'=>10, 'val'=> ''),
               array('len'=>(2*$width-10), 'size'=>10, 'height'=>10, 'val'=> ''),
               array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> ''),
               array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> ''),
               array('len'=>15, 'size'=>10, 'height'=>10, 'val'=> ''),
               array('len'=>15, 'size'=>10, 'height'=>10, 'val'=> '')
                                        );
}

// ligne totaux
        $lines[]['cols']=array(
               array('len'=>5, 'size'=>10, 'height'=>10, 'val'=> ''),
               array('len'=>5, 'size'=>10, 'height'=>10, 'val'=> ''),
               array('len'=>(2*$width-10), 'size'=>10, 'height'=>10, 'val'=> $n." Sociétaires"),
               array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> ""),
               array('len'=>20, 'size'=>12, 'height'=>10, 'val'=> "Totaux"),
               array('len'=>20, 'size'=>12, 'height'=>10, 'val'=> $wpcoop->shares->get_share_price()*$ts),
               array('len'=>30, 'size'=>12, 'height'=>10, 'val'=> $ts)
                                        );


$utf8=true;


// definition des colonnes du tableau
// somme doit etre = 190 pour A4 (210-2*10 de marge)
// lab for label
// jus for justification (L, C, R)
$cols=array(
        array('len'=>5, 'lab'=>'T', 'jus'=>'L'),
        array('len'=>5, 'lab'=>'C', 'jus'=>'L'),
        array('len'=>(2*$width-10), 'lab'=>'Nom Prénom', 'jus'=>'L'),
        array('len'=>$width, 'lab'=>'Raison Sociale', 'jus'=>'L'),
        array('len'=>$width, 'lab'=>'Date 1ère souscription', 'jus'=>'L'),
        array('len'=>15, 'lab'=>'Euros', 'jus'=>'R'),
        array('len'=>15, 'lab'=>'Parts', 'jus'=>'R')
            );

$nbp=20;
$np= intval((count($lines)%$nbp==0)? count($lines)/$nbp : (count($lines)/$nbp +1));
//split in pages
$plines=array();
$l=0;

if ($np!=0) {
    for($i=1;$i<$np+1;$i++) {

        $pdf->AddPage();
        // font par defaut
        $pdf->SetFont('Arial','B',12);
        // pas de saut de page automatique
        $pdf->SetAutoPageBreak(false);
        // watermark
        //$pdf->addWaterMark( 'test seulement!!!' );
        $pdf->addPageNumber( $i, $np);
        //$title, $mg=60, $mh=20, $l=100, $h=10
        $pdf->addTitle($title, 50, 20, 110);
        $pdf->addTitle( 'Mis à jour le '. date('d/m/Y') , 85, 30, 50, 8 );

        // entete
        //
        $pdf->addCompany($url_logo, $company, $address,10,25 );
        do_action( 'wcdn_after_branding', $order );

        // legendes
        //addText($text, $x=10, $y=65, $font="Arial", $style="", $size=12) {
        $pdf->addtext('T=> Type de sociétaire (p: personne physique, a: personne physique sous administration légale, m: personne morale)', 10, 43.5, "Arial", "", 7);
        $pdf->addtext('C=> Catégorie de sociétaire (p: producteurs/proprétaires/salariés, b: bénéficiaires, s: soutiens, c: Collectivités publiques)', 10, 46.5, "Arial", "", 7);

        $j=0;
        while ($j<$nbp) {
            if (isset($lines[$l])) $plines[$l]=$lines[$l];
            $l++;
            $j++;
        }
        // cols, l&r margin, start high, end hight
        $pdf->addTable( $cols, 10, 50, 20 );
        $pdf->printTable2($plines, $cols);
        $plines=array();
        
    }
    
} else { // 0 pages
        $pdf->AddPage();
        // font par defaut
        $pdf->SetFont('Arial','B',12);
        // pas de saut de page automatique
        $pdf->SetAutoPageBreak(false);
        // watermark
        //$pdf->addWaterMark( 'test seulement!!!' );
        $pdf->addPageNumber( $i, $np);
        $pdf->addTitle($title);
        $pdf->addTitle( 'Mis à jour le '. date('d/m/Y') , 85, 30, 50, 8 );
        
        // entete 
        //
        $pdf->addCompany($url_logo, $company, $address,10,25 );
        do_action( 'wcdn_after_branding', $order );
    
        $pdf->addtext('Aucun sociétaire!',$this->plugin_textdomain);
  
    
    
}





// Create filename.
$filename = date('Ymd') .'-'.sanitize_file_name( remove_accents( $title ) ).'.pdf';

// create destination
if ($output_mode=='I' || $output_mode=='D') {
 $dest = $filename;
} else {
 $dest = $uploads_dir.'/'.$filename;
}




/// output
$pdf->Output($output_mode, $filename);
exit();
