<?php
/**
 * gen proxies list
 *
 * alm 20210417
 *
 */

if ( !defined( 'ABSPATH' ) ) exit;

//$meta_key="wpcoop_ag2021_1_proxy_form";
$date='???';
$meta_key='';
$optionsags=get_option($wpcoop->plugin_prefix.'options_ags', array());
if (!empty($optionsags) && is_array($optionsags) && isset($optionsags['dateag']) && $wpcoop->functions->validate_date($optionsags['dateag']) ) {
  $date=$optionsags['dateag'];
  $meta_key=$wpcoop->plugin_prefix.'proxy_form_'.date_format( date_create_from_format('d/m/Y', $optionsags['dateag']), 'Y-m-d');
}

if (empty($title)) $title=sprintf(__('Liste des procurations du %s',$wpcoop->plugin_textdomain), $date);

// pour mettre a jour les souscriptions avec un numero d'ordre

$users= get_users(array( 'meta_key'=>$wpcoop->plugin_usersubs_meta));
//print_tab($users);

// get subscribers data ordered by lastname
$ops = $wpcoop->members->get_ordered_users('subs', 'datesubs');

//print_tab($ops);

//D: send to the browser and force a file download with the name given by filename.
//F: save to a local file with the name given by filename (may include a path).
//S: return the document as a string. filename is ignored.
$output_mode='D';

///alm
// The library for generating HTML PDF files
if (!require_once($wpcoop->plugin_pdf_path.'fpdf/fpdf.php' )) {
 wlog(LOG,'fpdf not included: '.$wpcoop->plugin_pdf_path.'fpdf/fpdf.php');
}
if (!require('doc_template.php') ) {
 wlog(LOG,'doc_template.php: ');
}
// declaration page pdf
$pdf = new PDF_WpCoop_Document( 'P', 'mm', 'A4' );

// indique que le texte est en utf8, et donc a convertir ou pas
define ('WCDN_UTF8', true);
// indique que les infos sont a retourner en chaine et pas a imprimer
define ('WCDN_STR', true);

$lines=array();

// calcul des parts et souscriptions
$tv=0; // reset total values
$ts=0; // reset total shares
$n=0;  // nbre souscripteur
$width=40;
foreach ($ops as $id=>$user) {
    $is_soc=false;
    if (empty($user['usersubs'])) continue;

    $proxy=get_user_meta($id, $meta_key, true);
    //print_tab($proxy);
    if (empty($proxy)) continue;
    $proxy_ts=$proxy['timestamp'];
    $proxy_name=$proxy['name'];
    $proxy_message=$proxy['message'];

     $v=0;
     $s=0;
     foreach($user['usersubs'] as $o=>$steps) {
      foreach ($steps as $i=>$step) {
        $has_share=false;
        if (strpos($step['s'],'share')!==false) {
         $has_share=true;
         $is_soc=true;
         //$unit='Parts';
         $val=$step['q']/$pps;
         $s+=$val;
         //$n++;
        } else {
         //$unit='Euros';
         //$val=$step['q'];
         if ($i==0) {$v+=$step['q'];  $d=$step['d'];}
        }
      }
      if (!$has_share) $v-=$step['q']; // no share, remove value

     }
    if ($is_soc) $n++;
    $ts+=$s;
    $tv+=$v;

    if ($s!=0) {

        $cat = $this->get_member_category($id,$user);
        switch ($cat) {
         //1 producteurs/salariés
            case '1';
                $dcat='p';
                break;
            case '2':
                $dcat='b';
                break;
            case '3':
                $dcat='s';
                break;
            case '4':
                $dcat='c';
                break;
            default:
                $dcat='?';
        }

        $type = $this->get_member_type($id,$user);
        switch ($type) {
            // person with capability
            case 'c':
                $dtype='p';
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberperson_';
                $thedisplayname=$this->get_thedisplayname($id,$user,$prefix, true);

                $institution = '';
                break;
            //institution
            case 'i':
                $dtype='m';
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'representative_';
                $thedisplayname=$this->get_thedisplayname($id,$user,$prefix, true);
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberinstitution_';
                $institution = $user[$prefix.'legalform']." ".$user[$prefix.'name']."\n";
                break;
            // person with legal representative
            case 'm':
                $dtype='a';
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberperson_';
                $thedisplayname=$this->get_thedisplayname($id,$user,$prefix, true);
                $institution = '';
                break;
            // type not set or unknown
            default:
                $dtype='?';
                $prefix=$this->plugin_prefix.$this->usersdata_prefix.'memberperson_';
                $thedisplayname=$this->get_thedisplayname($id,$user,$prefix, true);
                $institution='';
        }


        $width=40;
        $fdate=substr($d,0,2).'/'.substr($d,2,2).'/'.substr($d,4,4);
        $lines[]['cols']=array(
               array('len'=>5, 'size'=>10, 'height'=>10, 'val'=> $dtype),
               array('len'=>5, 'size'=>10, 'height'=>10, 'val'=> $dcat),
               array('len'=>($width+5), 'size'=>10, 'height'=>10, 'val'=> $thedisplayname),
               array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> $institution),
               array('len'=>($width+5), 'size'=>10, 'height'=>10, 'val'=> $proxy_name),
               array('len'=>($width+10), 'size'=>5, 'height'=>10, 'val'=> $proxy_message)
                                        );
    }

}


$utf8=true;


// definition des colonnes du tableau
// somme doit etre = 190 pour A4 (210-2*10 de marge)
// lab for label
// jus for justification (L, C, R)

$cols=array(
        array('len'=>5, 'lab'=>'T', 'jus'=>'L'),
        array('len'=>5, 'lab'=>'C', 'jus'=>'L'),
        array('len'=>($width+5), 'lab'=>'Nom Prénom', 'jus'=>'L'),
        array('len'=>$width, 'lab'=>'Raison Sociale', 'jus'=>'L'),
        array('len'=>($width+5), 'lab'=>'Mandataire', 'jus'=>'L'),
        array('len'=>($width+10), 'lab'=>'Message', 'jus'=>'L')
            );

$nbp=20;
$np= intval((count($lines)%$nbp==0)? count($lines)/$nbp : (count($lines)/$nbp +1));
//split in pages
$plines=array();
$l=0;
$i=1;
if ($np!=0) {
    for($i=1;$i<$np+1;$i++) {

        $pdf->AddPage();
        // font par defaut
        $pdf->SetFont('Arial','B',12);
        // pas de saut de page automatique
        $pdf->SetAutoPageBreak(false);
        // watermark
        //$pdf->addWaterMark( 'test seulement!!!' );
        $pdf->addPageNumber( $i, $np);
        $pdf->addTitle($title);
        $pdf->addTitle( 'Mis à jour le '. date('d/m/Y') , 85, 30, 50, 8 );

        // entete
        //
        $pdf->addCompany($url_logo, $company, $address,10,25 );
        do_action( 'wcdn_after_branding', $order );

        // legendes
        //addText($text, $x=10, $y=65, $font="Arial", $style="", $size=12) {
        $pdf->addtext('T=> Type de sociétaire (p: personne physique, a: personne physique sous administration légale, m: personne morale)', 10, 43.5, "Arial", "", 7);
        $pdf->addtext('C=> Catégorie de sociétaire (p: producteurs/proprétaires/salariés, b: bénéficiaires, s: soutiens, c: Collectivités publiques)', 10, 46.5, "Arial", "", 7);

        $j=0;
        while ($j<$nbp) {
            $plines[$l]=$lines[$l];
            $l++;
            $j++;
        }
        // cols, l&r margin, start high, end hight
        $pdf->addTable( $cols, 10, 50, 20 );
        $pdf->printTable2($plines, $cols);
        $plines=array();

    }

} else { // 0 pages
        $pdf->AddPage();
        // font par defaut
        $pdf->SetFont('Arial','B',12);
        // pas de saut de page automatique
        $pdf->SetAutoPageBreak(false);
        // watermark
        //$pdf->addWaterMark( 'test seulement!!!' );
        $pdf->addPageNumber( $i, $np);
        $pdf->addTitle($title);
        $pdf->addTitle( 'Mis à jour le '. date('d/m/Y') , 85, 30, 50, 8 );

        // entete
        //
        $pdf->addCompany($url_logo, $company, $address,10,25 );

        $pdf->addText(__('Aucun sociétaire!',$this->plugin_textdomain));
}





// Create filename.
$filename = date('Ymd') .'-'.sanitize_file_name( remove_accents( $title ) ).'.pdf';

// create destination
if ($output_mode=='I' || $output_mode=='D') {
 $dest = $filename;
} else {
 $dest = $uploads_dir.'/'.$filename;
}




/// output
$pdf->Output($output_mode, $filename);
exit();
