<?php
/**
 * list of subscriptions to validate. This is the main file.
 *
 * alm 20210410
 *
 */

if ( !defined( 'ABSPATH' ) ) exit;
//lt list type: v subscriptions to validate, i incomplete subscriptions
if (empty($lt)) $lt='i';
if (empty($title)) {
    $title = ($lt=='v')?  __("List of subscriptions to validate", $this->plugin_textdomain) : __("List of incomplete subscriptions", $this->plugin_textdomain);
}
// get subscribers data ordered by lastname
$ops = $wpcoop->members->get_ordered_users('subs');

//print_tab($ops);

//D: send to the browser and force a file download with the name given by filename.
//F: save to a local file with the name given by filename (may include a path).
//S: return the document as a string. filename is ignored.
$output_mode='D';

///alm
// The library for generating HTML PDF files
if (!require_once($wpcoop->plugin_pdf_path.'fpdf/fpdf.php' )) {
 wlog(LOG,'fpdf not included: '.$wpcoop->plugin_pdf_path.'fpdf/fpdf.php');
}
if (!require('doc_template.php') ) {
 wlog(LOG,'doc_template.php: ');
}
// declaration page pdf
$pdf = new PDF_WpCoop_Document( 'P', 'mm', 'A4' );

// indique que le texte est en utf8, et donc a convertir ou pas
define ('WCDN_UTF8', true);
// indique que les infos sont a retourner en chaine et pas a imprimer
define ('WCDN_STR', true);


$lines=array();

// calcul des parts et souscriptions
$tv=0; // reset total values
$n=0;  // nbre souscriptions
$width=50;
foreach ($ops as $id=>$user) {
    if (empty($user['usersubs'])) continue;

         $v=0;
         foreach($user['usersubs'] as $o=>$steps) {
            $step=end($steps);
            if ($lt=='v') {
                // if last step of operations is not subsok or pending -> not for this list
                if ($step['s']!='subsok' && $step['s']!='substok' && $step['s']!='pending') continue;

                $n++;
                if ($step['s']=='subsok') {
                   //update ? subsok -> pending
                   $user['usersubs'][$o][] = array('s'=>'pending', 'q'=>$step['q'], 'd'=> date('dmY'), 'o'=>$o);
                   // update
                   update_user_meta($id, $this->plugin_usersubs_meta, $user['usersubs']);
                }
            } else {
                if ($step['s']!='subsnok' && $step['s']!='subswft') continue;
            }

            // date subscription is date of first operation ?
            $date=$steps[0]['d'];
            $fdate=substr($date,0,2).'/'.substr($date,2,2).'/'.substr($date,4,4);
            $dd=$this->get_thedisplaydata($id, $user);
            $lines[]['cols']=array(
                   array('len'=>20, 'size'=>10, 'height'=>10, 'val'=> $fdate),
                   array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> $ops[$id]['last_name']),
                   array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> $ops[$id]['first_name']),
                   //array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> $ops[$id]['wpcoop_company']),
                   array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> $dd['institution']),
                   array('len'=>20, 'size'=>10, 'height'=>10, 'val'=> $step['q'])
                                            );
            $tv+=$step['q'];
        }

} // each user

// ligne totaux
        $lines[]['cols']=array(
               array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> ""),
               array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> $n." Souscriptions"),
               array('len'=>$width, 'size'=>10, 'height'=>10, 'val'=> ""),
               array('len'=>20, 'size'=>12, 'height'=>10, 'val'=> "Total"),
               array('len'=>20, 'size'=>12, 'height'=>10, 'val'=> $tv),
                                        );


$utf8=true;


// definition des colonnes du tableau
// somme doit etre = 190 pour A4 (210-2*10 de marge)
// lab for label
// jus for justification (L, C, R)
$cols=array(
        array('len'=>20, 'lab'=>'Date souscr.', 'jus'=>'L'),
        array('len'=>$width, 'lab'=>'Nom', 'jus'=>'L'),
        array('len'=>$width, 'lab'=>'Prénom', 'jus'=>'L'),
        array('len'=>$width, 'lab'=>'Raison Sociale', 'jus'=>'L'),
        array('len'=>20, 'lab'=>'Euros', 'jus'=>'R')
           );

$nbp=20;
$np= intval((count($lines)%$nbp==0)? count($lines)/$nbp : (count($lines)/$nbp +1));

//split in pages
$plines=array();
$l=0;
if ($np!=0) {
    for($i=1;$i<$np+1;$i++) {

        $pdf->AddPage();
        // font par defaut
        $pdf->SetFont('Arial','B',12);
        // pas de saut de page automatique
        $pdf->SetAutoPageBreak(false);
        // watermark
        //$pdf->addWaterMark( 'test seulement!!!' );
        $pdf->addPageNumber( $i, $np);
        $pdf->addTitle($title);
        $pdf->addTitle( 'Mis à jour le '. date('d/m/Y') , 105, 30, 50, 8 );

        // entete
        //
        $pdf->addCompany($url_logo, $company, $address,10,25 );

        $j=0;
        while ($j<$nbp) {
            if (isset($lines[$l])) $plines[$l]=$lines[$l];
            $l++;
            $j++;
        }
        $eh= ($i==$np)? 40 : 20;
        // cols, l&r margin, start high, end hight
        $pdf->addTable( $cols, 10, 50, $eh );
        $pdf->printTable2($plines, $cols);
        $plines=array();

    }
}





// Create filename.

$filename = date('Ymd') .'-'.sanitize_file_name( remove_accents( $title ) ).'.pdf';

// create destination
if ($output_mode=='I' || $output_mode=='D') {
 $dest = $filename;
} else {
 $dest = $uploads_dir.'/'.$filename;
}




/// output
$pdf->Output($output_mode, $filename);
exit();
