<?php
/** \brief
 *
 * @author alm
 * @date
 */

/** \file 
 */

/*
function create_csv_file($content,$file_name='extraction_nabuco.ods') {
    header("Content-Length: " . strlen($content));
    header('Content-type: text/plain; charset=utf-8');
    header("Content-Type: application/force-download; name=\"$file_name\"");
    header("Content-Disposition: attachment; filename=\"$file_name\"");
    header("Pragma: no-cache");
    echo($content);
}

function create_csv_content($data) {
  global $niveau;
  $titre='Feuille1';
  foreach($data as $k=>$dat) {
   switch ($k) {
    case('titre'):
     $titre=$data['titre'];
     break;
    case('file'):
     $niveau['file_name']=$data['file'].'.csv';
     break;
    case('data'):
     // pas de groupe data directement
     $rows='';
     $nr=0;
     $nc=0;
     foreach($dat as $ligne) {
      $nr++;
      foreach($ligne as $cell) {
       $nc++;
       $trim_cell=trim($cell);
       $cell=str_replace(' ','',$trim_cell);
       $cell=utf8_encode(strtr($cell,'&°"','__\''));
       $value_type= (is_numeric($cell))? 'float' : 'string';
       $value= (is_numeric($cell))? $cell : utf8_encode(strtr($trim_cell,'&°"','__\'')); // il ne faut pas virer les espaces pour les chaines!
       $rows.='"'.$value.'",';
      }
      $rows=substr($rows,0,-1)."\n";
      //$rows.="\n";
     }
     break;
   }
  }
 //print("Nbre de lignes: $nr, nbre de cellules: $nc<br>");
 //print('taille rows:'.strlen($rows).'<br>');
 $res=$rows;
 return $res;
}
*/
function create_ods_file($content,$file_name='content.ods') {
  // pour test test sortie en fichier
  $create_file=false;
  //The following example creates a zip file:
  // Create new zip file in the directory below the current one
  $test = new zip_file($file_name);

  $test->set_options(array('inmemory' => !$create_file, 'recurse' => 0, 'storepaths' => 1));
  //$test->set_options(array($create_file, 'recurse' => 0, 'storepaths' => 1));

  // Create archive in memory

  $test->add_memory_file(manifest(),"META-INF/manifest.xml");
  $test->add_memory_file($content,"content.xml");
  $test->create_archive();
  if (!$create_file) $test->download_file();
}

function create_ods_content($data,$styles=array(),$ar_styles_definitions=array(),$formulas=array()) {
  //print_tab($formulas);
  $titre='Feuille1';
  foreach($data as $k=>$dat) {
   switch ($k) {
    case('titre'):
     $titre=$data['titre'];
     break;
    case('file'):
     $niveau['file_name']=$data['file'].'.ods';
     break;
    case('data'):
     // pas de groupe data directement
     $rows='';
     $nr=0;
     $nc=0;
     foreach($dat as $r=>$ligne) {
      $nr++;
      $rows.='<table:table-row table:style-name="ro1">'."\n";
       ;
      foreach($ligne as $c=>$cell) {
       $style='';
       if (isset($styles[$r]) && isset($styles[$r][$c]) && in_array($styles[$r][$c],array_keys($ar_styles_definitions)))
           $style='table:style-name="'.$styles[$r][$c].'"';
       $formula='';
       $nc++;
       $trim_cell=trim($cell);
       $cell=str_replace(' ','',$trim_cell);
       $cell=utf8_encode(strtr($cell,'&°"',"__'"));
       $value_type= (is_numeric($cell))? 'float' : 'string';
       $value= (is_numeric($cell))? $cell : utf8_encode(strtr($trim_cell,'&°"',"__'")); // il ne faut pas virer les espaces pour les chaines!
       $formula= (isset($formulas[$r]) && isset($formulas[$r][$c]))? $formulas[$r][$c] : '';
       $rows.='<table:table-cell '.$style.' '.$formula.' office:value-type="'.$value_type.'"  office:value="'.$value.'">
          <text:p>'.$value.'</text:p>
        </table:table-cell>';
      }
      $rows.="\n</table:table-row>\n";
     }
     break;
   }
  }
 //print("Nbre de lignes: $nr, nbre de cellules: $nc<br>");
 //print('taille rows:'.strlen($rows).'<br>');
 $res=ods_header($ar_styles_definitions).ods_begin_table($titre).$rows.ods_end_table().ods_footer();
 return $res;
}

function manifest() {
 return '<?xml version="1.0" encoding="UTF-8"?>
<manifest:manifest xmlns:manifest="urn:oasis:names:tc:opendocument:xmlns:manifest:1.0">
 <manifest:file-entry manifest:media-type="application/vnd.oasis.opendocument.spreadsheet" manifest:version="1.2" manifest:full-path="/"/>
 <manifest:file-entry manifest:media-type="" manifest:full-path="Configurations2/statusbar/"/>
 <manifest:file-entry manifest:media-type="" manifest:full-path="Configurations2/accelerator/current.xml"/>
 <manifest:file-entry manifest:media-type="" manifest:full-path="Configurations2/accelerator/"/>
 <manifest:file-entry manifest:media-type="" manifest:full-path="Configurations2/floater/"/>
 <manifest:file-entry manifest:media-type="" manifest:full-path="Configurations2/popupmenu/"/>
 <manifest:file-entry manifest:media-type="" manifest:full-path="Configurations2/progressbar/"/>
 <manifest:file-entry manifest:media-type="" manifest:full-path="Configurations2/menubar/"/>

 <manifest:file-entry manifest:media-type="" manifest:full-path="Configurations2/toolbar/"/>
 <manifest:file-entry manifest:media-type="" manifest:full-path="Configurations2/images/Bitmaps/"/>
 <manifest:file-entry manifest:media-type="" manifest:full-path="Configurations2/images/"/>
 <manifest:file-entry manifest:media-type="application/vnd.sun.xml.ui.configuration" manifest:full-path="Configurations2/"/>
 <manifest:file-entry manifest:media-type="text/xml" manifest:full-path="content.xml"/>
 <manifest:file-entry manifest:media-type="text/xml" manifest:full-path="styles.xml"/>
 <manifest:file-entry manifest:media-type="text/xml" manifest:full-path="meta.xml"/>
 <manifest:file-entry manifest:media-type="" manifest:full-path="Thumbnails/thumbnail.png"/>
 <manifest:file-entry manifest:media-type="" manifest:full-path="Thumbnails/"/>

 <manifest:file-entry manifest:media-type="text/xml" manifest:full-path="settings.xml"/>
</manifest:manifest>';
}


function ods_begin_table($titre) {
  return '<table:table table:name="'.utf8_encode($titre).'" table:style-name="ta1" table:print="false">
         ';
}

function ods_end_table() {
  return '
   </table:table>';
}


function ods_header($ar_styles_definitions=array()) {
$xml_styles_definitions='';
foreach ($ar_styles_definitions as $def) {
 $xml_styles_definitions .= $def;
}

return '<?xml version="1.0" encoding="UTF-8"?>
<office:document-content xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0"
                         xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0"
                         xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0"
                         xmlns:table="urn:oasis:names:tc:opendocument:xmlns:table:1.0"
                         xmlns:draw="urn:oasis:names:tc:opendocument:xmlns:drawing:1.0"
                         xmlns:fo="urn:oasis:names:tc:opendocument:xmlns:xsl-fo-compatible:1.0"
                         xmlns:xlink="http://www.w3.org/1999/xlink"
                         xmlns:dc="http://purl.org/dc/elements/1.1/"
                         xmlns:meta="urn:oasis:names:tc:opendocument:xmlns:meta:1.0"
                         xmlns:number="urn:oasis:names:tc:opendocument:xmlns:datastyle:1.0"
                         xmlns:presentation="urn:oasis:names:tc:opendocument:xmlns:presentation:1.0"
                         xmlns:svg="urn:oasis:names:tc:opendocument:xmlns:svg-compatible:1.0"
                         xmlns:chart="urn:oasis:names:tc:opendocument:xmlns:chart:1.0"
                         xmlns:dr3d="urn:oasis:names:tc:opendocument:xmlns:dr3d:1.0"
                         xmlns:math="http://www.w3.org/1998/Math/MathML"
                         xmlns:form="urn:oasis:names:tc:opendocument:xmlns:form:1.0"
                         xmlns:script="urn:oasis:names:tc:opendocument:xmlns:script:1.0"
                         xmlns:ooo="http://openoffice.org/2004/office"
                         xmlns:ooow="http://openoffice.org/2004/writer"
                         xmlns:oooc="http://openoffice.org/2004/calc"
                         xmlns:dom="http://www.w3.org/2001/xml-events"
                         xmlns:xforms="http://www.w3.org/2002/xforms"
                         xmlns:xsd="http://www.w3.org/2001/XMLSchema"
                         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                         xmlns:rpt="http://openoffice.org/2005/report"
                         xmlns:of="urn:oasis:names:tc:opendocument:xmlns:of:1.2"
                         xmlns:rdfa="http://docs.oasis-open.org/opendocument/meta/rdfa#"
                         office:version="1.2">
 <office:scripts/>
  <office:font-face-decls>
   <style:font-face style:name="Arial" svg:font-family="Arial" style:font-family-generic="swiss" style:font-pitch="variable"/>
   <style:font-face style:name="Andale Sans UI" svg:font-family="&apos;Andale Sans UI&apos;" style:font-family-generic="system" style:font-pitch="variable"/>
   <style:font-face style:name="Tahoma" svg:font-family="Tahoma" style:font-family-generic="system" style:font-pitch="variable"/>
  </office:font-face-decls>
 <office:automatic-styles>
   <style:style style:name="co1" style:family="table-column">

     <style:table-column-properties fo:break-before="auto" style:column-width="2.267cm"/>
   </style:style>
   <style:style style:name="ro1" style:family="table-row">
     <style:table-row-properties style:row-height="0.453cm" fo:break-before="auto" style:use-optimal-row-height="true"/>
   </style:style>
   <style:style style:name="ta1" style:family="table" style:master-page-name="Default">
     <style:table-properties table:display="true" style:writing-mode="lr-tb"/>
   </style:style>
   '.$xml_styles_definitions.'
 </office:automatic-styles>

 <office:body>
 <office:spreadsheet>
 ';
}

function ods_footer() {
 return '
 </office:spreadsheet>
 </office:body>
</office:document-content>';
}

/// exemple de contenu:
/*
   <table:table-column table:style-name="co1" table:number-columns-repeated="2" table:default-cell-style-name="Default"/>
    <table:table-row table:style-name="ro1">

     <table:table-cell office:value-type="string" table:number-columns-spanned="2" table:number-rows-spanned="1">
       <text:p>sur titre</text:p>
     </table:table-cell>

     <table:covered-table-cell/>

    </table:table-row>

    <table:table-row table:style-name="ro1">

      <table:table-cell office:value-type="string">
        <text:p>toto</text:p>
      </table:table-cell>

      <table:table-cell office:value-type="string">
        <text:p>tata</text:p>
      </table:table-cell>

    </table:table-row>



    <table:table-row table:style-name="ro1">
      <table:table-cell office:value-type="float" office:value="1">
        <text:p>1</text:p>
      </table:table-cell>
      <table:table-cell office:value-type="float" office:value="2">
        <text:p>2</text:p>

      </table:table-cell>
    </table:table-row>
    <table:table-row table:style-name="ro1">
      <table:table-cell office:value-type="float" office:value="3">
        <text:p>3</text:p>
      </table:table-cell>
      <table:table-cell office:value-type="float" office:value="4">
        <text:p>4</text:p>

      </table:table-cell>
    </table:table-row>
    <table:table-row table:style-name="ro1">
      <table:table-cell table:formula="of:=SUM([.A3:.A4])" office:value-type="float" office:value="4">
        <text:p>4</text:p>
      </table:table-cell>
      <table:table-cell table:formula="of:=SUM([.B3:.B4])" office:value-type="float" office:value="6">
        <text:p>6</text:p>

      </table:table-cell>
    </table:table-row>';
*/