<?php
/**
 * The template for displaying accounts.
 *
 */

 //maj 20210419 15:46

if (!defined('ABSPATH')) {
    exit;  //should not be here
}

$maintenance=false;

global $wpcoop;

if (!is_object($wpcoop)) {
    get_header();
    echo "Erreur, plugin wpcoop inactif";
    get_footer();
    exit;
} elseif ($maintenance) {
    get_header();
    echo "<h1>Désolé, maintenance en cours sur cette page, revenez plus tard, merci</h1>";
    get_footer();
    exit;
}

$user = wp_get_current_user();
//$thispageurl given by including procedure
// redirect to login page if not connected
if (0==$user->ID) {
 wp_redirect( wp_login_url($thispageurl));
 exit;
} elseif (!current_user_can('read')) {
 wp_redirect( wp_login_url(get_active_blog_for_user( $user->ID )->siteurl));
 exit;
}
$promositems=get_option($this->plugin_prefix.'options_promositems');
$promosok=get_option($this->plugin_prefix.'options_promos');

$monkitsolaireok=(!empty($promosok) && is_array($promosok) && isset($promosok['menu_enabled']) && $promosok['menu_enabled']=='y' && !empty($promositems) && is_array($promositems) && isset($promositems['monkitsolaire']) && isset($promositems['monkitsolaire']['enabled']) &&  $promositems['monkitsolaire']['enabled']=='y')? 'y' : 'n';
$codemks=$promositems['monkitsolaire']['codepromo']?? '';

if (isset($_REQUEST['doc'])) {
 $wpcoop->admin->issue_documents($user->ID);
 exit;
} elseif (isset($_REQUEST['doccnil'])) {
 $wpcoop->admin->issue_documents($user->ID, 5);
 exit;
} elseif($monkitsolaireok=='y'){
  if (wp_verify_nonce( $_POST[$this->plugin_prefix.'wp_nonce_monkitsolaireok'], 'monkitsolaireok' )) {
   update_user_meta($user->ID, $this->plugin_prefix.'monkitsolaireok', 'y');
  }
}

// ok, user is logged on
get_header();

//print_tab($_REQUEST);


//echo get_page_link();

$error=false;
$errormess='';

// display user data

echo 'Identifiant: ' . $user->user_login . '<br />';
echo 'Adresse mél: ' . $user->user_email . '<br />';
echo 'Prénom: ' . $user->user_firstname . '<br />';
echo 'Nom: ' . $user->user_lastname . '<br />';
echo 'Nom affiché: ' . $user->display_name . '<br />';
echo 'Numéro utilisateur: ' . $user->ID . '<br />';
echo '<br/>';

//
// read subscriptions
//
$ops=$wpcoop->members->get_ordered_users($user->ID);
$usersubs=(isset($ops[$user->ID]) && isset($ops[$user->ID]['usersubs']))? $ops[$user->ID]['usersubs'] : array();

// display subs, don't display action buttons and fields
$wpcoop->members->display_user_subs_table($user->ID, $usersubs, false);

if ($wpcoop->members->is_shareholder($usersubs)) {
    // proxy-form for meetings
    $optionsags=get_option($this->plugin_prefix.'options_ags',array());
    $optionproxy=get_option($this->plugin_prefix.'options_proxy_form',array());
    if (!empty($optionsags) && is_array($optionsags) && isset($optionsags['dateag']) && isset($optionsags['datepouvoir']) && !empty($optionproxy) && is_array($optionproxy) && isset($optionproxy['number']) && isset($optionproxy['posttype']) &&  get_post_type($optionproxy['number'])==$optionproxy['posttype']) {
      if ($this->functions->validate_date($optionsags['dateag']) && $this->functions->validate_date($optionsags['datepouvoir'])) {
        $dateag=date_create_from_format('d/m/Y', $optionsags['dateag']);
        $datepouvoir=date_create_from_format('d/m/Y', $optionsags['datepouvoir']);
        $today=date_create();
        if($today>=$datepouvoir && $today<$dateag){
          echo '<h4>Donner votre pouvoir pour l\'AG du '.$optionsags['dateag'].'</h4>';
          echo do_shortcode( '[contact-form-7 id="'.$optionsags['number'].'" title="Pouvoir AG"]' );
        }
      }
    }
    // promos
    if ($monkitsolaireok=='y') {
        echo '<h4>Accord de partenariat avec MonKitSolaire</h4>';
        if (get_usermeta($user->ID, $this->plugin_prefix.'monkitsolaireok')=='y') {
         echo '<span>Je me suis engagé à rester sociétaire PEP2A pendant 3 ans à compter de ma première souscription<span><br/>
               <span>Mon code promo (confidentiel) chez monkitsolaire est: <span><span class="codepromo">'.esc_html($codemks).'</span><br/><br/>';

        } else {
            echo '<span>Je m\'engage à rester sociétaire de PEP2A pendant 3 ans à partir de la date de ma première souscription pour bénéficier des remises PEP2A en cliquant sur le bouton ci-dessous<span><br />';
            echo '<form method="POST">
            <input type="submit" name="'.$this->plugin_prefix.'monkitsolaireok'.'" value="OUI - attention cette action m\'engage!" />';
            wp_nonce_field( 'monkitsolaireok', $this->plugin_prefix.'wp_nonce_monkitsolaireok', get_permalink());
            echo'
            </form><br/>';
        }
    }

} else {
  $isshareholder=false;
  echo "<span>Vous n'êtes pas encore sociétaire PEP2A<span>";
}
echo '<br />';

 echo '<table><tr>';
 echo ($isshareholder)? '<td><a href="'.$thispageurl.'?doc">Cliquez ici pour obtenir votre relevé de situation</a></td>' : '';
 echo '<td><a href="'.$thispageurl.'?doccnil">Cliquez ici pour obtenir les informations personnelles détenues</a></td>';

 $options=get_option($this->plugin_prefix.'options_inline', array());

 if (!empty($options) && isset($options['inline_pay']) &&  $options['inline_pay']=='y'){

   $options=get_option($this->plugin_prefix.'options_inlineitems');
   //print_tab($options);
   if (!empty($options) && is_array($options)) {
     //print_tab(array_keys($options));
     if (in_array('pep2anparts', array_keys($options), 'strict')  && isset($options['pep2anparts']['url'])) {
       echo '<td><a href="'.($options['pep2anparts']['url']).'" target="_blank">Cliquez ici pour investir dans plus de parts</a></td>';
     }
     if (in_array('pep2a5parts', array_keys($options), 'strict')  && isset($options['pep2a5parts']['url'])) {
       echo '<td><a href="'.($options['pep2a5parts']['url']).'" target=_blank">Adoptez un panneau solaire (5 parts)</a></td>';
     }

   }
 }
 echo '</tr></table>';

get_footer();
