<?php

if (!defined('ABSPATH')) {
    exit;  //should not be here  
}

$maintenance=false;

global $wpcoop;
if (!is_object($wpcoop)) { 
    get_header();
    echo "<h3>Erreur, plugin wpcoop inactif</h3>";
    get_sidebar();
    get_footer();
    exit;
} elseif ($maintenance) {
    get_header();
    echo "<h3>Désolé, maintenance en cours sur cette page, revenez plus tard, merci</h3>";
    get_sidebar();
    get_footer();
    exit;
}  elseif (strpos($val, 'maires')!==0) {
    get_header();
    echo "<h3>Désolé, je ne comprends pas la demande</h3>";
    get_sidebar();
    get_footer();
    exit;
} 

$user = wp_get_current_user();
//$thispageurl given by including procedure
// redirect to login page if not connected
if (0==$user->ID) {
 wp_redirect( wp_login_url($thispageurl));
 exit;
} elseif (!current_user_can('read')) {
 wp_redirect( wp_login_url(get_active_blog_for_user( $user->ID )->siteurl));
 exit;
}
get_header();

global $wpdb;
$table_name='communes06';
if ($wpdb->get_var($wpdb->prepare( "SHOW TABLES LIKE %s", $table_name))!==$table_name) {
  echo "<h3>Désolé, les données sont absentes</h3>";
  get_sidebar();
  get_footer(); 
  exit;    
} 

if(!empty(substr($val, strlen('maires'))) && strpos($val,'maires/')===0) {
 $code= (int) substr($val,strlen('maires/'));  
 $rows=$wpdb->get_results("SELECT * FROM ".$table_name." WHERE Code_Insee='".$code."' LIMIT 1");
    if (!$rows){
      echo "<h3>Désolé, pas de données disponibles</h3>";
      get_sidebar();
      get_footer();
      exit;
    } 
    
    $row=$rows[0];
    echo '<span>Contact de la commune: '.esc_html($row->Nom_Commune).'</span><p/>';
    echo '<div><table>
    <tr><td>Code Insee</td><td>'.esc_html($row->Code_Insee).'</td></tr>
    <tr><td>Maire</td><td>'.esc_html($row->Nom_Elu.' '.$row->Prenom_Elu).'</td></tr>
    <tr><td>Email Commune</td><td>'.esc_html($row->Email_General).'</td></tr>
    <tr><td>Email Maire</td><td>'.esc_html($row->Email_Maire).'</td></tr>
    <tr><td>Emails contacts</td><td>'.esc_html($row->Email_Contacts).'</td></tr>
    </table>';
} else {
    
    $rows=$wpdb->get_results("SELECT * FROM ".$table_name." ORDER BY Code_Insee");
    //print_tab($rows);
    if (!$rows){
      echo "<h3>Désolé, pas de données disponibles</h3>";
      get_sidebar();
      get_footer();
      exit;
    } 

    echo '<span>Liste des maires des communes des Alpes-Maritimes</span><p/>';
    echo '<div><table><tr><th width="5%">Code Insee</th><th>Commune</th><th>Nom</th><th>Prénom</th><th>Date Naissance</th><th width="10%">Election</th></tr>';
    foreach($rows as $row){
     echo '<tr><td>'.esc_html($row->Code_Insee).'</td>
               <td><a href="'.$thispageurl.'/'.esc_attr($row->Code_Insee).'">'.esc_html($row->Nom_Commune).'</a></td>
               <td>'.esc_html($row->Nom_Elu).'</td>
               <td>'.esc_html($row->Prenom_Elu).'</td>
               <td>'.esc_html($row->Date_Naissance).'</td>
               <td>'.esc_html($row->Debut_Mandat).'</td>
           </tr>';          
    }


    echo '</table>';
    echo '</div>';
}
get_footer();

///