<?php

/**
 * Exit if accessed directly
 */
if ( !defined( 'ABSPATH' ) ) {
    exit; 
}

//print_tab($this);

$maintenance=false;
$timeout=86400; // 3600*24


if (!is_object($this)) { 
    get_header();
    _e("<h1>Erreur, plugin wpcoop inactif, contactez votre administrateur système</h1>", $this->plugin_textdomain);
    get_footer();
    exit;
} elseif ($maintenance) {
    get_header();
    _e("<h1>Désolé, maintenance en cours sur cette page, revenez plus tard, merci</h1>", $this->plugin_textdomain);
    get_footer();
    exit;
}



if (file_exists($this->plugin_dir_path.'includes/class-wpcoop-subscription.php')){
    include($this->plugin_dir_path.'includes/class-wpcoop-subscription.php'); 
} else {
    get_header();
    _e("<h1>class subscription not found</h1>", $this->plugin_textdomain);
    get_footer();
    exit;
}

$subs=new WPCOOP_Subscription;

print_tab($subs);

//die('test');

///  

$user = wp_get_current_user();

$unknown=($user->ID==0)? '<li>L\'adresse email avec laquelle vous voulez souscrire (éventuellement adresse email ou identifiant et mot de passe si vous êtes déjà sociétaire ou avez un compte sur un des sites pep2a -pep2a.fr, pep2a.fr/societaires, ou pep2a.fr/intranet. Si vous ne savez plus, une procédure de récupération sera tentée )</li>' : '';
$unknown='<li>L\'adresse email avec laquelle vous voulez souscrire (celle avec laquelle vous êtes inscrit si vous êtes déjà sociétaire)</li>';
 
$connected=($user->ID==0)? '' : 'Vous êtes connecté sur un site PEP2A, restez connecté pour poursuivre votre souscription';


$step=$subs->get_step();

switch ($step){        
 case 1:
  //begins subscription, connect or send email
  
  break;      
 case 2:
  //download DIS
  break;      
 case 3:
  //enter subscriber information
  break;      
 case 4:
  //payment        
  break;      
 case 5:
  //documents       
  break;      
 case 6:
  //subscription validation send      
  break;      
}








if (!isset($_COOKIE[$this->plugin_prefix.'subscribe_step1']) ) {
    // no cookie set
    setcookie($this->plugin_prefix.'subscribe_step1',time(), time()+$timeout); // 24h left
    get_header();
    echo '<h2>Souscrire des parts de PEP2A : 1ère étape</h2>';
    //echo '<div><span>'.$connected.'</span></div>';
    echo '
    <div><span>Le processus de souscription se fait en deux étapes ; vous devez disposer de : </span>
    <ul>
    '.$unknown.'
    <li>Une pièce d\'identité (CNI recto/verso, passeport...) et un justificatif de domicile (facture électricité, téléphone... de moins de 3 mois), de préférence sous forme numérique (scan, photo)</li>
    <li>Un moyen de paiement, virement si possible, sinon Carte Bancaire, vous pourrez également régler votre souscription par chèque (à éviter)</li>
    </ul>
    <!-- <div><span>Le processus de souscription durera environ 15 minutes ; il peut être interrompu et repris dans les 24 heures</span></div> -->
    <p/>
    <div><span>Conformément à la réglementation, merci de télécharger le Document d\'Information Synthétique (DIS) afin de prendre connaissance  des risques associés à la souscription de parts PEP2A</span>. Le DIS comporte des liens vers les articles significatifs des statuts, <a href="https://pep2a.fr/societaires/wp-content/uploads/sites/2/2020/07/20190401-Statuts_SCIC_PEP2A_2019-03-23_statuts-modifies-suite-AGE.pdf">mais les statuts complets sont ici (pdf).</a><p/></div>
    <form method="post">
    <a href="">Téléchargement du DIS</a>    
    <div><span>Après avoir téléchargé le document, veuillez confirmez que vous en avez bien pris connaissance</span>
    <input type="submit" name="'.$wpcoop->plugin_prefix.'subscribe_step2'.'" value="Je confirme"/>    
    </form>
    </div>
    ';
    get_footer();
    exit;
} elseif (isset($_COOKIE[$this->plugin_prefix.'subscribe_step1']) 
      && !isset($_COOKIE[$this->plugin_prefix.'subscribe_step2']) 
      && !isset($_POST[$this->plugin_prefix.'subscribe_step2'])) {
    // download dis
    setcookie($this->plugin_prefix.'subscribe_step2',time(), time()+$timeout); // 24h left to acknowlege
    $dis=get_option('wpcoop_options_dis1_file');
    header("Content-type: application/force-download");
    header("Content-Disposition: attachment;filename=".urlencode($dis['name']));
    echo base64_decode($dis['data']);
    //exit;    
    
} elseif (isset($_COOKIE[$this->plugin_prefix.'subscribe_step1']) 
      &&  !isset($_COOKIE[$this->plugin_prefix.'subscribe_step2']) 
      &&   isset($_POST[$this->plugin_prefix.'subscribe_step2'])) {
    // validated without having downloaded dis
    get_header();
    echo '<h2>Souscrire des parts de PEP2A : 1ère étape </h2>';
    echo '
    <div><span>Conformément à la réglementation, </span><span style="color: red">VOUS DEVEZ</span> télécharger le DIS afin de prendre connaissance  des risques associés à la souscription de parts PEP2A</span></div>
    <form method="post">
    <a href="">Téléchargement du DIS</a>    
    <div><span>Après avoir téléchargé le document, veuillez confirmez que vous en avez bien pris connaissance</span>
    <input type="submit" name="'.$this->plugin_prefix.'subscribe_step2'.'" value="Je confirme"/>    
    </form>
    </div>
    ';
    get_footer();
    exit;
    
} elseif (isset($_COOKIE[$this->plugin_prefix.'subscribe_step1']) 
      &&  isset($_COOKIE[$this->plugin_prefix.'subscribe_step2'])
      &&  !isset($_REQUEST['bs1'])) {
    // dis downloaded and validation done
    get_header();
    // ajout de la classe survol pour RIB apparence/personnaliser/css additionnel
/*    
a.survol {
  position:relative;
  border-bottom:1px dashed #808080;
  text-decoration: none;
}
a:hover.survol {
  text-decoration: none;
  background: none;
}
a.survol span {display: none;}

a:hover.survol span {
  display: block;
  position: relative; 
  top: -20px;
  left: 10px;
  z-index: 20;
  width:100%;
  padding:2px 4px;
}
    
    echo '<h2>Souscrire des parts de PEP2A : 2ième étape</h2>';
    echo 'La souscription en ligne ne fonctionne pas encore, vous devez donc télécharger et remplir le bulletin de souscription, puis le retourner avec les justificatifs demandés à l\'adresse email <a href="mailto:souscription@pep2a.fr">souscription@pep2a.fr</a>. <br />
    <ul>
    <li>Vous pouvez régler votre souscription par virement en utilisant <a class="survol" href="#">ce rib (passer la souris ici)<span><img src="https://pep2a.fr/societaires/wp-content/uploads/sites/2/2020/07/20200720-image_rib_pep2a.jpg" alt=""></span></a></li>
    <li>Vous pouvez également régler en ligne par <a href="https://secure.payplug.com/p/Xy6jr">Carte Bancaire sur le site sécurisé Payplug</a> (et donc vos données ne transitent pas par le site PEP2A)</li>
    <li>Vous pouvez aussi envoyer vos documents et un chèque à l\'adresse
 postale de pep2a, mais nous ne conseillons pas cette option, qui occasionnera un temps de traitement plus long car demandera plus de travail et de déplacement à nos bénévoles (n\'oubliez pas que notre coopérative fonctionne essentiellement grâce au bénévolat des sociétaires, qui sont répartis sur le département).</li></ul>
 <a href="?bs1">Téléchargement du Bulletin de souscription</a><p/>';

//wpcoop_subscribe_form('no',$user->ID);

include($this->plugin_dir_path . 'includes/subscription_form.php'); 

    
 
 /*echo 'RIB PEP2A : <br>
 La Nef<br>
 IMMEUBLE WOOPA<br>8 AVENUE DES CANUTS,<br>
 CS 60032<br>
 69517 VAULX EN VELIN CEDEX<br>
 IBAN: FR76 2157 0000 0100 5166 3000 135<br>
 BIC: STFEFR21XXX';*/
    
      //$sites=get_sites(array('fields'=>'ids'));
      $thisblog=get_current_blog_id(); 
      //switch_to_blog($id);
    
      echo 'current_blog '.$thisblog.'<br>';
    
         $user=wp_get_current_user();
         //print_tab($user->ID);

      //switch_to_blog($thisblog);
      //echo 'current_blog '.get_current_blog_id().'<br>';  
    
    $usersites=get_blogs_of_user( $user->ID, true );
    //print_tab($usersites);
    if ($user->ID!=0) {                    
            echo 'user loggued<br>';
        //    if (in_array($thisblog, array_keys($usersites))){
            echo 'user site ok<br>';  
            if ($subscribe->is_shareholder_by_id($user->ID)){
                // if loggued user is shareholder, go on 
                echo 'user is share holder<br>';
                $subscribe->subscribe_form($user->ID); 
            } elseif (isset($_REQUEST[$this->plugin_prefix.'new_email'])
                      && isset($_REQUEST[$this->plugin_prefix.'submit_new_email'])){
                //loggued user has submitted newmail form          
                if (empty($_REQUEST[$this->plugin_prefix.'new_email'])) {
                 //newmail vide user ok to subscroibe with this email      
                 $subscribe->subscribe_form($user->ID);       
                } elseif (is_email($_REQUEST[$this->plugin_prefix.'new_email'])) {
                 // newemail ok, send an email with link   
                 echo 'send email with link<br>';
                 echo $subscribe->send_subscribe_link_email($_REQUEST[$this->plugin_prefix.'new_email']);   
                } else {
                 //newemail given is not a valid email   
                 echo '<span style="color: red">ERREUR! EMAIL incorrect!</span><br>'; 
                 echo $subscribe->ok_or_new_email($user->user_email,$_REQUEST[$this->plugin_prefix.'new_email']);     
                }       
            } else {
                echo 'user is not share holder<br>';
                echo $subscribe->ok_or_new_email($user->user_email);              
            } 
    } else {
        echo 'si vous êtes déjà sociétaire, merci de vous connecter à votre compte, en utilisant éventuellement la récupération du mot de passe : <a href="https://test.pep2a.fr/societaires/wp-login.php?redirect=https://test.pep2a.fr/societaires/souscrire">cliquez ici</a>';
        echo 'si vous avez un compte sur un site pep2a, merci de vous y connecté';
        echo 'merci de remplir votre email, un lien s'; 
    
    }
    
    get_footer();
    exit;
    
} elseif (isset($_COOKIE[$wpcoop->plugin_prefix.'subscribe_step1']) 
      &&  isset($_COOKIE[$wpcoop->plugin_prefix.'subscribe_step2'])
      &&  isset($_REQUEST['bs1'])) {   
    $dis=get_option('wpcoop_options_bs1_file');
    header("Content-type: application/force-download");
    header("Content-Disposition: attachment;filename=".urlencode($dis['name']));
    echo base64_decode($dis['data']);
}

/* elseif (isset($_POST) && isset($_POST[$wpcoop->plugin_prefix.'whoamiemails'])) {
    
  print_tab($_POST);
  $emails=explode(',', str_replace(' ', '', $_POST[$wpcoop->plugin_prefix.'whoamiemails']));
  //print_tab($emails); 
  $emailsok=true;
  $newemails='';
  $emailsent=false;
  $mess=array();
  print_tab($emails);
    /// TODO code entre 2 fois !!!
    
    $code=1278547;
  if (isset($_POST[$wpcoop->plugin_prefix.'hash']) && isset($_POST[$wpcoop->plugin_prefix.'captcha']) && $_POST[$wpcoop->plugin_prefix.'hash']==hash('md5', $_POST[$wpcoop->plugin_prefix.'captcha']+$code)) {    
  if (count($emails)<4) {   
      foreach($emails as $email) {
        if (!is_email($email)) continue; 
        $blogs=wp_coop_get_blogs_from_email($email);
        print_tab($blogs);
        $mess[$email]='';  
        if ($blogs===false){
          $mess[$email].='Vous n\'êtes pas inscrit sur les sites pep2a, <a href="'.$thispageurl.'?email='.urlencode($email).'">cliquez sur ce lien</a> pour souscrire avec l\'email: '.esc_html($email);         
        } else {
          foreach($blogs as $blog){
           $mess[$email].='Vous êtes inscrit sur le site '.$blog['blogname'].'('.$blog['siteurl'].'), avec l\'email: '.esc_html($email).', <a href="'.$thispageurl.'?email='.urlencode($email).'">cliquez sur ce lien</a> pour souscrire avec cet email';                    
          }          
        }       
      } 
      print_tab($mess);
      $cookiename=$wpcoop->plugin_prefix.'subscribe'.hash('md5', random_int(1,1000000));
      echo $cookiename;

      foreach($emails as $email) {
         $email=trim($email); 
         echo '<ul>';  
         if (is_email($email)) { 
           //verif_account_and_send_info($email);
           if (wp_mail($email, 'instructions pour souscription pep2a', $mess[$email], array('From: souscriptions pep2a <souscriptions@pep2a.fr>'))){     
            echo '<li>Un email a été envoyé à '.esc_html($email).', suivez les instructions contenues </li>';           
            $emailsent=true;
           }else {
            echo '<li>Un email n\'a pas pu être envoyé à '.esc_html($email).'</li>';                  
           }

         } else {
           echo '<li>'.esc_html($email).' n\'est pas une adresse email valide</li>';  
           $newemails.=$email.',';
           $emailsok=false;     
         }
         echo '</ul>'; 
      }  
      if ($emailsok) {
          get_footer();
          die;  
      }
      echo 'Vous pouvez recommencer la procédure ci-dessous si vous vous êtes trompé d\'adresse(s) email<p /><p/>';
      $emails=substr($newemails, 0, -1);  
    } else {
        echo '3 adresses email maximum!</p>';      
    }
  } else {
      echo $code.'<br>';
      echo hash('md5', $_POST[$wpcoop->plugin_prefix.'captcha']+$code).'<br>';
      echo 'Erreur dans la somme, recommencez!<br/>';
  }
}



$user = wp_get_current_user();
//$thispageurl given by including procedure
//


if (0==$user->ID) {

   $checkkey=wpcoop_check_key(); 
   if ($checkkey=='no') {
     // user not logged in && no key, log or new 
     //echo $thispageurl;   
     echo 'Si vous êtes déjà coopérateur ou si vous avez un compte sur un site PEP2A, merci de vous connectez en cliquant sur ce lien: 
           <a href="'.wp_login_url($thispageurl).'" >Connexion au site</a><p/>';
     wpcoop_subscribe_form('no');       
   } elseif ($checkkey=='bad') {
     // bad key, redo   
     echo '<li>Le code est faux ou trop ancien</li>'; 
     echo '<li>Si vous êtes déjà coopérateur ou si vous avez un compte sur un site PEP2A, merci de vous connectez en cliquant sur ce lien: 
           <a href="'.'kjh'.'" >Connexion au site</a></li>';
     wpcoop_subscribe_form('bad');             
   } elseif ($checkkey=='user') {
     // test si utilisateur du site societaires
     // si deja societaire (part validees ou pas), afficher le nombre de parts
     //    
       
     echo '<li>Vous avez un compte sur un site PEP2A, merci de vous connectez en cliquant sur ce lien: 
           <a href="'.'kjh'.'" >Connexion au site</a></li>';
   } elseif ($checkkey=='new') {
     wpcoop_subscribe_form('new');             
       
   } else {
       echo 'erreur';
   }


//wp_redirect( wp_login_url($thispageurl));

} elseif (!current_user_can('read')) {
     
 echo '<li>Si vous êtes déjà coopérateur ou si vous avez un compte sur un site PEP2A, merci de vous connectez en cliquant sur ce lien: 
       <a href="'.'kljkk'.'" >Connexion au site</a></li>';     
 //wp_redirect( wp_login_url(get_active_blog_for_user( $user->ID )->siteurl));

} else {
 // already known on this site
 echo 'déjà connu du site';   
}


get_footer();
*/